/*
  Test program for toger backup.
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef CHECK_BACKUP_HPP
#define CHECK_BACKUP_HPP

#include <cppunit/extensions/HelperMacros.h>

#include <girl/girlToger.hpp>


class BackupTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( BackupTest );
  CPPUNIT_TEST( testDirection );  
  CPPUNIT_TEST( testChessboardBackup );
  CPPUNIT_TEST( testHorizontalBackup );
  CPPUNIT_TEST( testVerticalBackup );  
  CPPUNIT_TEST( testOddsBackup );      
  CPPUNIT_TEST( testConcentricBackup );
  CPPUNIT_TEST( testDiagonalBackup );  
  CPPUNIT_TEST( testEmptyToger1 );  
  CPPUNIT_TEST_SUITE_END();
  
public:

  void setUp();
  void tearDown();

  void testEmptyToger1();

  void testDirection();  

  void testChessboardBackup();
  void testHorizontalBackup();
  void testVerticalBackup();
  void testOddsBackup();
  void testConcentricBackup();
  void testDiagonalBackup();  
  


protected:
  static void initPath();

protected:
  static std::string ms_path;

  void benchToger(girl::toger::sameRegion &func, girl::POINT_TYPE width);
  void benchEmptyTogerDisk(girl::toger::sameRegion &func, girl::POINT_TYPE width);
  void benchEmptyTogerMem(girl::toger::sameRegion &func, girl::POINT_TYPE width);
  void benchBitmapBackup(girl::toger::sameRegion &func, girl::POINT_TYPE width);
};



#endif /* ! CHECK_BACKUP_HPP */
