/*
  Test program for closed contour class.
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef CHECK_CONTOUR_HPP
#define CHECK_CONTOUR_HPP

#include <cppunit/extensions/HelperMacros.h>

#include <girl/girlContour.hpp>

class ContourTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( ContourTest );
  CPPUNIT_TEST( testEqual0   	         );
  CPPUNIT_TEST( testEqual1	         );
  CPPUNIT_TEST( testSetGet0 	         );
  CPPUNIT_TEST( testSetGet1	         );
  CPPUNIT_TEST( testSetGet2	         );
  CPPUNIT_TEST( testSetGet3	         );
  CPPUNIT_TEST( testPositiveOrientation0 );
  CPPUNIT_TEST( testPositiveOrientation1 );
  CPPUNIT_TEST( testPositiveOrientation2 );
  CPPUNIT_TEST( testPositiveOrientation3 );
  CPPUNIT_TEST( testPositiveOrientation4 );
  CPPUNIT_TEST( testPositiveOrientation5 );
  CPPUNIT_TEST( testPositiveOrientation6 );
  CPPUNIT_TEST( testLength0	         );
  CPPUNIT_TEST( testLength1	         );
  CPPUNIT_TEST( testLength2              );
  CPPUNIT_TEST( testLength2 );
  CPPUNIT_TEST( testMove1 );
  CPPUNIT_TEST( testMove2 );
  CPPUNIT_TEST( testInvert0 );
  CPPUNIT_TEST( testInvert1 );
  CPPUNIT_TEST( testInvert2 );
  CPPUNIT_TEST( testInvert3 );
  CPPUNIT_TEST( testCopy );
  CPPUNIT_TEST( testCopy2 );
  CPPUNIT_TEST( testBelongs );
  CPPUNIT_TEST( testSwap1 );
  CPPUNIT_TEST( testSwap2 );
  CPPUNIT_TEST_SUITE_END();
  
public:

  void setUp();
  void tearDown();

  void testEqual0();
  void testEqual1();
  void testEqual2();
  void testEqual3();
  void testSetGet0();
  void testSetGet1();
  void testSetGet2();
  void testSetGet3();
  void testPositiveOrientation0();
  void testPositiveOrientation1();
  void testPositiveOrientation2();
  void testPositiveOrientation3();
  void testPositiveOrientation4();
  void testPositiveOrientation5();
  void testPositiveOrientation6();
  void testLength0();
  void testLength1();
  void testLength2();
  void testMove1();
  void testMove2();
  void testInvert0();
  void testInvert1();
  void testInvert2();
  void testInvert3();
  void testInvert4();
  void testCopy();
  void testCopy2();
  void testBelongs();
  void testSwap1();
  void testSwap2();

protected:
  void testGet() const;


protected:
  std::deque<girl::direction> dirs;
  girl::contour c;

};



#endif /* ! CHECK_CONTOUR_HPP */
