/*
  Test program for crop of toger.
  Copyright (C) 2010 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef CHECK_CROP_HPP
#define CHECK_CROP_HPP

#include <cppunit/extensions/HelperMacros.h>

#include <girl/girlToger.hpp>

class CropTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( CropTest );

  CPPUNIT_TEST( testCrop1 );
  CPPUNIT_TEST( testCrop1b );
  CPPUNIT_TEST( testCrop2 );
  CPPUNIT_TEST( testCrop2c );
  CPPUNIT_TEST( testCrop2d );
  CPPUNIT_TEST( testCrop3 );
  CPPUNIT_TEST( testCrop3b );
  CPPUNIT_TEST( testCrop3c );
  CPPUNIT_TEST( testCrop3d );
  CPPUNIT_TEST( testCropRectangles0 );
  CPPUNIT_TEST( testCropRectangles1 );
  CPPUNIT_TEST( testCropRectangles1b );

  CPPUNIT_TEST( testCropRectanglesChessboard );
  CPPUNIT_TEST( testCropRectanglesHorizontal );
  CPPUNIT_TEST( testCropRectanglesVertical );
  CPPUNIT_TEST( testCropRectanglesOdds );
  CPPUNIT_TEST( testCropRectanglesConcentric );
  CPPUNIT_TEST( testCropRectanglesDiagonals );

  CPPUNIT_TEST_SUITE_END();

public:
  void setUp();
  void tearDown();

  void testCrop1();
  void testCrop1b();

  void testCrop2();
  void testCrop2c();
  void testCrop2d();
  void testCrop3();
  void testCrop3b();
  void testCrop3c();
  void testCrop3d();

  void testCropRectangles0();
  void testCropRectangles1();
  void testCropRectangles1b();

  void testCropRectanglesChessboard();
  void testCropRectanglesHorizontal();
  void testCropRectanglesVertical();
  void testCropRectanglesOdds();
  void testCropRectanglesConcentric();
  void testCropRectanglesDiagonals();

protected:

};

#endif /* ! CHECK_CROP_HPP */
