/*
  Test program for direction class.
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef CHECKDIRECTION_HPP
#define CHECKDIRECTION_HPP

#include <cppunit/extensions/HelperMacros.h>

#include <girl/girlDirection.hpp>

class DirectionTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( DirectionTest );
  CPPUNIT_TEST( testDoubleOpposite );
  CPPUNIT_TEST( testNextPrevious );
  CPPUNIT_TEST( testCycleNext );
  CPPUNIT_TEST( testCyclePrevious );
  CPPUNIT_TEST( testIsVerticalHorizontal );
  CPPUNIT_TEST_SUITE_END();

public:
  void setUp();
  void tearDown();

  void testDoubleOpposite();
  void testNextPrevious();
  void testCycleNext();
  void testCyclePrevious();
  void testIsVerticalHorizontal();

protected:
  
};

#endif /* ! CHECKDIRECTION_HPP */
