/*
  Test program for some empty toger properties.
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef CHECKEMPTYTOGER_HPP
#define CHECKEMPTYTOGER_HPP

#include <cppunit/extensions/HelperMacros.h>

#include <girl/girlToger.hpp>

class EmptyTogerTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( EmptyTogerTest );
  CPPUNIT_TEST( testConstructor1 );
  CPPUNIT_TEST( testBelongsTo1 );
  CPPUNIT_TEST( testBelongsTo2 );
  CPPUNIT_TEST( testBelongsTo3 );
  CPPUNIT_TEST( testFindRegion1 );
  CPPUNIT_TEST( testFindRegion1b );
  CPPUNIT_TEST( testFindRegion2 );
  CPPUNIT_TEST( testFindRegion3 );
  CPPUNIT_TEST( testFindRegions1 );
  CPPUNIT_TEST( testFindRegions2 );
  CPPUNIT_TEST( testFindDart );
  CPPUNIT_TEST( testRegionNeighbourhood );
  CPPUNIT_TEST( testAnyRegionNeighbour );
  CPPUNIT_TEST( testAllRegions );
  CPPUNIT_TEST( testInnerRegions );
  CPPUNIT_TEST( testFirstChild );
  CPPUNIT_TEST( testParent );
  CPPUNIT_TEST( testArtificialNode1 );
  CPPUNIT_TEST( testArtificialNode2 );
  CPPUNIT_TEST( testArtificialNode3 );
  CPPUNIT_TEST( testArtificialNode4 );
  CPPUNIT_TEST( testNoMark );
  CPPUNIT_TEST( testRegionDomain );
  CPPUNIT_TEST( testRegionBoundary );
  CPPUNIT_TEST( testDartSegment );
  CPPUNIT_TEST( testIterateOnDomain );
  CPPUNIT_TEST( testIterateOnBoundary );
  CPPUNIT_TEST( testIterateOnSegment );
  CPPUNIT_TEST( testShrink );

  CPPUNIT_TEST( testSwap );
  
  CPPUNIT_TEST( testPimpl1a );
  CPPUNIT_TEST( testPimpl1b );
  CPPUNIT_TEST( testPimpl2a );
  CPPUNIT_TEST( testPimpl2b );
  CPPUNIT_TEST( testPimpl3a );
  CPPUNIT_TEST( testPimpl3b );
  CPPUNIT_TEST( testPimpl4a );
  CPPUNIT_TEST( testPimpl4b );
  CPPUNIT_TEST( testPimpl5a );
  CPPUNIT_TEST( testPimpl5b );
  CPPUNIT_TEST( testPimpl5c );
  CPPUNIT_TEST( testPimpl6a );
  CPPUNIT_TEST( testPimpl6b );
  CPPUNIT_TEST( testPimpl7a );

  CPPUNIT_TEST_SUITE_END();

public:
  void setUp();
  void tearDown();

  void testConstructor1();
  void testBelongsTo1();
  void testBelongsTo2();
  void testBelongsTo3();
  void testFindRegion1();
  void testFindRegion1b();
  void testFindRegion2();
  void testFindRegion3();
  void testFindRegions1();
  void testFindRegions2();
  void testAreNeighbours();
  void testFindDart();
  void testRegionNeighbourhood();
  void testAnyRegionNeighbour();
  void testAllRegions();
  void testInnerRegions();
  void testFirstChild();
  void testParent();
  void testArtificialNode1();
  void testArtificialNode2();
  void testArtificialNode3();
  void testArtificialNode4();
  void testNoMark();
  void testRegionDomain();
  void testRegionBoundary();
  void testDartSegment();
  void testIterateOnDomain();
  void testIterateOnBoundary();
  void testIterateOnSegment();
  void testShrink();

  void testSwap();

  void testPimpl1a();
  void testPimpl1b();
  void testPimpl2a();
  void testPimpl2b();
  void testPimpl3a();
  void testPimpl3b();
  void testPimpl4a();
  void testPimpl4b();
  void testPimpl5a();
  void testPimpl5b();
  void testPimpl5c();
  void testPimpl6a();
  void testPimpl6b();
  void testPimpl7a();

protected:

};

#endif /* ! CHECKEMPTYTOGER_HPP */
