/*
  Test program for euclidean path set.
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef CHECKEUCLIDEANPATHSET_HPP
#define CHECKEUCLIDEANPATHSET_HPP

#include <cppunit/extensions/HelperMacros.h>

#include <girl/euclideanPathSet.hpp>

class EuclideanPathSetTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( EuclideanPathSetTest );
  CPPUNIT_TEST( testInit1 );
  CPPUNIT_TEST( testInit2 );
  CPPUNIT_TEST( testStartPtIndependance1 );
  CPPUNIT_TEST( testStartPtIndependance2 );
  CPPUNIT_TEST_SUITE_END();

public:
  
  void setUp();
  void tearDown();

  void testInit1();
  void testInit2();
  void testStartPtIndependance1();
  void testStartPtIndependance2();

protected:

  void testInit(girl::POINT_TYPE w, girl::POINT_TYPE h,
		girl::point startPt,
		const std::deque<girl::direction> &dirs,
		girl::point ptIn);

  void  testStartPtIndependance(girl::POINT_TYPE w, girl::POINT_TYPE h,
				girl::point startPt,
				std::deque<girl::direction> &dirs,
				girl::point ptIn);

};

#endif /* ! CHECKEUCLIDEANPATHSET_HPP */
