/*
  Test program for euclidean paths.
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef CHECKEUCLIDEANPATH_HPP
#define CHECKEUCLIDEANPATH_HPP

#include <cppunit/extensions/HelperMacros.h>

#include <girl/euclideanPath.hpp>

class EuclideanPathTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( EuclideanPathTest );
  CPPUNIT_TEST( testIterator1 );
  CPPUNIT_TEST( testIterator2 );
  CPPUNIT_TEST_SUITE_END();

public:
  
  void setUp();
  void tearDown();

  void testIterator1();
  void testIterator2();

protected:

  void testIterator(girl::point startPt,
		    const std::deque<girl::direction> &dirs);


};

#endif /* ! CHECKEUCLIDEANPATH_HPP */
