/*
  Test program for topological marking of toger.
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef CHECKMARK_HPP
#define CHECKMARK_HPP

#include <cppunit/extensions/HelperMacros.h>

#include <girl/girlToger.hpp>



class MarkTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( MarkTest );
  CPPUNIT_TEST( testEmptyXMark );
  CPPUNIT_TEST( testEmptyXMark2 );
  CPPUNIT_TEST( testEmptyMarkAll );
  CPPUNIT_TEST( testChessboardMark );
  CPPUNIT_TEST( testHorizontalMark );
  CPPUNIT_TEST( testVerticalMark );
  CPPUNIT_TEST( testOddsMark );
  CPPUNIT_TEST( testConcentricMark );
  CPPUNIT_TEST( testDiagonalMark );
  CPPUNIT_TEST_SUITE_END();

public:
  void setUp();
  void tearDown();

  void testEmptyXMark();
  void testEmptyXMark2();
  void testEmptyMarkAll();

  void testChessboardMark();
  void testHorizontalMark();
  void testVerticalMark();
  void testOddsMark();
  void testConcentricMark();
  void testDiagonalMark();

protected:

  girl::region getRandomRegion(void);

  void testFunc(girl::toger::sameRegion &func);

  void testMarkAll();
  void testXMark();
  void testCommonBoundaryMark();
  void testMergeKeepMark();
  void testOuterBoundaryAfterSplit(girl::toger::sameRegion &func);

protected:
  girl::toger tog;
  girl::POINT_TYPE width;
};




#endif /* ! CHECKMARK_HPP */
