/*
  Test program for merge operation in toger.
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef CHECK_MERGE_HPP
#define CHECK_MERGE_HPP

#include <cppunit/extensions/HelperMacros.h>

#include <girl/girlToger.hpp>


class MergeTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( MergeTest );
  CPPUNIT_TEST( testChessboardMerge );
  CPPUNIT_TEST( testHorizontalMerge );
  CPPUNIT_TEST( testVerticalMerge );
  CPPUNIT_TEST( testOddsMerge );
  CPPUNIT_TEST( testConcentricMerge );
  CPPUNIT_TEST( testDiagonalMerge );
  CPPUNIT_TEST_SUITE_END();
  
public:
  void setUp();
  void tearDown();
  
  void testChessboardMerge();
  void testHorizontalMerge();
  void testVerticalMerge();
  void testOddsMerge();
  void testConcentricMerge();
  void testDiagonalMerge();
  
protected:
  
  void testPimpl(girl::toger::sameRegion &func, girl::POINT_TYPE width);
  void testShrink(girl::toger::sameRegion &func, girl::POINT_TYPE width);
  void mergeFirst0(girl::toger::sameRegion &func, girl::POINT_TYPE width, int nbMerges);
  void mergeFirst0_hooks(girl::toger::sameRegion &func, girl::POINT_TYPE width, int nbMerges);
  girl::region getRandomRegion(girl::toger &tog);
  void mergeFirstRandom(girl::toger::sameRegion &func, girl::POINT_TYPE width, int nbMerges);
  void mergeAllRandom(girl::toger::sameRegion &func, girl::POINT_TYPE width, int nbMerges);
  
  
};

#endif /* ! CHECK_MERGE_HPP */
