/*
  Test program for path class.
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef CHECK_PATH_HPP
#define CHECK_PATH_HPP

#include <cppunit/extensions/HelperMacros.h>

#include <girl/girlPath.hpp>


class PathTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( PathTest );
  CPPUNIT_TEST( testEqual0 );
  CPPUNIT_TEST( testEqual1 );
  CPPUNIT_TEST( testEqual2 );
  CPPUNIT_TEST( testEqual3 );
  CPPUNIT_TEST( testIterator0 );
  CPPUNIT_TEST( testIterator1 );
  CPPUNIT_TEST( testIterator2 );
  CPPUNIT_TEST( testIteratorPlusN );
  CPPUNIT_TEST( testReverseIterator0 );
  CPPUNIT_TEST( testReverseIterator1 );
  CPPUNIT_TEST( testReverseIterator2 );
  CPPUNIT_TEST( testSetGet0 );
  CPPUNIT_TEST( testSetGet1 );
  CPPUNIT_TEST( testSetGet2 );
  CPPUNIT_TEST( testSetGet3 );
  CPPUNIT_TEST( testSetGet6 );
  CPPUNIT_TEST( testLength0 );
  CPPUNIT_TEST( testLength1 );
  CPPUNIT_TEST( testLength2 );
  CPPUNIT_TEST( testEndPt0 );
  CPPUNIT_TEST( testEndPt1 );
  CPPUNIT_TEST( testEndPt2 );
  CPPUNIT_TEST( testEndPt3 );
  CPPUNIT_TEST( testEndPt4 );
  CPPUNIT_TEST( testInvert0 );
  CPPUNIT_TEST( testInvert2 );
  CPPUNIT_TEST( testInvert3 );
  CPPUNIT_TEST( testInvert4 );
  CPPUNIT_TEST( testInvert5 );
  CPPUNIT_TEST( testAdd1 );
  CPPUNIT_TEST( testAdd2 );
  CPPUNIT_TEST( testAdd3 );
  CPPUNIT_TEST( testAdd4 );
  CPPUNIT_TEST( testMove0 );
  CPPUNIT_TEST( testMove1 );
  CPPUNIT_TEST( testMove2 );
  CPPUNIT_TEST( testAppend0 );
  CPPUNIT_TEST( testAppend1 );
  CPPUNIT_TEST( testAppend1b );
  CPPUNIT_TEST( testAppend2 );
  CPPUNIT_TEST( testAppend3 );
  CPPUNIT_TEST( testBelongs );  
  CPPUNIT_TEST( testClosed );    
  CPPUNIT_TEST( testCrop0 );    
  CPPUNIT_TEST( testCrop1 );    
  CPPUNIT_TEST( testCrop1b );    
  CPPUNIT_TEST( testCrop2 );    
  CPPUNIT_TEST( testCrop2b );    
  CPPUNIT_TEST( testCrop3 );    
  CPPUNIT_TEST( testCrop4 );    
  CPPUNIT_TEST( testSwap1 );
  CPPUNIT_TEST( testSwap2 );
  CPPUNIT_TEST_SUITE_END();
  
public:

  void setUp();
  void tearDown();

  void testEqual0();
  void testEqual1();
  void testEqual2();
  void testEqual3();
  void testIterator0();
  void testIterator1();
  void testIterator2();
  void testIteratorPlusN();
  void testReverseIterator0();
  void testReverseIterator1();
  void testReverseIterator2();
  void testSetGet0();
  void testSetGet1();
  void testSetGet2();
  void testSetGet3();
  void testSetGet6();
  void testLength0();
  void testLength1();
  void testLength2();
  void testEndPt0();
  void testEndPt1();
  void testEndPt2();
  void testEndPt3();
  void testEndPt4();
  void testInvert0();
  void testInvert2();
  void testInvert3();
  void testInvert4();
  void testInvert5();
  void testAdd1();
  void testAdd2();
  void testAdd3();
  void testAdd4();
  void testMove0();
  void testMove1();
  void testMove2();
  void testAppend0();
  void testAppend1();
  void testAppend1b();
  void testAppend2();
  void testAppend3();
  void testBelongs();
  void testClosed();
  void testCrop0();
  void testCrop1();
  void testCrop1b();
  void testCrop2();
  void testCrop2b();
  void testCrop3();
  void testCrop4();
  void testSwap1();
  void testSwap2();

protected:
  void testGet() const;


protected:
  std::deque<girl::direction> dirs;
  girl::path p;

};



#endif /* ! CHECK_PATH_HPP */
