/*
  Test program for pending edge finder.
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef CHECK_PENDINGEDGEFINDER_HPP
#define CHECK_PENDINGEDGEFINDER_HPP

#include <cppunit/extensions/HelperMacros.h>

#include <girl/girlPendingEdgeFinder.hpp>



class PendingEdgeFinderTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( PendingEdgeFinderTest );
  CPPUNIT_TEST( testHas1 );
  CPPUNIT_TEST( testHas2 );
  CPPUNIT_TEST( testHas3 );
  CPPUNIT_TEST( testHas4 );
  CPPUNIT_TEST( testHas5 );
  CPPUNIT_TEST( testHas6 );
  CPPUNIT_TEST( testHas7 );
  CPPUNIT_TEST( testHas8 );
  CPPUNIT_TEST( testHas9 );
  CPPUNIT_TEST( testHas10 );
  CPPUNIT_TEST( testHas11 );
  CPPUNIT_TEST( testHas12 );
  CPPUNIT_TEST( testHasNot1 );
  CPPUNIT_TEST( testHasNot2 );
  CPPUNIT_TEST( testHasNot3 );
  CPPUNIT_TEST( testHasNot4 );
  CPPUNIT_TEST( testHasNot5 );
  CPPUNIT_TEST( testHasNot6 );
  CPPUNIT_TEST( testHasNot7 );
  CPPUNIT_TEST( testHasNot8 );
  CPPUNIT_TEST( testHasNot9 );
  CPPUNIT_TEST( testHasNot10 );
  CPPUNIT_TEST( testHasNot11 );
  CPPUNIT_TEST( testHasNot12 );

  CPPUNIT_TEST_SUITE_END();

public:
  void setUp();
  void tearDown();

  void testHas1();
  void testHas2();
  void testHas3();
  void testHas4();
  void testHas5();
  void testHas6();
  void testHas7();
  void testHas8();
  void testHas9();
  void testHas10();
  void testHas11();
  void testHas12();

  void testHasNot1();
  void testHasNot2();
  void testHasNot3();
  void testHasNot4();
  void testHasNot5();
  void testHasNot6();
  void testHasNot7();
  void testHasNot8();
  void testHasNot9();
  void testHasNot10();
  void testHasNot11();
  void testHasNot12();

protected:

  void testHas(void (*initFct) (std::deque<girl::edge> &));
  void testHasNot(void (*initFct) (std::deque<girl::edge> &));

protected:

  std::deque<girl::edge> m_edgeList;
  girl::pendingEdgeFinder m_finder;

};





#endif /* ! CHECK_PENDINGEDGEFINDER_HPP */
