/*
  Test program for split operation in toger.
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef CHECK_SPLIT_HPP
#define CHECK_SPLIT_HPP

#include <cppunit/extensions/HelperMacros.h>

#include <girl/girlToger.hpp>



class SplitTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( SplitTest );
  CPPUNIT_TEST( testChessboardSplit );
  CPPUNIT_TEST( testHorizontalSplit );
  CPPUNIT_TEST( testVerticalSplit );
  CPPUNIT_TEST( testOddsSplit );
  CPPUNIT_TEST( testConcentricSplit );
  CPPUNIT_TEST( testDiagonalSplit );
  CPPUNIT_TEST_SUITE_END();

public:
  void setUp();
  void tearDown();

  void testChessboardSplit();
  void testHorizontalSplit();
  void testVerticalSplit();
  void testOddsSplit();
  void testConcentricSplit();
  void testDiagonalSplit();

protected:

  void testFunc(girl::toger::sameRegion &func, girl::POINT_TYPE width);
  void testFunc_aux(girl::toger::sameRegion &func, girl::toger::sameRegion &func2, girl::POINT_TYPE width);
  void testFuncB(girl::toger::sameRegion &func, girl::POINT_TYPE width);
  void testNewUpdateHooks(girl::toger::sameRegion &func, girl::POINT_TYPE width);
  void testNewRegionHook(girl::toger::sameRegion &func, girl::POINT_TYPE width);
};





#endif /* ! CHECK_SPLIT_HPP */
