/*
  Axis-Aligned Bounding Box class.
  Copyright (C) 2004-2009 Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#include "girlToolsAABBox.hpp"

#include <cassert>

using namespace girl::tools;

AABBox::AABBox(girl::point pt0, girl::point pt1)
  : m_xMin(pt0.x())
  , m_yMin(pt0.y())
  , m_xMax(pt1.x())
  , m_yMax(pt1.y())
{
}

AABBox::AABBox(girl::POINT_TYPE pXMin, girl::POINT_TYPE pYMin, 
	       girl::POINT_TYPE pXMax, girl::POINT_TYPE pYMax) 
  : m_xMin(pXMin)
  , m_yMin(pYMin)
  , m_xMax(pXMax)
  , m_yMax(pYMax)
{
}

void
AABBox::set(girl::POINT_TYPE pXMin, girl::POINT_TYPE pYMin, 
	    girl::POINT_TYPE pXMax, girl::POINT_TYPE pYMax)
{
  m_xMin = pXMin;
  m_yMin = pYMin; 
  m_xMax = pXMax;
  m_yMax = pYMax;
}

void
AABBox::setXMin(girl::POINT_TYPE pXMin)
{
  m_xMin = pXMin;
}
  
void
AABBox::setYMin(girl::POINT_TYPE yMin)
{
  m_yMin = yMin; 
}
  
void
AABBox::setXMax(girl::POINT_TYPE pXMax)
{
  m_xMax = pXMax;
}
  
void
AABBox::setYMax(girl::POINT_TYPE yMax)
{
  m_yMax = yMax;
}

