/*
  Functions to load/save toger to memory.
  Copyright (C) 2004-2009 Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef MEMORY_BACKUP_HPP
#define MEMORY_BACKUP_HPP

#include <girl/girlSharedPtr.hpp>
#include <girl/girlToger.hpp>

namespace girl {

  namespace tools {

    class MemoryBuffer;

    class GIRL_API oMemoryBackup : public girl::io::Writer
    {
    public:

      oMemoryBackup();

      girl::io::writeFlags flags() const;

      virtual size_t write(const void *p, size_t size);

      virtual bool end() { return true; }

      girl::shared_ptr<MemoryBuffer> get();

    private:

      oMemoryBackup(const oMemoryBackup &o);
      oMemoryBackup &operator=(const oMemoryBackup &o);
      
    protected:
      
      girl::shared_ptr<MemoryBuffer> m_mb;
      
      
    };
    
    class GIRL_API iMemoryBackup : public girl::io::Reader
    {
    public:

      explicit iMemoryBackup(girl::shared_ptr<MemoryBuffer> &mb);

      girl::io::writeFlags flags() const;

      virtual size_t read(void *p, size_t size);


    private:

      iMemoryBackup(const iMemoryBackup &);
      iMemoryBackup &operator=(const iMemoryBackup &);

    protected:

      girl::shared_ptr<MemoryBuffer> m_mb;
  
    };

  }

}

#endif /* ! MEMORY_BACKUP_HPP */
