/*
  Test program for functions providing information on regions of toger, related to OpenCV.
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef CHECK_CVUTILS_HPP
#define CHECK_CVUTILS_HPP

#include <cppunit/extensions/HelperMacros.h>

#include <girl/girlToger.hpp>


class CvUtilsTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( CvUtilsTest );
  CPPUNIT_TEST( testAABBoxNone );
  CPPUNIT_TEST( testAABBoxAll );
  CPPUNIT_TEST( testAABBox1 );
  CPPUNIT_TEST( testFindRegionsInMaskNone );
  CPPUNIT_TEST( testFindRegionsInMaskAll );
  CPPUNIT_TEST( testFindRegionsInMaskAllb );
  CPPUNIT_TEST( testFindRegionsInMask1 );
  CPPUNIT_TEST_SUITE_END();
  
public:

  void setUp();
  void tearDown();

  void testAABBoxNone();
  void testAABBoxAll();
  void testAABBox1();
  void testFindRegionsInMaskNone();
  void testFindRegionsInMaskAll();
  void testFindRegionsInMaskAllb();
  void testFindRegionsInMask1();

protected:

  void testFindRegionsInMaskAll_aux(girl::toger::sameRegion &func, int width, int height);

protected:
  
};



#endif /* ! CHECK_CVUTILS_HPP */
