/*
  Test program for saving/loading toger on disk.
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef CHECK_DISKBACKUP_HPP
#define CHECK_DISKBACKUP_HPP

#include <cppunit/extensions/HelperMacros.h>

#include <girl/girlToger.hpp>


class DiskBackupTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( DiskBackupTest );
  CPPUNIT_TEST( testChessboardBackup );
  CPPUNIT_TEST( testImageBackup );
  CPPUNIT_TEST_SUITE_END();
  
public:

  void setUp();
  void tearDown();

  void testChessboardBackup();
  void testImageBackup();  
  
protected:
  static void initPath();

protected:
  static std::string ms_path;

  void benchToger(girl::toger::sameRegion &func, int width, int height);
};



#endif /* ! CHECK_DISKBACKUP_HPP */
