/*
  Test program for functions providing information on regions of toger.
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef CHECK_REGIONINFO_HPP
#define CHECK_REGIONINFO_HPP

#include <cppunit/extensions/HelperMacros.h>

#include <girl/girlToger.hpp>


class RegionInfoTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( RegionInfoTest );
  CPPUNIT_TEST( testEmptyToger1 );
  CPPUNIT_TEST( testEmptyToger2 );
  CPPUNIT_TEST( testEmptyToger3 );
  CPPUNIT_TEST( testEmptyToger4 );
  CPPUNIT_TEST( testChessboardArea );
//   CPPUNIT_TEST( testHorizontalArea );
//   CPPUNIT_TEST( testVerticalArea );
//   CPPUNIT_TEST( testOddsArea );
//   CPPUNIT_TEST( testConcentricArea );
//   CPPUNIT_TEST( testDiagonalArea );
  CPPUNIT_TEST( testRegionInfoAABB1 );
  CPPUNIT_TEST_SUITE_END();
  
public:

  void setUp();
  void tearDown();

  void testEmptyToger1();
  void testEmptyToger2();
  void testEmptyToger3();
  void testEmptyToger4();
  void testChessboardArea();
//   void testHorizontalArea();
//   void testVerticalArea();
//   void testOddsArea();
//   void testConcentricArea();
//   void testDiagonalArea();
  void testRegionInfoAABB1();

protected:

  void benchTogerArea(girl::toger::sameRegion &func, int width, int height);

protected:
  
};



#endif /* ! CHECK_REGIONINFO_HPP */
