/*
  Test program for saving/loading toger with zlib compression.
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef CHECK_ZBACKUP_HPP
#define CHECK_ZBACKUP_HPP

#include <cppunit/extensions/HelperMacros.h>

#include <girl/girlToger.hpp>


class ZBackupTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE( ZBackupTest );
  CPPUNIT_TEST( testChessboardDiskBackup );
  CPPUNIT_TEST( testImageDiskBackup );  
  CPPUNIT_TEST( testChessboardMemBackup );
  CPPUNIT_TEST( testImageMemBackup );  
  CPPUNIT_TEST_SUITE_END();
  
public:

  void setUp();
  void tearDown();

  void testChessboardDiskBackup();
  void testImageDiskBackup();
  
  void testChessboardMemBackup();
  void testImageMemBackup();
  


protected:
  void benchTogerDiskBackup(girl::toger::sameRegion &func, int width, int height);
  void benchTogerMemBackup(girl::toger::sameRegion &func, int width, int height);
};



#endif /* ! CHECK_ZBACKUP_HPP */
