/*
  Synthetic functions for split.
  Copyright (C) 2005-2010 Boris Mansencal  boris.mansencal@labri.fr
 
  This file is part of GIRL.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef SAME_REGION_HPP
#define SAME_REGION_HPP

#include <string>


#include <girl/girlToger.hpp>
#include <girlTools/girlToolsImage.hpp>

//CODE DUPLICATION with girl++/tests/same_region/same_regions.hpp

class GIRL_API sameRegion_chessboard : public girl::toger::sameRegion
{
public:
  virtual bool same(const girl::point &p, girl::direction dir);
};

class GIRL_API sameRegion_horizontal : public girl::toger::sameRegion
{
public:
  virtual bool same(const girl::point &p, girl::direction dir);
};

class GIRL_API sameRegion_vertical : public girl::toger::sameRegion
{
public:
  virtual bool same(const girl::point &p, girl::direction dir);
};

class GIRL_API sameRegion_odds : public girl::toger::sameRegion
{
public:
  sameRegion_odds(girl::POINT_TYPE width, girl::POINT_TYPE height);
  
  void set(girl::POINT_TYPE width, girl::POINT_TYPE height);

  virtual bool same(const girl::point &p, girl::direction dir);
  
protected:
  girl::POINT_TYPE m_width;
  girl::POINT_TYPE m_height;
};

class GIRL_API sameRegion_concentric : public girl::toger::sameRegion
{
public:
  sameRegion_concentric(girl::POINT_TYPE width, girl::POINT_TYPE height);

  void set(girl::POINT_TYPE width, girl::POINT_TYPE height);

  virtual bool same(const girl::point &p, girl::direction dir);
  
protected:
  girl::POINT_TYPE m_width;
  girl::POINT_TYPE m_height;
};

class GIRL_API sameRegion_diagonals : public girl::toger::sameRegion
{
public:
   virtual bool same(const girl::point &p, girl::direction dir);
};


class sameRegion_image : public girl::toger::sameRegion
{
public:
  sameRegion_image()
    : m_img()
  {}


  bool loadImage(const std::string &filename);

  int width() const;
  int height() const;

  virtual bool same(const girl::point &p, girl::direction dir);

protected:

  girl::tools::Image m_img;
};



#endif /* ! SAME_REGION_HPP */
