#include "diskBackup.h"

#include <stdio.h>

struct diskBackupData
{
  FILE *f;
};
typedef struct diskBackupData diskBackupData;


static
size_t
P_writeFunc(const void *p, size_t size, void *userData)
{
  diskBackupData *d = (diskBackupData*)userData;
  return fwrite(p, (size_t)1, size, d->f);
}

static
size_t
P_readFunc(void *p, size_t size, void *userData)
{
  diskBackupData *d = (diskBackupData*)userData;
  return fread(p, (size_t)1, size, d->f);
}

int
diskBackup_write(const girlToger t, const char *fileName)
{
  diskBackupData d;
  d.f = fopen(fileName, "wb");
  if (d.f == NULL)
    return 0;

  girlToger_write(t, P_writeFunc, (void*)&d, GIRL_IO_DISK);

  fclose(d.f);

  return 1;
}

int
diskBackup_read(girlToger t, const char *fileName)
{
  diskBackupData d;
  d.f = fopen(fileName, "rb");
  if (d.f == NULL)
    return 0;

  if (! girlToger_read(t, P_readFunc, (void *)&d, GIRL_IO_DISK)) {
    return 0;
  }

  fclose(d.f);

  return 1;
}

