#include "memoryBackup.h"

#include "memoryBuffer.h"

#include <bcl/bcl.h>

struct memoryBackupS
{
  memoryBuffer wb;  
};

static
size_t
P_writeFunc(const void *p, size_t size, void *userData)
{
  memoryBackup ts = (memoryBackup)userData;

  memoryBuffer_write(ts->wb, p, size);
  return size;
}

static
size_t
P_readFunc(void *p, size_t size, void *userData)
{
  memoryBackup ts = (memoryBackup)userData;

  return memoryBuffer_read(ts->wb, p, size);
  //TODO:Warning: ts->wb is in an invalid state if read bytes != size

}

memoryBackup
memoryBackup_new(const girlToger t)
{
  memoryBackup self = (memoryBackup)bclMemory_alloc(sizeof(struct memoryBackupS));
  self->wb = memoryBuffer_new();

  girlToger_write(t, P_writeFunc, (void*)self, GIRL_IO_MEMORY);

  return self;
}

void
memoryBackup_delete(memoryBackup self)
{
  assert(self!=NULL);
  memoryBuffer_delete(self->wb);
  bclMemory_free(self);
}


int
memoryBackup_apply(memoryBackup ts, girlToger t)
{
  if (! girlToger_read(t, P_readFunc, (void *)ts, GIRL_IO_MEMORY)) {
     //TODO:Warning: ts->wb is in an invalid state 
   return 0;
  }
  return 1;
}

