#ifndef MEMORY_BACKUP_H
#define MEMORY_BACKUP_H

#include <girl/girlToger.h>

typedef struct memoryBackupS *memoryBackup;

/**
 * @brief Constructor.
 *
 * Build a memoryBackup from current state of toger @a t.
 */
memoryBackup memoryBackup_new(const girlToger t);

/**
 * @brief Destructor.
 */
void memoryBackup_delete(memoryBackup self);

/**
 * @brief Apply memoryBackup @a ts as current state of toger @a t. 
 *
 * @return 1 if operation succeeded, else 0. 
 */
int memoryBackup_apply(memoryBackup ts, girlToger t);



#endif //MEMORY_BACKUP_H
