#ifndef MEMORY_BUFFER_H
#define MEMORY_BUFFER_H

#include <stddef.h> //for size_t

typedef struct memoryBufferS *memoryBuffer;

/**
 * @brief Constructor.
 */
memoryBuffer memoryBuffer_new(void); 

/**
 * @brief Destructor.
 */
void memoryBuffer_delete(memoryBuffer self); 

/**
 * @brief Write @a n bytes from @a p in @a self.
 *
 * @return the number of bytes successfully written.
 */
size_t memoryBuffer_write(memoryBuffer self, const void *p, size_t n);

/**
 * @brief Read @a n bytes from @a self and write them at @a p.
 *
 * @return the number of bytes successfully read.
 */
size_t memoryBuffer_read(memoryBuffer self, void *p, size_t n);


#endif //MEMORY_BUFFER_H
