#ifndef AFFINITY_FUNCTOR_HPP
#define AFFINITY_FUNCTOR_HPP

template <typename T>
class AffinityFunctor
{

public:
  virtual T 
  operator()(size_t nodeIndex1, size_t nodeIndex2, size_t labelIndex1, size_t labelIndex2) = 0;

  /**
   * return true if the affinity coefficient between labels is independant of the nodes index
   * false otherwise
   */
  virtual bool
  isNodeIndependant() const = 0;
};

#endif /* AFFINITY_FUNCTOR_HPP */
