/*
  Copyright (C) 2005-2011 Remi Vieux, Boris Mansencal, remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef ENCLOSING_BOX_HPP
#define ENCLOSING_BOX_HPP

#include "EnclosingShape.hpp"


/**
 * Enclose a set of points with axis-aligned rectangle (bounding box)
 *
 */
class GIRL_API EnclosingBox : public EnclosingShape {

public:

  EnclosingBox() : m_rect(cv::Rect()) {}
  explicit EnclosingBox(const cv::Rect &rect) : m_rect(rect) {}
  ~EnclosingBox() {}

  virtual void draw(cv::Mat &,
		    const cv::Scalar &color = ENCLOSINGSHAPE_DEFAULT_COLOR,
		    int lineWidth = ENCLOSINGSHAPE_DEFAULT_LINEWIDTH) const;

  
  virtual void compute(const cv::Mat &);

  virtual double accept(ise::EnclosingShapeFeatureVisitor &visitor);

  cv::Rect getRect() const
  {
    return m_rect;
  }

  cv::Rect boundingRect() const
  {
    return m_rect;
  }

protected:
  cv::Rect m_rect;

};


#endif // ENCLOSING_BOX_HPP
