/*
  Copyright (C) 2005-2011 Remi Vieux, Boris Mansencal, remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#include "EnclosingCircle.hpp"



void
EnclosingCircle::draw(cv::Mat &mat, const cv::Scalar &color, int lineWidth) const
{
  cv::circle(mat, m_center, m_radius, color, lineWidth);
}

void
EnclosingCircle::compute(const cv::Mat &points)
{
    cv::minEnclosingCircle(points, m_center, m_radius);
}

double EnclosingCircle::accept(ise::EnclosingShapeFeatureVisitor &visitor)
{
    return visitor.visit(this);
}

cv::Point2f EnclosingCircle::getCenter()
{
    return m_center;
}

float EnclosingCircle::getRadius()
{
    return m_radius;
}

