/*
  Copyright (C) 2005-2011 Remi Vieux, Boris Mansencal, remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "EnclosingConnectedComponents.hpp"
#include <cassert>

void
EnclosingConnectedComponents::draw(cv::Mat &mat, const cv::Scalar &color, int) const
{
  std::vector<cv::Point>::const_iterator it = m_points.begin();
  const std::vector<cv::Point>::const_iterator itEnd = m_points.end();
  for ( ; it != itEnd; ++it) {
      cv::circle(mat, cv::Point(it->x, it->y), 0, color);
  }
}

void
EnclosingConnectedComponents::compute(const cv::Mat &points)
{
  m_points.clear();
  assert(points.isContinuous());
  assert(points.type() == CV_32SC2);
  const int *data = points.ptr<int>(0);
  const int *end = &data[points.rows*points.cols*points.channels()];
//  cv::MatConstIterator_<int> it = points.begin<int>();
//  cv::MatConstIterator_<int> it2 = points.begin<int>() +1;
//  cv::MatConstIterator_<int> itEnd = points.end<int>();
//  for ( ; it2 != itEnd; it+=2, it2+=2) {
  while (data < end) {
      m_points.push_back(cv::Point(data[0], data[1]));
      data += 2;
  }
}
