/*
  Copyright (C) 2005-2011 Remi Vieux, Boris Mansencal, remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#include "EnclosingConvexHull.hpp"


void computeShift(const cv::Point &src,
		  const cv::Point &prev,
		  const cv::Point &next,
		  cv::Point &shift)
{
  // int shiftx = 0;
  // int shifty = 0;
  // if (src.x >= prev.x && src.x <= next.x) {
//     if (src.y >= prev.y || src.y >= next.y)
//       --shifty;
//     else
//       ++shifty;
//   }
  
//   if (src.y >= prev.y && src.y <= next.y) {
//     if (src.x >= prev.x || src.x >= next.x)
//       --shiftx;
//     else
//       ++shiftx;
//   }
  
  // shiftx = (src.x == prev.x || src.x == next.x ) ? 0 : (src.x > prev.x || src.x > next.x) ? -1 : 1;
  // shifty = (src.y == prev.y || src.y == next.y ) ? 0 : (src.y >= prev.y || src.y >= next.y) ? -1 : 1;

  // shift.x = shiftx;
  // shift.y = shifty;

  
  shift.x = (src.x == prev.x || src.x == next.x ) ? 0 : (src.x > prev.x || src.x > next.x) ? -1 : 1;
  shift.y = (src.y == prev.y || src.y == next.y ) ? 0 : (src.y >= prev.y || src.y >= next.y) ? -1 : 1;

}

// void
// computeShift(std::vector<cv::Point> &points)
// {
//   for (int i = 1; i < m_hull.size(); ++i) {
//   }
// }

void
EnclosingConvexHull::draw(cv::Mat &mat, const cv::Scalar &color, int lineWidth) const
{
  if (lineWidth >= 0) {
    //     const unsigned int size = m_hull.size();
    //     for (unsigned int i = size; i < 2*size; ++i) {
    //       cv::Point src, prev, next, next2, shift;
    //       //      int index = i%size;
    //       src   = m_hull[i%size];
    //       prev  = m_hull[(i - 1)%size];
    //       next  = m_hull[(i + 1)%size];
    //       next2 = m_hull[(i + 2)%size];
    //       computeShift(src, prev, next, shift);
    //       cv::Point a = src + shift;
    //       computeShift(next, src, next2, shift);
    //       cv::Point b = next + shift;
    //       //      cv::Point b(m_hull[(i+1)%m_hull.size()].x , m_hull[(i+1)%m_hull.size()].y );
    //       //      cv::line(mat, m_hull[i], m_hull[(i+1)%m_hull.size()], color, lineWidth, CV_AA);
    //       //      cv::line(mat, src, dst, color, lineWidth, CV_AA);
    //       cv::line(mat, a, b, color, lineWidth);
    //     }
    
    for (unsigned int i = 0; i < m_hull.size(); ++i) {
      cv::Point src = m_hull[i];
      cv::Point dst = m_hull[(i + 1)%m_hull.size()];
      cv::line(mat, src, dst, color, lineWidth);
    }
  }
  else {
    cv::fillConvexPoly(mat, &m_hull[0], m_hull.size(), color, 4);
  }
}

#include <iostream>//DEBUG

void
EnclosingConvexHull::compute(const cv::Mat &points)
{
//   m_hull.clear();
//   std::vector<int> indices;
//   cv::convexHull(points, indices);
//   for (std::vector<int>::const_iterator it = indices.begin();
//        it != indices.end(); ++it) {
//     m_hull.push_back(cv::Point(points.at<int>(*it, 0),
// 			       points.at<int>(*it, 1)));
//   }


  cv::convexHull(points, m_hull);

  //REM: a convex hull may be reduced to a single point (then m_hull.size()==1)
  // or to a single line (then m_hull.size()==2).
  
}

double EnclosingConvexHull::accept(ise::EnclosingShapeFeatureVisitor &visitor)
{
    return visitor.visit(this);
}

