/*
  Copyright (C) 2005-2011 Remi Vieux, Boris Mansencal, remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#include "EnclosingRotatedRect.hpp"

void
EnclosingRotatedRect::draw(cv::Mat &mat, const cv::Scalar &color, int lineWidth) const
{
  cv::Point2f corners [4];
  //cvBoxPoints(m_rect, corners);
  m_rect.points(corners);
  if (lineWidth >= 0) {
    cv::line(mat, corners[0], corners[1], color, lineWidth);
    cv::line(mat, corners[0], corners[3], color, lineWidth);
    cv::line(mat, corners[3], corners[2], color, lineWidth);
    cv::line(mat, corners[1], corners[2], color, lineWidth);
  }
  else {
    std::vector<cv::Point> corners2(4);
    for (int i = 0; i < 4; ++i) {
      corners2[i].x = static_cast<int>(corners[i].x+0.5);
      corners2[i].y = static_cast<int>(corners[i].y+0.5);
    }
    cv::fillConvexPoly(mat, &corners2[0], 4, color);
  }

}

#include <iostream>//DEBUG

void
EnclosingRotatedRect::compute(const cv::Mat &points)
{
  /*
    Contrary to cv::Rect (see EnclosingBox.cpp)
    the cv::RotatedRect given by minAreaRect for a point or a line has a width or height null !
   */

  m_rect = cv::minAreaRect(points);
  /*
  m_rect.size.width--;
  m_rect.size.height--;
  */

}

double
EnclosingRotatedRect::accept(ise::EnclosingShapeFeatureVisitor &visitor)
{
  return visitor.visit(this);
}

cv::RotatedRect
EnclosingRotatedRect::getRect()
{
  return m_rect;
}
