/*
  Copyright (C) 2005-2011 Remi Vieux, Boris Mansencal, remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef ENCLOSING_SHAPE_FACTORY_HPP
#define ENCLOSING_SHAPE_FACTORY_HPP

#include <girl/girlCommon.hpp>
#include <girl/girlSharedPtr.hpp>

#include "EnclosingShape.hpp"

class GIRL_API EnclosingShapeFactory {
  
  
public:
  
  typedef girl::shared_ptr<EnclosingShape> EnclosingShapePtr;


  virtual ~EnclosingShapeFactory() {}
  
  virtual EnclosingShapePtr build() const = 0;
  
  virtual EnclosingShapePtr build(const cv::Mat &) const = 0;
  

};

#endif // ENCLOSING_SHAPE_FACTORY_HPP
