/*
  Merge driver using threshold on variance of tangent of regions contour.
  Copyright (C) 2005-2009 Jean-Philippe Domenger, Achille Braquelaire, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISEMERGEDRIVERTANGENTVARIANCE_HPP
#define ISEMERGEDRIVERTANGENTVARIANCE_HPP


#include <girl/girlCommon.hpp>
#include "iseMergeDriverDefault.hpp"

namespace ise {

  class SegmentationContext;
  
  class GIRL_API MergeDriverTangentVariance : public MergeDriverDefault
  {
  public :
    
    MergeDriverTangentVariance(ise::SegmentationContext *segContext = NULL, double threshold = 0.5);
    
    virtual ~MergeDriverTangentVariance() {}

    
    virtual void setParameters(double threshold);

    virtual void getParameters(double &threshold);

    
    virtual void init(const girl::regionDeque &regionsToMerge, int level);
    
    //virtual void filter(girl::regionDeque &regionsToMerge, int level);
    
    //virtual bool less(girl::region r1, girl::region r2);

    virtual double distance(girl::region reg1Id, girl::region reg2Id);
    
    virtual bool allowed(girl::region reg1Id, girl::region reg2Id, int level);
        
    //virtual girl::region selectCandidate(girl::region regId, int level);
    
    //virtual girl::region selectCandidate(girl::region regId, const girl::regionDeque &regions, int level);
    
    //virtual girl::region execute(girl::region reg1Id, girl::region reg2Id);
    

    double value(girl::region regId) const;

  protected:
    double m_threshold;


  };
  
  
}

#endif /* ! ISEMERGEDRIVERTANGENTVARIANCE_HPP */
