#include "Node.hpp"



Node::Node(data_type *data)
  : m_data(data),
    m_neighbours(),
    m_weights()
{}

Node::~Node()
{}

void
Node::setData(data_type *data)
{
  m_data = data;
}

data_type&
Node::operator[](size_t i)
{
  return m_data[i];
}

Node::NeighboursConstIterator
Node::neighboursBegin() const
{
  return m_neighbours.begin();
}

Node::NeighboursConstIterator
Node::neighboursEnd() const
{
  return m_neighbours.end();
}

Node::WeightsConstIterator
Node::weightsBegin() const
{
  return m_weights.begin();
}

Node::WeightsConstIterator
Node::weightsEnd() const
{
  return m_weights.end();
}

void
Node::addNeighbour(size_t index, data_type weight)
{
  m_neighbours.push_back(index);
  m_weights.push_back(weight);
}

