/*
  3D Histogram base class iterator.
  Copyright (C) 2004-2009 Jean-Philippe Domenger, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#include "iseAbstractHistogramIterator.hpp"

using namespace ise;

void 
AbstractHistogramIterator::get(ise::HistoInfo *info)
{
  assert(! atEnd());

  const unsigned int codeColor = static_cast<unsigned int>( *m_it );

  int c0Number = 256 >> m_histo->getOffset(0);
  int c1Number = 256 >> m_histo->getOffset(1);
  //int c2Number = 256 >> m_histo->getOffset(2);
  
  assert(c0Number);
  assert(c1Number);

  info->setColor(0, codeColor % c0Number);
  info->setColor(1, (codeColor / c0Number) % c1Number);
  info->setColor(2, codeColor / (c0Number * c1Number));
}

