#include "iseAbstractQuantificationHisto.hpp"

#include <girlTools/girlToolsImage.hpp>

#include "iseSegmentationContext.hpp"
/*
  Quantification by histogram base class.
  Copyright (C) 2004-2009 Jean-Philippe Domenger, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#include "iseHistogram.hpp"

using namespace ise;

AbstractQuantificationHisto::~AbstractQuantificationHisto()
{
  delete m_histo;
}

AbstractQuantificationHisto::AbstractQuantificationHisto(SegmentationContext *segContext, 
							 Histogram *histo)
  : 
  Quantification(segContext),
  m_histo(histo)
{

}

void
AbstractQuantificationHisto::processPoint(const girl::point &pt)
{
  const girl::tools::Pixel p = m_segContext->getImage()->getPixel(pt.x(), pt.y());
  m_histo->addColor(p.a(), p.b(), p.c());
}

void
AbstractQuantificationHisto::computeHistogramOnRegionSet(const girl::regionDeque &regions)
{
  girl::regionDeque::const_iterator it = regions.begin();
  const girl::regionDeque::const_iterator itEnd = regions.end();
  for ( ; it != itEnd; ++it) 
    m_segContext->getToger()->iterateOnRegionDomain(*it, *this);
}
