/*
  Quantification by histogram base class.
  Copyright (C) 2004-2009 Jean-Philippe Domenger, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISEABSTRACTQUANTIFICATIONHISTO_HPP
#define ISEABSTRACTQUANTIFICATIONHISTO_HPP

#include <girl/girlCommon.hpp>

#include "iseQuantification.hpp"

namespace ise {

  class Histogram;

  class GIRL_API AbstractQuantificationHisto : public Quantification, public girl::toger::pointIterator
  {
    
  public :

    //AbstractQuantificationHisto();

    /**
     * @brief Constructor.
     *
     * @warning takes ownership of @a histo.
     */ 
    AbstractQuantificationHisto(SegmentationContext *segContext,
				Histogram *histo);

    /**
     * @brief Destructor.
     */ 
    virtual ~AbstractQuantificationHisto();
  
    //virtual void init(const girl::regionDeque &regions, int level) = 0;
    
    //virtual void init(girl::region r, int level) = 0;

    virtual void processPoint(const girl::point &p);

  protected:  

    virtual bool areEquivalentColors(const girl::tools::Pixel &RGBcolor1, 
				     const girl::tools::Pixel &RGBcolor2) = 0;
    
    
    virtual void computeHistogramOnRegionSet(const girl::regionDeque &regions);
  
  private:
    AbstractQuantificationHisto(const AbstractQuantificationHisto &);
    AbstractQuantificationHisto &operator=(const AbstractQuantificationHisto &);

  protected:  

    Histogram *m_histo;
    
  };

}


#endif /*ISEABSTRACTQUANTIFICATIONHISTO_HPP*/
