#ifndef ISEAREAENCLOSINGSHAPEFEATUREVISITOR_HPP
#define ISEAREAENCLOSINGSHAPEFEATUREVISITOR_HPP

#include <girl/girlCommon.hpp>
#include <ise/iseEnclosingShapeFeatureVisitor.hpp>
#include <ise/iseEnclosingShapeFeatureVisitorRegistry.hpp>

namespace ise {

/**
  * Computes the area of some EncolsingShapes
  * \code
      EnclosingConvexHull hull(points);
      ise::EnclosingShapeFeatureVisitorRegistry * registry = ise::EnclosingShapeFeatureVisitorRegistry::instance();
      double registryBBoxArea = registry->applyEnclosingShapeFeatureVisitor("AreaEnclosingShapeFeatureVisitor", bbox);

  * \endcode
  * \example tests/testEnclosingShapeFeatureVisitor.cpp
  */
class GIRL_API AreaEnclosingShapeFeatureVisitor : public EnclosingShapeFeatureVisitor
{
public:
    AreaEnclosingShapeFeatureVisitor();

    virtual double visit(EnclosingBox *box);

    ///  sums of triangles areas
    virtual double visit(EnclosingConvexHull *box);

    virtual double visit(EnclosingCircle *box);

    virtual double visit(EnclosingEllipse *box);

    virtual double visit(EnclosingRotatedRect *box);
};

REGISTER_ENCLOSING_SHAPE_VISITOR(AreaEnclosingShapeFeatureVisitor)
}

#endif // ISEAREAENCLOSINGSHAPEFEATUREVISITOR_HPP
