/*
  3D Histogram stored as array.
  Copyright (C) 2004-2009 Jean-Philippe Domenger, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISEARRAYHISTOGRAM_HPP
#define ISEARRAYHISTOGRAM_HPP

#include <girl/girlCommon.hpp>

#include "iseHistogramIterator.hpp"
#include "iseAbstractHistogram.hpp"

namespace ise {

  class ArrayHistogramIterator;

  class GIRL_API ArrayHistogram : public AbstractHistogram
  {
  public:
    
    ArrayHistogram(unsigned char c1Offset=0, unsigned char c2Offset=0, unsigned char c3Offset=0);
    
    ~ArrayHistogram();

    void addColor(unsigned char r, 
		  unsigned char g,
		  unsigned char b);
    
    void clear();
    
    HistogramIterator *getIterator();

  protected:

    size_t dataSize() const 
    {
      return (256 >> m_offsets[0]) * (256 >> m_offsets[1]) * (256 >> m_offsets[2]);
    }

  private:
    
    ArrayHistogram(const ArrayHistogram &);

    ArrayHistogram &operator=(const ArrayHistogram &);

  protected:
    
    friend class ArrayHistogramIterator;
    
    unsigned int *m_histoData;
    
  };

}

#endif /* ISEARRAYHISTOGRAM_HPP */
