/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISEBINARIZER_HPP_
#define ISEBINARIZER_HPP_

#include <string>

#include <girl/girlCommon.hpp>


namespace girl {
  namespace tools {
    class Image;
  }
}

namespace cv {
class Mat;
}
namespace ise {

  /**
   * Interface for binarization classes used by SegmentationClusteringEnclosingShape
   * algorithm
   */
class GIRL_API Binarizer
{

public:

  virtual ~Binarizer() {}

  virtual const std::string name() const = 0;

  virtual void binarize(const girl::tools::Image* input, cv::Mat &output) = 0;

};


}
#endif /* ISEBINARIZER_HPP_ */
