/*
  Copyright (C) 2005-2011 Remi Vieux, Boris Mansencal  remi.vieux@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef BINARIZERCANNYOPENCV_HPP_
#define BINARIZERCANNYOPENCV_HPP_

#include "iseBinarizer.hpp"
/**
 * Produce a binary image of the input image contour using OpenCV canny algorithm
 */
namespace ise
{

  class GIRL_API BinarizerCannyOpenCv : public Binarizer
  {
  public:
    BinarizerCannyOpenCv();
    virtual
    ~BinarizerCannyOpenCv();

    const std::string name() const
    {
      return "BinarizerCannyOpenCV";
    }

    void binarize(const girl::tools::Image *input, cv::Mat &output);
  };

}

#endif /* BINARIZERCANNYOPENCV_HPP_ */
