/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISEBINARIZERQUANTIFICATIONTHRESHOLDER_HPP_
#define ISEBINARIZERQUANTIFICATIONTHRESHOLDER_HPP_

#include <string>

#include <girl/girlCommon.hpp>
#include <girl/girlSharedPtr.hpp>

#include "iseBinarizer.hpp"
/**
 * Class which wrap an ise::QuantificationTresholder to produce
 * the binary cv::Mat
 */
namespace ise
{

class QuantificationThresholder;

  class GIRL_API BinarizerQuantificationThresholder : public Binarizer
  {
  public:
    explicit BinarizerQuantificationThresholder(girl::shared_ptr<QuantificationThresholder>);
    virtual
    ~BinarizerQuantificationThresholder() {}


    const std::string name() const
    {
      return m_name;
    }

    void
    setName(const std::string& name) {
      m_name = name;
    }

    void
    binarize(const girl::tools::Image*, cv::Mat&);

  protected:

    girl::shared_ptr<QuantificationThresholder> m_thresholder;

    std::string m_name;
  };

}

#endif /* ISEBINARIZERQUANTIFICATIONTHRESHOLDER_HPP_ */
