/*
  CAG.
  Copyright (C) 2004-2009 Jean-Philippe Domenger, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISECAG_HPP
#define ISECAG_HPP


namespace ise {

  class ClusterSet;

  class Cag
  {

  public :

    Cag(ClusterSet *clusters, int nb);
  
    ~Cag();
	
    void findClosestNode(int *clus1, int *clus2);
	
    void getMinColorDist(ClusterSet *clusters, int *clus1, int *clus2);
  
    void mergeNode(ClusterSet *clusters, int clus1, int clus2);

  protected:

    void makeLinks(ClusterSet *clusters);
	
  private:

    Cag(const Cag &);

    Cag &operator=(const Cag &);
  

  protected:

    double *m_links;
    short *m_exist;
    int m_nbClusters;
    int m_size;

  };

}

#endif /* ISECAG_HPP */
