/*
  Cluster.
  Copyright (C) 2004-2009 Jean-Philippe Domenger, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISECLUSTER_HPP
#define ISECLUSTER_HPP

#include <girlTools/girlToolsVector.hpp>

//JP: REDEFINIR L'OPERATEUR D'AFFECTATION.
//JP: REVOIR PASSAGE en template


namespace ise {
  
  class ClusterSet;

  class Cluster
  {

    friend class ClusterSet;

  public:

    Cluster();
	
    void addColor(girl::tools::Int3, long);
	
    inline int isEmpty() const { return (m0 < 0.000000001); }
  
    inline double getSqe() const { return sqe; }
	
    void getMoments(double *, girl::tools::Flt3 *, girl::tools::Flt3 *) const;
	
    void setMoments(double, girl::tools::Flt3, girl::tools::Flt3);
	
    void move(Cluster *copy);

  protected:

    girl::tools::Flt3 mean;
    girl::tools::Flt3 m2;
    girl::tools::Flt3 m1;
    double  m0;
    double  sqe;
    int     canonic;
    bool    exist;  
	
  };

}

#endif /* ISECLUSTER_HPP */

