#include "iseCompacityEnclosingShapeFeatureVisitor.hpp"

#include "EnclosingBox.hpp"
#include "EnclosingConvexHull.hpp"
#include "EnclosingCircle.hpp"
#include "EnclosingEllipse.hpp"
#include "EnclosingRotatedRect.hpp"

using namespace ise;

CompacityEnclosingShapeFeatureVisitor::CompacityEnclosingShapeFeatureVisitor()
{
  m_registry = EnclosingShapeFeatureVisitorRegistry::instance();
}

double
CompacityEnclosingShapeFeatureVisitor::visit(EnclosingBox *box)
{
  return computeAreaWithVisitors(*box);
}

double
CompacityEnclosingShapeFeatureVisitor::visit(EnclosingConvexHull *box)
{
   return computeAreaWithVisitors(*box);
}

double ise::CompacityEnclosingShapeFeatureVisitor::visit(EnclosingCircle *box)
{
    return computeAreaWithVisitors(*box);
}

double ise::CompacityEnclosingShapeFeatureVisitor::visit(EnclosingEllipse *box)
{
    return computeAreaWithVisitors(*box);
}

double ise::CompacityEnclosingShapeFeatureVisitor::visit(EnclosingRotatedRect *box)
{
    return computeAreaWithVisitors(*box);
}
