#include "iseContourPoint.hpp"
#include <cmath>

#ifndef M_PI
//Visual C++ does not define these constants in <cmath>
#define M_PI 3.14159265358979323846
#endif 

using namespace ise;

ContourPoint::ContourPoint()
  : m_x(0.0), m_y(0.0), m_tx(0.0), m_ty(0.0), m_a(0.0), m_c(0.0) {}

ContourPoint::ContourPoint(const ContourPoint &other)
{
  m_x = other.m_x;
  m_y = other.m_y;
  m_tx = other.m_tx;
  m_ty = other.m_ty;
  m_a = other.m_a;
  m_c = other.m_c;
}

ContourPoint&
ContourPoint::operator=(const ContourPoint &other)
{
  if ( this != &other ) {
    m_x = other.m_x;
    m_y = other.m_y;
    m_tx = other.m_tx;
    m_ty = other.m_ty;
    m_a = other.m_a;
    m_c = other.m_c;
  }
  return *this;
}

void
ContourPoint::setAngle(double a)
{
  if ( a > M_PI/2 )
    a -= M_PI;
  if ( a < -M_PI/2 )
    a += M_PI;
  m_a = a;
}

void
ContourPoint::setCurvature(double c)
{
  if ( c > M_PI/2 )
    c -= M_PI;
  if ( c < -M_PI/2 )
    c += M_PI;
  m_c = c;
}
