/*
  Segmentation clustering: Watershed.
  Copyright (C) 2005-2009 Jean-Philippe Domenger, Achille Braquelaire, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef ISECVSOBEL_HPP
#define ISECVSOBEL_HPP

#include <girl/girlCommon.hpp>
#include <girl/girlSharedPtr.hpp>
#include <girlTools/girlToolsImageFeature.hpp>

namespace ise {
  class GIRL_API CvSobel
  {
  public:
    
    explicit CvSobel(girl::shared_ptr<girl::tools::ImageFeature> imageFeature);

    void compute(girl::shared_ptr<girl::tools::ImageFeature> &dest, int xorder, int yorder);

  private:

    girl::shared_ptr<girl::tools::ImageFeature> m_imageFeature;
    

  };
}

#endif /* ! ISECVSOBEL_HPP */
