#ifndef ISEENCLOSINGSHAPEVISITORONDISTRIBFILTER_HPP
#define ISEENCLOSINGSHAPEVISITORONDISTRIBFILTER_HPP

#include <ise/iseSparseHistogram1D.hpp>
#include <girl/girlCommon.hpp>
#include <ise/EnclosingShapeFactory.hpp>



namespace ise {

/// should memoize visitors computation
class GIRL_API EnclosingShapeVisitorOnDistribFilter
{
public:
    typedef std::vector<EnclosingShapeFactory::EnclosingShapePtr> ShapeList;

    explicit EnclosingShapeVisitorOnDistribFilter(ShapeList &list);

    void populateHistogram(ise::SparseHistogram1DD &histo, const std::string &visitorName);

    void filter(std::vector<bool> &filteredShapes, double threshold, const std::string &visitorName);


private :
    ShapeList &m_shapeList;
};
}

#endif // ISEENCLOSINGSHAPEVISITORONDISTRIBFILTER_HPP
