/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef ISEFOREGROUNDBACKGROUNDCLASSIFIER_HPP_
#define ISEFOREGROUNDBACKGROUNDCLASSIFIER_HPP_

#include <girl/girlCommon.hpp>
#include <girl/girlToger.hpp>

#include "iseAbstractFactoryTemplate.hxx"
namespace ise
{

  class SegmentationContext;
  /**
   * Interface for all classes that must separate the regions
   * into foreground and background regions
   */
  class GIRL_API ForegroundBackgroundClassifier
  {

  public:

    ForegroundBackgroundClassifier(SegmentationContext *segContext)
    : m_segContext(segContext) {}

    virtual
    ~ForegroundBackgroundClassifier() {}

    virtual void
    classify(const girl::regionDeque &input, girl::regionDeque &foreground, girl::regionDeque &background) = 0;

  protected:

    SegmentationContext *m_segContext;
  };

  typedef AbstractFactoryTemplate<ForegroundBackgroundClassifier> ForegroundBackgroundClassifierFactory;

}
#endif /* ISEFOREGROUNDBACKGROUNDCLASSIFIER_HPP_ */
