/*
  Copyright (C) 2005-2011 Remi Vieux, Boris Mansencal, remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#include "iseForegroundBackgroundClassifierHoles.hpp"

#include <girl/girlToger.hpp>
#include "iseSegmentationContext.hpp"

namespace ise
{

  void
  ForegroundBackgroundClassifierHoles::classify(const girl::regionDeque &input, girl::regionDeque &foreground, girl::regionDeque &background)
  {
    assert(m_segContext);
    girl::toger *tog = m_segContext->getToger();
    assert(tog);
    foreground.clear();
    background.clear();
    girl::regionDeque::const_iterator it = input.begin();
    const girl::regionDeque::const_iterator itEnd = input.end();
    for ( ; it != itEnd; ++it) {
        girl::regionDeque regs;
        tog->regionNeighbourhood(*it, girl::toger::NEIGHBOUR_INNER, girl::toger::MARK_NONE, regs);
        if (!regs.size())
          foreground.push_back(*it);
        else
          background.push_back(*it);
    }

    //   assert(background.size() == 1);
    assert(input.size() == (foreground.size() + background.size()));
  }

}
