/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISEFOREGROUNDBACKGROUNDCLASSIFIERHOLES_HPP_
#define ISEFOREGROUNDBACKGROUNDCLASSIFIERHOLES_HPP_

#include "iseFactoryTemplate.hxx"
#include "iseForegroundBackgroundClassifier.hpp"

/**
 * a fg/bg classifier which class as background the region(s) which has interior neighboors
 * and foreground the other regions
 *
 * This classifier is suitable for EnclosingShapes were the inclusion between the shapes has
 * previously been solved, ie. merging by union or aggregation:
 * ASSUME ONLY 1 REGION HAS INTERIOR NEIGHBOURS
 *
 */
namespace ise
{

  class GIRL_API ForegroundBackgroundClassifierHoles : public ForegroundBackgroundClassifier
  {
  public:
    explicit ForegroundBackgroundClassifierHoles(ise::SegmentationContext *segContext) :
      ForegroundBackgroundClassifier(segContext) {}
    virtual
    ~ForegroundBackgroundClassifierHoles() {}

    virtual void
    classify(const girl::regionDeque &input, girl::regionDeque &foreground, girl::regionDeque &background);
  };

  typedef FactoryTemplate<ForegroundBackgroundClassifier, ForegroundBackgroundClassifierHoles> ForegroundBackgroundClassifierHolesFactory;

}

#endif /* ISEFOREGROUNDBACKGROUNDCLASSIFIERHOLES_HPP_ */
