#ifndef ISEGRAYLEVELCOOCCURRENCEMATRIX_HPP
#define ISEGRAYLEVELCOOCCURRENCEMATRIX_HPP

#include "iseSegmentationContext.hpp"
#include <girlTools/girlToolsRegionInfos.hpp>
#include "iseImageLabelToger.hpp"
#include <girlTools/girlToolsImageFeature.hpp>
//1
//typedef enum orientationGLCM { D0, D45, D135, D90 } OrientationGLCM;

//2
typedef enum orientationGLCM { D0, D90, D180, D270 } OrientationGLCM;

//1
// const int dir[4][2][2] = { 
 //  { {-1, 0}, {1, 0} },
 //  { {-1, -1}, {1, 1} },
 //  { {-1, 1}, {1, -1} },
 //  { {0, -1}, {0, 1} } 
 //  };

// const int dir[4][2] = { 
//   { 1,  0} ,
//   { 1, -1},
//   {-1, -1},
//   { 0, -1}
// };

//2
const int dir[4][2] = { 
   {1, 0} ,
   {0, 1} ,
   {-1, 0} ,
   {0, -1} 
}; 


namespace ise{
  class GIRL_API GrayLevelCooccurrenceMatrix{
  public:
    explicit GrayLevelCooccurrenceMatrix(ise::SegmentationContext *segC = NULL);

    void clear();

    void compute(const girl::region &id, OrientationGLCM orientation);

    double energy() const;double entropy() const;

    double mean() const;

    double stdd() const;

    double sumEntropy() const;
    
    double diffEntropy() const;

  private:
    ise::SegmentationContext *m_segC;

    ise::ImageLabelToger m_imageLabel;

    girl::shared_ptr<girl::tools::ImageFeature> m_img;

    std::vector<double> m_values;
    std::vector<int> m_ind;

    double m_m1;
    double m_m2;
  };
}

#endif /* !  ISEGRAYLEVELCOOCCURRENCEMATRIX_HPP */
