/*
  3D Histogram base class.
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISEHISTOGRAM_HPP
#define ISEHISTOGRAM_HPP

#include "iseHistogramIterator.hpp"

namespace ise {

  class GIRL_API Histogram
  {
  public:  
    
    virtual ~Histogram() {}
    
    virtual void addColor(unsigned char r, 
			  unsigned char g,
			  unsigned char b) = 0;
    
    virtual int getSize() const = 0;
    
    virtual void clear() = 0;
    
    virtual HistogramIterator *getIterator() = 0;
    
  };

}

#endif /* ! ISEHISTOGRAM_HPP */
