/*
  3D Histogram iterator base class.
  Copyright (C) 2005-2009 Jean-Philippe Domenger, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISEHISTOGRAMITERATOR_HPP
#define ISEHISTOGRAMITERATOR_HPP

#include "iseHistoInfo.hpp"

namespace ise {

  class GIRL_API HistogramIterator 
  {
  public:
    
    virtual ~HistogramIterator() {}
    
    virtual void get(HistoInfo *info) = 0;
    
    virtual void begin() = 0;
    
    virtual void next() = 0;
    
    virtual bool atEnd() = 0;
    
  };

}

#endif /* ! ISEHISTOGRAMITERATOR_HPP */
