/*
  Copyright (C) 2005-2010 Vieux Remi, Roigt Julian, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISEIMAGEFEATURETEXTON_HPP
#define ISEIMAGEFEATURETEXTON_HPP

#include <girl/girlCommon.hpp>
#include <girlTools/girlToolsImageFeature.hpp>

#include "iseFactoryTemplate.hxx"
#include "iseImageFeatureTextureComputer.hpp"
#include "iseSegmentationContext.hpp"

namespace ise {

  class GIRL_API ImageFeatureTexton : public ise::ImageFeatureTextureComputer
  {
  public:

    explicit ImageFeatureTexton(ise::SegmentationContext *segC);
    
    virtual ~ImageFeatureTexton()
    {
    }

    virtual void compute();
    
    virtual void setParameters(int windowSize);

    virtual void getParameters(int &windowSize) const;

    virtual const std::string uri() const;

    virtual const std::string baseUri() const;

    void
    getDimDescription(std::vector<std::string> &dimDesc) const;

    size_t
    getFeatureDim() const { return m_windowSize * m_windowSize; }

    void
    getRequiredComputers(FeatureComputer::FeatureComputerListType &) const
    {
    }


  private:
    ImageFeatureTexton(const ImageFeatureTexton&);
    ImageFeatureTexton &operator=(const ImageFeatureTexton&);
    
  private:
    
    int m_windowSize;
  };

  typedef FactoryTemplate<ImageFeatureComputer, ImageFeatureTexton> ImageFeatureTextonFactory;
}
#endif /* ! ISEIMAGEFEATURETEXTON_HPP */
