/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

/**
 * Interface for all classes implementing a kernel functions
 */
#ifndef ISEKERNELFUNCTION_HPP_
#define ISEKERNELFUNCTION_HPP_

#include <girl/girlCommon.hpp>

namespace ise
{
  template <typename T>
  class GIRL_API KernelFunction
  {

  public:

    virtual
    ~KernelFunction() {}

    /**
     * @return the evaluation of kernel function for input vectors
     * @param a, @param @b of dimension @param dim
     */
    virtual double
    operator()(const T* a, const T *b, size_t dim) const = 0;
  };
}


#endif /* ISEKERNELFUNCTION_HPP_ */
