/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "iseNeighbouringRegions.hpp"

namespace ise
{



bool
NeighbouringRegionsList::addNeighbour(girl::region r,
                                      int dist,
                                      NeighbourListType &regs)
{

  Neighbour n(r, dist);
  NeighbourListType::iterator it = regs.find(n);
  if (it == regs.end()) {
    regs.insert(n);
    return true;
  } else {
    if (it->m_dist > dist) {
      regs.erase(it);
      regs.insert(n);
      return true;
    }
    return false;
  }
}

}
