/*
  3D Histogram implemented with OpenCV.
  Copyright (C) 2005-2009 Jean-Philippe Domenger, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISEOPENCVHISTOGRAM_HPP
#define ISEOPENCVHISTOGRAM_HPP

//extern "C" {
#include <opencv2/core/core.hpp>
//}

#include <girl/girlCommon.hpp>

#include "iseAbstractHistogram.hpp"
#include "iseHistogramIterator.hpp"


namespace ise {

  class OpenCVHistogramIterator;

  class GIRL_API OpenCVHistogram : public AbstractHistogram
  {
    
  public:
    
    OpenCVHistogram(unsigned char c1Offset = 0, 
		    unsigned char c2Offset = 0, 
		    unsigned char c3Offset = 0, 
		    CvHistType type = CV_HIST_SPARSE);
 
    ~OpenCVHistogram();

    void addColor(unsigned char r, 
		  unsigned char g,
		  unsigned char b);
    
    void clear();
    
    HistogramIterator * getIterator();

  private:

    OpenCVHistogram(const OpenCVHistogram &);

    OpenCVHistogram &operator=(const OpenCVHistogram &);

  protected:
  
    friend class OpenCVHistogramIterator;

    CvHistogram *m_histoData;

  };

}

#endif /* ! ISEOPENCVHISTOGRAM_HPP */
