/*
  Iterator on 3D Histogram implemented with OpenCV.
  Copyright (C) 2005-2009 Jean-Philippe Domenger, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#include <opencv2/core/core.hpp>

#include "iseOpenCVHistogramIterator.hpp"

using namespace ise;

OpenCVHistogramIterator::OpenCVHistogramIterator(OpenCVHistogram *hist)
  : AbstractHistogramIterator(hist)
{

}


void 
OpenCVHistogramIterator::get(HistoInfo *info)
{
  AbstractHistogramIterator::get(info);  

  //const unsigned int codeColor = (unsigned int)*m_it;
  const int c1 = info->getColor()[0];
  const int c2 = info->getColor()[1];
  const int c3 = info->getColor()[2];
  
  // OpenCV stores rgb channels with gbr order with histograms, so
  // even if we aren't in this color space, we shift the canal order
  const long f = static_cast<long>( cvQueryHistValue_3D(static_cast<OpenCVHistogram *>(m_histo)->m_histoData, c2, c3, c1) );
  info->setFrequency(f);
}
