/*
  Iterator on 3D Histogram implemented with OpenCV.
  Copyright (C) 2005-2009 Jean-Philippe Domenger, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISEOPENCVHISTOGRAMITERATOR_HPP
#define ISEOPENCVHISTOGRAMITERATOR_HPP

#include <girl/girlCommon.hpp>
#include "iseAbstractHistogramIterator.hpp"
#include "iseOpenCVHistogram.hpp"
#include "iseHistoInfo.hpp"

namespace ise {

  class GIRL_API OpenCVHistogramIterator : public AbstractHistogramIterator
  {
    
  public:
    
    explicit OpenCVHistogramIterator(OpenCVHistogram *histo);

    void get(HistoInfo *info);
  };

}


#endif /* ! ISEOPENCVHISTOGRAMITERATOR_HPP */
