/*
  Partition class.
  Copyright (C) 2005-2009 Jean-Philippe Domenger, Achille Braquelaire, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#include <cmath>

#include "isePartition.hpp"

using namespace ise;

Partition::Partition(int *nCluster)
  : nbCluster(0),
    initClus(),
    nbClusAxis(0),
    nbClusSurf(0)
{
  const double nbClus = pow(*nCluster, 1.0 / 3.0);

  nbClusAxis = static_cast<int>(nbClus + 0.5);
  nbClusSurf = nbClusAxis * nbClusAxis; 
  
  *nCluster = nbClusSurf * nbClusAxis;
  this->nbCluster = *nCluster;

  const int lengthAxis = RGB_LENGTH / nbClusAxis;
  int limit = lengthAxis;
  
  int ind = 0;
  for (int i = 0; i < RGB_LENGTH; ++i)
    {
      initClus[i] = ind;
      if ((i > limit) && ((RGB_LENGTH - i) > lengthAxis))
	{
	  ++ind;
	  limit += lengthAxis;
	}
    }  
}
