/*
  Partition class.
  Copyright (C) 2005-2009 Jean-Philippe Domenger, Achille Braquelaire, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISEPARTITION_HPP
#define ISEPARTITION_HPP

#include <girlTools/girlToolsImage.hpp>

#include<map>

//#define RGB_LENGTH 256

namespace ise {

  class Partition
  {
  public:
    
    explicit Partition(int *nbCcluster);

    inline int getClusterIndex (const girl::tools::Pixel &C) //const 
    { 
      return (initClus[C[0]] + nbClusAxis * initClus[C[1]] + nbClusSurf * initClus[C[2]] ); 
    };

    inline int getNbCluster() const { return nbCluster; }

  protected:
    static const int RGB_LENGTH = sizeof(girl::tools::Image::type); //256;
  
    int nbCluster;
    //int initClus[RGB_LENGTH];
    std::map<const girl::tools::Image::type, int> initClus;
    int nbClusAxis;
    int nbClusSurf;
  
  };

}


#endif /* ISEPARTITION_HPP */
