/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef ISEPIXELLIST_HPP_
#define ISEPIXELLIST_HPP_

#include <opencv2/core/core.hpp>

#include <girl/girlToger.hpp>


namespace ise {
  /**
   * Utility class, give the coordinates of each pixel belonging to the region
   *
   */
  class GIRL_API PixelList : public girl::toger::pointIterator
  {
  public:
    explicit PixelList(std::vector<cv::Point> &pixels) : m_pixels(pixels) {}
    virtual ~PixelList() {}

    virtual void processPoint(const girl::point &p) {
      m_pixels.push_back(cv::Point(p.x(), p.y()));
    }
  protected:
    std::vector<cv::Point> &m_pixels;
  };

}
#endif /* ISEPIXELLIST_HPP_ */
