/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef ISEREGIONBINARYFUNCTIONWITHREGSETHISTOGRAMINTERSECTIONDISTANCE_HPP_
#define ISEREGIONBINARYFUNCTIONWITHREGSETHISTOGRAMINTERSECTIONDISTANCE_HPP_

#include <girl/girlCommon.hpp>


#include "iseFactoryTemplate.hxx"
#include "iseRegionBinaryFunctionWithRegSet.hpp"
/**
 * Return the Histogram Intersection distance between the region feature
 * (cf flann dist.h)
 *
 */

namespace ise {
  class GIRL_API RegionBinaryFunctionWithRegSetHistogramIntersectionDistance :
public RegionBinaryFunctionWithRegSet
{
public:

  /**
   * Constructor
   */
  explicit RegionBinaryFunctionWithRegSetHistogramIntersectionDistance(ise::SegmentationContext *segContext)
  : RegionBinaryFunctionWithRegSet(segContext) {}

  virtual
  ~RegionBinaryFunctionWithRegSetHistogramIntersectionDistance() {}

  result_type
  operator()(const first_argument_type & reg1,
      const second_argument_type& reg2);

  //    /**
  //     * Get parameters associated with the regset
  //     */
  //    void
  //    getParameters(girl::shared_ptr<RegionSetInterface> regSet,
  //        RegionSetParameters &regSetParameters) const
  //    {
  //      regSet = m_regSet;
  //      regSetParameters = m_regSetParameters;
  //    }
  //
  //
  //    /**
  //     * Set parameters associated with the regset
  //     */
  //    void
  //    setParameters(const girl::shared_ptr<RegionSetInterface> regSet,
  //        const RegionSetParameters& regSetParameters)
  //    {
  //      assert(regSetParameters.getDimWeights().size() == regSet->getFeatureDim());
  //      m_regSet = regSet;
  //      m_regSetParameters = regSetParameters;
  //    }
  //
  //    class RegionSetBinaryFunctionHistogramIntersectionDistanceMemento : public RegionSetBinaryFunctionWeighted::RegionSetBinaryFunctionWeightedMemento
  //    {
  //    public:
  //      RegionSetBinaryFunctionHistogramIntersectionDistanceMemento() {}
  //
  //    protected:
  //      virtual void
  //      getParameters(const Mementable &m)
  //      {
  //        const RegionBinaryFunctionWithRegSetHistogramIntersectionDistance& rs
  //        = reinterpret_cast<const RegionBinaryFunctionWithRegSetHistogramIntersectionDistance&>(m);
  //        RegionSetBinaryFunctionWeightedMemento::getParameters(rs);
  //      }
  //      virtual void
  //      setParameters(Mementable &m)
  //      {
  //        RegionBinaryFunctionWithRegSetHistogramIntersectionDistance& rs
  //        = reinterpret_cast<RegionBinaryFunctionWithRegSetHistogramIntersectionDistance&>(m);
  //        RegionSetBinaryFunctionWeightedMemento::setParameters(rs);
  //      }
  //
  //    };
  //
  //    protected:
  //
  //    virtual RegionBinaryFunctionMemento* createMemento() const
  //    {
  //      return new RegionSetBinaryFunctionHistogramIntersectionDistanceMemento;
  //    }
  //
  //    virtual RegionBinaryFunction::result_type operator_aux(const double *wrf1, const double *wrf2, size_t featureDim)
  //    {
  //      return cvflann::hist_intersection_dist_sq(wrf1, wrf1 + featureDim, wrf2);
  //    }

};

typedef FactoryTemplate<RegionBinaryFunction, RegionBinaryFunctionWithRegSetHistogramIntersectionDistance> RegionBinaryFunctionWithRegSetHistogramIntersectionDistanceFactory;

}
#endif /* ISEREGIONBINARYFUNCTIONWITHREGSETHISTOGRAMINTERSECTIONDISTANCE_HPP_ */
