/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
 * iseRegionFeatureColorimetricMoment.hpp
 *
 *  Created on: Aug 24, 2010
 *      Author: vieux
 */

#ifndef ISEREGIONFEATURECOLORIMETRICMOMENT_HPP_
#define ISEREGIONFEATURECOLORIMETRICMOMENT_HPP_

#include <typeinfo>

#include <girlTools/girlToolsImage.hpp>

#include "iseRegionFeatureComputer.hpp"
#include "iseSegmentationContext.hpp"

namespace ise
{

#define COLORIMETRIC_MOMENTS_FEATURE_SIZE 7

  class GIRL_API RegionFeatureColorimetricMoment : public ise::RegionFeatureComputer
  {
  public:

    RegionFeatureColorimetricMoment(ise::SegmentationContext *segContext, int colorspace = ISE_RGB_to_RGB);

    virtual
    ~RegionFeatureColorimetricMoment();

    const std::string uri() const;
    //{ return typeid(*this).name(); }

    inline size_t size() const { return COLORIMETRIC_MOMENTS_FEATURE_SIZE; }

    virtual RegionFeature *compute(const girl::toger &tog, girl::region id);

    bool mergeFeatures(RegionFeature *keptFeatures, RegionFeature* delFeatures);

    inline virtual void setParameters(int colorSpace) { m_colorSpace = colorSpace; }

    inline virtual void getParameters(int &colorSpace) const
    { colorSpace = m_colorSpace; }

  protected:

    int m_colorSpace;
  };

}

#endif /* ISEREGIONFEATURECOLORIMETRICMOMENT_HPP_ */
