/*
 * iseRegionFeatureComputerGravityCenter.cpp
 *
 *  Created on: Oct 15, 2010
 *      Author: vieux
 */

#include "iseRegionFeatureComputerGravityCenter.hpp"
#include "iseSegmentationContext.hpp"

namespace ise
{

  void
  RegionFeatureComputerGravityCenter::compute(const girl::region& id, ise::RegionFeature &feature)
  {
    m_x = m_y = m_area = 0;
    assert(m_segContext);
    assert(m_segContext->getToger());
    m_segContext->getToger()->iterateOnRegionDomain(id, *this);
    assert(m_area);
    //RegionFeature *result = allocate(RegionFeatureComputerGravityCenter::FEATURE_SIZE);
    //    (*result)[0] = m_x/m_area;
    //    (*result)[1] = m_y/m_area;
    feature[0] = m_x/m_area;
    feature[1] = m_y/m_area;
  }

  void
  RegionFeatureComputerGravityCenter::mergeFeatures(RegionFeature &kept, RegionFeature &del, const girl::region&)
  {
    kept[2] += del[2];
    kept[0] = (kept[0] + del[0])/kept[3];
    kept[1] = (kept[1] + del[1])/kept[3];
  }

  void
  RegionFeatureComputerGravityCenter::processPoint(const girl::point &pt)
  {
    ++m_area;
    m_x += pt.x();
    m_y += pt.y();
  }
}
