/*
 * iseRegionFeatureNeedBinarization.cpp
 *
 *  Created on: Sep 7, 2010
 *      Author: vieux
 */

#include "iseRegionFeatureNeedBinarization.hpp"
#include "iseSegmentationContext.hpp"

namespace ise
{

  RegionFeature *
  RegionFeatureNeedBinarization::compute(const girl::toger &tog, girl::region id)
  {
    if (!m_binaryImage.data) {
      const cv::Mat *mat = m_segContext->getImage()->getCvMat();
      cv::Mat mat8u;
      cv::convertScaleAbs(*mat, mat8u);
      cv::Mat gray;
      cv::cvtColor(mat8u, gray, CV_RGB2GRAY);
      cv::threshold(gray, m_binaryImage, 0, 255, cv::THRESH_BINARY|cv::THRESH_OTSU);
    }

    return computeImpl(tog, id);
  }

}
