#ifndef ISEREGIONPROFILECOMPUTER_HPP
#define ISEREGIONPROFILECOMPUTER_HPP

#include <girl/girlToger.hpp>

#include <girlTools/girlToolsImageFeature.hpp>
#include <girlTools/girlToolsRegionInfos.hpp>


#include "iseHistogram1D.hpp"
#include "iseSegmentationContext.hpp"

namespace ise {
class GIRL_API RegionProfileComputer : public girl::toger::pointIterator
{
public:
 RegionProfileComputer(ise::SegmentationContext *segContext,
		       /*  ise::Histogram1D& profileHoriz,
			   ise::Histogram1D& profileVerti,*/
                       int colorSpace = ISE_RGB_to_GRAY);

 ~RegionProfileComputer() {
   delete m_profileHoriz;
   delete m_profileVerti;
}

 void
 computeProfile(const girl::regionDeque& regs);

 void
 processPoint(const girl::point &);

private:

 ise::SegmentationContext *m_segContext;
 girl::shared_ptr<girl::tools::ImageFeature> m_imageFeaturePtr;
 ise::Histogram1D *m_profileHoriz;
 ise::Histogram1D *m_profileVerti;

 std::vector<size_t> m_countHoriz;
 std::vector<size_t> m_countVerti;

 girl::tools::AABBox m_box;
 int m_colorSpace;

};

}
#endif // ISEREGIONPROFILECOMPUTER_HPP
