/*
  Copyright (C) 2005-2012 Jean-Philippe Domenger, Boris Mansencal, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef ISEREGIONSETINTERFACEBOUNDINGBOX_HPP_
#define ISEREGIONSETINTERFACEBOUNDINGBOX_HPP_

#include <girl/girlCommon.hpp>
#include <girl/girlSharedPtr.hpp> //?

#include "iseRegionSetInterface.hpp"



namespace ise {


  /**
   * 
   */
  class GIRL_API RegionSetInterfaceBoundingBox : public RegionSetInterface
  {

  public:

    static const int FEATURE_DIMENSION = 8;
    static const RegionSetInterface::CacheType DEFAULT_CACHE_STRATEGY = RegionSetInterface::LAZY;

    enum {X_COORD_TOP_LEFT_CORNER=0,
	  Y_COORD_TOP_LEFT_CORNER,
	  BB_WIDTH,
	  BB_HEIGHT,
	  RATIO_WIDTH_HEIGHT,
	  RATIO_MAX_MIN,
	  DIAGONAL_SQUARE,
	  AREA};

  public:
    RegionSetInterfaceBoundingBox(ise::SegmentationContext* segContext,
        ise::RegionSetInterface::CacheType cacheType = DEFAULT_CACHE_STRATEGY);

    virtual
    ~RegionSetInterfaceBoundingBox();

    const URI
    uri() const;

    size_t
    getFeatureDim() const;

    void
    getDimDescription(std::vector<std::string>& dimDesc) const;

    void
    getRequiredComputers(FeatureComputerListType &) const {}

    const std::string
    help() const;

  protected:

    void
    compute(const girl::region& id, ise::RegionFeature& feature);

    void
    mergeFeatures(RegionFeature& kept, RegionFeature& del,
        const girl::region& keptId, const girl::region& delId);

  private:

  };

}
#endif /* ISEREGIONSETINTERFACEBOUNDINGBOX_HPP_ */


