/*
Copyright (C) 2004-2010 Boris Mansencal  boris.mansencal@labri.fr

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "iseRegionSetInterface.hpp"

#ifndef ISEREGIONSETINTERFACECONTOURORIENTATIONHISTOGRAM_HPP
#define ISEREGIONSETINTERFACECONTOURORIENTATIONHISTOGRAM_HPP


#include <girl/girlCommon.hpp>

#include "iseRegionSetInterface.hpp"

namespace ise {




class GIRL_API RegionSetInterfaceContourOrientationHistogram : public ise::RegionSetInterface
{
 static const RegionSetInterface::CacheType DEFAULT_CACHE_STRATEGY = RegionSetInterface::LAZY;
 static const size_t DEFAULT_NUM_BINS = 36;
public:
 explicit RegionSetInterfaceContourOrientationHistogram(ise::SegmentationContext* segContext);

 virtual
 ~RegionSetInterfaceContourOrientationHistogram();

 const URI
 uri() const;

 size_t
 getFeatureDim() const;

 void
 getDimDescription(std::vector<std::string> &dimDesc) const;

 void
 getRequiredComputers(FeatureComputerListType &computers) const;

 const std::string
 help() const;

protected:

 void
 compute(const girl::region &id, ise::RegionFeature &feature);

 void
 mergeFeatures(RegionFeature &keptFeatures, RegionFeature &delFeatures, const girl::region &keptId, const girl::region &delId);


protected:

 size_t m_numBins;

};
}

#endif // ISEREGIONSETINTERFACECONTOURORIENTATIONHISTOGRAM_HPP
