/*
 * iseRegionSetInterfaceImplFactory.cpp
 *
 *  Created on: Oct 6, 2010
 *      Author: vieux
 */

#include "iseRegionSetInterfaceImplFactory.hpp"

#include "iseRegionSetFactoryHandler.hpp"
#include "iseRegionSetInterfaceImpl.hpp"

#include <girl/girlSharedPtr.hpp>

namespace ise
{

  static RegionSetInterfaceImplFactory *regionSetInterfaceImplFactory = RegionSetInterfaceImplFactory::instance();


  RegionSetInterfaceImplFactory*
  RegionSetInterfaceImplFactory::instance()
  {
    static RegionSetInterfaceImplFactory* fac = NULL;
    if (fac == NULL) {
      fac = new RegionSetInterfaceImplFactory();
    }
    return fac;
  }

  girl::shared_ptr<RegionSetInterface>
  RegionSetInterfaceImplFactory::newRegionSet(girl::shared_ptr<RegionFeatureComputer> featureComputer)
  {
    girl::shared_ptr<RegionSetInterface> result(new RegionSetInterfaceImpl(featureComputer));
    //    girl::shared_ptr<T> result(new RegionSetInterfaceImpl(featureComputer));
    // RegionSetInterface result = new RegionSetInterfaceImpl(featureComputer);
    return result;
  }

  const std::string
  RegionSetInterfaceImplFactory::uri() const
  {
    return ise::RegionSetInterfaceImpl::type();
  }

  RegionSetInterfaceImplFactory::RegionSetInterfaceImplFactory()
  {
    RegionSetFactoryHandler::instance()->addFactory(this);
  }

}
