/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef ISEREGIONSETINTERFACELOCALBINARYPATTERNS_HPP_
#define ISEREGIONSETINTERFACELOCALBINARYPATTERNS_HPP_

#include <girl/girlCommon.hpp>
#include <girl/girlToger.hpp>

#include "iseImageFeatureLocalBinaryPatterns.hpp"
#include "iseRegionSetInterface.hpp"
/*
 *
 */
namespace ise
{

  class GIRL_API RegionSetInterfaceLocalBinaryPatterns : public RegionSetInterface,
  public girl::toger::pointIterator
  {


    typedef girl::shared_ptr<ise::ImageFeatureLocalBinaryPatterns> LbpImagePtr;

  public:
    explicit RegionSetInterfaceLocalBinaryPatterns(ise::SegmentationContext *segContext);
    virtual
    ~RegionSetInterfaceLocalBinaryPatterns();

    const std::string
    uri() const;

    size_t
    getFeatureDim() const;


    void
    getDimDescription(std::vector<std::string>& dimDesc) const;

    void
    setParameters(LbpImagePtr regSetMoment);

    void
    getRequiredComputers(FeatureComputerListType &) const;

    const std::string
    help() const;

  protected:

    void
    processPoint(const girl::point &);

    void
    compute(const girl::region& id, ise::RegionFeature& feature);

    void
    mergeFeatures(RegionFeature& kept,
        RegionFeature& del,
        const girl::region& keptId,
        const girl::region& delId);

  protected:

    LbpImagePtr m_lbpImage;

    RegionFeature_Data_Type *m_buffer;

    size_t m_area;

  };

}

#endif /* ISEREGIONSETINTERFACELOCALBINARYPATTERNS_HPP_ */
