#ifndef ISEREGIONSETINTERFACERELAXATION_HPP
#define ISEREGIONSETINTERFACERELAXATION_HPP

#include "iseRegionSetInterface.hpp"

namespace ise
{


class GIRL_API RegionSetInterfaceRelaxation : public RegionSetInterface
{

public:

    static const FeatureComputer::CacheType DEFAULT_CACHE_STRATEGY = ise::FeatureComputer::ALWAYS;

public:
    RegionSetInterfaceRelaxation(ise::SegmentationContext* segContext,
                                 ise::RegionSetInterface::CacheType cacheType = DEFAULT_CACHE_STRATEGY);

    ~RegionSetInterfaceRelaxation();

    const std::string
    uri() const;

    size_t
    getFeatureDim() const;

    void
    getDimDescription(std::vector<std::string> &dimDesc) const;

    void
    setParameters(const girl::shared_ptr<ise::RegionSetInterface> &ptr);

    void
    getParameters(girl::shared_ptr<ise::RegionSetInterface> &ptr);

    void
    getRequiredComputers(FeatureComputerListType&) const;

    const std::string
    help() const;

    void
    compute();

  protected:
    void
    compute(const girl::region &id, ise::RegionFeature &feature);

    void
    mergeFeatures(RegionFeature& kept,
        RegionFeature& del,
        const girl::region& keptId,
        const girl::region& delId);


protected:

    girl::shared_ptr<ise::RegionSetInterface> m_probInit;
    cv::Mat m_probFinal;
};

}
#endif // ISEREGIONSETINTERFACERELAXATION_HPP
