/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

/*
 * RegionSetInterfaceViewArea.cpp
 *
 *  Created on: Nov 15, 2010
 *      Author: vieux
 */


#include <iostream>
#include <sstream>

#include "iseRegionSetInterfaceViewArea.hpp"

namespace ise
{

  const URI
  RegionSetInterfaceViewArea::uri() const
  {
    std::stringstream ss(std::ios::in|std::ios::out);
    ss << __FILE__ << "_" << m_regSet->uri();
    return ss.str();
  }

  void
  RegionSetInterfaceViewArea::getRegionFeatures(const girl::region &id, RegionFeature& rf) const
  {
    // REMI: TODO:OPTIM do not create an object at each call but use a class member ?
    RegionFeature moments(m_regSet->getFeatureDim());
    m_regSet->getRegionFeatures(id, moments);
    rf[0] = moments[0];
  }

  void
  checkAllRegions()
  {
    // REMI TODO:UNSURE, how can we iterate through the regions when we don't
    // store them ?
    std::cerr << "REMI TODO:UNSURE, how can we iterate through the regions when we don't store them" << __FILE__ << std::endl;
  }

}
