/*
 * iseRegionSetStatisticalFactory.cpp
 *
 *  Created on: Oct 6, 2010
 *      Author: vieux
 */

#include "iseRegionSetStatisticalFactory.hpp"

#include "iseRegionSetFactoryHandler.hpp"
#include "iseRegionSetInterfaceImplFactory.hpp"
#include "iseRegionSetStatistical.hpp"

namespace ise
{
  static RegionSetStatisticalFactory *regionSetStatisticalFactory = RegionSetStatisticalFactory::instance();



  RegionSetStatisticalFactory*
  RegionSetStatisticalFactory::instance()
  {
    static RegionSetStatisticalFactory* fac = NULL;
    if (fac == NULL) {
      fac = new RegionSetStatisticalFactory();
    }
    return fac;
  }


  girl::shared_ptr<RegionSetInterface>
  RegionSetStatisticalFactory::newRegionSet(girl::shared_ptr<RegionFeatureComputer> featureComputer)
  {
    girl::shared_ptr<RegionSetInterface> result
      (RegionSetInterfaceImplFactory::instance()->newRegionSet(featureComputer));
    return result;
  }
  
  const std::string
  RegionSetStatisticalFactory::uri() const
  {
    return ise::RegionSetStatistical::type();
  }

  RegionSetStatisticalFactory::RegionSetStatisticalFactory()
  {
    RegionSetFactoryHandler::instance()->addFactory(this);
  }
}
