#include "iseRegionUnaryFunctionWithRegSetIndexOfMax.hpp"

#include <limits>

namespace ise
{
  RegionUnaryFunction::result_type
  RegionUnaryFunctionWithRegSetIndexOfMax:: operator()(const RegionUnaryFunction::argument_type &regId)
    
  {
    assert(m_memory.size() == m_regSet->getFeatureDim());
    RegionFeature rf(&m_memory[0]);
    m_regSet->getRegionFeatures(regId, rf);
    RegionFeature_Data_Type max = -std::numeric_limits<RegionFeature_Data_Type>::max();
    int maxIndex = 0;
    for (size_t i = 0; i < m_regSet->getFeatureDim(); ++i) {
        if (rf[i] > max) {
            max = rf[i];
            maxIndex = i;
        }
    }
    return maxIndex;
  }
  
}
