/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef ISEREGIONUNARYFUNCTIONWITHREGSETINDEXOFMAX_HPP_
#define ISEREGIONUNARYFUNCTIONWITHREGSETINDEXOFMAX_HPP_

#include <girl/girlCommon.hpp>

#include "iseFactoryTemplate.hxx"
#include "iseRegionUnaryFunctionWithRegSet.hpp"

namespace ise {

  /**
   * IndexOfMax function: returns the value of the feature vector at the
   * index specified
   */

  class GIRL_API RegionUnaryFunctionWithRegSetIndexOfMax : public RegionUnaryFunctionWithRegSet
  {

  public:

    /**
     * Constructor
     * @param regSet, the RegionSet this object is bound to
     * @param index, the index of the channel of the region set to return
     */
    explicit RegionUnaryFunctionWithRegSetIndexOfMax(ise::SegmentationContext *segContext)
      : RegionUnaryFunctionWithRegSet(segContext)
	{}
    
    ~RegionUnaryFunctionWithRegSetIndexOfMax() {}
    
    /**
     * Return the i^th component of the feature vector
     */
    RegionUnaryFunction::result_type
      operator()(const RegionUnaryFunction::argument_type &regId);
    /**
     * @return index of the returned value
     */
    void getParameters(RegionUnaryFunctionWithRegSet::RegSetPtr regSet) const
    {
      RegionUnaryFunctionWithRegSet::getParameters(regSet);
    }

    /**
     * @param index: index of the returned value
     */
    void setParameters(RegionUnaryFunctionWithRegSet::RegSetPtr regSet)
    {
      RegionUnaryFunctionWithRegSet::setParameters(regSet);
    }


    protected:

  };

  typedef FactoryTemplate<RegionUnaryFunction, RegionUnaryFunctionWithRegSetIndexOfMax> RegionUnaryFunctionWithRegSetIndexOfMaxFactory;

}
#endif /* ISEREGIONUNARYFUNCTIONWITHREGSETINDEXOFMAX_HPP_ */
