#ifndef ISESEGMENTATIONCLUSTERINGBITMAP_HPP
#define ISESEGMENTATIONCLUSTERINGBITMAP_HPP

#include "iseSegmentationClustering.hpp"

#include <opencv2/core/core.hpp>


namespace ise
{
class GIRL_API SegmentationClusteringBitmap : public SegmentationClustering
{
public:
    explicit SegmentationClusteringBitmap(SegmentationContext *segContext);

    ~SegmentationClusteringBitmap() {}

    virtual void init(const girl::regionDeque &, int) {
   //   assert(m_mat.type() == CV_8U);
      assert(m_mat.data != NULL);
      assert(m_mat.isContinuous());
    }

    virtual void init(girl::region , int ) {
  //    assert(m_mat.type() == CV_8U);
      assert(m_mat.data != NULL);
      assert(m_mat.isContinuous());
    }

    virtual bool same(const girl::point &p, girl::direction dir);

    void
    setParameters(const cv::Mat &bitMap)
    {
      m_mat = bitMap;
      m_pixSize = m_mat.elemSize();
    }

protected:

    cv::Mat m_mat;
    size_t m_pixSize;
};


}
#endif // ISESEGMENTATIONCLUSTERINGBITMAP_HPP
