/*
  Segmentation clustering for ColorChecker detection.
  Copyright (C) 2012-2013 Jean-Philippe Domenger, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISESEGMENTATIONCLUSTERING_COLORCHECKER_HPP
#define ISESEGMENTATIONCLUSTERING_COLORCHECKER_HPP

#include <opencv2/core/core.hpp>

#include <ise/iseSegmentationClustering.hpp>
#include <ise/iseSegmentationContext.hpp>

namespace ise {


  
  class GIRL_API SegmentationClusteringColorCheckerAux
  {
  public :

    typedef std::map<int, girl::region> CCIndex2RegionMap;

    void process(girl::tools::Image &img, girl::toger &togOut, CCIndex2RegionMap &m);

  protected:
    cv::Mat m_indexMat; //DEBUG//no need to keep it if we have toger.


  //girl::toger m_toger;

  };


  class GIRL_API SegmentationClusteringColorChecker : public SegmentationClustering
  {
  public :
    
    explicit SegmentationClusteringColorChecker(ise::SegmentationContext *segContext);

    virtual void init(const girl::regionDeque &regions, int level=1);

    virtual void init(girl::region r, int level=1);
    
    virtual bool same(const girl::point &p, girl::direction dir);

  protected:

    girl::toger m_toger;


  };

}



#endif /* ! ISESEGMENTATIONCLUSTERING_COLORCHECKER_HPP */

