/*
  Copyright (C) 2005-2011 Remi Vieux, Jean-Philippe Domenger, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISESEGMENTATIONCLUSTERINGDOCUMENTPRESEG_HPP_
#define ISESEGMENTATIONCLUSTERINGDOCUMENTPRESEG_HPP_

#include <girl/girlToger.hpp>
#include <girlTools/girlToolsImage.hpp>
#include <ise/iseSegmentationClustering.hpp>
#include <ise/iseSegmentationContext.hpp>

/*
 *
 */
namespace ise
{

  class SegmentationContext;

  class GIRL_API SegmentationClusteringDocumentPreseg : public SegmentationClustering
  {

  public:

    static const size_t DEFAULT_AREA_THRESHOLD = 10;
    static const double DEFAULT_RATIO_THRESHOLD;
    static const double DEFAULT_COMPACITY_THRESHOLD;

  public:
    explicit SegmentationClusteringDocumentPreseg(SegmentationContext *segContext);
    virtual
    ~SegmentationClusteringDocumentPreseg();

    void
    setParameters(size_t areaThreshold, double axisRatioThreshold, double compacityThreshold);

    void
    getParameters(size_t &areaThreshold, double &axisRatioThreshold, double &compacityThreshold);

    void
    init(const girl::regionDeque &regs, int level = 1);

    void
    init(girl::region, int);

    bool
    same(const girl::point&, girl::direction);


  protected:

    void
    applyOtsu(const girl::region, girl::regionDeque &createdRegions);

    bool
    getRegionsByAxisRatioOrCompacity(const girl::regionDeque &toCheck, girl::regionDeque &selected);

    void
    mergeRegionsByAxisRatioOrCompacity(girl::regionDeque &regs);

//    bool
//    getRegionsByCompacity(const girl::regionDeque &tocheck, girl::regionDeque &selected);
//
//    void
//    mergeRegionsByCompacity();

    void
    applyWord();

    void
    applyWhiteSpace(const girl::region reg, girl::regionDeque &createdRegions);


  protected:

    double m_areaThreshold;
    double m_axisRatioThreshold;
    double m_compacityThreshold;

    girl::tools::Image m_image;

    girl::toger m_toger;
    ise::SegmentationContext m_segContext2;

    girl::toger m_togerEnclosingShapes;
    girl::toger m_togerWord;

  };

}

#endif /* ISESEGMENTATIONCLUSTERINGDOCUMENTPRESEG_HPP_ */
