/*
 * iseSegmentationClusteringFelzenswalb.hpp
 *
 *  Created on: Nov 4, 2013
 *      Author: remi
 */

#ifndef ISESEGMENTATIONCLUSTERINGFELZENSWALB_HPP_
#define ISESEGMENTATIONCLUSTERINGFELZENSWALB_HPP_

#include <girl/girlCommon.hpp>


#include "iseSegmentationClustering.hpp"
#include "iseImageFeatureComputer.hpp"
#include "segment-graph.h"

namespace ise
{

 
  class GIRL_API SegmentationClusteringFelzenswalb : public SegmentationClustering
  {
  public:
    typedef enum FelzGraphType {
      GRID_4_CONNEX,
      GRID_8_CONNEX,
      KNN
    } FelzGraphType;

    static float DEFAULT_SIGMA;
    static float DEFAULT_K;
    static int DEFAULT_MIN_AREA;
    static FelzGraphType DEFAULT_GRAPH_TYPE;

    explicit SegmentationClusteringFelzenswalb(SegmentationContext *segContext);

    virtual
    ~SegmentationClusteringFelzenswalb();

    virtual void init(const girl::regionDeque &regions, int level);

    virtual void init(girl::region r, int level);

    void setParameters(float sigma, float k, int minArea, ise::ImageFeatureComputerPtr algo, FelzGraphType graphType);

    void getParameters(float &sigma, float &k, int &minArea, ise::ImageFeatureComputerPtr &algo, FelzGraphType &graphType) const;

  protected:

    virtual bool same(const girl::point &p, const girl::direction dir);

  private:

    SegmentationClusteringFelzenswalb(const SegmentationClusteringFelzenswalb&);
    SegmentationClusteringFelzenswalb& operator=(const SegmentationClusteringFelzenswalb&);

  private:

    void computeGraph();

    void doSeg();

  protected:
    float m_sigma;
    float m_k;
    int m_minArea;
    FelzGraphType m_graphType;
    ise::ImageFeatureComputerPtr m_imageFeature;

  private:
    std::vector<edge> m_edges;
    universe *m_universe;

  };

} /* namespace ise */
#endif /* ISESEGMENTATIONCLUSTERINGFELZENSWALB_HPP_ */
