/*
  Quantification non uniform of colors.
  Copyright (C) 2005-2011 Julian Roigt  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "iseSegmentationClusteringLocalThresholds.hpp"

using namespace ise;

SegmentationClusteringLocalThresholds::SegmentationClusteringLocalThresholds(SegmentationContext *segContext)
  : 
  SegmentationClustering(segContext),
  m_activeThresholder()
{
  
}

void
SegmentationClusteringLocalThresholds::init(const girl::regionDeque &regions, int /* level */)
{
  m_activeThresholder->init(m_segContext, regions);
}

void
SegmentationClusteringLocalThresholds::setParams(girl::shared_ptr<ise::SegmentationClusteringLocalThresholder> activeThresholder)
{
  m_activeThresholder = activeThresholder;
}

void
SegmentationClusteringLocalThresholds::getParams(girl::shared_ptr<ise::SegmentationClusteringLocalThresholder> &activeThresholder) const
{
  activeThresholder = m_activeThresholder;
}
    



bool
SegmentationClusteringLocalThresholds::same(const girl::point &p1, girl::direction dir)
{
  girl::point p2 = p1;
  p2.move(dir);
  
  if ( m_activeThresholder )
    return m_activeThresholder->areEquivalentColor(p1, p2);
  else
    return true;
}
