/*
  Quantification non uniform of colors.
  Copyright (C) 2005-2011 Julian Roigt  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

/**
 * @file iseSegmentationClusteringLocalThresholds.hpp
 * @brief non uniform of colors.
 */
#ifndef ISESEGMENTATIONCLUSTERINGLOCALTHRESHOLDS_HPP
#define ISESEGMENTATIONCLUSTERINGLOCALTHRESHOLDS_HPP

#include <vector>
#include <girl/girlCommon.hpp>
#include <ise/iseConversion.hpp>

#include <ise/iseSegmentationClustering.hpp>
#include <ise/iseSegmentationClusteringLocalThresholder.hpp>

namespace ise {

  class GIRL_API SegmentationClusteringLocalThresholds : public SegmentationClustering
  {
  public:
    
    explicit SegmentationClusteringLocalThresholds(SegmentationContext *segContext);

    void setParams(girl::shared_ptr<ise::SegmentationClusteringLocalThresholder> activeThresholder);

    void getParams( girl::shared_ptr<ise::SegmentationClusteringLocalThresholder> &activeThresholder) const;
    


    virtual void init(const girl::regionDeque  &/* regions */, int /* level */);

    virtual void init(girl::region /* r */, int /* level */) {}

  protected:

    virtual bool same(const girl::point &p1, girl::direction dir);

  protected:

    girl::shared_ptr<ise::SegmentationClusteringLocalThresholder> m_activeThresholder;
  };
    

}

#endif /* ! ISESEGMENTATIONCLUSTERINGLOCALTHRESHOLDS_HPP */
