/*
  Copyright (C) 2005-2009 Jean-Philippe Domenger, Achille Braquelaire, Boris Mansencal  boris.mansencal@labri.fr

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef ISESEGMENTATIONCLUSTERINGMEANSHIFT_HPP
#define ISESEGMENTATIONCLUSTERINGMEANSHIFT_HPP


#include <girl/girlCommon.hpp>

#include "iseConversion.hpp"
#include "iseSegmentationClustering.hpp"
#include "iseMeanShift.hpp"
#include <cmath>
#include <map>

namespace ise {

  class GIRL_API SegmentationClusteringMeanShift : public SegmentationClustering
  {
    
  public:

    explicit SegmentationClusteringMeanShift(SegmentationContext *segContext);
    
    virtual ~SegmentationClusteringMeanShift();
  
    virtual void init(const girl::regionDeque &regions, int level);
    
    virtual void init(girl::region r, int level);
    
    virtual void setParameters(std::string imageFeatureUri, float sigmaR);

    virtual void getParameters(std::string &imageFeatureUri, float &sigmaR) const;
    
  protected :
    
    virtual bool same(const girl::point &p1, girl::direction dir);
    
  private:
    SegmentationClusteringMeanShift(const SegmentationClusteringMeanShift &);
    SegmentationClusteringMeanShift &operator=(const SegmentationClusteringMeanShift &);
  
  protected:
    ise::MeanShift m_ms;
    std::map<int, int> m_index;
    std::string m_imageFeatureUri;
    int m_dim;
    int *m_pos;
  };

}

#endif /* ISESEGMENTATIONCLUSTERINGMEANSHIFT_HPP */
