/*
  Copyright (C) 2005-2009 Roigt Julian, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISESEGMENTATIONCLUSTERINGSHAPECC_HPP
#define ISESEGMENTATIONCLUSTERINGSHAPECC_HPP

#include <girl/girlToger.hpp>
#include <girlTools/girlToolsImage.hpp>
#include <ise/iseSegmentationClustering.hpp>
#include "EnclosingShape.hpp"
#include "EnclosingShapeFactory.hpp"

namespace ise {

  // avoid pushing recursively too much matrices, use a global mat with ref counter
  static cv::Mat g_aggregateCCMat;

  class SegmentationContext;
  
  class  GIRL_API SegmentationClusteringShapeCC : public SegmentationClustering
  {
  public :

    explicit SegmentationClusteringShapeCC(SegmentationContext *segContext);
    
    virtual ~SegmentationClusteringShapeCC() {}

    virtual void setSegContext(ise::SegmentationContext *s);

    virtual void setParameters(std::string Shapes);

    virtual void getParameters(std::string &Shapes) const;
    
    virtual void init(const girl::regionDeque &regions, int level=1);

    virtual void init(girl::region /*r*/, int /*level*/) {} 
    
    virtual bool same(const girl::point &p, girl::direction dir);

  protected:

    std::vector<EnclosingShapeFactory::EnclosingShapePtr> aggregateCC(cv::Mat &input, std::vector<EnclosingShapeFactory::EnclosingShapePtr> &cc, const EnclosingShapeFactory &factory, int connectivity = 8);
    void extractCC(cv::Mat &input, std::vector<EnclosingShapeFactory::EnclosingShapePtr> &cc, const EnclosingShapeFactory &factory, int connectivity);
    void getCCPoints(cv::Mat &input, const cv::Point &seed, std::vector<cv::Point> &points, int connectivity = 4);

  private:
    std::string m_Shapes;
    girl::tools::Image m_image;
  };
}

#endif /* ! ISESEGMENTATIONCLUSTERINGSHAPECC_HPP */
