#ifndef ISESEGMENTATIONCLUSTERINGSPATIALMEANSHIFT_HPP
#define ISESEGMENTATIONCLUSTERINGSPATIALMEANSHIFT_HPP


#include <cmath>
#include <girl/girlCommon.hpp>

#include "iseConversion.hpp"
#include "iseQuantification.hpp"
#include "iseSpatialMeanShift.hpp"
#include "iseSpatialMeanShiftUtil.hpp"

namespace ise {

  class GIRL_API SegmentationClusteringSpatialMeanShift : public SegmentationClustering
  {
    
  public:
    
    ~SegmentationClusteringSpatialMeanShift();
  
    explicit SegmentationClusteringSpatialMeanShift(SegmentationContext *segContext); 

    virtual void init(const girl::regionDeque &regions, int level);
    
    virtual void init(girl::region r, int level);
    
    void setParameters(float sigmaR, float sigmaS, int minRegion, bool fuseRegion, ise::ImageFeatureComputerPtr algo);

    void getParameters(float &sigmaR, float &sigmaS, int &minRegion, bool &fuseRegion, ise::ImageFeatureComputerPtr algo) const;
    
  protected :
    
    virtual bool same(const girl::point &p1, girl::direction dir);
    
  private:

    SegmentationClusteringSpatialMeanShift(const SegmentationClusteringSpatialMeanShift &);

    SegmentationClusteringSpatialMeanShift &operator=(const SegmentationClusteringSpatialMeanShift &);

  protected:

    ise::SpatialMeanShift<double> m_ms;
    int m_dim;
    ise::ImageFeatureComputerPtr m_algo;
  };

}

#endif /* ISESEGMENTATIONCLUSTERINGSPATIALMEANSHIFT_HPP */
