/*
  Segmentation clustering base class.
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Achille Braquelaire, Boris Mansencal  boris.mansencal@labri.fr

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef ISESEGMENTATIONCLUSTERINGWHITESPACESEPARATOR_HPP_
#define ISESEGMENTATIONCLUSTERINGWHITESPACESEPARATOR_HPP_


#include <ise/iseSegmentationClustering.hpp>

#include <opencv2/core/core.hpp>

namespace ise
{

  class GIRL_API SegmentationClusteringWhitespaceSeparator : public SegmentationClustering
  {


  public:

  public:
    explicit SegmentationClusteringWhitespaceSeparator(ise::SegmentationContext *segContext);
    virtual
    ~SegmentationClusteringWhitespaceSeparator();

    void
    init(const girl::regionDeque &regions, int level = 1);

    void
    init(girl::region, int);

    virtual bool same(const girl::point &p, girl::direction dir);

  protected:

    void
    // TODO: reset the const, removed for debugging purposes
    dilateSeparator(const girl::region reg, /*const*/ cv::Mat &labels);

    void
    extendBBox(const cv::Mat &obstacles, girl::point &tl, girl::point &br, girl::direction d, int width, int height);


    void
      extendLine(girl::point &extremity, const std::deque<girl::direction> &directions, const cv::Mat &obstacles, std::deque<girl::direction>::const_iterator &itC);

    bool extendLineTotally(girl::point p0c,
			   const std::deque<girl::direction> &directions,
			   const cv::Mat &obstacles);
      
  protected:
    cv::Mat m_mat;
  };

}

#endif /* ISESEGMENTATIONCLUSTERINGWHITESPACESEPARATOR_HPP_ */
