/*
  Recursive Split driver default implementation.
  Copyright (C) 2005-2009 Jean-Philippe Domenger, Achille Braquelaire, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISESPLITDRIVERRECURSIVEDEFAULT_HPP
#define ISESPLITDRIVERRECURSIVEDEFAULT_HPP


#include <girl/girlCommon.hpp>

#include "iseSplitDriverRecursive.hpp"
#include "iseConversion.hpp"

namespace ise {

  class GIRL_API SplitDriverRecursiveDefault : public SplitDriverRecursive
  {
  public:
    SplitDriverRecursiveDefault(ise::SegmentationContext *segContext, 
				double threshold = 0.3,
				int conversion = ISE_RGB_to_K1K2K3);

    virtual void init(const girl::regionDeque &regionsToSplit, int level);

    virtual void init(girl::region r, int level);

    virtual bool toSplit(girl::region r, int level) const;

    virtual void setParameters(double threshold);

    virtual void getParameters(double &threshold);

  public:

    
  protected:
    
    double m_homogeneityCriteria;
    double m_threshold;
    int  m_conversion;
    bool m_toStop;
  };

}


#endif /* ! ISESPLITDRIVERRECURSIVEDEFAULT_HPP */
