/*
  Split and Merge algorithm default implementation.
  Copyright (C) 2005-2009 Jean-Philippe Domenger, Achille Braquelaire, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISESPLITMERGEALGOEXTENDSELECTION_HPP
#define ISESPLITMERGEALGOEXTENDSELECTION_HPP

#include <girl/girlCommon.hpp>
#include <girl/girlToger.hpp>
#include "iseSplitMergeAlgorithm.hpp"
#include "iseSplitAlgorithmSimple.hpp"

namespace ise {

  class GIRL_API SplitMergeAlgoExtendSelection: public SplitMergeAlgorithm 
  {

  public:
    explicit SplitMergeAlgoExtendSelection(ise::SegmentationContext *segContext,
				  girl::shared_ptr<SplitAlgorithm> /*splitAlgo*/ = girl::shared_ptr<SplitAlgorithm>(), 
				     girl::shared_ptr<MergeAlgorithm> mergeAlgo = girl::shared_ptr<MergeAlgorithm>())
      : SplitMergeAlgorithm(segContext, girl::shared_ptr<SplitAlgorithm>(new SplitAlgorithmSimple(segContext)), mergeAlgo)
    {

    }
    
    virtual ~SplitMergeAlgoExtendSelection() {}
    
    virtual void apply(const girl::regionDeque &regionsToMerge,
		       ise::MergeDriver &driverMerge,
		       ise::SplitDriver &driverSplit,
		       ise::SegmentationClustering &clust,
		       int level,
		       girl::regionDeque &keptRegions);

    virtual void setSplitAlgorithm(girl::shared_ptr<SplitAlgorithm> /*splitAlgo*/)
    {

    }


  protected:

  };
}

#endif /*  ISESPLITMERGEALGOEXTENDSELECTION_HPP */
