/*
  Split and Merge algorithm default implementation.
  Copyright (C) 2005-2009 Jean-Philippe Domenger, Achille Braquelaire, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#include "iseSplitMergeAlgorithmDefault.hpp"

#include "iseSplitDriver.hpp"
#include "iseMergeDriver.hpp"
#include "iseSegmentationClustering.hpp"
#include "iseSegmentationContext.hpp"
#include "iseMergeAlgorithm.hpp"
#include "iseSplitAlgorithm.hpp"

using namespace ise;

void 
SplitMergeAlgorithmDefault::apply(const girl::regionDeque &regionsToSplitMerge,
				  ise::MergeDriver &driverMerge,
				  ise::SplitDriver &driverSplit,
				  ise::SegmentationClustering &clust,
				  int level,
				  girl::regionDeque &keptRegions)
{
  
  assert(m_splitAlgo);
  assert(m_mergeAlgo);
  assert(m_segContext);

  girl::regionDeque createdRegions;

  m_splitAlgo->apply(regionsToSplitMerge, 
		     driverSplit,
		     clust,
		     level,
		     createdRegions);

  
  m_mergeAlgo->apply(createdRegions,
		     driverMerge,
		     level,
		     keptRegions);

}
