/*
  Split and Merge recursive algorithm.
  Copyright (C) 2005-2009 Jean-Philippe Domenger, Achille Braquelaire, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISESPLITMERGEALGORITHMRECURSIVE_HPP
#define ISESPLITMERGEALGORITHMRECURSIVE_HPP

#include "iseSplitMergeAlgorithm.hpp"

namespace ise {

  class GIRL_API SplitMergeAlgorithmRecursive : public SplitMergeAlgorithm
  {

  public:

    SplitMergeAlgorithmRecursive(ise::SegmentationContext *segContext, 
				 girl::shared_ptr<SplitAlgorithm> splitAlgo = girl::shared_ptr<SplitAlgorithm>(), 
				 girl::shared_ptr<MergeAlgorithm> mergeAlgo = girl::shared_ptr<MergeAlgorithm>())
      : SplitMergeAlgorithm(segContext, splitAlgo, mergeAlgo)
    {}
    
    virtual ~SplitMergeAlgorithmRecursive() {}
    
    virtual void apply(const girl::regionDeque &regionsToMerge,
		       ise::MergeDriver &mergeDriver,
		       ise::SplitDriver &splitDriver,
		       ise::SegmentationClustering &clust,
		       int level,
		       girl::regionDeque &keptRegions);

  private:
    SplitMergeAlgorithmRecursive(SplitMergeAlgorithmRecursive &c);
    SplitMergeAlgorithmRecursive &operator=(SplitMergeAlgorithmRecursive &c);

  protected:

    bool apply_aux(const girl::regionDeque &regionsToSplitMerge,
		   ise::MergeDriver &mergeDriver,
		   ise::SplitDriver &splitDriver,
		   ise::SegmentationClustering &clust,
		   int level,
		   girl::regionDeque &keptRegions);
    
  protected:

  };
}

#endif /*  ISEMERGEALGORITHMRECURSIVE_HPP */
