/*
  Copyright (C) 2005-2010 Vieux Remi, Roigt Julian, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef WEIGHTEDIMAGEFEATURE_HPP
#define WEIGHTEDIMAGEFEATURE_HPP

#include <girlTools/girlToolsImageFeature.hpp>
#include <girl/girlSharedPtr.hpp>

namespace ise{

  class WeightedImageFeature : public girl::tools::ImageFeatureAbstract {
    
  public:

    explicit WeightedImageFeature(girl::shared_ptr<girl::tools::ImageFeature> imageFeature);

    WeightedImageFeature(girl::shared_ptr<girl::tools::ImageFeature> imageFeature, const std::vector<double> &weights);

    void setWeights(const std::vector<double> &weights);

    void weights(std::vector<double> &weights) const;

    virtual int width() const;
    virtual int height() const;
    virtual int bytesPerLine() const;

    virtual int channels() const;

    virtual bool isNull() const;

    virtual girl::tools::ImageFeatureAbstract::type *bits();
    virtual const girl::tools::ImageFeatureAbstract::type *bits() const;

    virtual girl::tools::PixelFromImage<girl::tools::ImageFeatureAbstract::type> getPixel(int x, int y);
    virtual const girl::tools::PixelFromImage<girl::tools::ImageFeatureAbstract::type> getPixel(int x, int y) const;

  private:

    girl::shared_ptr<girl::tools::ImageFeature> m_imageFeature;

    std::vector<double> m_weights;
  };
}

#endif /* ! WEIGHTEDIMAGEFEATURE_HPP */
