/*
 * iseMeanShiftRange.hpp
 *
 *  Created on: Mar 7, 2011
 *      Author: vieux
 */

#ifndef ISEMEANSHIFTRANGE_HPP_
#define ISEMEANSHIFTRANGE_HPP_

//#define WITH_TBB

#include <girl/girlCommon.hpp>
#include <opencv2/core/core.hpp>

namespace ise
{

  class GIRL_API MeanShiftRange
  {

#ifdef WITH_TBB
    friend class MeanShifter;
#endif

  public:
    MeanShiftRange(const cv::Mat &input, const cv::Mat &ranges, cv::Mat &output);

    virtual
    ~MeanShiftRange();




    void
    computeMeanShift(const cv::Mat &input, cv::Mat &ms);

    void
    rangeSearch(const cv::Mat &input, const cv::Mat &ranges, std::vector<int> &indexes);
  protected:

    const cv::Mat &m_input;
    const cv::Mat &m_ranges;
  };

}

#endif /* ISEMEANSHIFTRANGE_HPP_ */

//
//
//
//
//
//
//
//
//
//
//
//
//
///*
// * iseMeanShiftRange.hpp
// *
// *  Created on: Mar 7, 2011
// *      Author: vieux
// */
//
//#ifndef ISEMEANSHIFTRANGE_HPP_
//#define ISEMEANSHIFTRANGE_HPP_
//
//#include <girl/girlCommon.hpp>
//#include <cv.hpp>
///**
// *
// */
//namespace ise
//{
//
//  class GIRL_API MeanShiftRange
//  {
//  public:
//    MeanShiftRange(const cv::Mat &input, const cv::Mat &ranges, cv::Mat &output);
//
//    virtual
//    ~MeanShiftRange();
//
//
//
//  protected:
//
//    void
//    computeMeanShift(const cv::Mat &input, cv::Mat &ms);
//
//    void
//    rangeSearch(const cv::Mat &input, const cv::Mat &ranges, std::vector<int> &indexes);
//  protected:
//
//    const cv::Mat &m_input;
//    const cv::Mat &m_ranges;
//  };
//
//}
//
//#endif /* ISEMEANSHIFTRANGE_HPP_ */
