/*
  Copyright (C) 2010-2011 Remi Vieux  remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <cstdlib>

#include <girl/girlToger.hpp>

#include <girlTools/girlToolsImage.hpp>
#include <girlTools/girlToolsDiskBackup.hpp>
#include <ise/iseRegionUnaryFunctionTangentVariance.hpp>

#include <ise/iseRegionBinaryFunctionCommonBoundaryTangentVariance.hpp>
#include <ise/iseRegionUnaryPredicateTrue.hpp>
#include <ise/iseRegionBinaryPredicateTrue.hpp>
#include <ise/iseRegionUnaryFunctionWithRegSetManhattanDistance.hpp>

//#include <ise/iseRegionSetInterfaceViewArea.hpp>

//#include <ise/iseRegionFeatureColorimetricMoment.hpp>

#include <ise/iseSegmentationContext.hpp>
//#include <ise/iseImageFeatureRunLength.hpp>
//#include <ise/iseRegionFeatureAutocorrelation.hpp>
//#include <ise/iseRegionFeatureRunLength.hpp>
//#include <ise/iseRegionSetInterface.hpp>
//#include <ise/iseSignalProcessingUtils.hpp>

//#include <ise/iseRegionFeatureTools.hpp>
//#include <ise/iseRegionFeature.hpp>

#include <ise/iseImageFeatureColorSpace.hpp>

#include <ise/iseRegionSetInterfaceDistribution.hpp>

#include <ise/iseRegionSetInterfaceMoments.hpp>

#include <ise/iseRegionSetInterfaceMean.hpp>

#include <ise/iseRegionSetInterfaceVariance.hpp>

#include <ise/iseRegionSetInterfaceWeighted.hpp>
//
//#include <ise/iseRegionSetInterfaceWeighted.hpp>

#include <ise/iseWordLinker.hpp>


#include <ise/iseBinarizerCannyOpenCv.hpp>
#include <ise/iseBinarizerInvert.hpp>


#include <ise/EnclosingBoxFactory.hpp>
#include <ise/EnclosingConvexHullFactory.hpp>
#include <ise/iseSegmentationClusteringEnclosingShape.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <opencv2/imgproc/imgproc.hpp>


//#include <ise/iseGrayScaleHistogram.hpp>
#include <ise/iseQuantificationThresholderWhatmough.hpp>
void
f(int)
{
  std::cout << "Toto" << std::endl;
}

using namespace cv;



double
gaussian(double at, double height, double mean, double sigma)
{
  return height*(exp(-(at - mean)*(at - mean)/(2*sigma*sigma)));
}

#include <girlTools/girlToolsAABBox.hpp>

int
main (int argc, char *argv[])
{


  girl::tools::AABBox a(0,0,10,10);
  girl::tools::AABBox b (10, 0, 20, 10);
  std::cout << a.intersects(b) << std::endl;
  return 0;
//  int min = 0;
//  int max = 255;
//  ise::GrayScaleHistogram histo(min, max);
//  for (int i = min; i < max; ++i)
//    histo[i] = 0; //gaussian(i, 100, 100, 4) + gaussian(i, 25, 25, 16) + gaussian(i, 80, 150, 30) + gaussian(i, 20, 70, 5) - gaussian(i, 40, 125, 10);
//
//  histo[0] = 500;
//  histo[1] = 505;
//  histo[2] = 499;
//  histo[3] = 200;
//  histo[4] = 600;
//  histo[5] = 554;
//
//
//
//  ise::QuantificationThresholderWhatmough thresholder;
//  std::vector<int> levels;
//  thresholder.getLevels(histo, levels);
//  std::vector<int>::const_iterator it = levels.begin();
//  const std::vector<int>::const_iterator itEnd = levels.end();
//  for (; it != itEnd; ++it) {
//      std::cout << *it << std::endl;
//  }
//  return EXIT_SUCCESS;
//




  cv::Mat test = cv::Mat::zeros(100,100, CV_8U);
  cv::Rect rect(50, 50, 1, 1);

  cv::rectangle(test, rect, CV_RGB(255, 255, 255), 0);
  cv::circle(test, cv::Point(40, 50), 0, CV_RGB(128, 128, 128));

  cv::namedWindow("Test", 0);
  cv::imshow("Test", test);
  cv::waitKey(0);

  return EXIT_SUCCESS;








  girl::tools::Image img(argv[1]);

  cv::Mat mat;

  ise::BinarizerCannyOpenCv binarizer;
  binarizer.binarize(&img, mat);

//  ise::BinarizerInvert inverter;
//  inverter.binarize(&img, mat);

  cv::namedWindow("Original", 0);
  cv::imshow("Original", mat);
//  cv::waitKey(0);
  girl::toger tog(img.width(), img.height());

  ise::SegmentationContext segContext(&tog, &img);

  //EnclosingBoxFactory *factory = new EnclosingBoxFactory();
  EnclosingConvexHullFactory *factoConvexHull = new EnclosingConvexHullFactory();
  EnclosingShapeFactory::EnclosingShapePtr box1(new EnclosingBox(cv::Rect(10, 10, 100, 100)));

  EnclosingShapeFactory::EnclosingShapePtr box2(new EnclosingBox(cv::Rect(90, 90, 10, 100)));


  std::vector<EnclosingShapeFactory::EnclosingShapePtr> shapes;
//  shapes.push_back(box1);
//  shapes.push_back(box2);

  ise::SegmentationClusteringEnclosingShape enclosingShape(&segContext);
  girl::shared_ptr<EnclosingShapeFactory> factoryPtr(factoConvexHull);

  enclosingShape.extractCC(mat, shapes, *factoConvexHull, 8);

  enclosingShape.setParameters(shapes, factoryPtr, ise::SegmentationClusteringEnclosingShape::UNION);

  girl::regionDeque regs;
  enclosingShape.init(regs, 0);

  enclosingShape.setParameters(shapes, factoryPtr, ise::SegmentationClusteringEnclosingShape::ITERATIVE);
  enclosingShape.init(regs, 0);





  return 0;
  //
  //  //  cv::Mat test = cv::Mat::zeros(10, 10, CV_8U);
  //  //  test.at<unsigned char>(5, 5) = 255;
  //
  //  for (int i = 1; i < argc; ++i) {
  //
  //      cv::Mat test = cv::imread(argv[i], CV_LOAD_IMAGE_GRAYSCALE);
  //
  //      cv::Mat dst;
  //
  //      //  std::vector<int> rowCoeffs(2, 3);
  //      //  rowCoeffs[0] = 1;
  //      //  rowCoeffs[1] = -1;
  //      cv::Mat rowKernel = cv::Mat::ones(2, 1, CV_8S);
  //      rowKernel.at<unsigned char>(0,0) = 1;
  //      //  rowKernel.at<unsigned char>(0, 2) = -2;
  //      //  rowKernel.at<unsigned char>(0, 3) = -1;
  //      rowKernel.at<unsigned char>(1,0) = -1;
  //      //  rowKernel.at<unsigned char>(1, 2) = 2;
  //      //  rowKernel.at<unsigned char>(1, 3) = 1;
  //      cv::Mat colKernel = rowKernel.t();
  //
  //      cv::filter2D(test, dst, CV_32F, rowKernel);
  //
  //
  //      //    for (int i = 0; i < dst.rows; ++i) {
  //      //        for (int j = 0; j < dst.cols; ++j) {
  //      //            std::cout << ( dst.at<float>(i, j)) << "\t\t\t";
  //      //        }
  //      //        std::cout << std::endl;
  //      //    }
  //      //    std::cout << std::endl;
  //
  //      cv::Mat dstY;
  //      cv::filter2D(test, dstY, -1, colKernel);
  //
  //      cv::namedWindow("X", 0);
  //      cv::namedWindow("Y", 0);
  //      cv::namedWindow("Original", 0);
  //
  //      cv::Mat dispX, dispY;
  //      double min, max;
  //      cv::minMaxLoc(dst, &min, &max);
  //      dst.convertTo(dispX, CV_8U, 255./(max - min), -min);
  //      cv::minMaxLoc(dstY, &min, &max);
  //      dstY.convertTo(dispY, CV_8U, 255./(max - min), -min);
  //      cv::imshow("X", dispX);
  //      cv::imshow("Y", dispY);
  //      cv::imshow("Original", test);
  //      //  for (int i = 0; i < dst.rows; ++i) {
  //      //       for (int j = 0; j < dst.cols; ++j) {
  //      //           std::cout << (int)( dstY.at<unsigned char>(i, j)) << "\t\t\t";
  //      //       }
  //      //       std::cout << std::endl;
  //      //   }
  //      //   std::cout << std::endl;
  //      //
  //      //  std::vector<cv::Point> totoVect;
  //      //  totoVect.push_back(cv::Point(50, 50));
  //      //  cv::Mat toto(totoVect);
  //      //
  //      //  cv::Rect rect = cv::boundingRect(toto);
  //      //
  //      //  cv::rectangle(test, rect, CV_RGB(255, 255, 255));
  //
  //      //  cv::namedWindow("test", 0);
  //      //  cv::imshow("test", test);
  //
  //      cv::waitKey(0);
  //  }
  //
  //  return EXIT_SUCCESS;
  //
  //
  //  //  if (argc < 2)
  //  //    {
  //  //      std::cerr << "Usage " << argv[0] << " <toger file> " << std::endl;
  //  //      return EXIT_FAILURE;
  //  //    }
  //  //
  //  //  girl::tools::iDiskBackup backup(argv[1]);
  //  //  girl::toger tog;
  //  //  tog.read(backup);
  //  //
  //  //  std::cout << tog.numRegions() << std::endl;
  //  //
  //  //  ise::WordLinker linker;
  //  //
  //  //  std::deque<girl::regionDeque> words;
  //  //  linker.linkWords(tog,words);
  //
  //  //  int *p = NULL;
  //  //
  //  //  f(*p);
  //  //
  //  //
  //  //
  //  //
  //  //
  //  //
  //  //  int *totoa = new int[1];
  //  //  girl::shared_ptr<int> toto(totoa);
  //  //  if (toto)
  //  //    {
  //  //      std::cout << "pas vide" << std::endl;
  //  //    } else
  //  //    { std::cout << "vide" << std::endl;
  //  //    }
  //  //
  //  //
  //  //  std::cout << *toto << std::endl;
  //
  //  girl::tools::Image image(argv[1]);
  //
  //  girl::toger tog(image.width(), image.height());
  //
  //  ise::SegmentationContext segContext(&tog, &image);
  //
  //  ise::ImageFeatureColorSpace *imageColorSpace = new ise::ImageFeatureColorSpace(&segContext);
  //  imageColorSpace->setParameters(ISE_RGB_to_YCbCr);
  //  imageColorSpace->compute();
  //  std::cout << "URI ImageF:" <<  imageColorSpace->getImageFeature()->uri() << std::endl;;
  //
  //  girl::shared_ptr<ise::ImageFeatureComputer> imageColorSpacePtr(imageColorSpace);
  //  segContext.addImageFeatureComputer(imageColorSpacePtr);
  //
  //  girl::shared_ptr<ise::RegionSetInterface> distrib(
  //      new ise::RegionSetInterfaceDistribution (&segContext, ise::RegionSetInterfaceDistribution::DEFAULT_CACHE_STRATEGY, imageColorSpacePtr));
  //  segContext.addRegionSet(distrib);
  //  segContext.checkAllRegions();
  //
  //  // DOUBLE FREE.... but hey :/
  //  //girl::shared_ptr<girl::tools::ImageFeature> imageFeaturePtr(&(imageColorSpace->getImageFeature()));
  //
  //  ise::RegionSetInterfaceMoments* regsetMoment =
  //      new ise::RegionSetInterfaceMoments(&segContext, ise::RegionSetInterface::ALWAYS, imageColorSpacePtr);
  //  girl::shared_ptr<ise::RegionSetInterfaceMoments> regSetMomentPtr(regsetMoment);//  regsetMoment->registerToSegContext();
  //  segContext.addRegionSet(regSetMomentPtr);
  //
  //  ise::RegionSetInterfaceMean* meanRegSet =
  //      new ise::RegionSetInterfaceMean(&segContext, ise::RegionSetInterface::NONE, regSetMomentPtr);
  //  girl::shared_ptr<ise::RegionSetInterface> meanRegSetPtr(meanRegSet);
  //  segContext.addRegionSet(meanRegSetPtr);
  //  //  meanRegSet->registerToSegContext();
  //
  //  ise::RegionSetInterfaceVariance* varianceRegSet =
  //      new ise::RegionSetInterfaceVariance(&segContext, ise::RegionSetInterface::NONE, regsetMoment);
  //  girl::shared_ptr<ise::RegionSetInterface> varianceRegSetPtr(varianceRegSet);
  //  segContext.addRegionSet(varianceRegSetPtr);
  //  //  varianceRegSet->registerToSegContext();
  //
  //  // REMI: BUG PRONE: DOUBLE FREE IF REGSET IS NOT ALLOCATED USING NEW SINCE
  //  // SEGCONTEXT TAKES OWNERSHIP OF REGIONSET DURING CONSTRUCTION
  //  //ise::RegionSetInterfaceMoments *regSeg = new ise::RegionSetInterfaceMoments(&segContext, regsetMoment);
  //
  //  // ise::RegionSetInterfaceMean * regSetMean = new ise::RegionsSetInterfaceMean(&segContext, meanComputer, regSeg);
  //
  //  segContext.checkAllRegions();
  //
  //  ise::RegionSetInterfaceWeighted weightedMean(&segContext, meanRegSetPtr);
  //  ise::RegionSetInterfaceWeighted weightedVar(&segContext, varianceRegSetPtr);
  //
  //  ise::RegionUnaryFunctionWithRegSetManhattanDistance manNorm(&segContext);
  //  manNorm.setParameters(meanRegSetPtr);
  //  std::cout << "NORM" <<  manNorm(1) << std::endl;
  //
  //  std::vector<double> weights(3, 1);
  //  weightedMean.setWeights(weights);
  //  weightedVar.setWeights(weights);
  //  segContext.checkAllRegions();
  //  std::cout << "Querying weighted mean" << std::endl;
  //  weightedMean.checkAllRegions();
  //  std::cout << "Querying weighted variance" << std::endl;
  //  weightedVar.checkAllRegions();
  //
  //  weights[0] = 0;
  //  weightedMean.setWeights(weights);
  //  weightedVar.setWeights(weights);
  //  segContext.checkAllRegions();
  //  std::cout << "Querying weighted mean" << std::endl;
  //  weightedMean.checkAllRegions();
  //  std::cout << "Querying weighted variance" << std::endl;
  //  weightedVar.checkAllRegions();
  //
  //
  //  weights[2] = 0;
  //  weightedMean.setWeights(weights);
  //  weightedVar.setWeights(weights);
  //  segContext.checkAllRegions();
  //  std::cout << "Querying weighted mean" << std::endl;
  //  weightedMean.checkAllRegions();
  //  std::cout << "Querying weighted variance" << std::endl;
  //  weightedVar.checkAllRegions();
  //
  //
  //  weights[0] = weights[1] = 0;
  //  weights[2] = 1;
  //  weightedMean.setWeights(weights);
  //  weightedVar.setWeights(weights);
  //  segContext.checkAllRegions();
  //  std::cout << "Querying weighted mean" << std::endl;
  //  weightedMean.checkAllRegions();
  //  std::cout << "Querying weighted variance" << std::endl;
  //  weightedVar.checkAllRegions();
  //
  //
  //  varianceRegSet->setCacheState(ise::RegionSetInterface::ALWAYS);
  //  varianceRegSet->setCacheState(ise::RegionSetInterface::LAZY);
  //  varianceRegSet->setCacheState(ise::RegionSetInterface::NONE);
  //  varianceRegSet->setCacheState(ise::RegionSetInterface::LAZY);
  //  varianceRegSet->setCacheState(ise::RegionSetInterface::ALWAYS);
  //  varianceRegSet->setCacheState(ise::RegionSetInterface::ALWAYS);
  //  varianceRegSet->setCacheState(ise::RegionSetInterface::NONE);
  //  varianceRegSet->setCacheState(ise::RegionSetInterface::NONE);
  //  varianceRegSet->setCacheState(ise::RegionSetInterface::LAZY);
  //  varianceRegSet->setCacheState(ise::RegionSetInterface::LAZY);
  //  segContext.checkAllRegions();
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //  //
  //  //  girl::shared_ptr<ise::RegionFeatureComputerMoment> regsetMoment =
  //  //      girl::static_pointer_cast<ise::RegionUnaryFunctionTangentVariance>
  //  //  (ise::RegionFeatureregsetMomentFactory::instance::create());
  //
  //
  //  //
  //  //  girl::toger tog(10, 10);
  //  //
  //  ////  ise::RegionUnaryFunctionTangentVariance varianceCommputer(tog);
  //  //
  //  //  girl::shared_ptr<ise::RegionUnaryFunctionTangentVariance> varianceComputer
  //  //   = girl::static_pointer_cast<ise::RegionUnaryFunctionTangentVariance>
  //  //  (ise::RegionUnaryFunctionTangentVarianceFactory::instance().create());
  //  //  varianceComputer->setParameters(&tog);
  //  //  girl::shared_ptr<ise::ParametersMemento> varianceComputerMemento = varianceComputer->getMemento();
  //  //
  //  //  double var = (*varianceComputer)(1);
  //  //  std::cout << var << std::endl;
  //  //
  //  //  girl::shared_ptr<ise::RegionUnaryFunction> variance2
  //  //    = ise::RegionUnaryFunctionTangentVarianceFactory::instance().create();
  //  //  variance2->setMemento(varianceComputerMemento);
  //  //  std::cout << (*variance2)(1) << std::endl;
  //  //
  //  //
  //  //  girl::shared_ptr<ise::RegionUnaryPredicate> t
  //  //    = ise::RegionUnaryPredicateTrueFactory::instance().create();
  //  //  std::cout << (*t)(1) << std::endl;
  //  //  girl::shared_ptr<ise::RegionBinaryPredicate> t2
  //  //     = ise::RegionBinaryPredicateTrueFactory::instance().create();
  //  //   std::cout << (*t2)(1, 1) << std::endl;
  //
  //
  //  //ise::RegionBinaryFunctionCommonBoundaryTangentVariance cvar(tog);
  //
  //  //  girl::shared_ptr<ise::RegionBinaryFunctionCommonBoundaryTangentVariance> cvar
  //  //  = girl::static_pointer_cast<ise::RegionBinaryFunctionCommonBoundaryTangentVariance>
  //  //  (ise::RegionBinaryFunctionCommonBoundaryTangentVarianceFactory::instance().create());
  //  //  cvar->setParameters(&tog);
  //  //  var = (*cvar)(1, 1);
  //  //  std::cout << var << std::endl;
  //  //
  //
  //
  //  //  ise::ImageFeatureColorSpace colorspace(NULL);
  //  //  colorspace.compute();
  //
  //  /*
  //
  //  const int size = 3;
  //  ise::RegionFeature regFeature(size);
  //  regFeature[0] = 1;
  //  regFeature[1] = 2;
  //  regFeature[2] = 300;
  //
  //  ise::RegionFeature regFeature2(size);
  //
  //  ise::RegionFeatureL1Norm norm(size);
  //  ise::RegionFeatureL2Norm normL2(size);
  //  double val = regFeature.norm(norm);
  //  std::cout << val << " L2: "<< regFeature.norm(normL2) << std::endl;
  //
  ////  std::cout << "Distance L1" << regFeature.dist(regFeature2) << " L2 " << regFeature.dist(regFeature2) << std::endl;
  ////  std::cout << "Distance L1" << regFeature2.dist(regFeature) << " L2 " << regFeature2.dist(regFeature) << std::endl;
  ////  std::cout << "Distance L1" << regFeature.dist(regFeature2) << " L2 " << regFeature.dist(regFeature) << std::endl;
  //   */
  //
  //
  //
  //  /*
  //  const int size = 10;
  //  //  float values[size] = { 0.556, 1.05, 0.7277, 1.1518, 0.6998, 1.2450, 1.3697, 1.8559, 0.9029, -0.0692};
  //
  //  cv::Mat input(1, size, CV_32F);
  //  std::vector<double> inputVec(size, 0);
  //  std::cout << "[ ";
  //  for (int i = 0; i < size; ++i) {
  //    float val = 0.5*cos(i);
  //    input.at<float>(0, i) = val;
  //    std::cout << val << " ";
  //    inputVec[i] = static_cast<double>(val);
  //  }
  //  std::cout << " ]" << std::endl;
  //  //  cv::Mat input = cv::Mat(values).reshape(1, size);
  //  cv::Mat output;
  //
  //  // ise::convolveDFT(input, input, output);
  //
  //  ise::autocorrelation(input, output);
  //
  //  std::vector<double> outputVec;
  //  ise::autocorrelation(inputVec, outputVec);
  //  for (int i = 0; i < output.cols; ++i) {
  //    std::cout << output.at<float>(0, i) << " " <<  outputVec[i] << std::endl;
  //  }
  //
  //  // ise::SegmentationContext *segContext = NULL;
  //  // ise::RegionFeatureComputerAutocorrelation correl(segContext);
  //   */
  //
  //
  //  /*
  //  girl::tools::Image image(argv[1]);
  //  girl::toger tog(image.width(), image.height());
  //
  //  ise::SegmentationContext segContext(&tog, &image, NULL);
  //
  //  ise::RegionFeatureRunLength rfrl(&segContext);
  //
  //  ise::RegionSetInterface rsi(rfrl);
  //  segContext.addRegionSet(&rsi);
  //  segContext.checkAllRegions();
  //
  //
  // ise::ImageFeatureRunLength rl(&segContext);
  // const int nbDir = 8;
  // ise::ImageFeatureRunLength::direction directions[nbDir] = { ise::ImageFeatureRunLength::NORTH,
  //							     ise::ImageFeatureRunLength::NORTH_EAST,
  //							     ise::ImageFeatureRunLength::EAST,
  //							     ise::ImageFeatureRunLength::SOUTH_EAST,
  //							     ise::ImageFeatureRunLength::SOUTH,
  //							     ise::ImageFeatureRunLength::SOUTH_WEST,
  //							     ise::ImageFeatureRunLength::WEST,
  //							     ise::ImageFeatureRunLength::NORTH_WEST
  // };
  //
  // for (int i = 0; i < nbDir; ++i)
  //   {
  //     std::cout << i << std::endl;
  //     rl.setParameters(255, directions[i]);
  //     rl.compute();
  //
  //     // const girl::tools::ImageFeature& imageFeature = rl.getImageFeature();
  //
  //     // for (int i = 0; i < image.height(); ++i) {
  //     // 	for (int j = 0; j < image.width(); ++j) {
  //     // 	  std::cout << *(imageFeature.getPixelPtr(j, i)) << " ";
  //     // 	}
  //     // 	std::cout << std::endl;
  //     // }
  //     // std::cout << std::endl;
  //   }
  //
  //   */
  //  return EXIT_SUCCESS;
}
