/*
  Copyright (C) 2010-2011 Julian Roigt, Remi Vieux  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef CLUSTERERMEANSHIFTPLUGIN_HPP
#define CLUSTERERMEANSHIFTPLUGIN_HPP

#include <girl/girlCommon.hpp>

#include <qiseTools/ClustererPlugin.hpp>

#include <ise/iseClusterer.hpp>
#include <ise/iseClustererMeanShift.hpp>

#include <qiseTools/ClustererMeanShiftWidget.hpp>
#include <qiseTools/ClustererSettingsMeanShift.hpp>

#include <QObject>

class GIRL_API ClustererMeanShiftPlugin : public QObject,
					      public ClustererPlugin
{
  
  Q_OBJECT
  Q_INTERFACES(ClustererPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
    Q_PLUGIN_METADATA(IID ClustererPlugin_iid)
#endif
    
public:
    
  ~ClustererMeanShiftPlugin() {}
  
  ClustererMeanShiftPlugin()
    : ClustererPlugin(QString::fromUtf8("Mean shift"),
		      QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::Clusterer> create(ise::SegmentationContext * /*segContext*/)
  {
    girl::shared_ptr<ise::Clusterer> result = ise::ClustererMeanShiftFactory::instance().create();
    return result;
  }
  
  virtual girl::shared_ptr<ClustererSettingsInterface> createSettings()
  {
    return girl::shared_ptr<ClustererSettingsInterface>(new ClustererSettingsMeanShift());
  }

  virtual ClustererWidgetInterface* createWidget(MainView *mainView, QWidget *parent = NULL)
  {
    return new ClustererMeanShiftWidget(mainView, this, parent);
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseClustererMeanShiftPlugin, ClustererMeanShiftPlugin)
#endif

#endif /* ! CLUSTERERMEANSHIFTPLUGIN_HPP */
