/* 
 * Copyright (C) 2010-2011 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation (Inc., 59
 * Temple Place - Suite 330, Boston, MA 02111-1307, USA); either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */
#ifndef IMAGEFEATURETHRESHOLDPLUGIN_HPP
#define IMAGEFEATURETHRESHOLDPLUGIN_HPP

#include <girl/girlCommon.hpp>

#include <qiseTools/ImageFeatureBinaryPlugin.hpp>

#include <ise/iseImageFeatureComputer.hpp>

#include <qiseTools/ImageFeatureThresholdWidget.hpp>
#include <qiseTools/ImageFeatureThresholdSettings.hpp>

#include <QObject>

class GIRL_API ImageFeatureThresholdPlugin : public QObject
					   , public ImageFeatureBinaryPlugin
{

  Q_OBJECT
  Q_INTERFACES(ImageFeatureBinaryPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
    Q_PLUGIN_METADATA(IID ImageFeatureBinaryPlugin_iid)
#endif
    
public:
    
  ~ImageFeatureThresholdPlugin() {}
  
  ImageFeatureThresholdPlugin()
    : ImageFeatureBinaryPlugin(QString::fromUtf8("Binary"),
			 QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::FeatureComputer> create(ise::SegmentationContext *segContext)
  {
    girl::shared_ptr<ise::FeatureComputer> result
      = ise::ImageFeatureThresholdFactory::instance().create(segContext);
    return result;
  }
  
  virtual girl::shared_ptr<FeatureInterfaceSettings> createSettings()
  {
    return girl::shared_ptr<FeatureInterfaceSettings>(new ImageFeatureThresholdSettings());
  }

  virtual FeatureInterfaceWidget* createWidget(MainView *mainView, FeatureComputerGUIInfoPtr featureComputerGUIInfo, QWidget *parent = NULL)
  {
    return new ImageFeatureThresholdWidget(mainView, featureComputerGUIInfo, "Binary", this, parent);
  }  
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseImageFeatureThresholdPlugin, ImageFeatureThresholdPlugin)
#endif

#endif /* ! IMAGEFEATURETHRESHOLDPLUGIN_HPP */
