/*
  Copyright (C) 2010-2011 Julian Roigt  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef IMAGEFEATURELINEARCOMBINATIONPLUGIN_HPP
#define IMAGEFEATURELINEARCOMBINATIONPLUGIN_HPP

#include <girl/girlCommon.hpp>

#include <qiseTools/ImageFeatureCompositionPlugin.hpp>
#include <qiseTools/ImageFeatureLinearCombinationSimpleWidget.hpp>
#include <qiseTools/ImageFeatureLinearCombinationSimpleSettings.hpp>
#include <ise/iseImageFeatureLinearCombination.hpp>


#include <QObject>

class GIRL_API ImageFeatureLinearCombinationPlugin : public QObject,
						     public ImageFeatureCompositionPlugin
{

  Q_OBJECT
  Q_INTERFACES(ImageFeatureCompositionPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
    Q_PLUGIN_METADATA(IID ImageFeatureCompositionPlugin_iid)
#endif
    
public:
    
  ~ImageFeatureLinearCombinationPlugin() {}
  
  ImageFeatureLinearCombinationPlugin()
    : ImageFeatureCompositionPlugin(QString::fromUtf8("LinearCombination"),
			 QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::FeatureComputer> create(ise::SegmentationContext *segContext)
  {
    girl::shared_ptr<ise::FeatureComputer> result = ise::ImageFeatureLinearCombinationFactory::instance().create(segContext);
    return result;
  }
  
  virtual girl::shared_ptr<FeatureInterfaceSettings> createSettings()
  {
    return girl::shared_ptr<FeatureInterfaceSettings>(new ImageFeatureLinearCombinationSimpleSettings());
  }

  virtual ImageFeatureWidgetInterface* createWidget(MainView *mainView, FeatureComputerGUIInfoPtr featureComputerGUIInfo, QWidget *parent = NULL) {
    return new ImageFeatureLinearCombinationSimpleWidget(mainView, featureComputerGUIInfo, "LinearCombination", this, parent);
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseImageFeatureLinearCombinationPlugin, ImageFeatureLinearCombinationPlugin)
#endif

#endif /* ! IMAGEFEATURELINEARCOMBINATIONPLUGIN_HPP */
