/*
  Copyright (C) 2010-2011 Julian Roigt  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef IMAGEFEATURECOMPOSITIONTABPLUGIN_HPP
#define IMAGEFEATURECOMPOSITIONTABPLUGIN_HPP

#include <girl/girlCommon.hpp>

#include <qiseTools/FeatureTabPlugin.hpp>
#include <qiseTools/ImageFeatureCompositionTabWidget.hpp>

#include <ise/iseImageFeatureComputer.hpp>

#include <QObject>

class GIRL_API ImageFeatureCompositionTabPlugin : public QObject,
					  public FeatureTabPlugin
{

  Q_OBJECT
  Q_INTERFACES(FeatureTabPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
    Q_PLUGIN_METADATA(IID FeatureTabPlugin_iid)
#endif
    
 public:
    
  ~ImageFeatureCompositionTabPlugin() {}
  
  ImageFeatureCompositionTabPlugin()
    : FeatureTabPlugin(QString::fromUtf8("Composition"),
			 QIseVersion(1, 0), QIseVersion(1, 0))
    {}
  
  virtual girl::shared_ptr<ise::ImageFeatureComputer> create(ise::SegmentationContext*)
  {
    return girl::shared_ptr<ise::ImageFeatureComputer>();
  }
  
  // virtual girl::shared_ptr<FeatureTabSettingsInterface> createSettings()
  // {
  //   return girl::shared_ptr<FeatureTabSettingsInterface>(new ImageFeatureCompositionTabSettings());
  // }

  virtual FeatureTabWidget* createWidget(MainView *mainView, FeatureComputerGUIInfoPtr featureComputerGUIInfo, QWidget *parent = NULL) {
    return new ImageFeatureCompositionTabWidget(mainView, featureComputerGUIInfo, "Composition", parent);
  }

};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseImageFeatureCompositionTabPlugin, ImageFeatureCompositionTabPlugin)
#endif

#endif /* ! IMAGEFEATURECOMPOSITIONTABPLUGIN_HPP */
