#include "matrix.hpp"
#include <cstdlib>
double max(double a,double b)
{
  if(a>b)
    return a;
  else
    return b;
}

int min(int a, int b)
{
  if(a<b)
    return a;
  else
    return b;
}

double min(double a, double b)
{
  if(a<b)
    return a;
  else
    return b;
}


template <class F> Matrix<F> Matrix<F>::getMatrix(int i0, int i1, int j0, int j1)
{
  if((i0<=i1)&&(j0<=j1)&&(i0>=0)&&(j0>=0)&&(i1<m)&&(j1<n))
    {
      Matrix X(i1-i0, j1-j0);
      F ** B = X.getArray();
      int i,j;
      for(i=i0;i<=i1;i++)
        for(j=j0;j<=j1;j++)
          B[i-i0][j-j0]=A[i][j];
      return X;
    }
  else
    {
      std::cerr<<"Erreur dans les dimensions de la sous-matrice"<<std::endl;
      exit(-1);
    }
  return Matrix(0,0);
}

template <class F> Matrix <F> Matrix<F>::getMatrix(int * r, int rlength, int j0, int j1)
{
  Matrix<F> X(rlength, j1 - j0 + 1);
  F** B = X.getArray();
  for(int i = 0; i < rlength; i++)
    for(int j = j0; j <= j1; j++)
      B[i][j - j0] = A[r[i]][j];
  return X;
}

template <class F> Matrix<F> Matrix<F>::transpose()
{
  Matrix<F> X(n,m);
  F **C = X.getArray();
  int i,j;
  for(i=0;i<m;i++)
    for(j=0;j<n;j++)
      C[j][i] = A[i][j];
  return X;
}

template <class F> F Matrix<F>::norm1()
{
  F f=0;
  int i,j;
  F s;
  for(j=0;j<n;j++)
    {
      s=0;
      for(i=0;i<m;i++)
        s+=fabs(A[i][j]);
      if(s>f)
        f=s;
      }
  return f;
}

template <class F> F Matrix<F>::normInf()
{
  F f=0;
  int i,j;
  F s;
  for(i=0;i<m;i++)
    {
      s=0;
      for(j=0;j<n;j++)
        s+=fabs(A[i][j]);
      if(s>f)
        f=s;
    }
  return f;
}

template <class F> Matrix <F> Matrix<F>::uminus()
{
  Matrix <F> X(m,n);
  F **C = X.getArray();
  int i,j;
  for(i=0;i<m;i++)
    for(j=0;j<n;j++)
      C[i][j] = -A[i][j];
  return X;
}

template <class F> Matrix <F> Matrix<F>::plus(Matrix <F> B)
{
  if((B.getRowDimension()==m)&&(B.getColDimension()==n))
    {
      Matrix <F> X(m,n);
      F ** C = X.getArray();
      int i,j;
      for(i=0;i<m;i++)
        for(j=0;j<n;j++)
          C[i][j] = A[i][j] + B.A[i][j];
      return X;
    }
  else
    return B;
}

template <class F> void Matrix<F>::plusE(Matrix <F> B)
{
  if((B.getRowDimension()==m)&&(B.getColDimension()==n))
    {
      int i,j;
      for(i=0;i<m;i++)
        for(j=0;j<n;j++)
          A[i][j] = A[i][j] + B.A[i][j];
    }
}

template <class F> Matrix <F> Matrix<F>::minus(Matrix<F> B)
{
  if((B.getRowDimension()==m)&&(B.getColDimension()==n))
    {
      Matrix <F> X(m,n);
      F** C = X.getArray();
      int i,j;
      for(i=0;i<m;i++)
        for(j=0;j<n;j++)
          C[i][j] = A[i][j] - B.A[i][j];
      return X;
    }
  else
    return B;
}

template <class F> void Matrix<F>::minusE(Matrix <F> B)
{
  if((B.getRowDimension()==m)&&(B.getColDimension()==n))
    {
      int i,j;
      for(i=0;i<m;i++)
        for(j=0;j<n;j++)
          A[i][j] = A[i][j] - B.A[i][j];
    }
}

template <class F> Matrix <F> Matrix<F>::arrayTimes(Matrix <F> B)
{
  if((B.getRowDimension()==m)&&(B.getColDimension()==n))
    {
      Matrix <F> X(m,n);
      F ** C = X.getArray();
      int i,j;
      for(i=0;i<m;i++)
        for(j=0;j<n;j++)
          C[i][j] = A[i][j] * B.A[i][j];
      return X;
    }
  else
    return B;
}

template <class F> void Matrix<F>::arrayTimesE(Matrix <F> B)
{
  if((B.getRowDimension()==m)&&(B.getColDimension()==n))
    {
      int i,j;
      for(i=0;i<m;i++)
        for(j=0;j<n;j++)
          A[i][j] = A[i][j] * B.A[i][j];
    }
}

template <class F> Matrix<F> Matrix<F>::times(F s)
{
  Matrix <F> X(m,n);
  F ** C = X.getArray();
  int i,j;
  for(i=0;i<m;i++)
    for(j=0;j<n;j++)
      C[i][j] = A[i][j] * s;
  return X;
}

template <class F> void Matrix<F>::timesE(F s)
{
  int i,j;
  for(i=0;i<m;i++)
    for(j=0;j<n;j++)
      A[i][j] = A[i][j] * s;
}






template <class F> Matrix <F> Matrix<F>::times(Matrix <F> B)
{
  if((B.getRowDimension()==n))
    {
      Matrix <F> X(m,B.n);
      F ** C = X.getArray();
      int i,j,k;
      F * Bcolj = new F [n];
      for(j=0;j<B.n;j++)
        {
          for(k=0;k<n;k++)
            Bcolj[k] = B.A[k][j];
          for(i=0;i<m;i++)
            {
              F * Arowi = A[i];
              F s = 0;
              for(k=0;k<n;k++)
                s+=Arowi[k]*Bcolj[k];
              C[i][j]=s;
            }
        }
      delete [] Bcolj;//B
      return X;
    }
  else
    return B;
}


