#ifndef IMAGEFEATUREGABORFILTERSSETTINGS_HPP
#define IMAGEFEATUREGABORFILTERSSETTINGS_HPP

#include <qiseTools/FeatureInterfaceSettings.hpp>


class ImageFeatureGaborFiltersSettings : public FeatureInterfaceSettings
{
public:
    ImageFeatureGaborFiltersSettings();

     void
     configureWidget(FeatureInterfaceWidget *widget) const;

     void
     getWidgetConfig(const FeatureInterfaceWidget *widget);

     void
     configureAlgo(girl::shared_ptr<ise::FeatureComputer> algo) const;

     girl::shared_ptr<FeatureInterfaceSettings>
     clone() const;

     bool
     isValid() const;

private:

     static std::string
     toString(const std::vector<double> &values);

     static void
     toDoubleVect(const std::string &s, std::vector<double> &vect);

private:

    std::vector<double> m_sigma;
    std::vector<double> m_theta;
    std::vector<double> m_lambda;
    std::vector<double> m_gamma;
    std::vector<double> m_psi;
    int m_filterSize;
    bool m_normalizeImage;
    bool m_normalizeKernel;
    bool m_normalizeContrast;

};

#endif // IMAGEFEATUREGABORFILTERSSETTINGS_HPP
