#include "ImageFeatureGaborFiltersWidget.hpp"

#include "ui_GaborWidget.h"


ImageFeatureGaborFiltersWidget::ImageFeatureGaborFiltersWidget(MainView *mainView, FeatureComputerGUIInfoPtr featureComputerGUIInfo, QString name, ImageFeaturePlugin *imageFeaturePlugin, QWidget *parent)
    : ImageFeatureWidgetInterface(mainView,
                                  featureComputerGUIInfo,
                                  name,
                                  imageFeaturePlugin,
                                  parent),
      ui(new Ui::GaborWidget)
{

    setWindowTitle(tr("Gabor filters parameters..."));
 //   setAttribute(Qt::WA_DeleteOnClose);
    build();

}

ImageFeatureGaborFiltersWidget::~ImageFeatureGaborFiltersWidget()
{
    delete ui;
}

void
ImageFeatureGaborFiltersWidget::build()
{
    ui->setupUi(this);
  //  this->setMinimumSize(640,480);
}


void
ImageFeatureGaborFiltersWidget::setParameters(const std::string &sigma, const std::string &theta, const std::string &lambda, const std::string &gamma, const std::string &psi, bool normalizeImage, bool normalizeKernel, bool normalizeContrast)
{
    ui->sigmaLineEdit->setText(tr(sigma.c_str()));
    ui->thetaLineEdit->setText(tr(theta.c_str()));
    ui->gammaLineEdit->setText(tr(gamma.c_str()));
    ui->lambdaLineEdit->setText(tr(lambda.c_str()));
    ui->psiLineEdit->setText(tr(psi.c_str()));
    ui->normalizeImageCheckBox->setChecked(normalizeImage);
    ui->normalizeKernelsCheckBox->setChecked(normalizeKernel);
    ui->normalizeContrastCheckBox->setChecked(normalizeContrast);
}


void
ImageFeatureGaborFiltersWidget::getParameters(std::string &sigma, std::string &theta, std::string &lambda, std::string &gamma, std::string &psi, bool &normalizeImage, bool &normalizeKernel, bool &normalizeContrast) const
{
    sigma = ui->sigmaLineEdit->text().toStdString();
    theta =ui->thetaLineEdit->text().toStdString();
    gamma =ui->gammaLineEdit->text().toStdString();
    lambda = ui->lambdaLineEdit->text().toStdString();
    psi = ui->psiLineEdit->text().toStdString();
    normalizeImage = ui->normalizeImageCheckBox->isChecked();
    normalizeKernel = ui->normalizeKernelsCheckBox->isChecked();
    normalizeContrast = ui->normalizeContrastCheckBox->isChecked();
}
