#ifndef IMAGEFEATUREGABORFILTERSWIDGET_HPP
#define IMAGEFEATUREGABORFILTERSWIDGET_HPP

#include <qiseTools/ImageFeatureWidgetInterface.hpp>


#include <QWidget>

namespace Ui
{
class GaborWidget;
}

class ImageFeatureGaborFiltersWidget : public ImageFeatureWidgetInterface
{

    Q_OBJECT

public:
    ImageFeatureGaborFiltersWidget(MainView *mainView,
                                   FeatureComputerGUIInfoPtr featureComputerGUIInfo,
                                   QString name,
                                   ImageFeaturePlugin *imageFeaturePlugin,
                                   QWidget *parent = NULL);


    ~ImageFeatureGaborFiltersWidget();

    void
    build();

    bool
    isValid()
    {
        return true;
    }

    void
    setParameters(const std::string &sigma,
                  const std::string &theta,
                  const std::string &lambda,
                  const std::string &gamma,
                  const std::string &psi,
                  bool normalizeImage,
                  bool normalizeKernel,
                  bool normalizeContrast);

    void
    getParameters(std::string &sigma,
                  std::string &theta,
                  std::string &lambda,
                  std::string &gamma,
                  std::string &psi,
                  bool &normalizeImage,
                  bool &normalizeKernel,
                  bool &normalizeContrast) const;


private:

    Ui::GaborWidget *ui;


};

#endif // IMAGEFEATUREGABORFILTERSWIDGET_HPP
