/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef IMAGEFEATUREPIXELCLASSIFICATIONWIDGET_HPP
#define IMAGEFEATUREPIXELCLASSIFICATIONWIDGET_HPP

#include <QWidget>
#include <QVector>

#include <qiseTools/ImageFeatureWidgetInterface.hpp>

class QLabel;
class QGridLayout;
class WeightedChannelsImageFeatureWidget;
class QPushButton;

namespace ise {
class SegmentationContext;
}

class GIRL_API ImageFeaturePixelClassificationWidget : public ImageFeatureWidgetInterface
{

    Q_OBJECT

public:

    /**
   * @brief Constructor.
   */
    ImageFeaturePixelClassificationWidget(MainView *mainView,
                                          FeatureComputerGUIInfoPtr featureComputerGUIInfo,
                                          QString name,
                                          ImageFeaturePlugin *imageFeaturePlugin,
                                          QWidget *parent=NULL);

    virtual ~ImageFeaturePixelClassificationWidget()
    {
    }

    virtual void build();
    virtual bool isValid();

    void setParameters(const ise::FeatureComputerPtr &algo, const std::vector<double> &weightedChannelsCoeffs, const std::string &modelFile);
    void getParameters(ise::FeatureComputerPtr &data, std::vector<double> &weightedChannelsCoeffs, std::string &modelFile) const;


protected slots:

    void chooseFile();

private:

    WeightedChannelsImageFeatureWidget *m_wcifw;
    QPushButton *m_openFileButton;
    std::string m_modelFile;
};

#endif /* ! IMAGEFEATUREPIXELCLASSIFICATIONWIDGET_HPP */
