/*
  Copyright (C) 2005-2011 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef IMAGEFEATURERELAXATIONSETTINGS_HPP
#define IMAGEFEATURERELAXATIONSETTINGS_HPP

#include <qiseTools/FeatureInterfaceSettings.hpp>

class ImageFeatureRelaxationSettings : public FeatureInterfaceSettings
{
  
public:
  
  ImageFeatureRelaxationSettings();

  virtual void configureWidget(FeatureInterfaceWidget *widget) const;
  
  virtual void getWidgetConfig(const FeatureInterfaceWidget *widget);

  virtual void configureAlgo(girl::shared_ptr<ise::FeatureComputer> algo) const;
  
  virtual girl::shared_ptr<FeatureInterfaceSettings> clone() const;

  virtual bool isValid() const;

private:
  ise::FeatureComputerPtr m_algo;
  int m_connexity;
  
};

#endif /* ! IMAGEFEATURERELAXATIONSETTINGS_HPP */
