/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef IMAGEFEATURERELAXATIONWIDGET_HPP
#define IMAGEFEATURERELAXATIONWIDGET_HPP

#include <QWidget>
#include <QVector>

#include <qiseTools/ImageFeatureWidgetInterface.hpp>

class QLabel;
class QGridLayout;
class WeightedChannelsImageFeatureWidget;
class QRadioButton;

namespace ise {
class SegmentationContext;
}

class GIRL_API ImageFeatureRelaxationWidget : public ImageFeatureWidgetInterface
{

    Q_OBJECT

public:

    /**
   * @brief Constructor.
   */
    ImageFeatureRelaxationWidget(MainView *mainView,
                                          FeatureComputerGUIInfoPtr featureComputerGUIInfo,
                                          QString name,
                                          ImageFeaturePlugin *imageFeaturePlugin,
                                          QWidget *parent=NULL);

    virtual ~ImageFeatureRelaxationWidget()
    {
    }

    virtual void build();
    virtual bool isValid();

    void setParameters(const ise::FeatureComputerPtr &algo, int connexity);
    void getParameters(ise::FeatureComputerPtr &data, int &connexity) const;

private:

    WeightedChannelsImageFeatureWidget *m_wcifw;
    QRadioButton *m_4connexButton;
    QRadioButton *m_8connexButton;

};

#endif /* ! IMAGEFEATURERELAXATIONWIDGET_HPP */
