/*
  Copyright (C) 2005-2011 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef IMAGEFEATURECOLORIMETRICWIDGETPLUGIN_HPP
#define IMAGEFEATURECOLORIMETRICWIDGETPLUGIN_HPP

#include <girl/girlCommon.hpp>

#include <qiseTools/FeatureListMultiPluginWidget.hpp>
#include <qiseTools/ImageFeatureWidgetPlugin.hpp>
#include <qiseTools/ImageFeatureColorimetricWidget.hpp>
#include <qiseTools/FeatureComputerGUIInfo.hpp>

class GIRL_API ImageFeatureColorimetricWidgetPlugin : public QObject
  , public ImageFeatureWidgetPlugin
{
  Q_OBJECT
  Q_INTERFACES(ImageFeatureWidgetPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
    Q_PLUGIN_METADATA(IID ImageFeatureWidgetPlugin_iid)
#endif

 public:

    ~ImageFeatureColorimetricWidgetPlugin() {}

  ImageFeatureColorimetricWidgetPlugin()
    : ImageFeatureWidgetPlugin(QString::fromUtf8("ColorimetricWidget"),
					   QIseVersion(1, 0), QIseVersion(1, 0))
    {}

  virtual FeatureListMultiPluginWidget *widget(MainView *mainView, QWidget *parent = NULL)
  { return new ImageFeatureColorimetricWidget(mainView, name(), parent); }

};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseImageFeatureColorimetricWidgetPlugin, ImageFeatureColorimetricWidgetPlugin)
#endif

#endif /* !  IMAGEFEATURECOLORIMETRICWIDGETPLUGIN_HPP */
