/*
  Copyright (C) 2011 Cédric Aguerre  aguerre@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef MERGEALGORITHMNORMALIZEDCUTWIDGET_HPP
#define MERGEALGORITHMNORMALIZEDCUTWIDGET_HPP

#include <qiseTools/MergeAlgorithmWidgetInterface.hpp>
#include <QRadioButton>

#include <NormalizedCutMergeAlgorithm.hpp>

class QSpinBox;
class QDoubleSpinBox;

class MainView;
class MergeAlgorithmPlugin;

namespace ise {
  class MergeAlgorithm;
}

class GIRL_API MergeAlgorithmNormalizedCutWidget : public MergeAlgorithmWidgetInterface
{
  Q_OBJECT

public:
  MergeAlgorithmNormalizedCutWidget(MergeAlgorithmPlugin *mergeAlgorithmPlugin,
				    QWidget *parent = NULL);

  virtual void setMainView(MainView *v);

  void setParameters(int nbClusters, int distance, ncut::NormalizedCutMergeAlgorithm::NeighbouringType neighType, ncut::NormalizedCutMergeAlgorithm::SimilarityCriterion criterion, double sampleRate, double edgeVariance);
  void getParameters(int &nbClusters, int &distance, ncut::NormalizedCutMergeAlgorithm::NeighbouringType &neighType, ncut::NormalizedCutMergeAlgorithm::SimilarityCriterion &criterion, double &sampleRate, double &edgeVariance) const;

protected slots:

  void changeNeighbouringType(bool checked);
  void changeSimilarityCriterion(bool checked);

protected:

  void buildGUI();

 private:

  QRadioButton *m_radioNeighbouringGeometric;
  QRadioButton *m_radioNeighbouringGraphGeodesic;
  QRadioButton *m_radioSimilarityGray;
  QRadioButton *m_radioSimilarityIC;

  QSpinBox *m_nbClustersSB;
  QSpinBox *m_distanceSB;
  QDoubleSpinBox *m_sampleRateSB;
  QDoubleSpinBox *m_edgeVarianceSB;
};


#endif /* ! MERGEALGORITHMNORMALIZEDCUTWIDGET_HPP */
