#ifndef SIMPLEMERGEALGORITHMPLUGIN_HPP
#define SIMPLEMERGEALGORITHMPLUGIN_HPP

#include <qiseTools/MergeAlgorithmPlugin.hpp>

#include <ise/iseMergeAlgorithmDefault.hpp>

#include <QObject>

class SimpleMergeAlgorithmPlugin : public QObject,
				   public MergeAlgorithmPlugin
{

  Q_OBJECT
  Q_INTERFACES(MergeAlgorithmPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID MergeAlgorithmPlugin_iid)
#endif
    
public:
    
  ~SimpleMergeAlgorithmPlugin() {}
  
  SimpleMergeAlgorithmPlugin()
    : MergeAlgorithmPlugin(QString::fromUtf8("Simple merge algorithm"),
			   QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  

  virtual girl::shared_ptr<ise::MergeAlgorithm>
    create(ise::SegmentationContext *segContext)
  {
    girl::shared_ptr<ise::MergeAlgorithm> result(new ise::MergeAlgorithmDefault(segContext));
    return result;
  }
  
  virtual girl::shared_ptr<MergeAlgorithmSettings>
  createSettings(ise::SegmentationContext* /*segContext*/)
  {
    return girl::shared_ptr<MergeAlgorithmSettings>(); //NULL
  }

  virtual bool hasSettings() const
  {
    return false;
  }

protected:

  virtual MergeAlgorithmWidgetInterface *
  createWidget(ise::SegmentationContext * /*segContext*/, QWidget * /*parent*/)
  {
    return NULL;
  }
 

protected:
  
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseSimpleMergeAlgorithmPlugin, SimpleMergeAlgorithmPlugin)
#endif

#endif /* ! SIMPLEMERGEALGORITHMPLUGIN_HPP */
