#ifndef UNTILMERGEALGORITHMPLUGIN_HPP
#define UNTILMERGEALGORITHMPLUGIN_HPP

#include <qiseTools/MergeAlgorithmPlugin.hpp>

#include <ise/iseMergeAlgorithmUntil.hpp>

#include <QObject>

class UntilMergeAlgorithmPlugin : public QObject,
				  public MergeAlgorithmPlugin
{
  
  Q_OBJECT
  Q_INTERFACES(MergeAlgorithmPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID MergeAlgorithmPlugin_iid)
#endif
    
public:
    
  ~UntilMergeAlgorithmPlugin() {}
  
  UntilMergeAlgorithmPlugin()
    : MergeAlgorithmPlugin(QString::fromUtf8("Until merge algorithm"),
			   QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::MergeAlgorithm>
    create(ise::SegmentationContext *segContext)
  {
    girl::shared_ptr<ise::MergeAlgorithm> result(new ise::MergeAlgorithmUntil(segContext));
    return result;
  }
  
  
  virtual girl::shared_ptr<MergeAlgorithmSettings>
  createSettings(ise::SegmentationContext* /*segContext*/)
  {
    return girl::shared_ptr<MergeAlgorithmSettings>(); //NULL
  }

  virtual bool hasSettings() const
  {
    return false;
  }
  
 
protected:

  virtual MergeAlgorithmWidgetInterface *
  createWidget(ise::SegmentationContext * /*segContext*/, QWidget * /*parent*/)
  {
    return NULL;
  }
 
protected:

};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseUntilMergeAlgorithmPlugin, UntilMergeAlgorithmPlugin)
#endif

#endif /* ! UNTILMERGEALGORITHMPLUGIN_HPP */
