/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef MERGEDRIVERCLUSTERERWIDGET_HPP
#define MERGEDRIVERCLUSTERERWIDGET_HPP


#include <qiseTools/MergeDriverWidgetInterface.hpp>
#include <qiseTools/PluginIndexChoiceWidget.hpp>
#include <qiseTools/ClustererWidgetInterface.hpp>
#include <map>

#include <QString>

class MergeDriverWidget;
class RegionFeatureChoiceComboWidget;

class MergeDriverClustererWidget : public MergeDriverWidgetInterface
{
  Q_OBJECT

  public:

  MergeDriverClustererWidget(MainView *mainView, MergeDriverPlugin *plugin = NULL, QWidget *parent = NULL);

  void setParameters(girl::shared_ptr<ise::Clusterer> activeClusterer, const girl::shared_ptr<ise::RegionSetInterface> &algo);

  void getParameters(girl::shared_ptr<ise::Clusterer> &activeClusterer, girl::shared_ptr<ise::RegionSetInterface> &data) const;

  virtual void setNeighbouringModes(girl::toger::neighbouringModes neighbourhoodMode);

  virtual girl::toger::neighbouringModes getNeighbouringModes() const;

  virtual void setMarkFlags(girl::toger::markFlags m);

  virtual girl::toger::markFlags getMarkFlags() const;


protected slots:
  
  void showWidget(int);

protected:
  
  void buildGUI();
  
  
protected:

  MergeDriverWidget *m_mergeDriverWidget;

  RegionFeatureChoiceComboWidget *m_rfccw;
  PluginIndexChoiceWidget *m_clustererCB;

  std::map<QString, ClustererWidgetInterface*> m_clusterer;
  ClustererWidgetInterface* m_activeClustererWidget;
};


#endif /* ! MERGEDRIVERCLUSTERERWIDGET_HPP */
