#ifndef COLORDISTANCEMERGEDRIVERPLUGIN_HPP
#define COLORDISTANCEMERGEDRIVERPLUGIN_HPP

#include <qiseTools/MergeDriverPlugin.hpp>

#include <ise/iseMergeDriverColorDistance.hpp>

#include <qiseTools/MergeDriverColorDistanceWidget.hpp>

#include <QObject>

class ColorDistanceMergeDriverPlugin : public QObject,
				       public MergeDriverPlugin
{

  Q_OBJECT
  Q_INTERFACES(MergeDriverPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID MergeDriverPlugin_iid)
#endif
    
public:
    
  ~ColorDistanceMergeDriverPlugin() {}
  
  ColorDistanceMergeDriverPlugin()
    : MergeDriverPlugin(QString::fromUtf8("Color distance merge driver"),
			QIseVersion(1, 0), QIseVersion(1, 0)),
      m_memento()
  {}
  
  virtual girl::shared_ptr<ise::MergeDriver> create()
  {
    girl::shared_ptr<ise::MergeDriver> result(new ise::MergeDriverColorDistance(m_segContext));
    return result;
  }
  
  virtual girl::shared_ptr<MergeDriverSettings> createSettings(ise::SegmentationContext* segContext)
  {
    //TODO
    //add hasSettings() ???
  }
  
  
protected:
  
  virtual MergeDriverWidgetInterface* createWidget()
  {
    return new MergeDriverColorDistanceWidget(m_segContext, this);
  }

};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseColorDistanceMergeDriverPlugin, ColorDistanceMergeDriverPlugin)
#endif

#endif /* ! COLORDISTANCEMERGEDRIVERPLUGIN_HPP */
