#ifndef COLORHOMOGENEITYMERGEDRIVERPLUGIN_HPP
#define COLORHOMOGENEITYMERGEDRIVERPLUGIN_HPP

#include <qiseTools/MergeDriverPlugin.hpp>

#include <ise/iseMergeDriverColorHomogeneity.hpp>

#include <qiseTools/MergeDriverColorHomogeneityWidget.hpp>

#include <QObject>

class ColorHomogeneityMergeDriverPlugin : public QObject,
					  public MergeDriverPlugin
{

  Q_OBJECT
  Q_INTERFACES(MergeDriverPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID MergeDriverPlugin_iid)
#endif
    
public:
    
  ~ColorHomogeneityMergeDriverPlugin() {}
  
  ColorHomogeneityMergeDriverPlugin()
    : MergeDriverPlugin(QString::fromUtf8("Color homogeneity merge driver"),
			QIseVersion(1, 0), QIseVersion(1, 0)),
      m_memento()
  {}
  
  virtual girl::shared_ptr<ise::MergeDriver> create()
  {
    girl::shared_ptr<ise::MergeDriver> result(new ise::MergeDriverColorHomogeneity(m_segContext));
    return result;
  }
  
  virtual girl::shared_ptr<MergeDriverSettings> createSettings(ise::SegmentationContext* segContext)
  {
    //TODO
    //add hasSettings() ???
  }
  
  
protected:
  
  virtual MergeDriverWidgetInterface* createWidget()
  {
    return new MergeDriverColorHomogeneityWidget(m_segContext, this);
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseColorHomogeneityMergeDriverPlugin, ColorHomogeneityMergeDriverPlugin)
#endif

#endif /* ! COLORHOMOGENEITYMERGEDRIVERPLUGIN_HPP */
