/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef CONTEXTUALMERGEDRIVERPLUGIN_HPP_
#define CONTEXTUALMERGEDRIVERPLUGIN_HPP_

#include <QObject>

#include <qiseTools/MergeDriverPlugin.hpp>

#include "iseContextualMergeDriver.hpp"
#include "ContextualMergeDriverWidget.hpp"

class ContextualMergeDriverPlugin : public QObject,
                                public MergeDriverPlugin
{

  Q_OBJECT
  Q_INTERFACES(MergeDriverPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID MergeDriverPlugin_iid)
#endif

public:

  ~ContextualMergeDriverPlugin() {}

  ContextualMergeDriverPlugin()
    : MergeDriverPlugin(QString::fromUtf8("Contextual merge driver"),
                        QIseVersion(1, 0), QIseVersion(1, 0)),
      m_memento()
  {}

  virtual girl::shared_ptr<ise::MergeDriver> create()
  {
    girl::shared_ptr<ise::MergeDriver> result(new ise::ContextualMergeDriver(m_segContext));
    return result;
  }

  virtual girl::shared_ptr<MergeDriverSettings> createSettings(ise::SegmentationContext* segContext)
  {
    //TODO
    //add hasSettings() ???
  }

protected:

  virtual MergeDriverWidgetInterface* createWidget()
  {
    return new ContextualMergeDriverWidget(m_segContext, this);
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseContextualMergeDriverPlugin, ContextualMergeDriverPlugin)
#endif

#endif /* CONTEXTUALMERGEDRIVERPLUGIN_HPP_ */
