/*
 * iseContextualMergeDriver.hpp
 *
 *  Created on: Oct 22, 2010
 *      Author: vieux
 */

#ifndef ISECONTEXTUALMERGEDRIVER_HPP_
#define ISECONTEXTUALMERGEDRIVER_HPP_

#include <ise/iseMergeDriverDefault.hpp>
#include <ise/iseRegionSetBinaryFunctionEuclideanDistance.hpp>
#include <ise/iseRegionSetInterface.hpp>
#include <ise/iseRegionSetParameters.hpp>


/**
 * Test class for a method of merge based on Voronoi Area and neighborhood position
 */
namespace ise
{

  class GIRL_API ContextualMergeDriver : public ise::MergeDriverDefault
  {
  public:
    explicit ContextualMergeDriver(ise::SegmentationContext *segContext);

    virtual ~ContextualMergeDriver();

    virtual double distance(girl::region reg1Id, girl::region reg2Id);
    virtual bool allowed(girl::region reg1Id, girl::region reg2Id, int level);


    double
    getThreshold() const
    {
      return m_threshold;
    }

    void
    setThreshold(double m_threshold)
    {
      this->m_threshold = m_threshold;
    }

    ise::RegionSetParameters&
    getContextParams()
    {
      return m_contextParams;
    }

    const girl::shared_ptr<ise::RegionSetInterface>
    getRegSetContext() const
    {
      return m_regSetContext;
    }

    void
    setContextParams(ise::RegionSetParameters m_contextParams)
    {
      this->m_contextParams = m_contextParams;
    }

  public:

    virtual MergeDriverMemento *createMemento() const {
      return new ise::MergeDriverDefault::MergeDriverDefaultMemento;
    }

  private:

    girl::shared_ptr<ise::RegionSetInterface> m_regSetContext;
    girl::shared_ptr<ise::RegionSetInterface> m_regSetGravityCenter;

    //REMI: Why cant I use the interface here? Coz of params... but hell
    girl::shared_ptr<ise::RegionSetBinaryFunctionEuclideanDistance> m_distanceComputer;
    ise::RegionSetParameters m_contextParams;

    double m_threshold;

  };

}

#endif /* ISECONTEXTUALMERGEDRIVER_HPP_ */
