/*
  Copyright (C) 2010-2011 Remi Vieux, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef GEOCOLORMERGEDRIVERPLUGIN_HPP
#define GEOCOLORMERGEDRIVERPLUGIN_HPP

#include <qiseTools/MergeDriverPlugin.hpp>

#include <ise/iseMergeDriverGeoColor.hpp>

#include <qiseTools/MergeDriverGeoColorWidget.hpp>

#include <QObject>

class GeoColorMergeDriverPlugin : public QObject,
				       public MergeDriverPlugin
{

  Q_OBJECT
  Q_INTERFACES(MergeDriverPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID MergeDriverPlugin_iid)
#endif
    
public:
    
  ~GeoColorMergeDriverPlugin() {}
  
  GeoColorMergeDriverPlugin()
    : MergeDriverPlugin(QString::fromUtf8("Geo/Color merge driver"),
			QIseVersion(1, 0), QIseVersion(1, 0)),
      m_memento()
  {}
  
  virtual girl::shared_ptr<ise::MergeDriver> create()
  {
    girl::shared_ptr<ise::MergeDriver> result(new ise::MergeDriverGeoColor(m_segContext));
    return result;
  }
  
  virtual girl::shared_ptr<MergeDriverSettings> createSettings(ise::SegmentationContext* segContext)
  {
    //TODO
    //add hasSettings() ???
  }
  
  
protected:
  
  virtual MergeDriverWidgetInterface* createWidget()
  {
    return new MergeDriverGeoColorWidget(m_segContext, this);
  }

};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseGeoColorMergeDriverPlugin, GeoColorMergeDriverPlugin)
#endif

#endif /* ! GEOCOLORMERGEDRIVERPLUGIN_HPP */
