#ifndef GRADIENTMERGEDRIVERPLUGIN_HPP
#define GRADIENTMERGEDRIVERPLUGIN_HPP

#include <qiseTools/MergeDriverPlugin.hpp>

#include <ise/iseMergeDriverGradient.hpp>

#include <qiseTools/MergeDriverGradientWidget.hpp>

#include <QObject>

class GradientMergeDriverPlugin : public QObject,
				       public MergeDriverPlugin
{

  Q_OBJECT
  Q_INTERFACES(MergeDriverPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID MergeDriverPlugin_iid)
#endif
    
public:
    
  ~GradientMergeDriverPlugin() {}
  
  GradientMergeDriverPlugin()
    : MergeDriverPlugin(QString::fromUtf8("Gradient merge driver"),
			QIseVersion(1, 0), QIseVersion(1, 0)),
      m_memento()
  {}
  
  virtual girl::shared_ptr<ise::MergeDriver> create()
  {
    girl::shared_ptr<ise::MergeDriver> result(new ise::MergeDriverGradient(m_segContext));
    return result;
  }
  
  virtual girl::shared_ptr<MergeDriverSettings> createSettings(ise::SegmentationContext* segContext)
  {
    //TODO
    //add hasSettings() ???
  }
  
protected:
  
  virtual MergeDriverWidgetInterface* createWidget()
  {
    return new MergeDriverGradientWidget(this);
  }

};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseGradientMergeDriverPlugin, GradientMergeDriverPlugin)
#endif

#endif /* ! GRADIENTMERGEDRIVERPLUGIN_HPP */
