/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef MERGEDRIVERGRADIENTWIDGET_HPP
#define MERGEDRIVERGRADIENTWIDGET_HPP

#include "MergeDriverWidgetInterface.hpp"

namespace ise {
  class MergeDriver;
  class MergeDriverGradient;
}


class MergeDriverWidget;
class SliderSpinBoxWidget;
class WeightedChannelsColorSpaceWidget;
class PluginIndexChoiceWidget;

class GIRL_API MergeDriverGradientWidget : public MergeDriverWidgetInterface
{

public:
  MergeDriverGradientWidget(MergeDriverPlugin *mergeDriverPlugin,
			    QWidget *parent = NULL);

  virtual void setGUI();
  virtual void getGUI();
 

protected:

  void buildGUI();


protected:
  MergeDriverWidget *m_mergeDriverWidget;
  WeightedChannelsColorSpaceWidget *m_wccsw;
  SliderSpinBoxWidget *m_thresholdSB;

  //TODO: Remove
  PluginIndexChoiceWidget *m_rupcw;

};





#endif /* ! MERGEDRIVERGRADIENTWIDGET_HPP */
