/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef MEANDISTANCEMERGEDRIVERPLUGIN_HPP_
#define MEANDISTANCEMERGEDRIVERPLUGIN_HPP_

//#include <girl/girlCommon.hpp>
#include <qiseTools/MergeDriverPlugin.hpp>

#include <ise/iseMergeDriverMeanDistance.hpp>

//TODO:
//#include <qiseTools/MergeDriverMeanDistanceWidget.hpp>

#include <QObject>

class MeanDistanceMergeDriverPlugin: public QObject,
                                     public MergeDriverPlugin

{

  Q_OBJECT
  Q_INTERFACES(MergeDriverPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID MergeDriverPlugin_iid)
#endif

public:

  ~MeanDistanceMergeDriverPlugin() {}

  MeanDistanceMergeDriverPlugin()
  : MergeDriverPlugin(QString::fromUtf8("Mean distance merge driver"),
                                        QIseVersion(1, 0), QIseVersion(1, 0)),
      m_memento()
  {}

  virtual girl::shared_ptr<ise::MergeDriver> create()
  {
    girl::shared_ptr<ise::MergeDriver> result(new ise::MergeDriverMeanDistance(m_segContext));
    return result;
  }

  virtual girl::shared_ptr<MergeDriverSettings> createSettings(ise::SegmentationContext* segContext)
  {
    //TODO
    // add hasSettings() ???
  }

protected:

  virtual MergeDriverWidgetInterface* createWidget()
  {
    //return new MergeDriverMeanDistanceWidget(m_segContext, this);
    return NULL;
  }


};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseMeanDistanceMergeDriverPlugin, MeanDistanceMergeDriverPlugin)
#endif


#endif /* MEANDISTANCEMERGEDRIVERPLUGIN_HPP_ */
