/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef MERGEDRIVERMETASETTINGS_HPP_
#define MERGEDRIVERMETASETTINGS_HPP_

#include <ise/iseMergeDriverMeta.hpp>
#include <qiseTools/MergeDriverSettings.hpp>

//#include <qiseTools/RegionUnaryPredicatePlugin.hpp>
#include <qiseTools/RegionStrictWeakOrderingPlugin.hpp>
#include <qiseTools/RegionBinaryPredicatePlugin.hpp>
#include <qiseTools/RegionBinaryFunctionPlugin.hpp>

class MergeDriverWidgetInterface;


class MergeDriverMetaSettings : public MergeDriverSettings
{
public:
  
  virtual void configureWidget(MergeDriverWidgetInterface *widget) const;

  virtual void getWidgetConfig(const MergeDriverWidgetInterface *widget);

  virtual void configureAlgo(girl::shared_ptr<ise::MergeDriver> algo) const;

  virtual girl::shared_ptr<MergeDriverSettings> clone() const;

  virtual bool isValid() const;


  /*
  void setFilterPredicatePlugin(RegionUnaryPredicatePlugin *p)
  {
    m_filterPredicate = p;
  }

  RegionUnaryPredicatePlugin *getFilterPredicatePlugin()
  {
    return m_filterPredicate;
  }
  */

  void setStrictWeakOrderingPlugin(RegionStrictWeakOrderingPlugin *p)
  {
    m_sortOrdering = p;
  }

  RegionStrictWeakOrderingPlugin *getStrictWeakOrderingPlugin()
  {
    return m_sortOrdering;
  }

  void setAllowMergePredicatePlugin(RegionBinaryPredicatePlugin *p)
  {
    m_allowMergePredicate = p;
  }

  RegionBinaryPredicatePlugin *getAllowMergePredicatePlugin()
  {
    return m_allowMergePredicate;
  }

  void setDistanceFunctionPlugin(RegionBinaryFunctionPlugin *f)
  {
    m_distanceFunction = f;
  }

  RegionBinaryFunctionPlugin *getDistanceFunctionPlugin()
  {
    return m_distanceFunction;
  }

protected:

  /*
  RegionUnaryPredicatePlugin *m_filterPredicate;
  girl::shared_ptr<RegionUnaryPredicateSettings> m_filterSettings;
  */

  RegionStrictWeakOrderingPlugin *m_sortOrdering;
  girl::shared_ptr<RegionStrictWeakOrderingSettings> m_sortOrderingSettings;

  RegionBinaryPredicatePlugin *m_allowMergePredicate;
  girl::shared_ptr<RegionBinaryPredicateSettings> m_allowMergeSettings;

  RegionBinaryFunctionPlugin *m_distanceFunction;
  girl::shared_ptr<RegionBinaryFunctionSettings> m_distanceSettings;
};


#endif /* ! MERGEDRIVERMETASETTINGS_HPP_ */
