/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef MERGEDRIVERMETAWIDGET_HPP_
#define MERGEDRIVERMETAWIDGET_HPP_

#include <qiseTools/MergeDriverWidgetInterface.hpp>

class MergeDriverWidget;
class MergeDriverPlugin;
class PluginIndexChoiceWidget;
//class RegionUnaryPredicateComboWidget;
class RegionStrictWeakOrderingComboWidget;
class RegionBinaryPredicateComboWidget;
class RegionBinaryFunctionComboWidget;
//class RegionUnaryPredicatePlugin;
class RegionStrictWeakOrderingPlugin;
class RegionBinaryPredicatePlugin;
class RegionBinaryFunctionPlugin;
class MainView;

class MergeDriverMetaWidget : public MergeDriverWidgetInterface
{
  Q_OBJECT

  public:

  MergeDriverMetaWidget(MainView *mainView, MergeDriverPlugin *plugin = NULL, QWidget *parent = NULL);


  /*
  void setFilterPredicatePlugin(RegionUnaryPredicatePlugin *);

  RegionUnaryPredicatePlugin *getFilterPredicatePlugin() const;
  */

  void setStrictWeakOrderingPlugin(RegionStrictWeakOrderingPlugin *);

  RegionStrictWeakOrderingPlugin *getStrictWeakOrderingPlugin() const;

  void setAllowMergePredicatePlugin(RegionBinaryPredicatePlugin *);

  RegionBinaryPredicatePlugin *getAllowMergePredicatePlugin() const;

  void setDistanceFunctionPlugin(RegionBinaryFunctionPlugin *);

  RegionBinaryFunctionPlugin *getDistanceFunctionPlugin() const;

  virtual void setNeighbouringModes(girl::toger::neighbouringModes neighbourhoodMode);

  virtual girl::toger::neighbouringModes getNeighbouringModes() const;

  virtual void setMarkFlags(girl::toger::markFlags m);

  virtual girl::toger::markFlags getMarkFlags() const;


protected:

  void buildGUI();


protected:

  MergeDriverWidget *m_mergeDriverWidget;

  //QWidget *m_filterPage;
  QWidget *m_swoPage;
  QWidget *m_allowPage;
  QWidget *m_distancePage;

  //RegionUnaryPredicateComboWidget *m_filterCW;
  RegionStrictWeakOrderingComboWidget *m_swoCW;
  RegionBinaryPredicateComboWidget *m_allowCW;
  RegionBinaryFunctionComboWidget *m_distanceCW;
};


#endif /* ! MERGEDRIVERMETAWIDGET_HPP_ */
