/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef MERGEDRIVERMINIMALDISTANCEPLUGIN_HPP_
#define MERGEDRIVERMINIMALDISTANCEPLUGIN_HPP_

#include <ise/iseMergeDriverMinimalDistance.hpp>

#include <qiseTools/MergeDriverPlugin.hpp>
#include "MergeDriverMinimalDistanceWidget.hpp"
#include "MergeDriverMinimalDistanceSettings.hpp"

#include <QObject>

class MergeDriverMinimalDistancePlugin : public QObject,
			      public MergeDriverPlugin
{
  Q_OBJECT
  Q_INTERFACES(MergeDriverPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID MergeDriverPlugin_iid)
#endif

public:

  MergeDriverMinimalDistancePlugin()
    : MergeDriverPlugin(QString::fromUtf8("Merge Driver Minimal Distance"),
			QIseVersion(1, 0), QIseVersion(1, 0))
  {}

  ~MergeDriverMinimalDistancePlugin() {}



  virtual girl::shared_ptr<ise::MergeDriver> create(ise::SegmentationContext *segContext)
  {
    girl::shared_ptr<ise::MergeDriver> result
      = ise::MergeDriverMinimalDistanceFactory::instance().create(segContext);
    return result;
  }
  
  virtual girl::shared_ptr<MergeDriverSettings> createSettings(ise::SegmentationContext* /*segContext*/)
  {
    return girl::shared_ptr<MergeDriverSettings>(new MergeDriverMinimalDistanceSettings());
  }

protected:

  virtual MergeDriverWidgetInterface *createWidget(MainView *mainView, QWidget *parent)
  {
    return new MergeDriverMinimalDistanceWidget(mainView, this, parent);
  }


protected:

};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseMergeDriverMinimalDistancePlugin, MergeDriverMinimalDistancePlugin)
#endif

#endif /* MERGEDRIVERMINIMALDISTANCEPLUGIN_HPP_ */
