/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef MERGEDRIVERMINIMALDISTANCESETTINGS_HPP_
#define MERGEDRIVERMINIMALDISTANCESETTINGS_HPP_

#include <ise/iseMergeDriverMinimalDistance.hpp>
#include <qiseTools/MergeDriverSettings.hpp>


#include <qiseTools/RegionUnaryPredicatePlugin.hpp>
#include <qiseTools/RegionStrictWeakOrderingPlugin.hpp>
#include <qiseTools/RegionBinaryPredicatePlugin.hpp>
#include <qiseTools/RegionBinaryFunctionPlugin.hpp>

class MergeDriverWidgetInterface;


class MergeDriverMinimalDistanceSettings : public MergeDriverSettings
{
public:
  
  virtual void configureWidget(MergeDriverWidgetInterface *widget) const;

  virtual void getWidgetConfig(const MergeDriverWidgetInterface *widget);

  virtual void configureAlgo(girl::shared_ptr<ise::MergeDriver> algo) const;

  virtual girl::shared_ptr<MergeDriverSettings> clone() const;

  virtual bool isValid() const;


  void setDistanceFunctionPlugin(RegionBinaryFunctionPlugin *f)
  {
    m_distanceFunction = f;
  }

  RegionBinaryFunctionPlugin *getDistanceFunctionPlugin()
  {
    return m_distanceFunction;
  }

protected:

  RegionBinaryFunctionPlugin *m_distanceFunction;
  girl::shared_ptr<RegionBinaryFunctionSettings> m_distanceSettings;
};


#endif /* ! MERGEDRIVERMINIMALDISTANCESETTINGS_HPP_ */
