/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef MERGEDRIVERMINIMALDISTANCEWIDGET_HPP_
#define MERGEDRIVERMINIMALDISTANCEWIDGET_HPP_

#include <qiseTools/MergeDriverWidgetInterface.hpp>

class MainView;
class MergeDriverWidget;
class MergeDriverPlugin;
class RegionBinaryFunctionComboWidget;
class RegionBinaryFunctionPlugin;


class MergeDriverMinimalDistanceWidget : public MergeDriverWidgetInterface
{
  Q_OBJECT

  public:

  MergeDriverMinimalDistanceWidget(MainView *mainView, MergeDriverPlugin *plugin = NULL, QWidget *parent = NULL);


  void setDistanceFunctionPlugin(RegionBinaryFunctionPlugin *);

  RegionBinaryFunctionPlugin *getDistanceFunctionPlugin() const;


  virtual void setNeighbouringModes(girl::toger::neighbouringModes neighbourhoodMode);

  virtual girl::toger::neighbouringModes getNeighbouringModes() const;

  virtual void setMarkFlags(girl::toger::markFlags m);

  virtual girl::toger::markFlags getMarkFlags() const;


protected:

  void buildGUI();


protected:

  MergeDriverWidget *m_mergeDriverWidget;
  RegionBinaryFunctionComboWidget *m_rbfcw;
};


#endif /* ! MERGEDRIVERMINIMALDISTANCEWIDGET_HPP_ */
