#ifndef SIMPLEMERGEDRIVERPLUGIN_HPP
#define SIMPLEMERGEDRIVERPLUGIN_HPP

#include <ise/iseMergeDriverDefault.hpp>
#include <qiseTools/MergeDriverPlugin.hpp>
#include <qiseTools/MergeDriverDefaultWidget.hpp>


#include <QObject>

class SimpleMergeDriverPlugin : public QObject,
				public MergeDriverPlugin
{

  Q_OBJECT
  Q_INTERFACES(MergeDriverPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID MergeDriverPlugin_iid)
#endif
    
public:
    
  ~SimpleMergeDriverPlugin() {}
  
  SimpleMergeDriverPlugin()
    : MergeDriverPlugin(QString::fromUtf8("Simple merge driver"),
			QIseVersion(1, 0), QIseVersion(1, 0)),
      m_memento()
  {}
  
  virtual girl::shared_ptr<ise::MergeDriver> create()
  {
    girl::shared_ptr<ise::MergeDriver> result(new ise::MergeDriverDefault(m_segContext));
    return result;
  }
  
  virtual girl::shared_ptr<MergeDriverSettings> createSettings(ise::SegmentationContext* segContext)
  {
    //TODO
    // add hasSettings() ???
  }
  
  
protected:

  virtual MergeDriverWidgetInterface* createWidget()
  {
    return new MergeDriverDefaultWidget(m_segContext, this);
  }

};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseSimpleMergeDriverPlugin, SimpleMergeDriverPlugin)
#endif

#endif /* ! SIMPLEMERGEDRIVERPLUGIN_HPP */
