#ifndef SIZEFILTERGINMERGEDRIVERPLUGIN_HPP
#define SIZEFILTERGINMERGEDRIVERPLUGIN_HPP

#include <qiseTools/MergeDriverPlugin.hpp>

#include <ise/iseMergeDriverSizeFiltering.hpp>

#include <qiseTools/MergeDriverSizeFilteringWidget.hpp>

#include <QObject>

class SizeFilteringMergeDriverPlugin : public QObject,
				       public MergeDriverPlugin
{

  Q_OBJECT
  Q_INTERFACES(MergeDriverPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID MergeDriverPlugin_iid)
#endif
    
public:
    
  ~SizeFilteringMergeDriverPlugin() {}
  
  SizeFilteringMergeDriverPlugin()
    : MergeDriverPlugin(QString::fromUtf8("Size Filtering merge driver"),
			QIseVersion(1, 0), QIseVersion(1, 0)),
      m_memento()
  {}
  
  virtual girl::shared_ptr<ise::MergeDriver> create()
  {
    girl::shared_ptr<ise::MergeDriver> result(new ise::MergeDriverSizeFiltering(m_segContext));
    return result;
  }
  
  virtual girl::shared_ptr<MergeDriverSettings> createSettings(ise::SegmentationContext* segContext)
  {
    //TODO
    // add hasSettings() ???
  }

  
protected:
  
  virtual MergeDriverWidgetInterface* parameterWidget()
  {
    return new MergeDriverSizeFilteringWidget(m_segContext, this);
  }

};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseSizeFilteringMergeDriverPlugin, SizeFilteringMergeDriverPlugin)
#endif

#endif /* ! SIZEFILTERGINMERGEDRIVERPLUGIN_HPP */
