#ifndef TANGENTVARIANCEMERGEDRIVERPLUGIN_HPP
#define TANGENTVARIANCEMERGEDRIVERPLUGIN_HPP

#include <qiseTools/MergeDriverPlugin.hpp>

#include <ise/iseMergeDriverTangentVariance.hpp>

#include <qiseTools/MergeDriverTangentVarianceWidget.hpp>

#include <QObject>

class MergeDriverTangentVariancePlugin : public QObject,
				       public MergeDriverPlugin
{

  Q_OBJECT
  Q_INTERFACES(MergeDriverPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID MergeDriverPlugin_iid)
#endif
    
public:
    
  ~MergeDriverTangentVariancePlugin() {}
  
  MergeDriverTangentVariancePlugin()
    : MergeDriverPlugin(QString::fromUtf8("Tangent variance merge driver"),
			QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::MergeDriver> create()
  {
    girl::shared_ptr<ise::MergeDriver> result(new ise::MergeDriverTangentVariance(m_segContext));
    return result;
  }
  
  virtual girl::shared_ptr<MergeDriverSettings> createSettings(ise::SegmentationContext* segContext)
  {
    //TODO
    //add hasSettings() ???
  }
  
protected:

  virtual MergeDriverWidgetInterface* createWidget()
  {
    return new MergeDriverTangentVarianceWidget(this);
  }
  
protected:
  
  
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseMergeDriverTangentVariancePlugin, MergeDriverTangentVariancePlugin)
#endif

#endif /* ! TANGENTVARIANCEMERGEDRIVERPLUGIN_HPP */
