/*
  Copyright (C) 2010-2011 Remi Vieux, Boris Mansencal, J.-P. Domenger  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef THRESHOLDSMERGEDRIVERPLUGIN_HPP
#define THRESHOLDSMERGEDRIVERPLUGIN_HPP

#include <qiseTools/MergeDriverPlugin.hpp>

#include <ise/iseMergeDriverThresholds.hpp>

#include <qiseTools/QIsePluginDependance.hpp>
#include <qiseTools/MergeDriverThresholdsWidget.hpp>

#include <QObject>

class ThresholdsMergeDriverPlugin : public QObject,
				    public MergeDriverPlugin
{

  Q_OBJECT
  Q_INTERFACES(MergeDriverPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID MergeDriverPlugin_iid)
#endif
    
public:
    
  ~ThresholdsMergeDriverPlugin() {}
  
  ThresholdsMergeDriverPlugin()
    : MergeDriverPlugin(QString::fromUtf8("Thresholds merge driver"),
			QIseVersion(1, 0), QIseVersion(1, 0)),
      m_memento()
  {addDependance(QIsePluginDependance(tr("SegmentationClustering/Thresholds quantification"),
				      QIseVersion(1, 0)));}
  
  virtual girl::shared_ptr<ise::MergeDriver> create()
  {
    ise::MergeDriverThresholds* mergeDriverThresholds = new ise::MergeDriverThresholds(m_segContext);
    const int threshold1 = 15;
    const int threshold2 = 125;
    mergeDriverThresholds->setThresholds(threshold1, threshold2);
    girl::shared_ptr<ise::MergeDriver> result(mergeDriverThresholds);
    return result;
  }
  
  virtual girl::shared_ptr<MergeDriverSettings> createSettings(ise::SegmentationContext* segContext)
  {
    //TODO
    //add hasSettings() ???
  }
  
  
protected:
  
  virtual MergeDriverWidgetInterface* createWidget()
  {
    return new MergeDriverThresholdsWidget(m_segContext, this);
  }
  
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseThresholdsMergeDriverPlugin, ThresholdsMergeDriverPlugin)
#endif

#endif /* ! THRESHOLDSMERGEDRIVERPLUGIN_HPP */
