/*
  Copyright (C) 2010-2011 Julian Roigt  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef BITPYRAMIDPLUGIN_HPP
#define BITPYRAMIDPLUGIN_HPP

#include <ise/iseBitPyramid.hpp>

#include <qiseTools/PyramidPlugin.hpp>

#include <qiseTools/BitPyramidWidget.hpp>
#include <qiseTools/BitPyramidSettings.hpp>

#include <QObject>

class BitPyramidPlugin : public QObject,
			 public PyramidPlugin
{

  Q_OBJECT
  Q_INTERFACES(PyramidPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID PyramidPlugin_iid)
#endif

public:

  BitPyramidPlugin()
  : PyramidPlugin(QString::fromUtf8("Bit Pyramid"),
      QIseVersion(1, 0), QIseVersion(1, 0))
  {}

  ~BitPyramidPlugin() {}

  virtual girl::shared_ptr<ise::Pyramid> getNewPyramid()
    {
      girl::shared_ptr<ise::Pyramid> result(new ise::BitPyramid());
      if (m_settings)
	m_settings->configureAlgo(result);

      return result;
    }

  virtual girl::shared_ptr<PyramidSettingsInterface> createSettings()
  {
    return girl::shared_ptr<PyramidSettingsInterface>(new BitPyramidSettings());
  }

  virtual PyramidWidget* createWidget(MainView *mainView, int numLevel, int divider, QWidget *parent = NULL)
  {
    return new BitPyramidWidget(mainView, this, numLevel, divider, parent);
  }

};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseBitPyramidPlugin, BitPyramidPlugin)
#endif

#endif /* ! BITPYRAMIDPLUGIN_HPP */
