#ifndef QUANTIFICATIONTHRESHOLDERKITTLERPLUGIN_HPP
#define QUANTIFICATIONTHRESHOLDERKITTLERPLUGIN_HPP

#include <qiseTools/QuantificationThresholderPlugin.hpp>

#include <ise/iseQuantificationThresholder.hpp>

#include <ise/iseQuantificationThresholderKittler.hpp>
#include <QObject>

class QuantificationThresholderKittlerPlugin : public QObject,
					     public QuantificationThresholderPlugin
{

  Q_OBJECT
  Q_INTERFACES(QuantificationThresholderPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID QuantificationThresholderPlugin_iid)
#endif
    
public:
    
  ~QuantificationThresholderKittlerPlugin() {}
  
  QuantificationThresholderKittlerPlugin()
    : QuantificationThresholderPlugin(QString::fromUtf8("Kittler"),
				      QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::QuantificationThresholder> getNewQuantificationThresholder()  {
    girl::shared_ptr<ise::QuantificationThresholder> result(new ise::QuantificationThresholderKittler());
    return result;
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseQuantificationThresholderKittlerPlugin, QuantificationThresholderKittlerPlugin)
#endif

#endif /* ! QUANTIFICATIONTHRESHOLDERKITTLERPLUGIN_HPP */
