#ifndef QUANTIFICATIONTHRESHOLDERLLOYDPLUGIN_HPP
#define QUANTIFICATIONTHRESHOLDERLLOYDPLUGIN_HPP

#include <qiseTools/QuantificationThresholderPlugin.hpp>

#include <ise/iseQuantificationThresholder.hpp>

#include <ise/iseQuantificationThresholderLloyd.hpp>
#include <QObject>

class QuantificationThresholderLloydPlugin : public QObject,
					     public QuantificationThresholderPlugin
{

  Q_OBJECT
  Q_INTERFACES(QuantificationThresholderPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID QuantificationThresholderPlugin_iid)
#endif
    
public:
    
  ~QuantificationThresholderLloydPlugin() {}
  
  QuantificationThresholderLloydPlugin()
    : QuantificationThresholderPlugin(QString::fromUtf8("Lloyd"),
				      QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::QuantificationThresholder> getNewQuantificationThresholder()  {
    girl::shared_ptr<ise::QuantificationThresholder> result(new ise::QuantificationThresholderLloyd());
    return result;
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseQuantificationThresholderLloydPlugin, QuantificationThresholderLloydPlugin)
#endif

#endif /* ! QUANTIFICATIONTHRESHOLDERLLOYDPLUGIN_HPP */
