#ifndef QUANTIFICATIONTHRESHOLDEROTSUPLUGIN_HPP
#define QUANTIFICATIONTHRESHOLDEROTSUPLUGIN_HPP

#include <qiseTools/QuantificationThresholderPlugin.hpp>

#include <ise/iseQuantificationThresholder.hpp>

#include <ise/iseQuantificationThresholderOtsu.hpp>
#include <QObject>

class QuantificationThresholderOtsuPlugin : public QObject,
					     public QuantificationThresholderPlugin
{

  Q_OBJECT
  Q_INTERFACES(QuantificationThresholderPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID QuantificationThresholderPlugin_iid)
#endif
    
public:
    
  ~QuantificationThresholderOtsuPlugin() {}
  
  QuantificationThresholderOtsuPlugin()
    : QuantificationThresholderPlugin(QString::fromUtf8("Otsu"),
				      QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::QuantificationThresholder> getNewQuantificationThresholder()  {
    girl::shared_ptr<ise::QuantificationThresholder> result(new ise::QuantificationThresholderOtsu());
    return result;
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseQuantificationThresholderOtsuPlugin, QuantificationThresholderOtsuPlugin)
#endif

#endif /* ! QUANTIFICATIONTHRESHOLDEROTSUPLUGIN_HPP */
