#ifndef QUANTIFICATIONTHRESHOLDEROTSU1TPLUGIN_HPP
#define QUANTIFICATIONTHRESHOLDEROTSU1TPLUGIN_HPP

#include <qiseTools/QuantificationThresholderPlugin.hpp>

#include <ise/iseQuantificationThresholder.hpp>

#include <ise/iseQuantificationThresholderOtsu1T.hpp>
#include <QObject>

class QuantificationThresholderOtsu1TPlugin : public QObject,
					     public QuantificationThresholderPlugin
{

  Q_OBJECT
  Q_INTERFACES(QuantificationThresholderPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID QuantificationThresholderPlugin_iid)
#endif
    
public:
    
  ~QuantificationThresholderOtsu1TPlugin() {}
  
  QuantificationThresholderOtsu1TPlugin()
    : QuantificationThresholderPlugin(QString::fromUtf8("Otsu (1)"),
				      QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::QuantificationThresholder> getNewQuantificationThresholder()  {
    girl::shared_ptr<ise::QuantificationThresholder> result(new ise::QuantificationThresholderOtsu1T());
    return result;
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseQuantificationThresholderOtsu1TPlugin, QuantificationThresholderOtsu1TPlugin)
#endif

#endif /* ! QUANTIFICATIONTHRESHOLDEROTSU1TPLUGIN_HPP */
