#ifndef QUANTIFICATIONTHRESHOLDEROTSU2TPLUGIN_HPP
#define QUANTIFICATIONTHRESHOLDEROTSU2TPLUGIN_HPP

#include <qiseTools/QuantificationThresholderPlugin.hpp>

#include <ise/iseQuantificationThresholder.hpp>

#include <ise/iseQuantificationThresholderOtsu2T.hpp>
#include <QObject>

class QuantificationThresholderOtsu2TPlugin : public QObject,
					     public QuantificationThresholderPlugin
{

  Q_OBJECT
  Q_INTERFACES(QuantificationThresholderPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID QuantificationThresholderPlugin_iid)
#endif
    
public:
    
  ~QuantificationThresholderOtsu2TPlugin() {}
  
  QuantificationThresholderOtsu2TPlugin()
    : QuantificationThresholderPlugin(QString::fromUtf8("Otsu (2)"),
				      QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::QuantificationThresholder> getNewQuantificationThresholder()  {
    girl::shared_ptr<ise::QuantificationThresholder> result(new ise::QuantificationThresholderOtsu2T());
    return result;
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseQuantificationThresholderOtsu2TPlugin, QuantificationThresholderOtsu2TPlugin)
#endif

#endif /* ! QUANTIFICATIONTHRESHOLDEROTSU2TPLUGIN_HPP */
