#ifndef QUANTIFICATIONTHRESHOLDERQIRPLUGIN_HPP
#define QUANTIFICATIONTHRESHOLDERQIRPLUGIN_HPP

#include <qiseTools/QuantificationThresholderPlugin.hpp>

#include <ise/iseQuantificationThresholder.hpp>

#include <ise/iseQuantificationThresholderQIR.hpp>
#include <QObject>

class QuantificationThresholderQIRPlugin : public QObject,
					     public QuantificationThresholderPlugin
{

  Q_OBJECT
  Q_INTERFACES(QuantificationThresholderPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID QuantificationThresholderPlugin_iid)
#endif
    
public:
    
  ~QuantificationThresholderQIRPlugin() {}
  
  QuantificationThresholderQIRPlugin()
    : QuantificationThresholderPlugin(QString::fromUtf8("QIR"),
				      QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::QuantificationThresholder> getNewQuantificationThresholder()  {
    girl::shared_ptr<ise::QuantificationThresholder> result(new ise::QuantificationThresholderQIR());
    return result;
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseQuantificationThresholderQIRPlugin, QuantificationThresholderQIRPlugin)
#endif

#endif /* ! QUANTIFICATIONTHRESHOLDERQIRPLUGIN_HPP */
