#ifndef QUANTIFICATIONTHRESHOLDERRAMESHPLUGIN_HPP
#define QUANTIFICATIONTHRESHOLDERRAMESHPLUGIN_HPP

#include <qiseTools/QuantificationThresholderPlugin.hpp>

#include <ise/iseQuantificationThresholder.hpp>

#include <ise/iseQuantificationThresholderRamesh.hpp>
#include <QObject>

class QuantificationThresholderRameshPlugin : public QObject,
					     public QuantificationThresholderPlugin
{

  Q_OBJECT
  Q_INTERFACES(QuantificationThresholderPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID QuantificationThresholderPlugin_iid)
#endif
    
public:
    
  ~QuantificationThresholderRameshPlugin() {}
  
  QuantificationThresholderRameshPlugin()
    : QuantificationThresholderPlugin(QString::fromUtf8("Ramesh"),
				      QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::QuantificationThresholder> getNewQuantificationThresholder()  {
    girl::shared_ptr<ise::QuantificationThresholder> result(new ise::QuantificationThresholderRamesh());
    return result;
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseQuantificationThresholderRameshPlugin, QuantificationThresholderRameshPlugin)
#endif

#endif /* ! QUANTIFICATIONTHRESHOLDERRAMESHPLUGIN_HPP */
