/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef REGIONBINARYFUNCTIONCONSTANTNULL_HPP_
#define REGIONBINARYFUNCTIONCONSTANTNULL_HPP_

#include <ise/iseRegionBinaryFunctionConstantNull.hpp>

#include <qiseTools/RegionBinaryFunctionPlugin.hpp>

#include <QObject>

class RegionBinaryFunctionConstantNullPlugin :
  public QObject,
  public RegionBinaryFunctionPlugin
{
  Q_OBJECT
  Q_INTERFACES(RegionBinaryFunctionPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID RegionBinaryFunctionPlugin_iid)
#endif

public:

  RegionBinaryFunctionConstantNullPlugin()
  : RegionBinaryFunctionPlugin(QString::fromUtf8("Constant Null Distance"),
      QIseVersion(1,0), QIseVersion(1,0))
  {}

  ~RegionBinaryFunctionConstantNullPlugin() {}

  virtual girl::shared_ptr<ise::RegionBinaryFunction>
  create(ise::SegmentationContext *segContext)
  {
    girl::shared_ptr<ise::RegionBinaryFunction> result
    = ise::RegionBinaryFunctionConstantNullFactory::instance().create(segContext);
    return result;
  }

  girl::shared_ptr<RegionBinaryFunctionSettings>
  createSettings(ise::SegmentationContext *)
  {
    return girl::shared_ptr<RegionBinaryFunctionSettings>(); //NULL
  }

  virtual bool hasSettings() const
  {
    return false;
  }

 protected:

  RegionBinaryFunctionWidget*
  createWidget(MainView * /*ise::SegmentationContext *segContext*/, QWidget * /*parent*/)
  {
    return NULL;
  }

};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseRegionBinaryFunctionConstantNullPlugin, RegionBinaryFunctionConstantNullPlugin)
#endif

#endif /* REGIONBINARYFUNCTIONCONSTANTNULL_HPP_ */
