/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef REGIONBINARYFUNCTIONHISTOGRAMINTERSECTIONDISTANCEPLUGIN_HPP_
#define REGIONBINARYFUNCTIONHISTOGRAMINTERSECTIONDISTANCEPLUGIN_HPP_

#include <ise/iseRegionBinaryFunctionWithRegSetHistogramIntersectionDistance.hpp>

#include <qiseTools/RegionBinaryFunctionPlugin.hpp>
#include <qiseTools/RegionBinaryFunctionWithRegSetWeightSettings.hpp>
#include <qiseTools/RegionBinaryFunctionWithRegSetWeightWidget.hpp>

#include <QObject>

class RegionBinaryFunctionHistogramIntersectionDistancePlugin :
public QObject,
public RegionBinaryFunctionPlugin
{
  Q_OBJECT
  Q_INTERFACES(RegionBinaryFunctionPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID RegionBinaryFunctionPlugin_iid)
#endif

public:

  RegionBinaryFunctionHistogramIntersectionDistancePlugin()
  : RegionBinaryFunctionPlugin(QString::fromUtf8("HistogramIntersection Distance"),
      QIseVersion(1,0), QIseVersion(1,0))
  {}

  ~RegionBinaryFunctionHistogramIntersectionDistancePlugin() {}

  virtual girl::shared_ptr<ise::RegionBinaryFunction>
  create(ise::SegmentationContext *segContext)
  {
    girl::shared_ptr<ise::RegionBinaryFunction> result
    = ise::RegionBinaryFunctionWithRegSetHistogramIntersectionDistanceFactory::instance().create(segContext);
    return result;
  }

  girl::shared_ptr<RegionBinaryFunctionSettings>
  createSettings(ise::SegmentationContext *)
  {
    girl::shared_ptr<RegionBinaryFunctionSettings> result
    (new RegionBinaryFunctionWithRegSetWeightSettings());
    return result;
  }

  RegionBinaryFunctionWidget*
  createWidget(MainView *mainView/*ise::SegmentationContext *segContext*/, QWidget *parent)
  {
    return new RegionBinaryFunctionWithRegSetWeightWidget(mainView/*segContext*/, parent);
  }

};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseRegionBinaryFunctionHistogramIntersectionDistancePlugin, RegionBinaryFunctionHistogramIntersectionDistancePlugin)
#endif

#endif /* REGIONBINARYFUNCTIONHISTOGRAMINTERSECTIONDISTANCEPLUGIN_HPP_ */
