/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "RegionBinaryPredicateFromUnaryFunctionWidget.hpp"

#include <qiseTools/ComparisonFunctionWidget.hpp>
#include <qiseTools/RegionBinaryFunctionPlugin.hpp>
//#include <qiseTools/RegionBinaryFunctionWidget.hpp>
#include <qiseTools/RegionUnaryFunctionComboWidget.hpp>

#include <QGridLayout>
#include <QLabel>
#include <QLineEdit>
#include <QDoubleValidator>




RegionBinaryPredicateFromUnaryFunctionWidget::RegionBinaryPredicateFromUnaryFunctionWidget(MainView *mainView/*ise::SegmentationContext *segContext,*/ ,
									 RegionBinaryPredicatePlugin *plugin, 
									 QWidget *parent)
  : RegionBinaryPredicateWidget(plugin, parent),
    //m_segContext(segContext),
    m_mainView(mainView),
    m_rbfcw(NULL),
    m_cfw(NULL)
{
  buildGUI();
}


void
RegionBinaryPredicateFromUnaryFunctionWidget::buildGUI()
{
  assert(m_mainView);
  // assert(m_mainView->model());
  // assert(m_mainView->model()->getSegContextPtr());

  QGridLayout *gL = new QGridLayout;


  m_rbfcw = new RegionUnaryFunctionComboWidget(m_mainView/*m_segContext*/, this);

  QLabel *cfLabel = new QLabel(tr("Comparison operator: "), this);
  m_cfw = new ComparisonFunctionWidget(this);

  connect(m_rbfcw, SIGNAL(pluginChanged()), this, SIGNAL(pluginChanged()));
  connect(m_cfw, SIGNAL(comparisonOperatorChanged()), this, SIGNAL(comparisonOperatorChanged()));

  gL->addWidget(m_rbfcw, 0, 0, 1, 2);
  gL->addWidget(cfLabel, 2, 0);
  gL->addWidget(m_cfw, 2, 1);
  
  setLayout(gL);

  /*
  connect(m_pw, SIGNAL(pluginIndexChanged(int)),
	  this, SLOT(pluginChanged(int)));
  */
}



RegionUnaryFunctionPlugin *
RegionBinaryPredicateFromUnaryFunctionWidget::getRegionUnaryFunctionPlugin() const
{
  assert(m_rbfcw);
  return m_rbfcw->getRegionUnaryFunctionPlugin();
}

void
RegionBinaryPredicateFromUnaryFunctionWidget::setRegionUnaryFunctionPlugin(RegionUnaryFunctionPlugin *p)
{
  assert(m_rbfcw);
  m_rbfcw->setRegionUnaryFunctionPlugin(p);
}



ise::ComparisonOperator
RegionBinaryPredicateFromUnaryFunctionWidget::getComparisonOperator() const
{
  assert(m_cfw);
  return m_cfw->getComparisonOperator();
}

void
RegionBinaryPredicateFromUnaryFunctionWidget::setComparisonOperator(ise::ComparisonOperator c)
{
  assert(m_cfw);
  m_cfw->setComparisonOperator(c);
}


