/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef REGIONBINARYPREDICATEFROMUNARYPREDICATEPLUGIN_HPP_
#define REGIONBINARYPREDICATEFROMUNARYPREDICATEPLUGIN_HPP_

#include <ise/iseRegionBinaryPredicateFromUnaryPredicate.hpp>

#include <qiseTools/RegionBinaryPredicatePlugin.hpp>
#include "RegionBinaryPredicateFromUnaryPredicateWidget.hpp"
#include "RegionBinaryPredicateFromUnaryPredicateSettings.hpp"

#include <QObject>

class RegionBinaryPredicateFromUnaryPredicatePlugin : public QObject,
					    public RegionBinaryPredicatePlugin
{
  Q_OBJECT
  Q_INTERFACES(RegionBinaryPredicatePlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID RegionBinaryPredicatePlugin_iid)
#endif

public:

  RegionBinaryPredicateFromUnaryPredicatePlugin()
    : RegionBinaryPredicatePlugin(QString::fromUtf8("Binary Predicate From Unary Predicate"),
				 QIseVersion(1, 0), QIseVersion(1, 0))
  {}

  ~RegionBinaryPredicateFromUnaryPredicatePlugin() {}



protected:

  virtual RegionBinaryPredicateWidget *createWidget(MainView *mainView/*ise::SegmentationContext *segContext*/, QWidget *parent)
  {
    return new RegionBinaryPredicateFromUnaryPredicateWidget(mainView/*segContext*/, this, parent);
  }

  virtual girl::shared_ptr<ise::RegionBinaryPredicate> create(ise::SegmentationContext *segContext)
  {
    girl::shared_ptr<ise::RegionBinaryPredicate> result
    = ise::RegionBinaryPredicateFromUnaryPredicateFactory::instance().create(segContext);
    return result;
  }
  
  virtual girl::shared_ptr<RegionBinaryPredicateSettings> createSettings(ise::SegmentationContext * /*segContext*/)
  {
    return girl::shared_ptr<RegionBinaryPredicateSettings>(new RegionBinaryPredicateFromUnaryPredicateSettings());
  }

protected:

};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseRegionBinaryPredicateFromUnaryPredicatePlugin, RegionBinaryPredicateFromUnaryPredicatePlugin)
#endif

#endif /* REGIONBINARYPREDICATEFROMUNARYPREDICATEPLUGIN_HPP_ */
