/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef REGIONBINARYPREDICATEFROMUNARYPREDICATEWIDGET_HPP_
#define REGIONBINARYPREDICATEFROMUNARYPREDICATEWIDGET_HPP_

#include <qiseTools/RegionBinaryPredicateWidget.hpp>
#include <qiseTools/MainView.hpp>

#include <ise/iseComparisonFunction.hpp>

class QRadioButton;
class RegionUnaryPredicateComboWidget;
class RegionUnaryPredicatePlugin;



class RegionBinaryPredicateFromUnaryPredicateWidget : public RegionBinaryPredicateWidget
{
  Q_OBJECT

public:

  RegionBinaryPredicateFromUnaryPredicateWidget(MainView *mainView/*ise::SegmentationContext *segContext*/, 
						RegionBinaryPredicatePlugin *plugin = NULL, 
						QWidget *parent = NULL);

  RegionUnaryPredicatePlugin *getRegionUnaryPredicatePlugin() const;

  void setRegionUnaryPredicatePlugin(RegionUnaryPredicatePlugin *p);
  
  /**
   * return 0 if first region is selected
   * return 1 if second region is selected.
   */
  int getSelectedRegion() const;

  /**
   * Select first region if i is 0
   * else select second region.
   */
  void setSelectedRegion(int i);

signals:
    
  void pluginChanged();
  void selectedRegionChanged();

protected slots:

  void signalSelectedRegionChanged();

protected:

  void buildGUI();

protected:
  //ise::SegmentationContext *m_segContext;
  MainView *m_mainView;
  RegionUnaryPredicateComboWidget *m_rupcw;
  QRadioButton *m_firstRegionButton;
  QRadioButton *m_secondRegionButton;
};


#endif /* ! REGIONBINARYPREDICATEFROMUNARYPREDICATEWIDGET_HPP_ */
