/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef REGIONBINARYPREDICATETHRESHOLDPLUGIN_HPP_
#define REGIONBINARYPREDICATETHRESHOLDPLUGIN_HPP_

#include <ise/iseRegionBinaryPredicateThreshold.hpp>

#include <qiseTools/RegionBinaryPredicatePlugin.hpp>
#include "RegionBinaryPredicateThresholdWidget.hpp"
#include "RegionBinaryPredicateThresholdSettings.hpp"

#include <QObject>

class RegionBinaryPredicateThresholdPlugin : public QObject,
					    public RegionBinaryPredicatePlugin
{
  Q_OBJECT
  Q_INTERFACES(RegionBinaryPredicatePlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID RegionBinaryPredicatePlugin_iid)
#endif

public:

  RegionBinaryPredicateThresholdPlugin()
    : RegionBinaryPredicatePlugin(QString::fromUtf8("Binary Predicate Threshold"),
				 QIseVersion(1, 0), QIseVersion(1, 0))
  {}

  ~RegionBinaryPredicateThresholdPlugin() {}



protected:

  virtual RegionBinaryPredicateWidget *createWidget(MainView *mainView/*ise::SegmentationContext *segContext*/, QWidget *parent)
  {
    return new RegionBinaryPredicateThresholdWidget(mainView/*segContext*/, this, parent);
  }

  virtual girl::shared_ptr<ise::RegionBinaryPredicate> create(ise::SegmentationContext *segContext)
  {
    girl::shared_ptr<ise::RegionBinaryPredicate> result
    = ise::RegionBinaryPredicateThresholdFactory::instance().create(segContext);
    return result;
  }
  
  virtual girl::shared_ptr<RegionBinaryPredicateSettings> createSettings(ise::SegmentationContext* /*segContext*/)
  {
    return girl::shared_ptr<RegionBinaryPredicateSettings>(new RegionBinaryPredicateThresholdSettings());
  }

protected:

};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseRegionBinaryPredicateThresholdPlugin, RegionBinaryPredicateThresholdPlugin)
#endif

#endif /* REGIONBINARYPREDICATETHRESHOLDPLUGIN_HPP_ */
