/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef REGIONBINARYPREDICATETHRESHOLDSETTINGS_HPP_
#define REGIONBINARYPREDICATETHRESHOLDSETTINGS_HPP_

#include <ise/iseRegionBinaryPredicateThreshold.hpp>
#include <qiseTools/RegionBinaryPredicateSettings.hpp>

#include <qiseTools/RegionBinaryFunctionPlugin.hpp>

class RegionBinaryPredicateThresholdSettings : public RegionBinaryPredicateSettings
{
public:
  
  virtual void configureWidget(RegionBinaryPredicateWidget *widget) const;

  virtual void getWidgetConfig(const RegionBinaryPredicateWidget *widget);

  virtual void configureAlgo(girl::shared_ptr<ise::RegionBinaryPredicate> algo) const;

  virtual girl::shared_ptr<RegionBinaryPredicateSettings> clone() const;

  virtual bool isValid() const;

protected:

  RegionBinaryFunctionPlugin *m_binaryFctPlugin;
  girl::shared_ptr<RegionBinaryFunctionSettings> m_binaryFctSettings;
  ise::ComparisonOperator m_comp;
  double m_threshold;

};


#endif /* ! REGIONBINARYPREDICATETHRESHOLDSETTINGS_HPP_ */
