/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef REGIONBINARYPREDICATETHRESHOLDWIDGET_HPP_
#define REGIONBINARYPREDICATETHRESHOLDWIDGET_HPP_

#include <qiseTools/RegionBinaryPredicateWidget.hpp>

#include <ise/iseComparisonFunction.hpp>
#include <qiseTools/MainView.hpp>

class ComparisonFunctionWidget;
class QLineEdit;
class RegionBinaryFunctionComboWidget;
class RegionBinaryFunctionPlugin;



class RegionBinaryPredicateThresholdWidget : public RegionBinaryPredicateWidget
{
  Q_OBJECT

public:

  RegionBinaryPredicateThresholdWidget(MainView *mainView/*ise::SegmentationContext *segContext*/, RegionBinaryPredicatePlugin *plugin = NULL, QWidget *parent = NULL);

  RegionBinaryFunctionPlugin *getRegionBinaryFunctionPlugin() const;

  void setRegionBinaryFunctionPlugin(RegionBinaryFunctionPlugin *p);
  
  ise::ComparisonOperator getComparisonOperator() const;

  void setComparisonOperator(ise::ComparisonOperator c);

  double getThreshold() const;

public slots:

  void setThreshold(double th);

signals:
    
  void pluginChanged();
  void comparisonOperatorChanged();
  void thresholdChanged(double);

protected slots:

  void signalThresholdChanged();

protected:

  void buildGUI();


protected:
  //ise::SegmentationContext *m_segContext;
  MainView *m_mainView;
  RegionBinaryFunctionComboWidget *m_rbfcw;
  ComparisonFunctionWidget *m_cfw;
  QLineEdit *m_threshold;
};


#endif /* ! REGIONBINARYPREDICATETHRESHOLDWIDGET_HPP_ */
