/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef REGIONFEATUREMOMENTSPLUGIN_HPP_
#define REGIONFEATUREMOMENTSPLUGIN_HPP_

#include <ise/iseRegionFeatureMomentComputer.hpp>

#include <qiseTools/RegionFeatureMomentsComputerDialog.hpp>

//#include "../../RegionFeaturePlugin.hxx"

//class RegionFeatureMomentsPlugin : public RegionFeaturePlugin<ise::RegionFeatureMomentComputer,RegionFeatureMomentsDialog,QString::fromUtf8("Region Moments(Generic)")>
//{};
//typedef RegionFeaturePlugin<ise::RegionFeatureMomentComputer,RegionFeatureMomentsDialog,QString::fromUtf8("Region Moments(Generic)")> RegionFeatureMomentsPlugin;
//
//Q_EXPORT_PLUGIN2(QIseRegionFeatureMomentsPlugin, RegionFeatureMomentsPlugin)

//INSTANTIATE_PLUGIN(RegionFeatureMomentsPlugin, ise::RegionFeatureMomentComputer, RegionFeatureMomentsDialog, RegionFeature(Generic))





//#include <ise/iseRegionFeatureComputer.hpp>


#include <qiseTools/RegionFeatureComputerPlugin.hpp>

#include <QObject>

class RegionFeatureMomentsPlugin : public QObject,
public RegionFeatureComputerPlugin
{
  Q_OBJECT
  Q_INTERFACES(RegionFeatureComputerPlugin QIsePlugin)

public:

  RegionFeatureMomentsPlugin():
    RegionFeatureComputerPlugin(QString::fromUtf8("Region Moments (Generic)"),
    QIseVersion(1, 0), QIseVersion(1, 0)),
    m_memento()
  {}

  ~RegionFeatureMomentsPlugin() {}

  virtual girl::shared_ptr<ise::RegionFeatureComputer>
  getNewRegionFeatureComputer()
  {
    girl::shared_ptr<ise::RegionFeatureComputer> result(new ise::RegionFeatureMomentComputer(m_segContext));
    if (m_memento == NULL)
      m_memento = result->getMemento();
    else
      result->setMemento(m_memento);
    return result;
  }

  virtual void saveParameters(const girl::shared_ptr<ise::RegionFeatureComputer> &rfc)
  {
    m_memento = rfc->getMemento();
  }

  virtual RegionFeatureComputerDialog*
  parameterWidget(ise::SegmentationContext *segContext, QWidget *parent = NULL)
  {
    m_segContext = segContext;
    return new RegionFeatureMomentsComputerDialog(segContext, tr("Region Moments (Generic)"), getNewRegionFeatureComputer(), parent);
  }

protected:
  girl::shared_ptr<ise::ParametersMemento> m_memento;
};

Q_EXPORT_PLUGIN2(QIseRegionFeatureMomentsPlugin, RegionFeatureMomentsPlugin)


#endif /* REGIONFEATUREMOMENTSPLUGIN_HPP_ */
