/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
 * RegionFeaturePlugin.hxx
 *
 *  Created on: Sep 27, 2010
 *      Author: vieux
 *
 *  Template file to facilitate the integration of new RegionFeature plugins
 *  To create a new plugin, subclass the template and add the line
 *  Q_EXPORT_PLUGIN2(QIseRegionFeatureColorimetricMomentsPlugin, RegionFeatureColorimetricMomentsPlugin)
 *  with the appropriate names at the end of the file
 */

#ifndef REGIONFEATUREPLUGIN_HXX
#define REGIONFEATUREPLUGIN_HXX

#include <qiseTools/RegionFeatureComputerDialog.hpp>
#include <qiseTools/RegionFeatureComputerPlugin.hpp>

#include <QString>

//template <typename AlgoClass, typename DialogClass, QString PluginName>
//class RegionFeaturePlugin<AlgoClass, DialogClass, PluginName> : public QObject,
//                                                    public RegionFeatureComputerPlugin
//{
//
//public:
//  Q_OBJECT
//  Q_INTERFACES(RegionFeatureComputerPlugin QIsePlugin)
//
//  // TODO
//  RegionFeaturePlugin():
//    RegionFeaturePlugin(PluginName, QIseVersion(1,0), QIseVersion(1,0)),
//    m_memento()
//  {}
//
//  ~RegionFeaturePlugin() {}
//
//  virtual girl::shared_ptr<ise::RegionFeatureComputer> getNewRegionFeatureComputer()
//  {
//    girl::shared_ptr<ise::RegionFeatureComputer> result(new AlgoClass(m_segContext));
//    if (m_memento == NULL)
//      m_memento = result->getMemento();
//    else
//      result->setMemento(m_memento);
//    return result;
//  }
//
//  virtual void saveParameters(const girl::shared_ptr<ise::RegionFeatureComputer> &rfc)
//  {
//    m_memento = rfc->getMemento();
//  }
//
//  virtual RegionFeatureComputerDialog* parameterWidget(ise::SegmentationContext *segContext,
//                                                       QWidget *parent = NULL)
//  {
//    m_segContext = segContext;
//    return new DialogClass(segContext, PluginName, getNewRegionFeatureComputer(), parent);
//  }
//
//protected:
//  girl::shared_ptr<ise::ParametersMemento> m_memento;
//
//};
//
//
#endif /* REGIONFEATUREPLUGIN_HXX */





//template <typename AlgoClass, typename DialogClass, QString PluginName>
#define INSTANTIATE_PLUGIN(_PluginClassName, _AlgoClass, _DialogClass, _PluginDisplayName) \
class (_PluginClassName) : public QObject, \
                           public RegionFeatureComputerPlugin \
{ \
public: \
  Q_OBJECT \
  Q_INTERFACES(RegionFeatureComputerPlugin QIsePlugin) \
  (_PluginClassName) : \
    RegionFeaturePlugin(QString::fromUtf8((#_PluginDisplayName)), QIseVersion(1,0), QIseVersion(1,0)), \
    m_memento() \
  {} \
  ~(_PluginClassName)() {} \
  virtual girl::shared_ptr<ise::RegionFeatureComputer> getNewRegionFeatureComputer() \
  { \
    girl::shared_ptr<ise::RegionFeatureComputer> result(new (_PluginClassName)(m_segContext)); \
    if (m_memento == NULL) \
      m_memento = result->getMemento(); \
    else \
      result->setMemento(m_memento); \
    return result; \
  } \
  virtual void saveParameters(const girl::shared_ptr<ise::RegionFeatureComputer> &rfc) \
  { \
    m_memento = rfc->getMemento(); \
  } \
  virtual RegionFeatureComputerDialog* parameterWidget(ise::SegmentationContext *segContext, QWidget *parent = NULL) \
  { \
    m_segContext = segContext; \
    return new (_DialogClass)(segContext, PluginName, getNewRegionFeatureComputer(), parent); \
  } \
protected: \
  girl::shared_ptr<ise::ParametersMemento> m_memento; \
}; \
Q_EXPORT_PLUGIN2(QIse(##_PluginClassName), (_PluginClassName))
