/*
 * RegionSetInterfaceClusteringWidget.cpp
 *
 *  Created on: Apr 18, 2011
 *      Author: vieux
 */

#include "RegionSetInterfaceClusteringWidget.hpp"

#include <girl/girlToger.hpp>

#include <ise/iseSegmentationContext.hpp>

#include <qiseTools/RegionFeatureClustererWidget.hpp>
#include <qiseTools/SegModel.hpp>

#include <QCheckBox>
#include <QVBoxLayout>

RegionSetInterfaceClusteringWidget::RegionSetInterfaceClusteringWidget(MainView *mainView,
    FeatureComputerGUIInfoPtr featureComputerGUIInfo,
    RegionSetInterfacePlugin *plugin,
    QWidget *parent) :
    RegionSetInterfaceWidget(mainView, featureComputerGUIInfo, plugin, parent)
{
  buildGUI();
}

RegionSetInterfaceClusteringWidget::~RegionSetInterfaceClusteringWidget()
{
}


void
RegionSetInterfaceClusteringWidget::buildGUI()
{
  QVBoxLayout *layout = new QVBoxLayout;
  m_rfcw = new RegionFeatureClustererWidget(m_mainView, this);
  m_cb = new QCheckBox(tr("Only on selected regions? "), this);
  layout->addWidget(m_rfcw);
  layout->addWidget(m_cb);
  setLayout(layout);
}

void
RegionSetInterfaceClusteringWidget::getParameters(std::vector<girl::shared_ptr<ise::RegionSetInterface> > &regSets,
						  std::vector<bool> &mask,
						  girl::regionDeque &regs,
						  girl::shared_ptr<ise::Clusterer> &clusterer,
						  size_t /*nbClasses*/) const

{
  assert(m_mainView);
  m_rfcw->getParameters(regSets, mask, clusterer);

  SegModel *model = m_mainView->model();
  assert(model);
  if (m_cb->isChecked()) {
      regs = model->getSelectedRegions();
  } else {
      ise::SegmentationContext *segContext = model->getSegContextPtr();
      assert(segContext);
      girl::toger *tog = segContext->getToger();
      assert(tog);
      tog->allRegions(regs);
  }


}
