/*
 * RegionSetInterfaceClusteringWidget.hpp
 *
 *  Created on: Apr 18, 2011
 *      Author: vieux
 */

#ifndef REGIONSETINTERFACECLUSTERINGWIDGET_HPP_
#define REGIONSETINTERFACECLUSTERINGWIDGET_HPP_

#include <girl/girlCommon.hpp>
#include <girl/girlSharedPtr.hpp>


#include <qiseTools/RegionSetInterfaceWidget.hpp>

namespace ise {
  class RegionSetInterface;
  class Clusterer;
}

class RegionFeatureClustererWidget;
class QCheckBox;

/*
 *
 */
class RegionSetInterfaceClusteringWidget : public RegionSetInterfaceWidget
{
public:
  RegionSetInterfaceClusteringWidget(MainView *mainView,
      FeatureComputerGUIInfoPtr featureComputerGUIInfo,
      RegionSetInterfacePlugin *plugin,
      QWidget *parent);

  virtual
  ~RegionSetInterfaceClusteringWidget();

  void
  buildGUI();

  void
  getParameters(std::vector<girl::shared_ptr<ise::RegionSetInterface> > &regSets,
		std::vector<bool> &mask,
		girl::regionDeque &regs,
		girl::shared_ptr<ise::Clusterer> &clusterer,
		size_t nbClasses) const;

  void
  setParameters() {}


protected:

  RegionFeatureClustererWidget *m_rfcw;
  QCheckBox *m_cb;

};

#endif /* REGIONSETINTERFACECLUSTERINGWIDGET_HPP_ */
