/*
 * RegionSetInterfaceSettingsClustering.cpp
 *
 *  Created on: Apr 18, 2011
 *      Author: vieux
 */

#include <ise/iseRegionSetInterfaceClustering.hpp>

#include "RegionSetInterfaceSettingsClustering.hpp"
#include "RegionSetInterfaceClusteringWidget.hpp"



void
RegionSetInterfaceSettingsClustering::configureWidget(FeatureInterfaceWidget *) const
{
  // DO NOTHING
  //RegionSetInterfaceClusteringWidget *widget = static_cast<RegionSetInterfaceClusteringWidget>(w);

}

void
RegionSetInterfaceSettingsClustering::getWidgetConfig(const FeatureInterfaceWidget *w)
{
  const RegionSetInterfaceClusteringWidget *widget = static_cast<const RegionSetInterfaceClusteringWidget*>(w);
  widget->getParameters(m_regSets, m_mask, m_regs, m_clusterer, m_nbClasses);
}

void
RegionSetInterfaceSettingsClustering::configureAlgo(girl::shared_ptr<ise::FeatureComputer> algo) const
{

  girl::shared_ptr<ise::RegionSetInterfaceClustering> clustering =
      girl::static_pointer_cast<ise::RegionSetInterfaceClustering>(algo);
  clustering->setParameters(m_regSets, m_mask, m_regs, m_clusterer);
}


bool
RegionSetInterfaceSettingsClustering::isValid() const
{
  if (m_regs.size() == 0)
    return false;

  if (!m_clusterer)
    return false;

  size_t dim = 0;
  for (size_t i = 0; i < m_regSets.size(); ++i) {
      dim += m_regSets[i]->getFeatureDim();
  }
  return dim == m_mask.size();
}
