/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef REGIONSETINTERFACESETTINGSCLUSTERING_HPP_
#define REGIONSETINTERFACESETTINGSCLUSTERING_HPP_

#include <vector>

#include <girl/girlToger.hpp>
#include <girl/girlSharedPtr.hpp>

#include <ise/iseClusterer.hpp>
#include <ise/iseRegionSetInterface.hpp>

#include <qiseTools/FeatureInterfaceSettings.hpp>

class RegionSetInterfaceSettingsClustering : public FeatureInterfaceSettings
{

public:

  RegionSetInterfaceSettingsClustering()
  : FeatureInterfaceSettings(),
    m_regSets(),
    m_mask(),
    m_regs(),
    m_nbClasses(0),
    m_clusterer()
  {}

protected:

  virtual void configureWidget(FeatureInterfaceWidget *) const;

  virtual void getWidgetConfig(const FeatureInterfaceWidget *);

  virtual void configureAlgo(girl::shared_ptr<ise::FeatureComputer>) const;


  virtual girl::shared_ptr<FeatureInterfaceSettings> clone() const 
  {
    girl::shared_ptr<RegionSetInterfaceSettingsClustering> p(new RegionSetInterfaceSettingsClustering());
    *p = *this;
    return p;
  }

  virtual bool isValid() const;

protected:

  std::vector<girl::shared_ptr<ise::RegionSetInterface> > m_regSets;

  std::vector<bool> m_mask;

  girl::regionDeque m_regs;

  size_t m_nbClasses;

  girl::shared_ptr<ise::Clusterer> m_clusterer;

};

#endif /* REGIONSETINTERFACESETTINGSCLUSTERING_HPP_ */
