/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef REGIONSETINTERFACESETTINGSDISTRIBUTION_HPP_
#define REGIONSETINTERFACESETTINGSDISTRIBUTION_HPP_

#include <string>

#include <qiseTools/FeatureInterfaceSettings.hpp>
#include <qiseTools/FeatureData.hpp>

/**
 * Settings class for RSIDistribution
 */
class RegionSetInterfaceSettingsDistribution : public FeatureInterfaceSettings
{
public:

  RegionSetInterfaceSettingsDistribution();

  virtual ~RegionSetInterfaceSettingsDistribution();

protected:

  virtual void configureWidget(FeatureInterfaceWidget *widget) const;

  virtual void getWidgetConfig(const FeatureInterfaceWidget *widget);

  virtual void configureAlgo(girl::shared_ptr<ise::FeatureComputer> algo) const;

  virtual girl::shared_ptr<FeatureInterfaceSettings> clone() const;

  virtual bool isValid() const;


protected:

  // parameters to save
  ise::FeatureComputerPtr m_dataPtr;

  int m_codebookSize;

  int m_flags;

};

#endif /* REGIONSETINTERFACESETTINGSDISTRIBUTION_HPP_ */
