/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

/*
 * RegionSetInterfaceWidgetDistribution.hpp
 *
 *  Created on: Jan 10, 2011
 *      Author: vieux
 */


#ifndef REGIONSETINTERFACEWIDGETDISTRIBUTION_HPP_
#define REGIONSETINTERFACEWIDGETDISTRIBUTION_HPP_

#include <girl/girlCommon.hpp>

#include <qiseTools/ImageFeatureChoiceWidget.hpp>
#include <qiseTools/RegionSetInterfaceWidget.hpp>

class ImageFeatureChoiceWidget;
class QSpinBox;
class QComboBox;
class MainView;




/**
 *
 */
class GIRL_API RegionSetInterfaceWidgetDistribution : public RegionSetInterfaceWidget
{
public:
  RegionSetInterfaceWidgetDistribution(MainView *mainView,
				       FeatureComputerGUIInfoPtr featureComputerGUIInfo,
				       RegionSetInterfacePlugin *plugin,
				       QWidget *parent);

  virtual
  ~RegionSetInterfaceWidgetDistribution();

  void
  buildGUI();

  void
    getParameters(ise::FeatureComputerPtr &algo, int &codebookSize, int &centerFlags) const;

  void
    setParameters(const ise::FeatureComputerPtr &algo, const int &codebookSize, const int &centerFlags);

private:

  ImageFeatureChoiceWidget *m_ifcw;

  QSpinBox *m_codebookSizeSpinBox;

  QComboBox *m_flagsCombo;

  ise::SegmentationContext *m_segContext;
};

#endif /* REGIONSETINTERFACEWIDGETDISTRIBUTION_HPP_ */
