/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef REGIONSETINTERFACEDOCUMENTZONECLASSIFIERPLUGIN_HPP_
#define REGIONSETINTERFACEDOCUMENTZONECLASSIFIERPLUGIN_HPP_

#include <ise/iseRegionSetInterfaceDocumentZoneClassifier.hpp>

#include <qiseTools/RegionSetInterfacePlugin.hpp>
#include <qiseTools/RegionSetInterfaceWidget.hpp>

#include "RegionSetInterfaceSettingsDocumentZoneClassifier.hpp"

#include <QObject>
#include <QString>
#include <QApplication>

/**
 * Plugin for region gravity center
 */

#define CLASSIFIERFILE "3NNClassifier_Prima_FOLD0"

class RegionSetInterfaceDocumentZoneClassifierPlugin : public QObject,
					      public RegionSetInterfacePlugin
{
  Q_OBJECT
  Q_INTERFACES(RegionSetInterfacePlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID RegionSetInterfacePlugin_iid)
#endif

public:



  RegionSetInterfaceDocumentZoneClassifierPlugin()
  : RegionSetInterfacePlugin(QString::fromUtf8("Zone classification"),
      QIseVersion(1,0), QIseVersion(1,0))
  {}

  virtual
  ~RegionSetInterfaceDocumentZoneClassifierPlugin() {}

protected:

  girl::shared_ptr<ise::FeatureComputer>
  create(ise::SegmentationContext* segContext)
  {
    std::string s = QApplication::applicationDirPath().toStdString();
    s += "/plugins/";
    s += path().toStdString();
    s += CLASSIFIERFILE;
    girl::shared_ptr<ise::FeatureComputer> result
    (new ise::RegionSetInterfaceDocumentZoneClassifier(segContext,
        s));
    return result;
  }

  RegionSetInterfaceWidget*
  createWidget(MainView *mainView, FeatureComputerGUIInfoPtr featureComputerGUIInfo, QWidget* parent)
  {
    return new RegionSetInterfaceWidget(mainView, featureComputerGUIInfo, this, parent);
  }

  girl::shared_ptr<FeatureInterfaceSettings>
  createSettings()
  {
    return girl::shared_ptr<FeatureInterfaceSettings>(new RegionSetInterfaceSettingsDocumentZoneClassifier());
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseRegionSetInterfaceDocumentZoneClassifierPlugin, RegionSetInterfaceDocumentZoneClassifierPlugin)
#endif

#endif /* REGIONSETINTERFACEDOCUMENTZONECLASSIFIERPLUGIN_HPP_ */
