/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef REGIONSETINTERFACEMIXEDTEXTIMAGEPLUGIN_HPP_
#define REGIONSETINTERFACEMIXEDTEXTIMAGEPLUGIN_HPP_

#include <ise/iseRegionSetInterfaceMixedTextImage.hpp>

#include <qiseTools/RegionSetInterfacePlugin.hpp>
#include <qiseTools/RegionSetInterfaceWidget.hpp>

#include "RegionSetInterfaceSettingsMixedTextImage.hpp"
#include "RegionSetInterfaceMixedTextImageWidget.hpp"

#include <QObject>

/**
 * Plugin for region gravity center
 */

class RegionSetInterfaceMixedTextImagePlugin : public QObject,
public RegionSetInterfacePlugin
{
  Q_OBJECT
  Q_INTERFACES(RegionSetInterfacePlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID RegionSetInterfacePlugin_iid)
#endif

public:

  RegionSetInterfaceMixedTextImagePlugin()
  : RegionSetInterfacePlugin(QString::fromUtf8("Mixed text Image"),
      QIseVersion(1,0), QIseVersion(1,0))
  {}

  virtual
  ~RegionSetInterfaceMixedTextImagePlugin() {}

protected:

  girl::shared_ptr<ise::FeatureComputer>
  create(ise::SegmentationContext* segContext)
  {
    girl::shared_ptr<ise::FeatureComputer> result
    (new ise::RegionSetInterfaceMixedTextImage(segContext));
    return result;
  }

  RegionSetInterfaceWidget*
  createWidget(MainView* mainView, FeatureComputerGUIInfoPtr featureComputerGUIInfo, QWidget* parent)
  {
    return new RegionSetInterfaceMixedTextImageWidget(mainView, featureComputerGUIInfo, this, parent);
  }

  girl::shared_ptr<FeatureInterfaceSettings>
  createSettings()
  {
    return girl::shared_ptr<FeatureInterfaceSettings>(new RegionSetInterfaceSettingsMixedTextImage());
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseRegionSetInterfaceMixedTextImagePlugin, RegionSetInterfaceMixedTextImagePlugin)
#endif

#endif /* REGIONSETINTERFACEMIXEDTEXTIMAGEPLUGIN_HPP_ */
