#include "RegionSetInterfaceMixedTextImageWidget.hpp"

#include <QVBoxLayout>

RegionSetInterfaceMixedTextImageWidget::RegionSetInterfaceMixedTextImageWidget(MainView* mainView,
									       FeatureComputerGUIInfoPtr featureComputerGUIInfo,
    RegionSetInterfacePlugin *plugin, QWidget *parent)
  : RegionSetInterfaceWidget(mainView, featureComputerGUIInfo, plugin, parent)
  , m_qtwa(NULL)
{
  setAttribute(Qt::WA_DeleteOnClose);

  buildGUI();
}

RegionSetInterfaceMixedTextImageWidget::~RegionSetInterfaceMixedTextImageWidget()
{
  m_qtwa->deactivate();
}

void
RegionSetInterfaceMixedTextImageWidget::buildGUI()
{
  const bool allRegions = false;
  const bool oneChannel = true;
  m_qtwa = new QuantificationThresholdsWidgetAux(m_mainView, allRegions, oneChannel, this);
  m_qtwa->activate();
  QVBoxLayout *layout = new QVBoxLayout;
  layout->addWidget(m_qtwa);

  setLayout(layout);
}


void
RegionSetInterfaceMixedTextImageWidget::getParameters(std::vector<int> &levels, int &colorSpace, int &channel) const
{
  m_qtwa->getGUI(colorSpace, channel, levels);
}

void
RegionSetInterfaceMixedTextImageWidget::setParameters(std::vector<int> levels, int colorSpace, int channel)
{
  m_qtwa->setGUI(colorSpace, channel, levels);
}
