/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/


#ifndef REGIONSETINTERFACESETTINGSMIXEDTEXTIMAGE_HPP
#define REGIONSETINTERFACESETTINGSMIXEDTEXTIMAGE_HPP

//#include <qiseTools/RegionSetInterfaceSettings.hpp>
#include <qiseTools/FeatureInterfaceSettings.hpp>
#include "RegionSetInterfaceMixedTextImageWidget.hpp"

class RegionSetInterfaceSettingsMixedTextImage : public FeatureInterfaceSettings
{

public:

  RegionSetInterfaceSettingsMixedTextImage()
  : FeatureInterfaceSettings()
  , m_levels()
  , m_colorSpace(0)
  , m_channel(0)
  {}

protected:

  virtual void
  configureWidget(FeatureInterfaceWidget *widget) const 
  {
    static_cast<RegionSetInterfaceMixedTextImageWidget*>(widget)->setParameters(m_levels, m_colorSpace, m_channel);
  }

  virtual void
  getWidgetConfig(const FeatureInterfaceWidget *widget) 
  {
    static_cast<const RegionSetInterfaceMixedTextImageWidget*>(widget)->getParameters(m_levels, m_colorSpace, m_channel);
  }

  virtual void
  configureAlgo(girl::shared_ptr<ise::FeatureComputer> algo) const 
  {
    girl::shared_ptr<ise::RegionSetInterfaceMixedTextImage> algorithm = girl::static_pointer_cast<ise::RegionSetInterfaceMixedTextImage>(algo);
    algorithm->setParameters(m_levels, m_colorSpace, m_channel);
  }

  virtual girl::shared_ptr<FeatureInterfaceSettings> 
  clone() const
  {
    girl::shared_ptr<RegionSetInterfaceSettingsMixedTextImage> p(new RegionSetInterfaceSettingsMixedTextImage());
    *p = *this;
    return p;
  }

  virtual bool isValid() const
  {
    return (! m_levels.empty()); //B: ???
  }

private:

  //const static ise::RegionSetInterface::CacheType CACHE_STATE = ise::RegionSetInterface::NONE;
  std::vector<int> m_levels;
  int m_colorSpace;
  int m_channel;

};

#endif /* REGIONSETINTERFACESETTINGSMIXEDTEXTIMAGE_HPP */
