/*
  Copyright (C) 2010-2013 Remi Vieux  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef REGIONSETINTERFACEMOMENTSPLUGIN_HPP_
#define REGIONSETINTERFACEMOMENTSPLUGIN_HPP_

#include <ise/iseRegionSetInterfaceMoments.hpp>

#include <qiseTools/RegionSetInterfacePlugin.hpp>

#include "RegionSetInterfaceWidgetMoments.hpp"
#include "RegionSetInterfaceSettingsMoments.hpp"

#include <QObject>

/**
 * Plugins for RegionSetMoments
 */
class RegionSetInterfaceMomentsPlugin : public QObject,
public RegionSetInterfacePlugin
{

  Q_OBJECT
  Q_INTERFACES(RegionSetInterfacePlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID RegionSetInterfacePlugin_iid)
#endif

  typedef girl::shared_ptr<ise::RegionSetInterface> RegSetPtr;
public:
  RegionSetInterfaceMomentsPlugin(): RegionSetInterfacePlugin(QString::fromUtf8("Moments"),
      QIseVersion(1, 0), QIseVersion(1, 0))
  {}

  virtual
  ~RegionSetInterfaceMomentsPlugin() {}

  girl::shared_ptr<ise::FeatureComputer>
  create(ise::SegmentationContext* segContext){
    girl::shared_ptr<ise::RegionSetInterfaceMoments> result(new ise::RegionSetInterfaceMoments(segContext));
    //RegSetPtr result(new ise::RegionSetInterfaceMoments(segContext, cache));
    return girl::static_pointer_cast<ise::FeatureComputer>(result);
  }

  virtual
  RegionSetInterfaceWidget*
  createWidget(MainView* mainView, FeatureComputerGUIInfoPtr featureComputerGUIInfo, QWidget* parent)
  {
    return new RegionSetInterfaceWidgetMoments(mainView, featureComputerGUIInfo, this, parent);
  }

  virtual girl::shared_ptr<FeatureInterfaceSettings>
  createSettings()
  {
    girl::shared_ptr<RegionSetInterfaceSettingsMoments> result(new RegionSetInterfaceSettingsMoments());
    return girl::static_pointer_cast<FeatureInterfaceSettings>(result);
  }

};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseRegionSetInterfaceMomentsPlugin, RegionSetInterfaceMomentsPlugin)
#endif

#endif /* REGIONSETINTERFACEMOMENTSPLUGIN_HPP_ */
