/*
  Copyright (C) 2005-2010 Remi Vieux, Boris Mansencal remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#include <QVBoxLayout>

#include <qiseTools/MainView.hpp>

#include "RegionSetInterfaceWidgetMoments.hpp"


RegionSetInterfaceWidgetMoments::RegionSetInterfaceWidgetMoments(MainView *mainView,
FeatureComputerGUIInfoPtr featureComputerGUIInfo,
    RegionSetInterfacePlugin *plugin, QWidget *parent)
  : RegionSetInterfaceWidget(mainView, featureComputerGUIInfo, plugin, parent),
   m_segContext(mainView->model()->getSegContextPtr())
{
  buildGUI();
}

RegionSetInterfaceWidgetMoments::~RegionSetInterfaceWidgetMoments()
{
}

void
RegionSetInterfaceWidgetMoments::buildGUI()
{
  m_ifcw = new ImageFeatureChoiceWidget(m_mainView, m_featureComputerGUIInfo, this);

  QVBoxLayout *layout = new QVBoxLayout;
  layout->addWidget(m_ifcw);
  layout->stretch(0);
  setLayout(layout);
}


void
RegionSetInterfaceWidgetMoments::getParameters(ise::FeatureComputerPtr & algo) const
{
  algo = girl::static_pointer_cast<ise::FeatureComputer>(m_ifcw->imageFeatureComputerPtr());
}

void
RegionSetInterfaceWidgetMoments::setParameters(const ise::FeatureComputerPtr& algo)
{
  if (algo)
    m_ifcw->setImageFeatureComputerPtr(girl::static_pointer_cast<ise::ImageFeatureComputer>(algo));
}
