/*
  Copyright (C) 2005-2010 Remi Vieux, Boris Mansencal remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef REGIONSETINTERFACEWIDGETMOMENTS_HPP_
#define REGIONSETINTERFACEWIDGETMOMENTS_HPP_

#include <girl/girlCommon.hpp>

#include <qiseTools/ImageFeatureChoiceWidget.hpp>
#include <qiseTools/RegionSetInterfaceWidget.hpp>

class MainView;

/**
 *
 */
class GIRL_API RegionSetInterfaceWidgetMoments : public RegionSetInterfaceWidget
{
public:
  RegionSetInterfaceWidgetMoments(MainView *mainView,
				  FeatureComputerGUIInfoPtr featureComputerGUIInfo,
				  RegionSetInterfacePlugin* plugin,
				  QWidget *parent);

  virtual
  ~RegionSetInterfaceWidgetMoments();


  void
    buildGUI();

  void
    getParameters(ise::FeatureComputerPtr &algo) const;

  void
    setParameters(const ise::FeatureComputerPtr &algo);


private:

  ImageFeatureChoiceWidget *m_ifcw;

  ise::SegmentationContext *m_segContext;

};

#endif /* REGIONSETINTERFACEWIDGETMOMENTS_HPP_ */
