/*
  Copyright (C) 2005-2013 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef REGIONSETINTERFACEMOMENTSGEOMETRICPLUGIN_HPP
#define REGIONSETINTERFACEMOMENTSGEOMETRICPLUGIN_HPP

#include "RegionSetInterfaceMomentsGeometric.hpp"
#include <qiseTools/RegionSetInterfacePlugin.hpp>
#include <qiseTools/RegionSetInterfaceWidget.hpp>

#include "RegionSetInterfaceSettingsMomentsGeometric.hpp"

#include <QObject>

class RegionSetInterfaceMomentsGeometricPlugin : public QObject,
						 public RegionSetInterfacePlugin
{
  Q_OBJECT
  Q_INTERFACES(RegionSetInterfacePlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID RegionSetInterfacePlugin_iid)
#endif

public:

  RegionSetInterfaceMomentsGeometricPlugin()
  : RegionSetInterfacePlugin(QString::fromUtf8("Moments geometric"),
      QIseVersion(1,0), QIseVersion(1,0))
  {}

  virtual
  ~RegionSetInterfaceMomentsGeometricPlugin() {}

protected:

  girl::shared_ptr<ise::FeatureComputer>
  create(ise::SegmentationContext* segContext)
  {
    girl::shared_ptr<ise::FeatureComputer> result(new RegionSetInterfaceMomentsGeometric(segContext));
    return result;
  }

  RegionSetInterfaceWidget*
  createWidget(MainView* mainView, FeatureComputerGUIInfoPtr featureComputerGUIInfo, QWidget* parent)
  {
    return new RegionSetInterfaceWidget(mainView, featureComputerGUIInfo, this, parent);
  }

  girl::shared_ptr<FeatureInterfaceSettings>
  createSettings()
  {
    return girl::shared_ptr<FeatureInterfaceSettings>(new RegionSetInterfaceSettingsMomentsGeometric());
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseRegionSetInterfaceMomentsGeometricPlugin, RegionSetInterfaceMomentsGeometricPlugin)
#endif

#endif /* REGIONSETINTERFACEMOMENTSGEOMETRICPLUGIN_HPP_ */
