/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/


#ifndef REGIONSETINTERFACESETTINGSMOMENTSGEOMETRIC_HPP_
#define REGIONSETINTERFACESETTINGSMOMENTSGEOMETRIC_HPP_

#include <qiseTools/FeatureInterfaceSettings.hpp>

class RegionSetInterfaceSettingsMomentsGeometric : public FeatureInterfaceSettings
{

public:

  RegionSetInterfaceSettingsMomentsGeometric()
  : FeatureInterfaceSettings()
  {}

protected:

  virtual void
  configureWidget(FeatureInterfaceWidget *) const 
  {
  }

  virtual void
  getWidgetConfig(const FeatureInterfaceWidget *) 
  {
  }

  virtual void
  configureAlgo(girl::shared_ptr<ise::FeatureComputer>) const 
  {
  }

  virtual girl::shared_ptr<FeatureInterfaceSettings> 
  clone() const
  {
    girl::shared_ptr<RegionSetInterfaceSettingsMomentsGeometric> p(new RegionSetInterfaceSettingsMomentsGeometric());
    *p = *this;
    return p;
  }

  virtual bool 
  isValid() const
  {
    return true; // TODO : JULIAN
  }

private:

  const static ise::RegionSetInterface::CacheType CACHE_STATE = ise::RegionSetInterface::NONE;
};

#endif /* REGIONSETINTERFACESETTINGSMOMENTSGEOMETRIC_HPP_ */
