/*
 * RegionSetInterfaceWidgetNeighboursPosition.hpp
 *
 *  Created on: Dec 9, 2010
 *      Author: vieux
 */

#ifndef REGIONSETINTERFACEWIDGETNEIGHBOURSPOSITION_HPP
#define REGIONSETINTERFACEWIDGETNEIGHBOURSPOSITION_HPP

#include <qiseTools/RegionSetInterfaceWidget.hpp>
#include <ise/iseRegionSetInterfaceGravityCenter.hpp>

class MainView;
class RegionFeatureChoiceGravityCenterWidget;
class SliderSpinBoxWidget;

/**
 * Widget for NeighboursPosition Region Feature
 */
class GIRL_API RegionSetInterfaceWidgetNeighboursPosition : public RegionSetInterfaceWidget
{

public:
  RegionSetInterfaceWidgetNeighboursPosition(MainView *mainView,
					     FeatureComputerGUIInfoPtr featureComputerGUIInfo,
					     RegionSetInterfacePlugin *plugin,
					     QWidget *parent);

  virtual
  ~RegionSetInterfaceWidgetNeighboursPosition();

  void
  buildGUI();

  void
  getParameters(girl::shared_ptr<ise::RegionSetInterfaceGravityCenter> &regSetGravCenter, size_t &numBins, double &angle) const;

  void
  setParameters(const girl::shared_ptr<ise::RegionSetInterfaceGravityCenter> &regSetGravCenter, const size_t &numBins, const double &angle);

private:

  SliderSpinBoxWidget *m_numBinsSlider;
  SliderSpinBoxWidget *m_startAngleSlider;
  RegionFeatureChoiceGravityCenterWidget* m_rfccw;
};

#endif /* REGIONSETINTERFACEWIDGETNEIGHBOURSPOSITION_HPP */
