/*
  Copyright (C) 2005-2013 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef REGIONSETINTERFACEMEANPLUGIN_HPP_
#define REGIONSETINTERFACEMEANPLUGIN_HPP_

#include <ise/iseRegionSetInterfaceVariance.hpp>

#include <qiseTools/RegionSetInterfacePlugin.hpp>

#include "RegionSetInterfaceWidgetVariance.hpp"
#include "RegionSetInterfaceSettingsVariance.hpp"

#include <QObject>

/**
 * Plugin for Variance
 */
class RegionSetInterfaceVariancePlugin : public QObject,
				     public RegionSetInterfacePlugin
{
  Q_OBJECT
  Q_INTERFACES(RegionSetInterfacePlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID RegionSetInterfacePlugin_iid)
#endif

    public:
    RegionSetInterfaceVariancePlugin()
    : RegionSetInterfacePlugin(QString::fromUtf8("Variance"),
			       QIseVersion(1,0),QIseVersion(1,0))
  {}

  virtual
  ~RegionSetInterfaceVariancePlugin() {}

  girl::shared_ptr<ise::FeatureComputer>
  create(ise::SegmentationContext* segContext)
  {
    //m_settings;
    girl::shared_ptr<ise::FeatureComputer> result(new ise::RegionSetInterfaceVariance(segContext));
    return result;
  }
  
  RegionSetInterfaceWidget*
  createWidget(MainView *mainView, FeatureComputerGUIInfoPtr featureComputerGUIInfo, QWidget* parent)
  {
    return new RegionSetInterfaceWidgetVariance(mainView, featureComputerGUIInfo, this, parent);
  }
  
  girl::shared_ptr<FeatureInterfaceSettings>
  createSettings()
  {
    return girl::shared_ptr<FeatureInterfaceSettings>(new RegionSetInterfaceSettingsVariance());
  }
  
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseRegionSetInterfaceVariancePlugin, RegionSetInterfaceVariancePlugin)
#endif

#endif /* REGIONSETINTERFACEMEANPLUGIN_HPP_ */
