/*
  Copyright (C) 2005-2013 Remi Vieux, Boris Mansencal remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef REGIONSETINTERFACEWIDGETMEAN_HPP_
#define REGIONSETINTERFACEWIDGETMEAN_HPP_

#include <vector>
#include <girl/girlCommon.hpp>

#include <qiseTools/RegionSetInterfaceWidget.hpp>
#include <qiseTools/FeatureData.hpp>
#include <ise/iseRegionSetInterfaceMoments.hpp>

class QVBoxLayout;
class RegionFeatureChoiceMomentsWidget;
class WeightsSetupWidget;
class MainView;
/**
 *
 */
class RegionSetInterfaceWidgetVariance : public RegionSetInterfaceWidget
{

public:
  RegionSetInterfaceWidgetVariance(MainView *mainView,
			       FeatureComputerGUIInfoPtr featureComputerGUIInfo,
			       RegionSetInterfacePlugin* plugin,
			       QWidget *parent);
  virtual
  ~RegionSetInterfaceWidgetVariance();

  void
  buildGUI();

  void getParameters(girl::shared_ptr<ise::RegionSetInterfaceMoments> &regSetVariance) const;

  void
  setParameters(const girl::shared_ptr<ise::RegionSetInterfaceMoments> &regSetVariance);


private:

  QVBoxLayout* m_layout;

  RegionFeatureChoiceMomentsWidget* m_rfccw;

  ise::SegmentationContext* m_segContext;

};

#endif /* REGIONSETINTERFACEWIDGETMEAN_HPP_ */
