/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef REGIONSTRICTWEAKORDERINGASCENDINGPLUGIN_HPP_
#define REGIONSTRICTWEAKORDERINGASCENDINGPLUGIN_HPP_


#include <ise/iseRegionStrictWeakOrderingAscending.hpp>
#include <qiseTools/RegionStrictWeakOrderingPlugin.hpp>

#include <QObject>

#include <qiseTools/RegionStrictWeakOrderingWithUnaryFunctionsSettings.hpp>
#include <qiseTools/RegionStrictWeakOrderingWithUnaryFunctionsWidget.hpp>


class RegionStrictWeakOrderingAscendingPlugin :
  public QObject,
  public RegionStrictWeakOrderingPlugin
{
  Q_OBJECT
  Q_INTERFACES(RegionStrictWeakOrderingPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID RegionStrictWeakOrderingPlugin_iid)
#endif

public:

  RegionStrictWeakOrderingAscendingPlugin()
  : RegionStrictWeakOrderingPlugin(QString::fromUtf8("Ascending"),
      QIseVersion(1,0), QIseVersion(1,0))
  {}

  ~RegionStrictWeakOrderingAscendingPlugin() {}


  virtual girl::shared_ptr<RegionStrictWeakOrderingSettings> 
  createSettings(ise::SegmentationContext * /*segContext*/)
  {
    return girl::shared_ptr<RegionStrictWeakOrderingSettings>(new RegionStrictWeakOrderingWithUnaryFunctionsSettings());
  }

 protected:

  virtual girl::shared_ptr<ise::RegionStrictWeakOrdering> create(ise::SegmentationContext *segContext)
  {
    girl::shared_ptr<ise::RegionStrictWeakOrdering> result
    = ise::RegionStrictWeakOrderingAscendingFactory::instance().create(segContext);
    return result;
  }

  RegionStrictWeakOrderingWidget *createWidget(MainView *mainView/*ise::SegmentationContext *segContext*/, QWidget *parent)
  {
    return new RegionStrictWeakOrderingWithUnaryFunctionsWidget(mainView/*segContext*/, this, parent);
  }


protected:

};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseRegionStrictWeakOrderingAscendingPlugin, RegionStrictWeakOrderingAscendingPlugin)
#endif

#endif /* REGIONSTRICTWEAKORDERINGASCENDINGPLUGIN_HPP_ */
