/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef REGIONUNARYFUNCTIONAREAPLUGIN_HPP
#define REGIONUNARYFUNCTIONAREAPLUGIN_HPP

#include "RegionUnaryFunctionArea.hpp"

#include <qiseTools/RegionUnaryFunctionPlugin.hpp>
#include <qiseTools/RegionUnaryFunctionSettingsEmpty.hpp>

#include <QObject>

class RegionUnaryFunctionWidget;

class RegionUnaryFunctionAreaPlugin : public QObject,
                                                 public RegionUnaryFunctionPlugin
{

  Q_OBJECT
  Q_INTERFACES(RegionUnaryFunctionPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID RegionUnaryFunctionPlugin_iid)
#endif

public:

  RegionUnaryFunctionAreaPlugin() :
    RegionUnaryFunctionPlugin(QString::fromUtf8("Area"),
        QIseVersion(1, 0), QIseVersion(1,0))
  {}

  girl::shared_ptr<ise::RegionUnaryFunction>
  create(ise::SegmentationContext *segContext)
  {
    girl::shared_ptr<ise::RegionUnaryFunction> result(
        ise::RegionUnaryFunctionAreaFactory::instance().create(segContext));
    return result;
  }

  girl::shared_ptr<RegionUnaryFunctionSettings>
  createSettings(ise::SegmentationContext * /*segContext*/)
  {
    girl::shared_ptr<RegionUnaryFunctionSettings> result(new RegionUnaryFunctionSettingsEmpty());
    return result;
  }

  RegionUnaryFunctionWidget*
  createWidget(MainView * /*ise::SegmentationContext**/, QWidget*)
  {
    return NULL;
  }

};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseRegionUnaryFunctionAreaPlugin, RegionUnaryFunctionAreaPlugin)
#endif

#endif /* REGIONUNARYFUNCTIONAREAPLUGIN_HPP_ */
