/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef REGIONUNARYFUNCTIONWITHREGSETINDEXOFMASKPLUGIN_HPP_
#define REGIONUNARYFUNCTIONWITHREGSETINDEXOFMASKPLUGIN_HPP_

#include <ise/iseRegionUnaryFunctionWithRegSetIndexOfMax.hpp>

#include <qiseTools/RegionUnaryFunctionPlugin.hpp>
#include <qiseTools/RegionUnaryFunctionWithRegSetWidget.hpp>
#include <qiseTools/RegionUnaryFunctionWithRegSetSettings.hpp>

#include <QObject>

class RegionUnaryFunctionWithRegSetIndexOfMaxPlugin : public QObject,
						    public RegionUnaryFunctionPlugin
{
  Q_OBJECT
  Q_INTERFACES(RegionUnaryFunctionPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID RegionUnaryFunctionPlugin_iid)
#endif

public:

  RegionUnaryFunctionWithRegSetIndexOfMaxPlugin()
  : RegionUnaryFunctionPlugin(QString::fromUtf8("Unary Function IndexOfMax"),
      QIseVersion(1,0), QIseVersion(1,0))
  {}

  ~RegionUnaryFunctionWithRegSetIndexOfMaxPlugin() {}

  virtual girl::shared_ptr<ise::RegionUnaryFunction>
  create(ise::SegmentationContext *segContext)
  {
      girl::shared_ptr<ise::RegionUnaryFunction> result =
              ise::RegionUnaryFunctionWithRegSetIndexOfMaxFactory::instance().create(segContext);
      return result;
  }


  RegionUnaryFunctionWidget*
  createWidget(MainView *mainView/*ise::SegmentationContext *segContext*/, QWidget *parent)
  {
      return new RegionUnaryFunctionWithRegSetWidget(mainView, parent);
  }


  girl::shared_ptr<RegionUnaryFunctionSettings>
  createSettings(ise::SegmentationContext *)
  {
    girl::shared_ptr<RegionUnaryFunctionSettings> result
            (new RegionUnaryFunctionWithRegSetSettings());
    return result;
  }


};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseRegionUnaryFunctionWithRegSetIndexOfMaxPlugin, RegionUnaryFunctionWithRegSetIndexOfMaxPlugin)
#endif

#endif /* REGIONUNARYFUNCTIONWITHREGSETINDEXOFMASKPLUGIN_HPP_ */
