/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef REGIONUNARYFUNCTIONMINKOWSKIDISTANCEPLUGIN_HPP_
#define REGIONUNARYFUNCTIONMINKOWSKIDISTANCEPLUGIN_HPP_

#include <ise/iseRegionUnaryFunctionWithRegSetMinkowskiDistance.hpp>

#include <qiseTools/RegionUnaryFunctionPlugin.hpp>
#include <qiseTools/RegionUnaryFunctionWithRegSetWeightSettings.hpp>
#include <qiseTools/RegionUnaryFunctionWithRegSetWeightWidget.hpp>
// TODO: Change widget to enable setup of minkowski order

#include <QObject>

class RegionUnaryFunctionMinkowskiDistancePlugin :
public QObject,
public RegionUnaryFunctionPlugin
{
  Q_OBJECT
  Q_INTERFACES(RegionUnaryFunctionPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID RegionUnaryFunctionPlugin_iid)
#endif

public:

  RegionUnaryFunctionMinkowskiDistancePlugin()
  : RegionUnaryFunctionPlugin(QString::fromUtf8("Minkowski Norm"),
      QIseVersion(1,0), QIseVersion(1,0))
  {}

  ~RegionUnaryFunctionMinkowskiDistancePlugin() {}

  virtual girl::shared_ptr<ise::RegionUnaryFunction>
  create(ise::SegmentationContext *segContext)
  {
    girl::shared_ptr<ise::RegionUnaryFunction> result
    = ise::RegionUnaryFunctionWithRegSetMinkowskiDistanceFactory::instance().create(segContext);
    return result;
  }

  girl::shared_ptr<RegionUnaryFunctionSettings>
  createSettings(ise::SegmentationContext *)
  {
    girl::shared_ptr<RegionUnaryFunctionSettings> result(new RegionUnaryFunctionWithRegSetWeightSettings());
    return result;
  }

  RegionUnaryFunctionWidget*
  createWidget(MainView *mainView/*ise::SegmentationContext *segContext*/, QWidget *parent)
  {
    return new RegionUnaryFunctionWithRegSetWeightWidget(mainView /*segContext*/, parent);
  }

};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseRegionUnaryFunctionMinkowskiDistancePlugin, RegionUnaryFunctionMinkowskiDistancePlugin)
#endif

#endif /* REGIONUNARYFUNCTIONMINKOWSKIDISTANCEPLUGIN_HPP_ */
