/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef REGIONUNARYFUNCTIONWITHREGSETIDENTITYPLUGIN_HPP_
#define REGIONUNARYFUNCTIONWITHREGSETIDENTITYPLUGIN_HPP_

#include <ise/iseRegionUnaryFunctionWithRegSetIdentity.hpp>

#include <qiseTools/RegionUnaryFunctionPlugin.hpp>
#include "RegionUnaryFunctionWithRegSetIdentitySettings.hpp"
#include "RegionUnaryFunctionWithRegSetIdentityWidget.hpp"

#include <QObject>

class RegionUnaryFunctionWithRegSetIdentityPlugin : public QObject,
						    public RegionUnaryFunctionPlugin
{
  Q_OBJECT
  Q_INTERFACES(RegionUnaryFunctionPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID RegionUnaryFunctionPlugin_iid)
#endif

public:

  RegionUnaryFunctionWithRegSetIdentityPlugin()
  : RegionUnaryFunctionPlugin(QString::fromUtf8("Unary Function Identity"),
      QIseVersion(1,0), QIseVersion(1,0))
  {}

  ~RegionUnaryFunctionWithRegSetIdentityPlugin() {}

  RegionUnaryFunctionWidget*
  createWidget(MainView *mainView/*ise::SegmentationContext *segContext*/, QWidget *parent)
  {
    return new RegionUnaryFunctionWithRegSetIdentityWidget(mainView/*segContext*/, parent);
  }

  virtual girl::shared_ptr<ise::RegionUnaryFunction>
  create(ise::SegmentationContext *segContext)
  {
    girl::shared_ptr<ise::RegionUnaryFunction> result
    = ise::RegionUnaryFunctionWithRegSetIdentityFactory::instance().create(segContext);
    return result;
  }

  girl::shared_ptr<RegionUnaryFunctionSettings>
  createSettings(ise::SegmentationContext *)
  {
    girl::shared_ptr<RegionUnaryFunctionSettings> result(new RegionUnaryFunctionWithRegSetIdentitySettings());
    return result;
  }


};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseRegionUnaryFunctionWithRegSetIdentityPlugin, RegionUnaryFunctionWithRegSetIdentityPlugin)
#endif

#endif /* REGIONUNARYFUNCTIONWITHREGSETIDENTITYPLUGIN_HPP_ */
