/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "RegionUnaryFunctionWithRegSetIdentitySettings.hpp"

#include "RegionUnaryFunctionWithRegSetIdentityWidget.hpp"


void
RegionUnaryFunctionWithRegSetIdentitySettings::configureWidget(RegionUnaryFunctionWidget *w) const
{
  RegionUnaryFunctionWithRegSetIdentityWidget *widget = 
    static_cast<RegionUnaryFunctionWithRegSetIdentityWidget *>(w);

  RegionUnaryFunctionWithRegSetSettings::configureWidget(widget);

  widget->setIndex(m_index);
}

void
RegionUnaryFunctionWithRegSetIdentitySettings::getWidgetConfig(const RegionUnaryFunctionWidget *w)
{
  const RegionUnaryFunctionWithRegSetIdentityWidget *widget =
      static_cast<const RegionUnaryFunctionWithRegSetIdentityWidget *>(w);

  RegionUnaryFunctionWithRegSetSettings::getWidgetConfig(widget);
  
  m_index = widget->getIndex();
}

void
RegionUnaryFunctionWithRegSetIdentitySettings::configureAlgo(girl::shared_ptr<ise::RegionUnaryFunction> algo) const
{
  girl::shared_ptr<ise::RegionUnaryFunctionWithRegSetIdentity> a =
      girl::static_pointer_cast<ise::RegionUnaryFunctionWithRegSetIdentity>(algo);

  a->setParameters(m_regSet, m_index);
}
