/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "RegionUnaryFunctionWithRegSetIdentityWidget.hpp"

#include <ise/iseRegionSetInterface.hpp>

//#include <qiseTools/SliderSpinBoxWidget.hpp>

#include <QComboBox>
#include <QLabel>
#include <QLayout>

RegionUnaryFunctionWithRegSetIdentityWidget::RegionUnaryFunctionWithRegSetIdentityWidget(MainView *mainView/*ise::SegmentationContext *segContext*/, 
											 QWidget *parent)
  : RegionUnaryFunctionWithRegSetWidget(mainView/*segContext*/, parent)
{
  buildGUI();

}

void
RegionUnaryFunctionWithRegSetIdentityWidget::buildGUI()
{

  QLabel *label = new QLabel(tr("Channel: "), this);

//  m_indexW = new SliderSpinBoxWidget(this);
//  m_indexW->setDecimals(0);
//  m_indexW->setSingleStep(1);
//  m_indexW->setMinimum(0);
  m_indexW = new QComboBox(this);


  QHBoxLayout *hl = new QHBoxLayout;
  hl->addWidget(label);
  hl->addWidget(m_indexW);
  hl->setMargin(0); //because embedded widget
  QWidget *w = new QWidget(this);
  w->setLayout(hl);

  layout()->addWidget(w);

  connect(m_combo, SIGNAL(currentIndexChanged(int)),
	  this, SLOT(regSetChanged(int)));

  if (m_combo->currentIndex() != -1) {
    regSetChanged(0);
  }

}

void
RegionUnaryFunctionWithRegSetIdentityWidget::setIndex(size_t index)
{
  assert(m_indexW);
  //m_indexW->setValue(index);
  m_indexW->setCurrentIndex(index);
}

size_t
RegionUnaryFunctionWithRegSetIdentityWidget::getIndex() const
{
  assert(m_indexW);
 // return m_indexW->value();
  return m_indexW->currentIndex();
}

void
RegionUnaryFunctionWithRegSetIdentityWidget::regSetChanged(int)
{
  girl::shared_ptr<ise::RegionSetInterface> rs;
  //m_combo->getGUI(rs);
  rs = girl::static_pointer_cast<ise::RegionSetInterface>(m_combo->regionFeatureComputerPtr());
  if (rs) {
    const int currIndex = getIndex();

    m_indexW->clear();
    std::vector<std::string> dimDesc;
    rs->getDimDescription(dimDesc);
    const size_t dim = dimDesc.size();
    for (size_t i = 0; i < dim; ++i) {
      m_indexW->addItem(QString(dimDesc[i].c_str()));
    }
    
    if (currIndex >= (int)dim) {
      setIndex(0);
    }
    else {
      setIndex(currIndex);
    }
    //  m_indexW->setMaximum(dim-1);
  }
}
