/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef REGIONUNARYPREDICATETHRESHOLDPLUGIN_HPP_
#define REGIONUNARYPREDICATETHRESHOLDPLUGIN_HPP_

#include <ise/iseRegionUnaryPredicateThreshold.hpp>

#include <qiseTools/RegionUnaryPredicatePlugin.hpp>
#include <qiseTools/RegionUnaryPredicateThresholdWidget.hpp>
#include "RegionUnaryPredicateThresholdSettings.hpp"

#include <QObject>

class RegionUnaryPredicateThresholdPlugin : public QObject,
					    public RegionUnaryPredicatePlugin
{
  Q_OBJECT
  Q_INTERFACES(RegionUnaryPredicatePlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID RegionUnaryPredicatePlugin_iid)
#endif

public:

  RegionUnaryPredicateThresholdPlugin()
    : RegionUnaryPredicatePlugin(QString::fromUtf8("Unary Predicate Threshold"),
				 QIseVersion(1, 0), QIseVersion(1, 0))
  {}

  ~RegionUnaryPredicateThresholdPlugin() {}



protected:

  virtual RegionUnaryPredicateWidget *createWidget(MainView* mainView/*ise::SegmentationContext *segContext*/, QWidget *parent)
  {
    return new RegionUnaryPredicateThresholdWidget(mainView/*segContext*/, this, parent);
  }

  virtual girl::shared_ptr<ise::RegionUnaryPredicate> create(ise::SegmentationContext *segContext)
  {
    girl::shared_ptr<ise::RegionUnaryPredicate> result
    = ise::RegionUnaryPredicateThresholdFactory::instance().create(segContext);
    return result;
  }
  
  virtual girl::shared_ptr<RegionUnaryPredicateSettings> createSettings(ise::SegmentationContext* /*segContext*/)
  {
    return girl::shared_ptr<RegionUnaryPredicateSettings>(new RegionUnaryPredicateThresholdSettings());//NULL
  }

  virtual bool hasSettings() const
  {
    return false;
  }


protected:

};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseRegionUnaryPredicateThresholdPlugin, RegionUnaryPredicateThresholdPlugin)
#endif

#endif /* REGIONUNARYPREDICATETHRESHOLDPLUGIN_HPP_ */
