/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef REGIONUNARYPREDICATETHRESHOLDSETTINGS_HPP_
#define REGIONUNARYPREDICATETHRESHOLDSETTINGS_HPP_

#include <ise/iseRegionUnaryPredicateThreshold.hpp>
#include <qiseTools/RegionUnaryPredicateSettings.hpp>

#include <qiseTools/RegionUnaryFunctionPlugin.hpp>

class RegionUnaryPredicateThresholdSettings : public RegionUnaryPredicateSettings
{
public:
  
  virtual void configureWidget(RegionUnaryPredicateWidget *widget) const;

  virtual void getWidgetConfig(const RegionUnaryPredicateWidget *widget);

  virtual void configureAlgo(girl::shared_ptr<ise::RegionUnaryPredicate> algo) const;

  virtual girl::shared_ptr<RegionUnaryPredicateSettings> clone() const;

  virtual bool isValid() const;

protected:

  RegionUnaryFunctionPlugin *m_unaryFctPlugin;
  girl::shared_ptr<RegionUnaryFunctionSettings> m_unaryFctSettings;
  ise::ComparisonOperator m_comp;
  double m_threshold;

};


#endif /* ! REGIONUNARYPREDICATETHRESHOLDSETTINGS_HPP_ */
