#ifndef SEGMENTATIONCLUSTERINGBINARYRELAXATIONPLUGIN_HPP
#define SEGMENTATIONCLUSTERINGBINARYRELAXATIONPLUGIN_HPP

#include <qiseTools/SegmentationClusteringPlugin.hpp>

#include <ise/iseSegmentationClusteringBinaryRelaxation.hpp>

#include <qiseTools/SegmentationClusteringBinaryRelaxationWidget.hpp>
#include <qiseTools/SegmentationClusteringBinaryRelaxationWidgetSettings.hpp>

#include <QObject>

class SegmentationClusteringBinaryRelaxationPlugin : public QObject,
						     public SegmentationClusteringPlugin
{

  Q_OBJECT
  Q_INTERFACES(SegmentationClusteringPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID SegmentationClusteringPlugin_iid)
#endif
    
public:
    
  ~SegmentationClusteringBinaryRelaxationPlugin() {}
  
  SegmentationClusteringBinaryRelaxationPlugin()
    : SegmentationClusteringPlugin(QString::fromUtf8("Bahnu binary relaxation clustering"),
				   QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::SegmentationClustering> create()
  {
    girl::shared_ptr<ise::SegmentationClustering> result(new ise::SegmentationClusteringBinaryRelaxation(m_segContext));
    return result;
  }
  
  virtual bool inSubMenu(std::string &subMenu)
  {
    subMenu = "General";
    return true;
  }

  virtual girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface> createSettings()
  {
    return girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface>(new SegmentationClusteringBinaryRelaxationWidgetSettings());
  }

protected:

  virtual SegmentationClusteringWidgetInterface* createWidget(MainView *mainView, QWidget *parent = NULL)
  {
    return new SegmentationClusteringBinaryRelaxationWidget(mainView, this, parent);
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseSegmentationClusteringBinaryRelaxationPlugin, SegmentationClusteringBinaryRelaxationPlugin)
#endif

#endif /* ! SEGMENTATIONCLUSTERINGBINARYRELAXATIONPLUGIN_HPP */
