/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef SEGMENTATIONCLUSTERINGBLOCKWIDGET_HPP
#define SEGMENTATIONCLUSTERINGBLOCKWIDGET_HPP

#include <qiseTools/SegmentationClusteringWidgetInterface.hpp>

class QSpinBox;
class QDoubleSpinBox;
class SegmentationClusteringPlugin;



class GIRL_API SegmentationClusteringBlockWidget : public SegmentationClusteringWidgetInterface
{

 public:
  SegmentationClusteringBlockWidget(MainView *mainView,
				    SegmentationClusteringPlugin *segmentationClustering,
				    QWidget *parent = NULL);
  
  void setParameters(size_t areaThreshold, double axisRatioThreshold, double compacityThreshold);
  void getParameters(size_t &areaThreshold, double &axisRatioThreshold, double &compacityThreshold) const;

 protected:

  void buildGUI();

 protected:
  
  QSpinBox *m_areaThresholdSB;
  QDoubleSpinBox *m_axisRatioThresholdSB;
  QDoubleSpinBox *m_compacityThresholdSB;

};

#endif /* ! SEGMENTATIONCLUSTERINGBLOCKWIDGET_HPP */ 
