/*
  Copyright (C) 2005-2011 Remi Vieux, Jean-Philippe Domenger, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISEREGIONBINARYPREDICATEFORBIDDENREGIONS_HPP_
#define ISEREGIONBINARYPREDICATEFORBIDDENREGIONS_HPP_

#include <girl/girlHashFunc.hpp>
#include <girl/girlUnorderedSet.hpp>

#include <ise/iseRegionBinaryPredicate.hpp>
/*
 *
 */
namespace ise
{
  class RegionBinaryPredicateForbiddenRegions : public RegionBinaryPredicate
  {
  public:
    RegionBinaryPredicateForbiddenRegions(SegmentationContext *segContext,
					  const girl::unorderedSet<girl::region> &whitespaceRegions);
    virtual
    ~RegionBinaryPredicateForbiddenRegions();

    bool
    operator()(const first_argument_type& ,
	       const second_argument_type&);

  protected:

    const girl::unorderedSet<girl::region> &m_forbiddenRegs;
    
  };

}
#endif /* ISEREGIONBINARYPREDICATEFORBIDDENREGIONS_HPP_ */
