/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGDENSITYFEATUREWIDGET_HPP
#define SEGMENTATIONCLUSTERINGDENSITYFEATUREWIDGET_HPP

#include <qiseTools/SegmentationClusteringWidgetInterface.hpp>

class QLabel;
class QComboBox;

namespace ise {
  //class SegmentationClusteringDensityFeature;
  class Histogram1D;
}

class SegmentationClusteringPlugin;
class Histogram1DThresholdsWidget;

class GIRL_API SegmentationClusteringDensityFeatureWidget : public SegmentationClusteringWidgetInterface
{
  Q_OBJECT
public:
  SegmentationClusteringDensityFeatureWidget(MainView *mainView,
					     SegmentationClusteringPlugin *segmentationClustering,
					     QWidget *parent = NULL);

  void setParameters(std::string type, double threshold);
  void getParameters(std::string &type, double &threshold) const;

protected:

  void buildGUI();
 
 private:

  void computeHisto();

 private slots:

  void computeThreshold(int);
  void changeThreshold(size_t);

protected:
 
  QComboBox *m_type;
  QComboBox *m_thresholders;
  Histogram1DThresholdsWidget *m_histoView;
  ise::Histogram1D *m_histo;
  double m_threshold;
};
#endif /* ! SEGMENTATIONCLUSTERINGDENSITYFEATUREWIDGET_HPP */
