/*
  Copyright (C) 2005-2011 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGDENSITYFEATUREWIDGETSETTINGS_HPP
#define SEGMENTATIONCLUSTERINGDENSITYFEATUREWIDGETSETTINGS_HPP

#include <qiseTools/SegmentationClusteringWidgetSettingsInterface.hpp>
#include "SegmentationClusteringDensityFeatureWidget.hpp"
#include "iseSegmentationClusteringDensityFeature.hpp"

class SegmentationClusteringDensityFeatureWidgetSettings : public SegmentationClusteringWidgetSettingsInterface {
  
public:
  
  SegmentationClusteringDensityFeatureWidgetSettings() 
    : SegmentationClusteringWidgetSettingsInterface()
    , m_type("text")
    , m_threshold(0)
  {
  }

  virtual void configureWidget(SegmentationClusteringWidgetInterface *widget) const
  {
    static_cast<SegmentationClusteringDensityFeatureWidget*>(widget)->setParameters(m_type, m_threshold);
  }
  
  virtual void getWidgetConfig(const SegmentationClusteringWidgetInterface *widget)
  {
    static_cast<const SegmentationClusteringDensityFeatureWidget*>(widget)->getParameters(m_type, m_threshold);
  }

  virtual void configureAlgo(girl::shared_ptr<ise::SegmentationClustering> algo) const
  {
    girl::shared_ptr<ise::SegmentationClusteringDensityFeature> algorithm = girl::static_pointer_cast<ise::SegmentationClusteringDensityFeature>(algo);
    algorithm->setParameters(m_type, m_threshold);
  }

  virtual girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface> clone() const
  {
    girl::shared_ptr<SegmentationClusteringDensityFeatureWidgetSettings> p(new SegmentationClusteringDensityFeatureWidgetSettings);

    *p = *this;

    return p;
  }

  virtual bool isValid() const
  {
    return true; //B: ???
  }
  
  
private:
  
  std::string m_type;
  double m_threshold;
};

#endif /* ! SEGMENTATIONCLUSTERINGDENSITYFEATUREWIDGETSETTINGS_HPP */
