/*
  Copyright (C) 2005-2009 Roigt Julian, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISESEGMENTATIONCLUSTERINGDENSITYFEATURE_HPP
#define ISESEGMENTATIONCLUSTERINGDENSITYFEATURE_HPP

#include <girl/girlToger.hpp>
#include <ise/iseSegmentationClustering.hpp>
#include <ise/iseGenericImage.hpp>
#include <ise/iseImageLabelToger.hpp>

namespace ise {

  class SegmentationContext;
  
  class  GIRL_API SegmentationClusteringDensityFeature : public SegmentationClustering
  {
  public :

    explicit SegmentationClusteringDensityFeature(SegmentationContext *segContext);
    
    virtual ~SegmentationClusteringDensityFeature() {}

    virtual void setSegContext(ise::SegmentationContext *s);

    virtual void setParameters(std::string type, double threshold);

    virtual void getParameters(std::string &type, double &threshold) const;
    
    virtual void init(const girl::regionDeque &regions, int level=1);

    virtual void init(girl::region /*r*/, int /*level*/) {} 
    
    virtual bool same(const girl::point &p, girl::direction dir);

  private:

    void computeImage();

  private:
    std::string m_type;
    //cv::Mat m_image;
    ise::ImageLabelToger m_image;

    std::map<int, double> m_regionsDWB;
    double m_threshold;
  };

}

#endif /* ! ISESEGMENTATIONCLUSTERINGDENSITYFEATURE_HPP */
