#ifndef SEGMENTATIONCLUSTERINGENCLOSINGSHAPEWIDGETSETTINGS_HPP
#define SEGMENTATIONCLUSTERINGENCLOSINGSHAPEWIDGETSETTINGS_HPP

#include <ise/iseSegmentationClusteringEnclosingShape.hpp>
#include <qiseTools/SegmentationClusteringWidgetSettingsInterface.hpp>
#include "SegmentationClusteringEnclosingShapeWidget.hpp"

class SegmentationClusteringEnclosingShapeWidgetSettings : public SegmentationClusteringWidgetSettingsInterface
{
public:
    SegmentationClusteringEnclosingShapeWidgetSettings();


    virtual void configureWidget(SegmentationClusteringWidgetInterface *widget) const
    {
        static_cast<SegmentationClusteringEnclosingShapeWidget*>(widget)->setParameters(m_shapes, m_factory, m_method);
    }

    virtual void getWidgetConfig(const SegmentationClusteringWidgetInterface *widget)
    {
        static_cast<const SegmentationClusteringEnclosingShapeWidget*>(widget)->getParameters(m_shapes, m_factory, m_method);
    }

    virtual void configureAlgo(girl::shared_ptr<ise::SegmentationClustering> algo) const
    {
        girl::shared_ptr<ise::SegmentationClusteringEnclosingShape> algorithm = girl::static_pointer_cast<ise::SegmentationClusteringEnclosingShape>(algo);
        algorithm->setParameters(m_shapes, m_factory, m_method);
    }

  virtual girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface> clone() const
  {
    girl::shared_ptr<SegmentationClusteringEnclosingShapeWidgetSettings> p(new SegmentationClusteringEnclosingShapeWidgetSettings);

    *p = *this;

    return p;
  }

  virtual bool isValid() const
  {
    return true; //B: ???
  }

protected:

    ise::SegmentationClusteringEnclosingShape::ShapeList m_shapes;
    girl::shared_ptr<EnclosingShapeFactory> m_factory;
    ise::SegmentationClusteringEnclosingShape::MergeMethod m_method;

};

#endif // SEGMENTATIONCLUSTERINGENCLOSINGSHAPEWIDGETSETTINGS_HPP
