/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGFELZENSWALBWIDGET_HPP
#define SEGMENTATIONCLUSTERINGFELZENSWALBWIDGET_HPP

#include <qiseTools/SegmentationClusteringWidgetInterface.hpp>

#include <ise/iseImageFeatureComputer.hpp>

class QSpinBox;
class QDoubleSpinBox;

class SegmentationClusteringPlugin;
class ImageFeatureChoiceWidget;

class GIRL_API SegmentationClusteringFelzenswalbWidget : public SegmentationClusteringWidgetInterface
{

  Q_OBJECT

 public:

  SegmentationClusteringFelzenswalbWidget(MainView *mainView,
				       SegmentationClusteringPlugin *segmentationClustering,
				       QWidget *parent = NULL);
  
  void setParameters(float sigma, float k, int minArea, const ise::FeatureComputerPtr &algo);
  void getParameters(float &sigma, float &k, int &minArea, ise::FeatureComputerPtr &data) const;

protected:

  void buildGUI();

protected:
  
  ImageFeatureChoiceWidget *m_ifcw;

  QDoubleSpinBox *m_sigmaBox;
  QDoubleSpinBox *m_kBox;
  QSpinBox *m_areaBox;

};

#endif /* ! SEGMENTATIONCLUSTERINGFELZENSWALBWIDGET_HPP */ 
