#include "SegmentationClusteringSettingsFelzenswalb.hpp"

  
SegmentationClusteringSettingsFelzenswalb::SegmentationClusteringSettingsFelzenswalb() 
  : SegmentationClusteringWidgetSettingsInterface(),
    m_sigma(ise::SegmentationClusteringFelzenswalb::DEFAULT_SIGMA),
    m_k(ise::SegmentationClusteringFelzenswalb::DEFAULT_K),
    m_minArea(ise::SegmentationClusteringFelzenswalb::DEFAULT_MIN_AREA)
{
}

void 
SegmentationClusteringSettingsFelzenswalb::configureWidget(SegmentationClusteringWidgetInterface *widget) const
{
  static_cast<SegmentationClusteringFelzenswalbWidget*>(widget)->setParameters(m_sigma, m_k, m_minArea, m_algo);
}

void
SegmentationClusteringSettingsFelzenswalb::getWidgetConfig(const SegmentationClusteringWidgetInterface *widget)
{
  static_cast<const SegmentationClusteringFelzenswalbWidget*>(widget)->getParameters(m_sigma, m_k, m_minArea, m_algo);
}

void
SegmentationClusteringSettingsFelzenswalb::configureAlgo(girl::shared_ptr<ise::SegmentationClustering> algo) const
{
  girl::shared_ptr<ise::SegmentationClusteringFelzenswalb> algorithm = girl::static_pointer_cast<ise::SegmentationClusteringFelzenswalb>(algo);
  algorithm->setParameters(m_sigma, m_k, m_minArea, girl::static_pointer_cast<ise::ImageFeatureComputer>(m_algo),ise::SegmentationClusteringFelzenswalb::DEFAULT_GRAPH_TYPE);
}

girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface> 
SegmentationClusteringSettingsFelzenswalb::clone() const
{
  girl::shared_ptr<SegmentationClusteringSettingsFelzenswalb> p(new SegmentationClusteringSettingsFelzenswalb);
  
  *p = *this;
  
  return p;
}
  
bool 
SegmentationClusteringSettingsFelzenswalb::isValid() const
{
  return true; //B:???
}

