#ifndef SEGMENTATIONCLUSTERINGGENERICKMEANSPLUGIN_HPP
#define SEGMENTATIONCLUSTERINGGENERICKMEANSPLUGIN_HPP

#include <qiseTools/SegmentationClusteringPlugin.hpp>

#include <ise/iseSegmentationClusteringGenericKMeans.hpp>

#include <qiseTools/SegmentationClusteringGenericKMeansWidget.hpp>
#include <qiseTools/SegmentationClusteringGenericKMeansWidgetSettings.hpp>

#include <QObject>

class SegmentationClusteringGenericKMeansPlugin : public QObject,
						  public SegmentationClusteringPlugin
{

  Q_OBJECT
  Q_INTERFACES(SegmentationClusteringPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID SegmentationClusteringPlugin_iid)
#endif
    
public:
    
  ~SegmentationClusteringGenericKMeansPlugin() {}
  
  SegmentationClusteringGenericKMeansPlugin()
    : SegmentationClusteringPlugin(QString::fromUtf8("Generic K-means quantification"),
				   QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::SegmentationClustering> create()
  {
    girl::shared_ptr<ise::SegmentationClustering> result(new ise::SegmentationClusteringGenericKMeans(m_segContext));
    return result;
  }
  
  virtual bool inSubMenu(std::string &subMenu)
  {
    subMenu = "K-means";
    return true;
  }

  virtual girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface> createSettings()
  {
    return girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface>(new SegmentationClusteringGenericKMeansWidgetSettings());
  }

protected:

  virtual SegmentationClusteringWidgetInterface* createWidget(MainView *mainView, QWidget *parent = NULL)
  {
    return new SegmentationClusteringGenericKMeansWidget(mainView, this, parent);
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseSegmentationClusteringGenericKMeansPlugin, SegmentationClusteringGenericKMeansPlugin)
#endif

#endif /* ! SEGMENTATIONCLUSTERINGGENERICKMEANSPLUGIN_HPP */
