/*
  Copyright (C) 2013 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGGONOGO1WIDGET_HPP
#define SEGMENTATIONCLUSTERINGGONOGO1WIDGET_HPP

#include <qiseTools/SegmentationClusteringWidgetInterface.hpp>

class ColorSpaceChoiceWidget;
class QSpinBox;
class QLabel;
class QLineEdit;

namespace ise {
  class SegmentationClusteringGonogo1;
}

class SegmentationClusteringPlugin;

class GIRL_API SegmentationClusteringGonogo1Widget : public SegmentationClusteringWidgetInterface
{

public:
  SegmentationClusteringGonogo1Widget(MainView *mainView,
					      SegmentationClusteringPlugin *segmentationClustering,
					      QWidget *parent = NULL);

  void setParameters(int colorSpace, int nbClasses, int regionArea, double flashLuminanceThreshold);
  void getParameters(int &colorSpace, int &nbClasses, int &regionArea, double &flashLuminanceThreshold) const;

protected:

  void buildGUI();
 
protected:
 
  ColorSpaceChoiceWidget *m_cscw;
  QSpinBox *m_nbClassesSB;
  QSpinBox *m_areaSB;
  QLineEdit *m_flashLE;
};

#endif /* ! SEGMENTATIONCLUSTERINGGONOGO1WIDGET_HPP */
