/*
  Copyright (C) 2013 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGGONOGO1EMSETTINGS_HPP
#define SEGMENTATIONCLUSTERINGGONOGO1EMSETTINGS_HPP

#include <qiseTools/SegmentationClusteringWidgetSettingsInterface.hpp>
#include "SegmentationClusteringGonogo1EMWidget.hpp"
#include <ise/iseSegmentationClusteringGonogo1EM.hpp>

class SegmentationClusteringGonogo1EMSettings : public SegmentationClusteringWidgetSettingsInterface
{
  
public:
  
  //B: UGLY: duplication of default parameters !!!!!!!!!!!!!
  SegmentationClusteringGonogo1EMSettings() 
    : SegmentationClusteringWidgetSettingsInterface(),
      m_colorSpace(ISE_RGB_to_Lab),
      m_nbClasses(6),
      m_regionArea(145),
      m_flashLuminanceThreshold(57)
  {
  }

  virtual void configureWidget(SegmentationClusteringWidgetInterface *widget) const
  {
    static_cast<SegmentationClusteringGonogo1EMWidget*>(widget)->setParameters(m_colorSpace, m_nbClasses, m_regionArea, m_flashLuminanceThreshold);
  }
  
  virtual void getWidgetConfig(const SegmentationClusteringWidgetInterface *widget)
  {
    static_cast<const SegmentationClusteringGonogo1EMWidget*>(widget)->getParameters(m_colorSpace, m_nbClasses, m_regionArea, m_flashLuminanceThreshold);
  }

  virtual void configureAlgo(girl::shared_ptr<ise::SegmentationClustering> algo) const
  {
    girl::shared_ptr<ise::SegmentationClusteringGonogo1EM> algorithm = girl::static_pointer_cast<ise::SegmentationClusteringGonogo1EM>(algo);
    algorithm->setParameters(m_colorSpace, m_nbClasses, m_regionArea, m_flashLuminanceThreshold);
  }
  
  virtual girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface> clone() const
  {
    girl::shared_ptr<SegmentationClusteringGonogo1EMSettings> p(new SegmentationClusteringGonogo1EMSettings);
    
    *p = *this;
    
    return p;
  }
  
  virtual bool isValid() const
  {
    return (m_nbClasses > 0);
  }

private:
  
  int m_colorSpace;
  int m_nbClasses;
  int m_regionArea;
  double m_flashLuminanceThreshold;
};

#endif /* ! SEGMENTATIONCLUSTERINGGONOG1EMSETTINGS_HPP */
