/*
  Copyright (C) 2013 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGGONOGO2PLUGIN_HPP
#define SEGMENTATIONCLUSTERINGGONOGO2PLUGIN_HPP

#include <qiseTools/SegmentationClusteringPlugin.hpp>

#include <ise/iseSegmentationClusteringGonogo2.hpp>

#include "SegmentationClusteringGonogo2Widget.hpp"
#include "SegmentationClusteringGonogo2Settings.hpp"

#include <QObject>

class SegmentationClusteringGonogo2Plugin : public QObject,
					    public SegmentationClusteringPlugin
{
  
  Q_OBJECT
  Q_INTERFACES(SegmentationClusteringPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID SegmentationClusteringPlugin_iid)
#endif
  
public:
  
  ~SegmentationClusteringGonogo2Plugin() {}
  
  SegmentationClusteringGonogo2Plugin()
    : SegmentationClusteringPlugin(QString::fromUtf8("Gonogo2"),
				   QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::SegmentationClustering> create()
  {
    girl::shared_ptr<ise::SegmentationClustering> result(new ise::SegmentationClusteringGonogo2(m_segContext));
    return result;
  }
  
  virtual bool inSubMenu(std::string &subMenu)
  {
    subMenu = "General";
    return true;
  }

  virtual girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface> createSettings()
  {
    return girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface>(new SegmentationClusteringGonogo2Settings());
  }

protected:

  virtual SegmentationClusteringWidgetInterface* createWidget(MainView *mainView, QWidget *parent = NULL)
  {
    return new SegmentationClusteringGonogo2Widget(mainView, this, parent);
  }


};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseSegmentationClusteringGonogo2Plugin, SegmentationClusteringGonogo2Plugin)
#endif

#endif /* ! SEGMENTATIONCLUSTERINGGONOGO2PLUGIN_HPP */
