/*
  Copyright (C) 2013 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGGONOGO2WIDGET_HPP
#define SEGMENTATIONCLUSTERINGGONOGO2WIDGET_HPP

#include <qiseTools/SegmentationClusteringWidgetInterface.hpp>

class ColorSpaceChoiceWidget;
class QSpinBox;
class QLabel;
class QLineEdit;

namespace ise {
  class SegmentationClusteringGonogo2;
}

class SegmentationClusteringPlugin;

class GIRL_API SegmentationClusteringGonogo2Widget : public SegmentationClusteringWidgetInterface
{

public:
  SegmentationClusteringGonogo2Widget(MainView *mainView,
					      SegmentationClusteringPlugin *segmentationClustering,
					      QWidget *parent = NULL);

  void setParameters(int colorSpace, int nbClasses, int regionArea, double flashLuminanceThreshold, double a00, double a01, double a02, double a10, double a11, double a12, double tx=0, double ty=0);
  void getParameters(int &colorSpace, int &nbClasses, int &regionArea, double &flashLuminanceThreshold, double &a00, double &a01, double &a02, double &a10, double &a11, double &a12, double &tx, double &ty) const;

protected:

  void buildGUI();
 
protected:
 
  ColorSpaceChoiceWidget *m_cscw;
  QSpinBox *m_nbClassesSB;
  QSpinBox *m_areaSB;
  QLineEdit *m_flashLE;
  QLineEdit *m_a00;
  QLineEdit *m_a01;
  QLineEdit *m_a02;
  QLineEdit *m_a10;
  QLineEdit *m_a11;
  QLineEdit *m_a12;
  QLineEdit *m_tx;
  QLineEdit *m_ty;
};

#endif /* ! SEGMENTATIONCLUSTERINGGONOGO2WIDGET_HPP */
