#ifndef SEGMENTATIONCLUSTERINGLOCALTHRESHOLDSPLUGIN_HPP
#define SEGMENTATIONCLUSTERINGLOCALTHRESHOLDSPLUGIN_HPP

#include <qiseTools/SegmentationClusteringPlugin.hpp>

#include <ise/iseSegmentationClusteringLocalThresholds.hpp>

#include <qiseTools/SegmentationClusteringLocalThresholdsWidget.hpp>
#include <qiseTools/SegmentationClusteringLocalThresholdsWidgetSettings.hpp>

#include <QObject>

class SegmentationClusteringLocalThresholdsPlugin : public QObject,
					      public SegmentationClusteringPlugin
{

  Q_OBJECT
  Q_INTERFACES(SegmentationClusteringPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID SegmentationClusteringPlugin_iid)
#endif
    
public:
    
  ~SegmentationClusteringLocalThresholdsPlugin() {}
  
  SegmentationClusteringLocalThresholdsPlugin()
    : SegmentationClusteringPlugin(QString::fromUtf8("LocalThresholds"),
				   QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::SegmentationClustering> create()
  {
    girl::shared_ptr<ise::SegmentationClustering> result(new ise::SegmentationClusteringLocalThresholds(m_segContext));
    return result;
  }
  
  virtual bool inSubMenu(std::string &subMenu)
  {
    subMenu = "General";
    subMenu.append(1, SegmentationClusteringPlugin::SUBMENU_SEPARATOR);
    subMenu += "Thresholds";
    return true;
  }

  virtual girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface> createSettings()
  {
    return girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface>(new SegmentationClusteringLocalThresholdsWidgetSettings());
  }

protected:

  virtual SegmentationClusteringWidgetInterface* createWidget(MainView *mainView, QWidget *parent = NULL)
  {
    return new SegmentationClusteringLocalThresholdsWidget(mainView, this, parent);
  }

};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseSegmentationClusteringLocalThresholdsPlugin, SegmentationClusteringLocalThresholdsPlugin)
#endif

#endif /* ! SEGMENTATIONCLUSTERINGLOCALTHRESHOLDSPLUGIN_HPP */
