#ifndef SEGMENTATIONCLUSTERINGMARKOVPLUGIN_HPP
#define SEGMENTATIONCLUSTERINGMARKOVPLUGIN_HPP

#include <qiseTools/SegmentationClusteringPlugin.hpp>

#include <ise/iseSegmentationClusteringMarkov.hpp>

#include <qiseTools/SegmentationClusteringMarkovWidget.hpp>
#include <qiseTools/SegmentationClusteringMarkovWidgetSettings.hpp>

#include <QObject>

class SegmentationClusteringMarkovPlugin : public QObject,
					   public SegmentationClusteringPlugin
{

  Q_OBJECT
  Q_INTERFACES(SegmentationClusteringPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID SegmentationClusteringPlugin_iid)
#endif
    
public:
    
  ~SegmentationClusteringMarkovPlugin() {}
  
  SegmentationClusteringMarkovPlugin()
    : SegmentationClusteringPlugin(QString::fromUtf8("Markov Random Field"),
				   QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::SegmentationClustering> create()
  {
    girl::shared_ptr<ise::SegmentationClustering> result(new ise::SegmentationClusteringMarkov(m_segContext));
    return result;
  }
  
  virtual bool inSubMenu(std::string &subMenu)
  {
    subMenu = "General";
    return true;
  }

  virtual girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface> createSettings()
  {
    return girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface>(new SegmentationClusteringMarkovWidgetSettings());
  }

protected:

  virtual SegmentationClusteringWidgetInterface* createWidget(MainView *mainView, QWidget *parent = NULL)
  {
    return new SegmentationClusteringMarkovWidget(mainView, this, parent);
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseSegmentationClusteringMarkovPlugin, SegmentationClusteringMarkovPlugin)
#endif

#endif /* ! SEGMENTATIONCLUSTERINGMARKOVPLUGIN_HPP */
