/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGMaximalWhitespaceRectangleWIDGET_HPP
#define SEGMENTATIONCLUSTERINGMaximalWhitespaceRectangleWIDGET_HPP

#include <qiseTools/SegmentationClusteringWidgetInterface.hpp>



namespace ise {
  class SegmentationClusteringMaximalWhitespaceRectangle;
}

class SegmentationClusteringFactory;
class QCheckBox;
class QSpinBox;
class QDoubleSpinBox;

class GIRL_API SegmentationClusteringMaximalWhitespaceRectangleWidget : public SegmentationClusteringWidgetInterface
{

public:
  SegmentationClusteringMaximalWhitespaceRectangleWidget(MainView *mainView,
				   SegmentationClusteringPlugin *segmentationClustering,
				   QWidget *parent = NULL);

  void setParameters(size_t minArea, size_t maxNbWhiteSpace, size_t minWidthLow, size_t minWidthHigh, size_t minHeightLow, size_t minHeightHigh, double overlap, bool merge, bool useBBoxForDirect, bool useBBoxForInner);
  void getParameters(size_t &minArea, size_t &maxNbWhiteSpace, size_t &minWidthLow, size_t &minWidthHigh, size_t &minHeightLow, size_t &minHeightHigh, double &overlap, bool &merge, bool &useBBoxForDirect, bool &useBBoxForInner) const;

 protected:

  void buildGUI();
 
protected:

  QSpinBox *m_minArea;
  QSpinBox *m_maxNbWhiteSpace;
  QSpinBox *m_minWidthLow;
  QSpinBox *m_minWidthHigh;
  QSpinBox *m_minHeightLow;
  QSpinBox *m_minHeightHigh;
  QDoubleSpinBox *m_overlap;
  QCheckBox *m_mergeWhitespaceBox;
  QCheckBox *m_useBBoxForDirectNeighboursCB;
  QCheckBox *m_useBBoxForInnerNeighboursCB;
 
};
#endif /* ! SEGMENTATIONCLUSTERINGMaximalWhitespaceRectangleWIDGET_HPP */
