/*
  Copyright (C) 2005-2011 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGMIXEDTEXTIMAGEWIDGETSETTINGS_HPP
#define SEGMENTATIONCLUSTERINGMIXEDTEXTIMAGEWIDGETSETTINGS_HPP

#include <qiseTools/SegmentationClusteringWidgetSettingsInterface.hpp>
#include "SegmentationClusteringMixedTextImageWidget.hpp"
#include "iseSegmentationClusteringMixedTextImage.hpp"

class SegmentationClusteringMixedTextImageWidgetSettings : public SegmentationClusteringWidgetSettingsInterface {
  
public:
  
  SegmentationClusteringMixedTextImageWidgetSettings() 
    : SegmentationClusteringWidgetSettingsInterface()
    // , m_C_horizontal(20)
    // , m_C_s(20)
    // , m_C_vertical(20)
    , m_type("text")
    , m_levels()
    , m_colorSpace(0)
    , m_channel(0)
      //, m_auto(false)
  {
  }

  virtual void configureWidget(SegmentationClusteringWidgetInterface *widget) const
  {
    static_cast<SegmentationClusteringMixedTextImageWidget*>(widget)->setParameters(m_levels, m_colorSpace, m_channel,/*m_C_horizontal, m_C_s, m_C_vertical,*/ m_type/*, m_auto*/);
  }
  
  virtual void getWidgetConfig(const SegmentationClusteringWidgetInterface *widget)
  {
    static_cast<const SegmentationClusteringMixedTextImageWidget*>(widget)->getParameters(m_levels, m_colorSpace, m_channel,/*m_C_horizontal, m_C_s, m_C_vertical,*/ m_type/*, m_auto*/);
  }

  virtual void configureAlgo(girl::shared_ptr<ise::SegmentationClustering> algo) const
  {
    girl::shared_ptr<ise::SegmentationClusteringMixedTextImage> algorithm = girl::static_pointer_cast<ise::SegmentationClusteringMixedTextImage>(algo);
    algorithm->setParameters(m_levels, m_colorSpace, m_channel,/*m_C_horizontal, m_C_s, m_C_vertical,*/ m_type);
  }
  
  virtual girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface> clone() const
  {
    girl::shared_ptr<SegmentationClusteringMixedTextImageWidgetSettings> p(new SegmentationClusteringMixedTextImageWidgetSettings);

    *p = *this;

    return p;
  }

  virtual bool isValid() const
  {
    return true; //B: ???
  }

private:
  
  //int m_C_horizontal;
  //int m_C_s;
  //int m_C_vertical;
  std::string m_type;
  //bool m_auto;
  std::vector<int> m_levels;
  int m_colorSpace;
  int m_channel;
};

#endif /* ! SEGMENTATIONCLUSTERINGMIXEDTEXTIMAGEWIDGETSETTINGS_HPP */
