/*
  Copyright (C) 2005-2011 Roigt Julian, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISESEGMENTATIONCLUSTERINGMIXEDTEXTIMAGE_HPP
#define ISESEGMENTATIONCLUSTERINGMIXEDTEXTIMAGE_HPP

#include <girl/girlToger.hpp>
#include <ise/iseSegmentationClustering.hpp>
#include <ise/iseGenericImage.hpp>
#include <ise/iseBoxe.hpp>
#include <vector>
#include <opencv2/core/core.hpp>

namespace ise {

  class SegmentationContext;
  
  class  GIRL_API SegmentationClusteringMixedTextImage : public SegmentationClustering
  {
  public :

    explicit SegmentationClusteringMixedTextImage(SegmentationContext *segContext);
    
    virtual ~SegmentationClusteringMixedTextImage() {}

    virtual void setSegContext(ise::SegmentationContext *s);

    virtual void setParameters(const std::vector<int> &levels, int colorSpace, int channel, std::string type);

    virtual void getParameters(std::vector<int> &levels, int &colorSpace, int &channel, std::string &type) const;
    
    virtual void init(const girl::regionDeque &regions, int level=1);

    virtual void init(girl::region , int ) {} 
    
    virtual bool same(const girl::point &p, girl::direction dir);
    
  private:

      std::string m_type;
      cv::Mat m_labelImg;

      std::vector<int> m_labelClass;

      std::vector<int> m_levels;
      int m_colorSpace;
      int m_channel;
  };

}

#endif /* ! ISESEGMENTATIONCLUSTERINGMIXEDTEXTIMAGE_HPP */
