/*
  Segmentation clustering: Normalized Cut.
  Copyright (C) 2011 Cedric Aguerre  aguerre@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISESEGMENTATIONCLUSTERINGNORMALIZEDCUT_HPP
#define ISESEGMENTATIONCLUSTERINGNORMALIZEDCUT_HPP

#include <girl/girlToger.hpp>
#include <ise/iseSegmentationClustering.hpp>
#include <ise/iseVector.hpp>
#include <vector>

namespace ncut {

  class SegmentationContext;
  
  class GIRL_API SegmentationClusteringNormalizedCut : public ise::SegmentationClustering
  {
  public :

    explicit SegmentationClusteringNormalizedCut(ise::SegmentationContext *segContext);
    
    virtual ~SegmentationClusteringNormalizedCut() {}

    virtual void setSegContext(ise::SegmentationContext *s);

    virtual void setParameters(int nbClusters);

    virtual void getParameters(int &nbClusters) const;
    
    virtual void init(const girl::regionDeque &regions, int level=1);

    virtual void init(girl::region /*r*/, int /*level*/) {} /* VIDE.... peut être à Supprimer */
    
    virtual bool same(const girl::point &p, girl::direction dir);

  private :

    void compute();

  protected :

    std::vector<int> m_allPoints;
    int m_nbClusters;
    int m_nbRun;
  };

}

#endif /* ! ISESEGMENTATIONCLUSTERINGNORMALIZEDCUT_HPP */
