/*
  Copyright (C) 2011 Cedric Aguerre  aguerre@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include "SegmentationClusteringNormalizedCutWidget.hpp"
#include "SegmentationClusteringNormalizedCutWidgetSettings.hpp"

#include <qiseTools/SegmentationClusteringPlugin.hpp>

#include <QBoxLayout>
#include <QLabel>
#include <QSpinBox>

SegmentationClusteringNormalizedCutWidget::SegmentationClusteringNormalizedCutWidget(MainView *mainView,
										     SegmentationClusteringPlugin *segmentationClusteringPlugin,
										     QWidget *parent)
  :
  SegmentationClusteringWidgetInterface(mainView, segmentationClusteringPlugin, parent),
  m_nbClustersSB(NULL)
{

  setWindowTitle(tr("NormalizedCut parameters..."));

  setAttribute(Qt::WA_DeleteOnClose);

  buildGUI();

}

void
SegmentationClusteringNormalizedCutWidget::buildGUI()
{
  QLabel *nbClustersLabel = new QLabel(tr("Nb clusters:"), this);
  m_nbClustersSB = new QSpinBox(this);
  m_nbClustersSB->setRange(1, 1000);

  QHBoxLayout *hbox1 = new QHBoxLayout;
  hbox1->addWidget(nbClustersLabel);
  hbox1->addWidget(m_nbClustersSB);

  setLayout(hbox1);
}

void
SegmentationClusteringNormalizedCutWidget:: setParameters(int nbClusters)
{
  m_nbClustersSB->setValue(nbClusters); 
}

void
SegmentationClusteringNormalizedCutWidget::getParameters(int &nbClusters) const
{
  nbClusters = m_nbClustersSB->value();
}
