/*
  Copyright (C) 2011 Cedric Aguerre  aguerre@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGNORMALIZEDCUTWIDGET_HPP
#define SEGMENTATIONCLUSTERINGNORMALIZEDCUTWIDGET_HPP

#include <qiseTools/SegmentationClusteringWidgetInterface.hpp>
#include <ise/iseImageFeatureComputer.hpp>

namespace ncut {
  class SegmentationClusteringNormalizedCut;
}

class QSpinBox;
class SegmentationClusteringPlugin;

class GIRL_API SegmentationClusteringNormalizedCutWidget : public SegmentationClusteringWidgetInterface
{

public:
  SegmentationClusteringNormalizedCutWidget(MainView *mainView,
					    SegmentationClusteringPlugin *segmentationClustering,
					    QWidget *parent = NULL);

  void setParameters(int nbClusters);
  void getParameters(int &nbClusters) const;

protected:

  void buildGUI();
 
protected:
  
  QSpinBox *m_nbClustersSB;
  
};

#endif /* ! SEGMENTATIONCLUSTERINGNORMALIZEDCUTWIDGET_HPP */
