/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef SEGMENTATIONCLUSTERINGPROFILEWIDGET_HPP
#define SEGMENTATIONCLUSTERINGPROFILEWIDGET_HPP


#include <ise/iseImageFeatureComputer.hpp>

#include <qiseTools/SegmentationClusteringWidgetInterface.hpp>


class ImageFeatureChoiceWidget;
class QSpinBox;
class QDoubleSpinBox;
class SegmentationClusteringPlugin;



class GIRL_API SegmentationClusteringProfileWidget : public SegmentationClusteringWidgetInterface
{

 public:
  SegmentationClusteringProfileWidget(MainView *mainView,
				    SegmentationClusteringPlugin *segmentationClustering,
				    QWidget *parent = NULL);
  
  void setParameters(size_t erodeHoriz,
                     size_t dilateHoriz,
		     size_t erodeVerti,
		     size_t dilateVerti,
                     double threshold,
                     const ise::FeatureComputerPtr &algo);

  void getParameters(size_t &erodeHoriz,
                     size_t &dilateHoriz,
		     size_t &erodeVerti,
		     size_t &dilateVerti,
                     double &threshold,
                     ise::FeatureComputerPtr &algo) const;

 protected:

  void buildGUI();

 protected:
  
  ImageFeatureChoiceWidget *m_ifcw;

  QSpinBox *m_erodeHorizSB;
  QSpinBox *m_dilateHorizSB;
  QSpinBox *m_erodeVertiSB;
  QSpinBox *m_dilateVertiSB;

  QDoubleSpinBox *m_noiseThresholdSB;

};

#endif /* ! SEGMENTATIONCLUSTERINGPROFILEWIDGET_HPP */
