#ifndef SEGMENTATIONCLUSTERINGREGIONGROWINGPLUGIN_HPP
#define SEGMENTATIONCLUSTERINGREGIONGROWINGPLUGIN_HPP

#include <qiseTools/SegmentationClusteringPlugin.hpp>

#include <ise/iseSegmentationClusteringRegionGrowing.hpp>

#include <qiseTools/SegmentationClusteringRegionGrowingWidget.hpp>
#include <qiseTools/SegmentationClusteringRegionGrowingWidgetSettings.hpp>

#include <QObject>

class SegmentationClusteringRegionGrowingPlugin : public QObject,
				    public SegmentationClusteringPlugin
{

  Q_OBJECT
  Q_INTERFACES(SegmentationClusteringPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID SegmentationClusteringPlugin_iid)
#endif
    
public:
    
  ~SegmentationClusteringRegionGrowingPlugin() {}
  
  SegmentationClusteringRegionGrowingPlugin()
    : SegmentationClusteringPlugin(QString::fromUtf8("Region growing clustering"),
				   QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::SegmentationClustering> create()
  {
    girl::shared_ptr<ise::SegmentationClustering> result(new ise::SegmentationClusteringRegionGrowing(m_segContext));
    return result;
  }
  
  virtual bool inSubMenu(std::string &subMenu)
  {
    subMenu = "General";
    return true;
  }

  virtual girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface> createSettings()
  {
    return girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface>(new SegmentationClusteringRegionGrowingWidgetSettings());
  }

protected:

  virtual SegmentationClusteringWidgetInterface* createWidget(MainView *mainView, QWidget *parent = NULL)
  {
    return new SegmentationClusteringRegionGrowingWidget(mainView, this, parent);
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseSegmentationClusteringRegionGrowingPlugin, SegmentationClusteringRegionGrowingPlugin)
#endif

#endif /* ! SEGMENTATIONCLUSTERINGREGIONGROWINGPLUGIN_HPP */
