#ifndef SEGMENTATIONCLUSTERINGSPATIALMEANSHIFTPLUGIN_HPP
#define SEGMENTATIONCLUSTERINGSPATIALMEANSHIFTPLUGIN_HPP

#include <qiseTools/SegmentationClusteringPlugin.hpp>

#include <ise/iseSegmentationClusteringSpatialMeanShift.hpp>

#include <qiseTools/SegmentationClusteringSpatialMeanShiftWidget.hpp>
#include <qiseTools/SegmentationClusteringSpatialMeanShiftWidgetSettings.hpp>

#include <QObject>

class SegmentationClusteringSpatialMeanShiftPlugin : public QObject,
						     public SegmentationClusteringPlugin
{

  Q_OBJECT
  Q_INTERFACES(SegmentationClusteringPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID SegmentationClusteringPlugin_iid)
#endif
    
public:
    
  ~SegmentationClusteringSpatialMeanShiftPlugin() {}
  
  SegmentationClusteringSpatialMeanShiftPlugin()
    : SegmentationClusteringPlugin(QString::fromUtf8("SpatialMeanShift"),
				   QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::SegmentationClustering> create()
  {
    girl::shared_ptr<ise::SegmentationClustering> result(new ise::SegmentationClusteringSpatialMeanShift(m_segContext));

    return result;
  }
  
  virtual bool inSubMenu(std::string &subMenu)
  {
    subMenu = "General";
    subMenu.append(1, SegmentationClusteringPlugin::SUBMENU_SEPARATOR);
    subMenu += "MeanShift";
    return true;
  }

  virtual girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface> createSettings()
  {
    return girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface>(new SegmentationClusteringSpatialMeanShiftWidgetSettings());
  }

protected:

  virtual SegmentationClusteringWidgetInterface* createWidget(MainView *mainView, QWidget *parent = NULL)
  {
    return new SegmentationClusteringSpatialMeanShiftWidget(mainView, this, parent);
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseSegmentationClusteringSpatialMeanShiftPlugin, SegmentationClusteringSpatialMeanShiftPlugin)
#endif

#endif /* ! SEGMENTATIONCLUSTERINGSPATIALMEANSHIFTPLUGIN_HPP */
