/*
  Copyright (C) 2005-2011 Roigt Julian, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISESEGMENTATIONCLUSTERINGTEXTBLOCKSEGMENTATIONUSINGPYRAMIDSTRUCTURE_HPP
#define ISESEGMENTATIONCLUSTERINGTEXTBLOCKSEGMENTATIONUSINGPYRAMIDSTRUCTURE_HPP

#include <girl/girlToger.hpp>
#include <girlTools/girlToolsImage.hpp>
#include <ise/iseSegmentationClustering.hpp>
#include <opencv2/core/core.hpp>

namespace ise {

  class SegmentationContext;
  
  class  GIRL_API SegmentationClusteringTextBlockSegmentationUsingPyramidStructure : public SegmentationClustering
  {
  public :

    explicit SegmentationClusteringTextBlockSegmentationUsingPyramidStructure(SegmentationContext *segContext);
    
    virtual ~SegmentationClusteringTextBlockSegmentationUsingPyramidStructure() {}

    virtual void setSegContext(ise::SegmentationContext *s);

    virtual void setParameters();

    virtual void getParameters() const;
    
    virtual void init(const girl::regionDeque &regions, int level=1);

    virtual void init(girl::region /*r*/, int /*level*/) {} 
    
    virtual bool same(const girl::point &p, girl::direction dir);

  protected:

    void doSegmentationAndBlackRegion(girl::toger *tog, cv::Mat *image, girl::regionDeque &createdRegions);
    void doSegmentationInCC(girl::toger *tog, girl::tools::Image *image, girl::regionDeque &createdRegions);
    void blackRegions(const girl::tools::Image &img, const girl::toger *tog, const girl::regionDeque &regions, girl::regionDeque &kept);
    void largeRegions(const girl::tools::Image &img, const girl::toger *tog, const girl::regionDeque &regions, girl::regionDeque &kept);
    void smallRegions(const girl::tools::Image &img, const girl::toger *tog, const girl::regionDeque &regions, girl::regionDeque &kept);

  private:

    cv::Mat m_image;

  };

}

#endif /* ! ISESEGMENTATIONCLUSTERINGTEXTBLOCKSEGMENTATIONUSINGPYRAMIDSTRUCTURE_HPP */
