/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGTEXTIMAGEFUZZYCMEANWIDGET_HPP
#define SEGMENTATIONCLUSTERINGTEXTIMAGEFUZZYCMEANWIDGET_HPP

#include <qiseTools/SegmentationClusteringWidgetInterface.hpp>

class QSpinBox;
class QLabel;
class QComboBox;
class QDoubleSpinBox;

namespace ise {
  class SegmentationClusteringTextImageFuzzyCMean;
}

class SegmentationClusteringPlugin;

class GIRL_API SegmentationClusteringTextImageFuzzyCMeanWidget : public SegmentationClusteringWidgetInterface
{

public:
  SegmentationClusteringTextImageFuzzyCMeanWidget(MainView *mainView,
						  SegmentationClusteringPlugin *segmentationClustering,
						  QWidget *parent = NULL);

  void setParameters(int height, int width, std::string type, double tolerence);
  void getParameters(int &height, int &width, std::string &type, double &tolerence) const;

protected:

  void buildGUI();
 
protected:
 
  QComboBox *m_comboBox;
  QSpinBox *m_C_Height;
  QSpinBox *m_C_Width;
  QDoubleSpinBox *m_tolerence;
};
#endif /* ! SEGMENTATIONCLUSTERINGTEXTIMAGEFUZZYCMEANWIDGET_HPP */
