/*
  Copyright (C) 2005-2010 Vieux Remi, Roigt Julian, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#include "iseImageFeatureColorSpaceCompositeGrayScaleImage.hpp"

using namespace ise;

ImageFeatureColorSpaceCompositeGrayScaleImage::ImageFeatureColorSpaceCompositeGrayScaleImage(ise::SegmentationContext *segC)
  : ImageFeatureColorimetricComputer(segC)
{
}

void
ImageFeatureColorSpaceCompositeGrayScaleImage::compute()
{
  assert(m_segContext);
  assert(m_segContext->getImage());

  girl::tools::Image *img = m_segContext->getImage();

  const int width = img->width(); 
  const int height = img->height();

  //int dim = FEATURE_DIMENSION;
  
  ise::ImageFeatureColorSpace colorSpace(m_segContext);
  colorSpace.setParameters(ISE_RGB_to_YUV);
  colorSpace.compute();
  girl::shared_ptr<girl::tools::ImageFeature> imgF = colorSpace.getImageFeature();
  m_imgF = girl::shared_ptr<girl::tools::ImageFeature>(new girl::tools::ImageFeature(width, height, FEATURE_DIMENSION));

  for (int i = 0 ; i < height ; ++i) {
    girl::tools::Image::type *imgBuf = img->scanLine(i);
    girl::tools::ImageFeature::type *imgfBuf = imgF->scanLine(i);
    girl::tools::ImageFeature::type *imgfDest = m_imgF->scanLine(i);
    for (int j = 0 ; j < width ; ++j) {
      
      int g = -0.169 * imgBuf[0] + 0.5 * imgBuf[1] - 0.331 * imgBuf[2];
      if (g > 100 || imgfBuf[1] > 100 || imgfBuf[2] > 100)
	imgfDest[0] = 0;
      else
	imgfDest[0] = imgfBuf[0];
      
      imgBuf += img->formatSize();
      imgfBuf += imgF->formatSize();
      imgfDest += m_imgF->formatSize();
    }
  }

}
