/*
  Segmentation clustering: TextImageFuzzyCMean
  Copyright (C) 2005-2009 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef IMAGEFEATURECOLORSPACECOMPOSITEGRAYSCALEIMAGE_HPP
#define IMAGEFEATURECOLORSPACECOMPOSITEGRAYSCALEIMAGE_HPP

#include <ise/iseImageFeatureColorimetricComputer.hpp>
#include <ise/iseImageFeatureColorSpace.hpp>

namespace ise {
  class ImageFeatureColorSpaceCompositeGrayScaleImage : public ise::ImageFeatureColorimetricComputer
  {
  public:

    static const int FEATURE_DIMENSION = 1;

  public:
    
    explicit ImageFeatureColorSpaceCompositeGrayScaleImage(ise::SegmentationContext *segC);

    virtual ~ImageFeatureColorSpaceCompositeGrayScaleImage() {}

    virtual void compute();

    virtual const std::string uri() const { return ""; }

    virtual const std::string baseUri() const { return ""; }

    void getDimDescription(std::vector<std::string> &dimDesc) const { 
      dimDesc.push_back("");
    }

    size_t getFeatureDim() const { return FEATURE_DIMENSION; }

    void getRequiredComputers(FeatureComputerListType&) const {}

  private:
    ImageFeatureColorSpaceCompositeGrayScaleImage(const ImageFeatureColorSpaceCompositeGrayScaleImage&);
    ImageFeatureColorSpaceCompositeGrayScaleImage &operator=(const ImageFeatureColorSpaceCompositeGrayScaleImage&);

  };
}

#endif /* ! IMAGEFEATURECOLORSPACECOMPOSITEGRAYSCALEIMAGE_HPP */
