/*
  Copyright (C) 2005-2011 Roigt Julian, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#ifndef ISESEGMENTATIONCLUSTERINGTEXTIMAGEFUZZYCMEAN_HPP
#define ISESEGMENTATIONCLUSTERINGTEXTIMAGEFUZZYCMEAN_HPP

#include <girl/girlToger.hpp>
#include <ise/iseSegmentationClustering.hpp>
#include <ise/iseGenericImage.hpp>
#include <ise/iseClustererCMean.hpp>
#include <opencv2/core/core.hpp>

#include <ise/iseImageLabelToger.hpp>

namespace ise {

  class SegmentationContext;
  
  class  GIRL_API SegmentationClusteringTextImageFuzzyCMean : public SegmentationClustering
  {
  public :

    explicit SegmentationClusteringTextImageFuzzyCMean(SegmentationContext *segContext);
    
    virtual ~SegmentationClusteringTextImageFuzzyCMean();

    virtual void setSegContext(ise::SegmentationContext *s);

    virtual void setParameters(int C_Height, int C_Width, std::string type, double tolerence);

    virtual void getParameters(int &C_Height, int &C_Width, std::string &type, double &tolerence) const;
    
    virtual void init(const girl::regionDeque &regions, int level=1);

    virtual void init(girl::region , int ) {} 
    
    virtual bool same(const girl::point &p, girl::direction dir);

  private:
		
    ise::ClustererCMean m_cmean;
		   
    int m_C_Height;
    int m_C_Width;
    std::string m_type;
    double m_tolerence;

    int m_nbBlock;

    int m_statWidth;
    int m_statHeight;

    cv::Mat m_statImage;
    ImageLabelToger m_label;
    std::vector<std::string> m_sortCentroid; // m_sortCentroid[0]: image, m_sortCentroid[1]: text &,d m_sortCentroid[2]: background 
  };

}

#endif /* ! ISESEGMENTATIONCLUSTERINGTEXTIMAGEFUZZYCMEAN_HPP */
