/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGTEXTUREBASEDLINWIDGET_HPP
#define SEGMENTATIONCLUSTERINGTEXTUREBASEDLINWIDGET_HPP

#include <qiseTools/SegmentationClusteringWidgetInterface.hpp>

class QSpinBox;
class QLabel;
class QComboBox;

namespace ise {
  class SegmentationClusteringTextureBasedLin;
}

class SegmentationClusteringPlugin;

class GIRL_API SegmentationClusteringTextureBasedLinWidget : public SegmentationClusteringWidgetInterface
{

public:
  SegmentationClusteringTextureBasedLinWidget(MainView *mainView,
					      SegmentationClusteringPlugin *segmentationClustering,
					      QWidget *parent = NULL);

  void setParameters(int width, int height, const std::string &type);
  void getParameters(int &width, int &height, std::string &type) const;

protected:

  void buildGUI();
 
protected:
 
  QSpinBox *m_Block_height;
  QSpinBox *m_Block_width;
  QComboBox *m_type;
};
#endif /* ! SEGMENTATIONCLUSTERINGTEXTUREBASEDLINWIDGET_HPP */
