/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef SEGMENTATIONCLUSTERINGWHITESPACESEPARATORPLUGIN_HPP_
#define SEGMENTATIONCLUSTERINGWHITESPACESEPARATORPLUGIN_HPP_

#include <qiseTools/SegmentationClusteringPlugin.hpp>

#include <ise/iseSegmentationClusteringWhitespaceSeparator.hpp>

#include <QObject>

class SegmentationClusteringWhitespaceSeparatorPlugin : public QObject,
							       public SegmentationClusteringPlugin
{

  Q_OBJECT
  Q_INTERFACES(SegmentationClusteringPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
    Q_PLUGIN_METADATA(IID SegmentationClusteringPlugin_iid)
#endif

public:

  ~SegmentationClusteringWhitespaceSeparatorPlugin() {}

  SegmentationClusteringWhitespaceSeparatorPlugin()
    : SegmentationClusteringPlugin(QString::fromUtf8("Whitespace Separators"),
                                   QIseVersion(1, 0), QIseVersion(1, 0))
  {}


  virtual bool inSubMenu(std::string &subMenu)
  {
    subMenu = "Document";
    return true;
  }

  virtual girl::shared_ptr<ise::SegmentationClustering>
  create()
  {
    girl::shared_ptr<ise::SegmentationClustering> result(new ise::SegmentationClusteringWhitespaceSeparator(m_segContext));

    return result;
    
  }

  virtual girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface> createSettings()
  {
    return girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface>();
  }

  virtual bool hasSettings() const
  {
    return false;
  }  

protected:

  virtual SegmentationClusteringWidgetInterface* createWidget(MainView */*mainView*/, QWidget */*parent*/ = NULL)
  {
    //return new SegmentationClusteringMaximalWhitespaceRectangleWidget(mainView, this, parent);
    return NULL;
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseSegmentationClusteringWhitespaceSeparatorPlugin, SegmentationClusteringWhitespaceSeparatorPlugin)
#endif

#endif /* SEGMENTATIONCLUSTERINGWHITESPACESEPARATORPLUGIN_HPP_ */
