/*
  Copyright (C) 2005-2011 Julian Roigt, Remi Vieux, Boris Mansencal  remi.vieux@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include "SegmentationClusteringWordSettings.hpp"

#include <ise/iseSegmentationClusteringWord.hpp>

#include <qiseTools/SegmentationClusteringWidgetInterface.hpp>

#include "SegmentationClusteringWordWidget.hpp"



SegmentationClusteringWordSettings::SegmentationClusteringWordSettings()
: m_threshold(0),
  m_ccLabels(),
  m_neighbors()
{

}

SegmentationClusteringWordSettings::~SegmentationClusteringWordSettings()
{
}


void
SegmentationClusteringWordSettings::configureWidget(SegmentationClusteringWidgetInterface* widget) const
{
  SegmentationClusteringWordWidget *w= static_cast<SegmentationClusteringWordWidget*>(widget);
  assert(w);
  w->setParameters(m_threshold, m_ccLabels, m_neighbors);
}

void
SegmentationClusteringWordSettings::getWidgetConfig(const SegmentationClusteringWidgetInterface* widget)
{
  const SegmentationClusteringWordWidget *w= static_cast<const SegmentationClusteringWordWidget*>(widget);
  assert(w);
  w->getParameters(m_threshold, m_ccLabels, m_neighbors);
}

void
SegmentationClusteringWordSettings::configureAlgo(girl::shared_ptr<ise::SegmentationClustering> algo) const
{

  girl::shared_ptr<ise::SegmentationClusteringWord> a =
      girl::static_pointer_cast<ise::SegmentationClusteringWord>(algo);
  assert(a);

  a->setParameters(m_threshold, m_ccLabels, m_neighbors);

}

girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface>
SegmentationClusteringWordSettings::clone() const
{
  girl::shared_ptr<SegmentationClusteringWordSettings> p(new SegmentationClusteringWordSettings);

  *p = *this;

  return p;
}

bool
SegmentationClusteringWordSettings::isValid() const
{
  return true;//B: ???
}
