/*
  Copyright (C) 2005-2011 Julian Roigt, Remi Vieux, Boris Mansencal  remi.vieux@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef SEGMENTATIONCLUSTERINGWORDSETTINGS_HPP_
#define SEGMENTATIONCLUSTERINGWORDSETTINGS_HPP_

#include <ise/iseNeighbouringRegions.hpp>
#include <ise/iseForegroundBackgroundClassifier.hpp>
#include <ise/iseRunLengthExtractor.hpp>

#include <qiseTools/SegmentationClusteringPlugin.hpp>

class SegmentationClusteringWidgetInterface;

/*
 *
 */
class SegmentationClusteringWordSettings : public SegmentationClusteringWidgetSettingsInterface
{
public:
  SegmentationClusteringWordSettings();

  virtual ~SegmentationClusteringWordSettings();

  virtual void configureWidget(SegmentationClusteringWidgetInterface* widget) const;

  virtual void getWidgetConfig(const SegmentationClusteringWidgetInterface* widget);

  virtual void configureAlgo(girl::shared_ptr<ise::SegmentationClustering> algo) const;

  virtual girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface> clone() const;

  virtual bool isValid() const;
  
protected:

  int m_threshold;

  cv::Mat m_ccLabels;

  std::vector<ise::NeighbouringRegions> m_neighbors;




};

#endif /* SEGMENTATIONCLUSTERINGWORDSETTINGS_HPP_ */
