/*
  Copyright (C) 2005-2011 Remi Vieux, Boris Mansencal  remi.vieux@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef SEGMENTATIONCLUSTERINGWORDWIDGET_HPP_
#define SEGMENTATIONCLUSTERINGWORDWIDGET_HPP_

#include <girl/girlToger.hpp>

#include <ise/iseForegroundBackgroundClassifier.hpp>
#include <ise/iseRunLengthExtractor.hpp>

#include <qiseTools/SegmentationClusteringWidgetInterface.hpp>


namespace ise {
  class NeighbouringRegions;
  class QuantificationThresholder;
  class Histogram1D;
}

class Histogram1DThresholdsWidget;
class OrientationChoiceWidget;
class QComboBox;


/**
 *
 */
class SegmentationClusteringWordWidget : public SegmentationClusteringWidgetInterface
{

  Q_OBJECT

public:
  SegmentationClusteringWordWidget(MainView *mainView,
      SegmentationClusteringPlugin *factory,
      QWidget *parent = NULL);
  virtual
  ~SegmentationClusteringWordWidget();

  void
  buildGUI();

  void
  getParameters(int &thresold, cv::Mat &ccLabels, std::vector<ise::NeighbouringRegions> &neighbours) const;

  void
  setParameters(const int threhsold, const cv::Mat &ccLabels, const std::vector<ise::NeighbouringRegions> &neighbours);



  protected slots:

  void computeHistogram(int orientation);
  void computeThreshold(int thresholdIndex);
 // void computeSelectedRegions(int classifierIndex);


  protected:

  ise::ForegroundBackgroundClassifierFactory*
  getFactory(int index) const;

protected:

  Histogram1DThresholdsWidget *m_histoView;
  OrientationChoiceWidget *m_orientationChoiceWidget;

  QComboBox *m_thresholdersCombo;
 // QComboBox *m_classifiersCombo;

  ise::Histogram1D *m_histo;

//  girl::regionDeque m_selectedRegs;

  int m_threshold;
  std::vector<ise::NeighbouringRegions> m_spacings;
  cv::Mat m_ccLabels;


};

#endif /* SEGMENTATIONCLUSTERINGWORDWIDGET_HPP_ */
