/*
  Copyright (C) 2010-2011 Julian Roigt, Remi Vieux  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef SEGMENTATIONCLUSTERINGLOCALTHRESHOLDERBERNSENPLUGIN_HPP
#define SEGMENTATIONCLUSTERINGLOCALTHRESHOLDERBERNSENPLUGIN_HPP

#include <qiseTools/SegmentationClusteringLocalThresholderPlugin.hpp>

#include <ise/iseSegmentationClusteringLocalThresholder.hpp>

#include <qiseTools/SegmentationClusteringLocalThresholderBernsenWidget.hpp>
#include <qiseTools/SegmentationClusteringLocalThresholderBernsenWidgetSettings.hpp>

#include <ise/iseSegmentationContext.hpp>

#include <QObject>

class SegmentationClusteringLocalThresholderBernsenPlugin : public QObject,
							    public SegmentationClusteringLocalThresholderPlugin
{

  Q_OBJECT
  Q_INTERFACES(SegmentationClusteringLocalThresholderPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID SegmentationClusteringLocalThresholderPlugin_iid)
#endif
    
public:
    
  ~SegmentationClusteringLocalThresholderBernsenPlugin() {}
  
  SegmentationClusteringLocalThresholderBernsenPlugin()
    : SegmentationClusteringLocalThresholderPlugin(QString::fromUtf8("Bernsen"),
						   QIseVersion(1, 0), QIseVersion(1, 0))
  {}


  
  virtual girl::shared_ptr<ise::SegmentationClusteringLocalThresholder> create()
  {
    girl::shared_ptr<ise::SegmentationClusteringLocalThresholder> result(new ise::SegmentationClusteringLocalThresholderBernsen());
    return result;
  }
 
  virtual girl::shared_ptr<SegmentationClusteringLocalThresholderWidgetSettingsInterface> createSettings()
  {
    return girl::shared_ptr<SegmentationClusteringLocalThresholderWidgetSettingsInterface>(new SegmentationClusteringLocalThresholderBernsenWidgetSettings());
  }

protected:

  virtual SegmentationClusteringLocalThresholderWidget* createWidget(QWidget *parent = NULL)
  {
    return new SegmentationClusteringLocalThresholderBernsenWidget(this, parent);
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseSegmentationClusteringLocalThresholderBernsenPlugin, SegmentationClusteringLocalThresholderBernsenPlugin)
#endif

#endif /* ! SEGMENTATIONCLUSTERINGLOCALTHRESHOLDERBERNSENPLUGIN_HPP */
