/*
  Copyright (C) 2005-2011 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGLOCALTHRESHOLDERWHITEPLUGIN_HPP
#define SEGMENTATIONCLUSTERINGLOCALTHRESHOLDERWHITEPLUGIN_HPP

#include <qiseTools/SegmentationClusteringLocalThresholderPlugin.hpp>

#include <ise/iseSegmentationClusteringLocalThresholder.hpp>

#include <qiseTools/SegmentationClusteringLocalThresholderWhiteWidget.hpp>
#include <qiseTools/SegmentationClusteringLocalThresholderWhiteWidgetSettings.hpp>

#include <ise/iseSegmentationContext.hpp>

#include <QObject>

class SegmentationClusteringLocalThresholderWhitePlugin : public QObject,
							  public SegmentationClusteringLocalThresholderPlugin
{

  Q_OBJECT
  Q_INTERFACES(SegmentationClusteringLocalThresholderPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID SegmentationClusteringLocalThresholderPlugin_iid)
#endif
    
public:
    
  ~SegmentationClusteringLocalThresholderWhitePlugin() {}
  
  SegmentationClusteringLocalThresholderWhitePlugin()
    : SegmentationClusteringLocalThresholderPlugin(QString::fromUtf8("White"),
						   QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::SegmentationClusteringLocalThresholder> create()
  {
    girl::shared_ptr<ise::SegmentationClusteringLocalThresholder> result(new ise::SegmentationClusteringLocalThresholderWhite());
    return result;
  }

  virtual girl::shared_ptr<SegmentationClusteringLocalThresholderWidgetSettingsInterface> createSettings()
  {
    return girl::shared_ptr<SegmentationClusteringLocalThresholderWidgetSettingsInterface>(new SegmentationClusteringLocalThresholderWhiteWidgetSettings());
  }

protected:

  virtual SegmentationClusteringLocalThresholderWidget* createWidget(QWidget *parent = NULL)
  {
    return new SegmentationClusteringLocalThresholderWhiteWidget(this, parent);
  }
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseSegmentationClusteringLocalThresholderWhitePlugin, SegmentationClusteringLocalThresholderWhitePlugin)
#endif

#endif /* ! SEGMENTATIONCLUSTERINGLOCALTHRESHOLDERWHITEPLUGIN_HPP */
