#ifndef BFRECURSIVESPLITALGORITHMPLUGIN_HPP
#define BFRECURSIVESPLITALGORITHMPLUGIN_HPP

#include <qiseTools/SplitAlgorithmPlugin.hpp>

#include <ise/iseSplitAlgorithmBFRecursive.hpp>

#include <QObject>

class BFRecursiveSplitAlgorithmPlugin : public QObject,
					public SplitAlgorithmPlugin
{
  
  Q_OBJECT
  Q_INTERFACES(SplitAlgorithmPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
  Q_PLUGIN_METADATA(IID SplitAlgorithmPlugin_iid)
#endif
    
public:
    
  ~BFRecursiveSplitAlgorithmPlugin() {}
  
  BFRecursiveSplitAlgorithmPlugin()
    : SplitAlgorithmPlugin(QString::fromUtf8("BFRecursive split algorithm"),
			   QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::SplitAlgorithm>
  create(ise::SegmentationContext * /*segContext*/)
  {
     girl::shared_ptr<ise::SplitAlgorithm> result(new ise::SplitAlgorithmBFRecursive(m_segContext));
     return result;
  }

  virtual girl::shared_ptr<SplitAlgorithmSettings>
  createSettings(ise::SegmentationContext * /*segContext*/)
  {
    return girl::shared_ptr<SplitAlgorithmSettings>();//NULL
  }

  virtual bool hasSettings() const
  {
    return false;
  }

protected:
  
  virtual SplitAlgorithmWidgetInterface *
  createWidget(ise::SegmentationContext * /*segContext*/, QWidget * /*parent*/)
  {
    return NULL;
  }  
  
protected:
  
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseBFRecursiveSplitAlgorithmPlugin, BFRecursiveSplitAlgorithmPlugin)
#endif

#endif /* ! BFRECURSIVESPLITALGORITHMPLUGIN_HPP */
