#ifndef TEXTSPLITALGORITHMPLUGIN_HPP
#define TEXTSPLITALGORITHMPLUGIN_HPP

#include <qiseTools/SplitAlgorithmPlugin.hpp>

#include "iseSplitAlgorithmText.hpp"

#include <QObject>

class TextSplitAlgorithmPlugin : public QObject,
				 public SplitAlgorithmPlugin
{

  Q_OBJECT
  Q_INTERFACES(SplitAlgorithmPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
    Q_PLUGIN_METADATA(IID SplitAlgorithmPlugin_iid)
#endif
    
public:
    
  ~TextSplitAlgorithmPlugin() {}
  
  TextSplitAlgorithmPlugin()
    : SplitAlgorithmPlugin(QString::fromUtf8("Text split algorithm"),
			   QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::SplitAlgorithm>
  create(ise::SegmentationContext * /*segContext*/)
  {
     girl::shared_ptr<ise::SplitAlgorithm> result(new ise::SplitAlgorithmText(m_segContext));
     return result;
  }

  virtual girl::shared_ptr<SplitAlgorithmSettings>
  createSettings(ise::SegmentationContext* /*segContext*/)
  {
    return girl::shared_ptr<SplitAlgorithmSettings>();//NULL
  }

  virtual bool hasSettings() const
  {
    return false;
  }


protected:  
  
  virtual SplitAlgorithmWidgetInterface *
  createWidget(ise::SegmentationContext * /*segContext*/, QWidget * /*parent*/)
  {
    return NULL;
  }  

protected:
  
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseTextSplitAlgorithmPlugin, TextSplitAlgorithmPlugin)
#endif

#endif /* ! TEXTSPLITALGORITHMPLUGIN_HPP */
