/*
  text split algorithm.
  Copyright (C) 2005-2009 Jean-Philippe Domenger, Achille Braquelaire, Boris Mansencal  boris.mansencal@labri.fr
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#include "iseSplitAlgorithmText.hpp"

#include <ise/iseSplitDriver.hpp>
#include <ise/iseSegmentationClustering.hpp>
#include <ise/iseSegmentationContext.hpp>

using namespace ise;


SplitAlgorithmText::SplitAlgorithmText(ise::SegmentationContext *segContext)
  :
  SplitAlgorithm(segContext)
{

}


void 
SplitAlgorithmText::initHandleSplitOneRegion ( ise::SplitDriver &driver,
					       ise::SegmentationClustering &clust,
					       const girl::regionDeque &regions,
					       int level)
{
  driver.init(regions, level);
  clust.init(regions, level);
}

void 
SplitAlgorithmText::apply(const girl::regionDeque &regions2split, 
			     ise::SplitDriver &driver,
			     ise::SegmentationClustering &clust,
			     int level,
			     girl::regionDeque &createdRegions)
{

  initHandleSplitOneRegion(driver, clust, regions2split, level);

  //Do not do: [because Toger is juste referenced by SegContext and manage elsewhere]
  //girl::toger *tog = new girl::toger(m_segContext->getToger()->width(),   m_segContext->getToger()->height());
  //m_segContext->setToger(tog);
  //but:
  *m_segContext->getToger() = girl::toger(m_segContext->getToger()->width(),   m_segContext->getToger()->height());

  assert(m_segContext->getToger());

  splitOneRegion(1, clust, createdRegions);
}


void
SplitAlgorithmText::splitOneRegion(girl::region r, 
				   ise::SegmentationClustering &clust,
				   girl::regionDeque &createdRegions)
{
  m_segContext->getToger()->splitRegion(r, clust, createdRegions); 
  
}
