/*
  Copyright (C) 2010-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef RECURSIVESPLITDRIVERPLUGIN_HPP
#define RECURSIVESPLITDRIVERPLUGIN_HPP

#include <qiseTools/SplitDriverPlugin.hpp>

#include <ise/iseSplitDriverRecursiveDefault.hpp>

#include <qiseTools/SplitDriverRecursiveDefaultWidget.hpp>

#include <QObject>

class RecursiveSplitDriverPlugin : public QObject,
				   public SplitDriverPlugin
{

  Q_OBJECT
  Q_INTERFACES(SplitDriverPlugin QIsePlugin)
    
public:
    
  ~RecursiveSplitDriverPlugin() {}
  
  RecursiveSplitDriverPlugin()
    : SplitDriverPlugin(QString::fromUtf8("Recursive split driver"),
			QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::SplitDriver>
    create(ise::SegmentationContext *segContext)
  {
    
    const double THRESHOLD = 0.3;
    girl::shared_ptr<ise::SplitDriver> splitDriver(new ise::SplitDriverRecursiveDefault(m_segContext, THRESHOLD)); //!!!
    return splitDriver;
  }
  
  virtual girl::shared_ptr<SplitDriverSettings>
    createSettings(ise::SegmentationContext* segContext)
  {
    return girl::shared_ptr<SplitDriverSettings>();//NULL  //TODO !!! store threshold [then remove hasSettings() !]
  }

  virtual bool hasSettings() const
  {
    return false;
  }


protected:

  virtual SplitDriverWidgetInterface *
    createWidget(ise::SegmentationContext *segContext, QWidget *parent)
  {
    return new SplitDriverRecursiveDefaultWidget(this, parent);
  }
  
protected:

};

Q_EXPORT_PLUGIN2(QIseRecursiveSplitDriverPlugin, RecursiveSplitDriverPlugin)

#endif /* ! RECURSIVESPLITDRIVERPLUGIN_HPP */
