#ifndef SIMPLESPLITDRIVERPLUGIN_HPP
#define SIMPLESPLITDRIVERPLUGIN_HPP

#include <qiseTools/SplitDriverPlugin.hpp>

#include <ise/iseSplitDriverDefault.hpp>

#include <QObject>

class SimpleSplitDriverPlugin : public QObject,
				public SplitDriverPlugin
{

  Q_OBJECT
  Q_INTERFACES(SplitDriverPlugin QIsePlugin)
#if QT_VERSION >= 0x050000
    Q_PLUGIN_METADATA(IID SplitDriverPlugin_iid)
#endif
    
public:
    
  ~SimpleSplitDriverPlugin() {}
  
  SimpleSplitDriverPlugin()
    : SplitDriverPlugin(QString::fromUtf8("Simple split driver"),
			   QIseVersion(1, 0), QIseVersion(1, 0))
  {}
  
  virtual girl::shared_ptr<ise::SplitDriver>
  create(ise::SegmentationContext *segContext)
  {
    girl::shared_ptr<ise::SplitDriver> result(new ise::SplitDriverDefault(m_segContext));
    return result;
  }
  
  virtual girl::shared_ptr<SplitDriverSettings>
  createSettings(ise::SegmentationContext */*segContext*/)
  {
    return girl::shared_ptr<SplitDriverSettings>();//NULL
  }

  virtual bool hasSettings() const
  {
    return false;
  }


protected:

  virtual SplitDriverWidgetInterface *
  createWidget(ise::SegmentationContext */*segContext*/, QWidget */*parent*/)
  {
    return NULL;
  }

protected:
  
};

#if QT_VERSION < 0x050000
Q_EXPORT_PLUGIN2(QIseSimpleSplitDriverPlugin, SimpleSplitDriverPlugin)
#endif

#endif /* ! SIMPLESPLITDRIVERPLUGIN_HPP */
