/*
  Copyright (C) 2010-2011 Cedric Aguerre  aguerre@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef FOURIER_HPP
#define FOURIER_HPP

#include <string>

#ifdef NCUT_STANDALONE
#define GIRL_API
#else
#include <girl/girlCommon.hpp>
#endif

namespace ncut {

  class GIRL_API Fourier
  {
  public:
    virtual ~Fourier()
    {}

    virtual const std::string &getName() const = 0;

    virtual void forward(const double *in, double *reOut, double *imOut, unsigned int width, unsigned int height) const = 0;

    virtual void backward(const double *reIn, const double *imIn, double *out, unsigned int width, unsigned int height) const = 0;

    virtual void I2MP(const double *reIn, const double *imIn, double *magOut, double *phaseOut, unsigned int width, unsigned int height) const = 0;
 
    virtual void MP2I(const double *magIn, const double *phaseIn, double *reOut, double *imOut, unsigned int width, unsigned int height) const = 0;
 
    virtual void applyFilter(double *reTabImage, double *imTabImage, const double *reTabFiltre, const double *imTabFiltre, unsigned int width, unsigned int height) const = 0;
  };

}

#endif /*FOURIER_HPP*/
