/*
  Copyright (C) 2010-2011 Cedric Aguerre  aguerre@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#include <NCutKernel.hpp>

#if defined _WIN32 || defined __CYGWIN__
#define PATH_SEPARATOR "\\"
#else
#define PATH_SEPARATOR "/"
#endif

void
ncut::NCutKernel::loadPlugin(const std::string &path, const std::string &pluginName)
{
  if(m_loadedPlugins.find(pluginName) == m_loadedPlugins.end()) {
    std::string fullName = path + PATH_SEPARATOR + "lib" + pluginName;
#if defined _WIN32 || defined __CYGWIN__
    fullName += ".dll";
#else
#if defined __APPLE__
    fullName += ".dylib";
#else
    fullName += ".so";
#endif
#endif
    m_loadedPlugins.insert(PluginMap::value_type(pluginName, NCutPlugin(fullName))).first->second.registerPlugin(*this);
  }
}
