/*
  Copyright (C) 2010-2011 Cedric Aguerre  aguerre@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef PIXELSIMILARITY_HPP
#define PIXELSIMILARITY_HPP

#include <SparseMatrix.hpp>
#include <NCutImage.hpp>
#include <Fourier.hpp>
#include <string>
#include <memory>
#include <tr1/memory>

#ifdef NCUT_STANDALONE
#define GIRL_API
#else
#include <girl/girlCommon.hpp>
#endif

namespace ncut {

  class GIRL_API PixelSimilarity
  {
  public:
    virtual ~PixelSimilarity()
    {}

    virtual const std::string &getName() const = 0;

    virtual std::tr1::shared_ptr<ncut::SparseMatrix> computeSimilarityMatrix(const ncut::NCutImage &img, const ncut::Fourier &fourier) = 0;
  };

}

#endif /*PIXELSIMILARITY_HPP*/
