/*
  Copyright (C) 2010-2011 Cedric Aguerre  aguerre@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef PLUGINDEFS_HPP
#define PLUGINDEFS_HPP
// From: http://gcc.gnu.org/wiki/Visibility

// Generic helper definitions for shared library support
#if defined _WIN32 || defined __CYGWIN__
  #define NCUT_PLUGIN_HELPER_DLL_IMPORT __declspec(dllimport)
  #define NCUT_PLUGIN_HELPER_DLL_EXPORT __declspec(dllexport)
  #define NCUT_PLUGIN_HELPER_DLL_LOCAL
#else
  #if __GNUC__ >= 4
    #define NCUT_PLUGIN_HELPER_DLL_IMPORT __attribute__ ((visibility("default")))
    #define NCUT_PLUGIN_HELPER_DLL_EXPORT __attribute__ ((visibility("default")))
    #define NCUT_PLUGIN_HELPER_DLL_LOCAL  __attribute__ ((visibility("hidden")))
  #else
    #define NCUT_PLUGIN_HELPER_DLL_IMPORT
    #define NCUT_PLUGIN_HELPER_DLL_EXPORT
    #define NCUT_PLUGIN_HELPER_DLL_LOCAL
  #endif
#endif

// Now we use the generic helper definitions above to define NCUT_PLUGIN_API and NCUT_PLUGIN_LOCAL.
// NCUT_PLUGIN_API is used for the public API symbols. It either DLL imports or DLL exports (or does nothing for static build)
// NCUT_PLUGIN_LOCAL is used for non-api symbols.

#ifdef NCUT_PLUGIN_DLL_EXPORTS // defined if we are building the NCUT_PLUGIN DLL (instead of using it)
#define NCUT_PLUGIN_API NCUT_PLUGIN_HELPER_DLL_EXPORT
#else
#define NCUT_PLUGIN_API NCUT_PLUGIN_HELPER_DLL_IMPORT
#endif // NCUT_PLUGIN_DLL_EXPORTS
#define NCUT_PLUGIN_LOCAL NCUT_PLUGIN_HELPER_DLL_LOCAL


#endif /*PLUGINDEFS_HPP*/
