/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
 * main.cpp
 *
 *  Created on: Feb 14, 2011
 *      Author: vieux
 */


#include <cstdlib>
#include <iostream>

#include <girl/girlToger.hpp>

#include <girlTools/girlToolsDiskBackup.hpp>
#include <girlTools/girlToolsImage.hpp>

#include <ise/iseSegmentationContext.hpp>
#include <ise/iseSplitDriverDefault.hpp>

#include "../../SplitAlgorithm/TextSplitAlgorithm/src/iseSplitAlgorithmText.hpp"
#include "../../SegmentationClustering/segmentationClusteringMaximalWhitespaceRectangle/src/iseSegmentationClusteringMaximalWhitespaceRectangle.hpp"


int
main(int /*argc*/, char * /*argv*/[])
{

  std::cout << std::numeric_limits<girl::POINT_TYPE>::max() << std::endl;
std::cout << std::numeric_limits<girl::POINT_TYPE>::min() << std::endl;

  girl::tools::Image img("bonjourflip.ppm");

  girl::toger tog;
  girl::tools::iDiskBackup backup("bonjourflip2.seg");
  tog.read(backup);


  ise::SegmentationContext segContext(&tog, &img);

  ise::SplitAlgorithmText textSplit(&segContext);
  ise::SplitDriverDefault driver(&segContext);

  ise::SegmentationClusteringMaximalWhitespaceRectangle rect(&segContext);
  rect.setParameters(50, 90, 0.95, false);


  girl::regionDeque createdRegions;
  girl::regionDeque toSplit(1,3);
  textSplit.apply(toSplit, driver, rect, 1, createdRegions);

  return EXIT_SUCCESS;




}
