dnl ------------------------------------------------------------------------
dnl Try to find the Open GL headers and libraries.
dnl $(GL_INCLUDES) will be -Iglheaderlocation (if needed)
dnl $(GL_LDFLAGS) will be -Lglliblocation (if needed)
#   LIB_GL will be -lGL ...
dnl ------------------------------------------------------------------------
dnl
AC_DEFUN([AC_PATH_GL],
[
AC_REQUIRE([AC_PATH_X])
AC_MSG_CHECKING([for Open Gl])

ac_gl_includes="" ac_gl_libraries=""

AC_ARG_WITH(gl-includes,
    [  --with-gl-includes=DIR   where the OpenGL includes are. ],
    [  ac_gl_includes="$withval"
    ])

AC_ARG_WITH(gl-libraries,
    [  --with-gl-libraries=DIR where the OpenGL libraries are. ],
    [  ac_gl_libraries="$withval"
    ])

AC_CACHE_VAL(ac_cv_have_gl,
[
if test ${VAR_WIN32} = 1
then
gl_incdirs=" /mingw/include $ac_gl_includes $GLDIR/include /usr/include /usr/X11R6/include/X11 /usr/X11R6/include $x_includes "
else
gl_incdirs=" $ac_gl_includes $GLDIR/include /usr/include /usr/X11R6/include/X11 /usr/X11R6/include $x_includes "
fi
AC_FIND_FILE(GL/gl.h, $gl_incdirs, gl_incdir)
ac_gl_includes="$gl_incdir"

if test ${VAR_WIN32} = 1
then
gl_libdirs="$GLDIR $ac_gl_libraries $GLLIB /usr/X11R6/lib /usr/lib /usr/local/lib $x_libraries "
else
gl_libdirs="$ac_gl_libraries $GLLIB /usr/X11R6/lib /usr/lib /usr/local/lib $x_libraries "
fi

test -n "$GLDIR" && gl_libdirs="$GLDIR/lib $GLDIR $gl_libdirs"
test=NONE
gl_libdir=NONE
for dir in $gl_libdirs; do
if test ${VAR_WIN32} = 1
then
  try="ls -1 $dir/*opengl*"
else
  try="ls -1 $dir/libGL*"
fi
  if test=`eval $try 2> /dev/null`; then gl_libdir=$dir; break; else echo "tried $dir" >&AC_FD_CC ; fi
done
ac_gl_libraries="$gl_libdir"
])

eval "$ac_cv_have_gl"
if test "$ac_gl_libraries" = NONE; then
  AC_MSG_ERROR([ Not found , put your GLDIR environnement variable to the OpenGL directory ]);
else
  ac_cv_have_gl="have_gl=yes \
  ac_gl_includes=$ac_gl_includes ac_gl_libraries=$ac_gl_libraries"
  AC_MSG_RESULT([ libraries $ac_gl_libraries, headers $ac_gl_includes ])  
  gl_libraries="$ac_gl_libraries"
  gl_includes="$ac_gl_includes"
if test ${VAR_MACOSX} = 1
then
  GL_INCLUDES="-I$ac_gl_includes"
  GL_LDFLAGS=""
else
  GL_INCLUDES="-I$ac_gl_includes"	
  GL_LDFLAGS="-L$ac_gl_libraries"
fi
fi

dnl MAC PORT
if test ${VAR_MACOSX} = 1
then
  GL_INCLUDES="$GL_INCLUDES -I/usr/include/malloc"
fi
AC_SUBST(gl_libraries)
AC_SUBST(gl_includes)
AC_SUBST(GL_INCLUDES)
AC_SUBST(GL_LDFLAGS)

if test ${VAR_WIN32} = 1
then
  LIB_GL="-lglu32 -lopengl32"
else
  if test ${VAR_MACOSX} = 1
  then
    LIB_GL="-framework OpenGL"
  else
    LIB_GL="-lGLU -lGL"
  fi
fi
AC_SUBST(LIB_GL)
])
