
TEMPLATE = app
TARGET = 

QMAKE_CXXFLAGS_RELEASE = -g -Wall -Wextra
CONFIG += link_pkgconfig warn_on debug 
#CONFIG += link_pkgconfig warn_on release 
#release {
#  DEFINES += NDEBUG NDEBUG1
#}

DEFINES += WITHOUT_GLEW
#DEFINES += TIMING_PAINTER
#DEFINES += STATS_PAINTER
#DEFINES += GL_VERBOSE
#DEFINES += VERBOSE
#DEFINES += ORIGIN_CENTER_IMAGE
#DEFINES += VERBOSE_INSERT
#DEFINES += VERBOSE_QUANTIFLEVELS
#DEFINES += TIMING
#DEFINES += DEBUG_RESIZE
#DEFINES += DEBUG_GLIMAGE

DEFINES+=QT_NO_CAST_FROM_ASCII

PKGCONFIG += ise-0.2 
PKGCONFIG += qiseTools-1.0 

QT+=opengl


DEPENDPATH += . src
INCLUDEPATH += . src

!contains(DEFINES, WITHOUT_GLEW) {
  GLEW_INCLUDEPATH=
  GLEW_LIBS=-lGLEW
  macx-g++ {
    GLEW_INCLUDEPATH+=/sw/include
    GLEW_LIBS=-L/sw/lib -lGLEW
  }
  INCLUDEPATH += $$GLEW_INCLUDEPATH
  LIBS += $$GLEW_LIBS
}


# Input
HEADERS += \
           src/ClearAllMarkCommand.hpp \
           src/ClearSelectionCommand.hpp \
           src/CSVImageConceptReader.hpp \
           src/CSVImageConceptWriter.hpp \
           src/DragInteractor.hpp \
           src/DropInteractor.hpp \
           src/GLInteractiveRegularShape.hpp \
           src/HistogramIntervalsColorSpacesDialog.hpp \
           src/HistogramIntervalsColorSpacesInteractor.hpp \
           src/HistogramIntervalsColorSpacesSelector.hpp \
           src/HistogramIntervalsCommander.hpp \
           src/HistogramIntervalsCSProcessor.hpp \
           src/HistogramIntervalsCSSimpleProcessor.hpp \
           src/HistogramIntervalsDialog.hpp \
           src/HistogramIntervalsDrawer.hpp \
           src/HistogramIntervalsInteractor.hpp \
           src/HistogramIntervalsLuminanceVarianceSelector.hpp \
           src/HistogramIntervalsMeanLuminanceSelector.hpp \
           src/HistogramIntervalsProcessingInteractor.hpp \
           src/HistogramIntervalsProcessor.hpp \
           src/HistogramIntervalsProcessorLuminanceVariance.hpp \
           src/HistogramIntervalsProcessorMeanLuminance.hpp \
           src/HistogramIntervalsProcessorRegionArea.hpp \
           src/HistogramIntervalsProcessorRGBVariance.hpp \
           src/HistogramIntervalsProcessorT.hpp \
           src/HistogramIntervalsRegionAreaSelector.hpp \
           src/HistogramIntervalsRGBVarianceSelector.hpp \
           src/HistogramIntervalsSelectionCommander.hpp \
           src/HistogramIntervalsSelectionDrawer.hpp \
           src/HistogramIntervalsSimpleDialog.hpp \
           src/HistogramIntervalsWidget.hpp \
           src/ImageFeaturesChoiceDialog.hpp \
           src/HistogramIntervalsColorSpacesSelector.hpp \
           src/ImageAnnotatorDialog.hpp \
           src/ImageConcept.hpp \
           src/ImageConceptEditorDialog.hpp \
           src/ImagePyramidBuildDialog.hpp \
           src/InfoDialog.hpp \
           src/InfoInteractor.hpp \
           src/InteractiveRegularShapeDrawingStatus.hpp \
           src/InteractiveRegularShapeSelectedStatus.hpp \
           src/InteractiveRegularShapeUnSelectedStatus.hpp \
           src/InteractiveShapeMovePointStatus.hpp \
           src/InteractiveShapeMoveStatus.hpp \
           src/InteractiveShapeResizeCornerStatus.hpp \
           src/InteractiveShapeResizeHeightStatus.hpp \
           src/InteractiveShapeResizeWidthStatus.hpp \
           src/InteractiveShapeRotateStatus.hpp \
           src/InteractiveShapeTransformStatus.hpp \
           src/Interactor.hpp \
           src/IntervalsTypes.hpp \
           src/InvertSelectionCommand.hpp \
           src/MainWindow.hpp \
           src/MarkInteractorDialog.hpp \
           src/MarkInteractor.hpp \
           src/MergeAllCommand.hpp \
           src/MergeCommand.hpp \
           src/MergeDriverParametersDialog.hpp \
           src/PaintingComplexShape.hpp \
           src/PaintingEllipse.hpp \
           src/PaintingPolygon.hpp \
           src/PaintingRectangle.hpp \
           src/PaintingRegularShape.hpp \
           src/PathsInsertionCommand.hpp \
           src/RegionSelectAllCommand.hpp \
           src/RegionSelectionCommand.hpp \
           src/RegionSelectionInteractor.hpp \
           src/RemoveSelectionCommand.hpp \
           src/SegDocument.hpp \
#           src/SegmentationClusteringParametersDialog.hpp \
           src/SegmentationClusteringWatershedInterPixelDialog.hpp \
           src/SegmentInsertionDialog.hpp \
           src/SegModelQIO.hpp \
           src/SelectionSettingsDockWidget.hpp \
           src/SelectionSettingsWidget.hpp \
           src/ShapePaintingInteractor.hpp \
           src/SplitCommand.hpp \
           src/SplitDriverParametersDialog.hpp \
           src/SplitMergeCommand.hpp \
           src/TogerQIO.hpp \
           src/UndoCommand.hpp \
           src/ViewMover2.hpp \
           src/ViewMover.hpp \
           src/XMarkRegionCommand.hpp \
           src/ZoomTogerCommand.hpp


SOURCES += \
           src/ClearAllMarkCommand.cpp \
           src/ClearSelectionCommand.cpp \
           src/CSVImageConceptReader.cpp \
           src/CSVImageConceptWriter.cpp \
           src/DragInteractor.cpp \
           src/DropInteractor.cpp \
           src/GLInteractiveRegularShape.cpp \
           src/HistogramIntervalsColorSpacesDialog.cpp \
           src/HistogramIntervalsColorSpacesInteractor.cpp \
           src/HistogramIntervalsColorSpacesSelector.cpp \
           src/HistogramIntervalsCSSimpleProcessor.cpp \
           src/HistogramIntervalsLuminanceVarianceSelector.cpp \
           src/HistogramIntervalsMeanLuminanceSelector.cpp \
           src/HistogramIntervalsProcessingInteractor.cpp \
           src/HistogramIntervalsProcessorLuminanceVariance.cpp \
           src/HistogramIntervalsProcessorMeanLuminance.cpp \
           src/HistogramIntervalsProcessorRegionArea.cpp \
           src/HistogramIntervalsProcessorRGBVariance.cpp \
           src/HistogramIntervalsRegionAreaSelector.cpp \
           src/HistogramIntervalsRGBVarianceSelector.cpp \
           src/HistogramIntervalsSelectionCommander.cpp \
           src/HistogramIntervalsSelectionDrawer.cpp \
           src/HistogramIntervalsSimpleDialog.cpp \
           src/HistogramIntervalsWidget.cpp \
           src/ImageFeaturesChoiceDialog.cpp \
           src/ImageAnnotatorDialog.cpp \
           src/ImageConcept.cpp \
           src/ImageConceptEditorDialog.cpp \
           src/ImagePyramidBuildDialog.cpp \
           src/InfoDialog.cpp \
           src/InfoInteractor.cpp \
           src/InteractiveRegularShapeDrawingStatus.cpp \
           src/InteractiveRegularShapeSelectedStatus.cpp \
           src/InteractiveShapeMovePointStatus.cpp \
           src/InteractiveShapeMoveStatus.cpp \
           src/InteractiveShapeResizeCornerStatus.cpp \
           src/InteractiveShapeResizeHeightStatus.cpp \
           src/InteractiveShapeResizeWidthStatus.cpp \
           src/InteractiveShapeRotateStatus.cpp \
           src/InvertSelectionCommand.cpp \
           src/main.cpp \
           src/MainWindow.cpp \
           src/MarkInteractor.cpp \
           src/MarkInteractorDialog.cpp \
           src/MergeAllCommand.cpp \
           src/MergeCommand.cpp \
           src/MergeDriverParametersDialog.cpp \
           src/PaintingEllipse.cpp \
           src/PaintingRectangle.cpp \
           src/PaintingRegularShape.cpp \
           src/PathsInsertionCommand.cpp \
           src/RegionSelectAllCommand.cpp \
           src/RegionSelectionCommand.cpp \
           src/RegionSelectionInteractor.cpp \
           src/RemoveSelectionCommand.cpp \
           src/SegDocument.cpp \
#           src/SegmentationClusteringParametersDialog.cpp \
           src/SegmentationClusteringWatershedInterPixelDialog.cpp \
           src/SegmentInsertionDialog.cpp \
           src/SegModelQIO.cpp \
           src/SelectionSettingsDockWidget.cpp \
           src/SelectionSettingsWidget.cpp \
           src/ShapePaintingInteractor.cpp \
           src/SplitCommand.cpp \
           src/SplitDriverParametersDialog.cpp \
           src/SplitMergeCommand.cpp \
           src/TogerQIO.cpp \
           src/ViewMover2.cpp \
           src/ViewMover.cpp \
           src/XMarkRegionCommand.cpp \
           src/ZoomTogerCommand.cpp

RESOURCES += qise.qrc

TRANSLATIONS = qise_fr.ts

