/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef DRAGINTERACTOR_HPP
#define DRAGINTERACTOR_HPP

#include <QPoint>
#include <QTime>

#include <qiseTools/Interactor.hpp>


class QByteArray;
class MainView;


class DragInteractor : public Interactor
{
public:

  explicit DragInteractor(MainView *v)
    : m_view(v) 
    , m_startDragPosition()
    , m_startDragTime()
    , m_dragStarted(false)
  {}

  virtual bool eventFilter(QObject *target, QEvent *event);

protected:
  
  bool saveSelection(QByteArray &output);


protected:
  MainView *m_view;
  QPoint m_startDragPosition;
  QTime m_startDragTime;
  bool m_dragStarted : 1;

};



#endif /* ! DRAGINTERACTOR_HPP */
