/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef DROPINTERACTOR_HPP
#define DROPINTERACTOR_HPP

#include <girl/girlToger.hpp>

#include <girlTools/girlToolsAABBox.hpp>
#include <qiseTools/Interactor.hpp>

class MainView;
class MainWindow;
class SegmentInsertionDialog;
class GLMovableSegmentLayer;
class GLLayerMover;
class QDropEvent;

class DropInteractor : public Interactor
{
  Q_OBJECT

public:

  /**
   * @brief Constructor.
   */
  DropInteractor(MainView *v, MainWindow *mw);


  virtual bool eventFilter(QObject *target, QEvent *event);

  bool handleDropEvent(QDropEvent *e);

protected slots:

  void acceptInsertion();
  void cancelInsertion();

protected:
  
  void delMovableLayer();
  
  bool handleDropEventUrls(QDropEvent *e);



protected:
  MainView *m_view;
  MainWindow *m_mainWindow;

  SegmentInsertionDialog *m_insertionDialog;
  GLMovableSegmentLayer *m_movableLayer;
  GLLayerMover *m_layerMover;

  std::vector< std::vector<girl::point> > m_segments;
  girl::tools::AABBox m_segmentsBBox;
};



#endif /* ! DROPINTERACTOR_HPP */
