/*
  Copyright (C) 2005-2009 Jerome Charton, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef GLINTERACTIVEREGULARSHAPE_HPP
#define GLINTERACTIVEREGULARSHAPE_HPP

#include <qiseTools/GLInteractiveShape.hpp>

#include "PaintingRegularShape.hpp"

class GLInteractiveRegularShape : public GLInteractiveShape
{

public:

  /**
   * @brief Constructor.
   *
   * @warning Takes ownership of @a shape.
   */
  GLInteractiveRegularShape(GLView *view, PaintingRegularShape *shape);
  
  /**
   * @brief Destructor.
   */
  ~GLInteractiveRegularShape();
  
  
  virtual inline GLInteractiveShape *clone() 
  {
    return new GLInteractiveRegularShape(m_view, static_cast<PaintingRegularShape *>(m_shape->clone()));
  }

};

#endif /* ! GLINTERACTIVEREGULARSHAPE_HPP */
