/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef HISTOGRAMINTERVALSCSPROCESSOR_HPP
#define HISTOGRAMINTERVALSCSPROCESSOR_HPP

#include <ise/iseConversion.hpp>

#include "HistogramIntervalsProcessorT.hpp"

class HistogramIntervalsCSProcessor : public HistogramIntervalsProcessorT<double>
{
public:
  
  typedef double ValueType;

  /**
   * @brief Destructor.
   */
  virtual ~HistogramIntervalsCSProcessor() {}

  /**
   * @brief Constructor.
   */
  HistogramIntervalsCSProcessor(MainWindow *mw, MainView *v)
    : HistogramIntervalsProcessorT<double>(mw, v),
      m_conversion(0),
      m_channel(0)
  {}


  virtual HistogramIntervalsCSProcessor *clone() const = 0;

  virtual void setCSConversion(int colorSpace, int channel)
  {
    m_conversion = colorSpace;
    m_channel = channel;
  }

protected:

  //virtual ValueType computeValue(const SegModel *m, girl::region r);

  virtual int getInt(ValueType t)
  {
    if (t>0)
      return static_cast<int>(t+0.5);
    else
      return static_cast<int>(t-0.5);
  }


protected:

  int m_conversion;
  int m_channel;
};


#endif /* ! HISTOGRAMINTERVALSCSPROCESSOR_HPP */
