/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef HISTOGRAMINTERVALSCOLORSPACESINTERACTOR_HPP
#define HISTOGRAMINTERVALSCOLORSPACESINTERACTOR_HPP


#include "HistogramIntervalsProcessingInteractor.hpp"

class HistogramIntervalsCSProcessor;

class HistogramIntervalsColorSpacesInteractor : public HistogramIntervalsProcessingInteractor
{
  Q_OBJECT  

public:

  /**
   * @brief Destructor.
   */
  virtual ~HistogramIntervalsColorSpacesInteractor();

  /**
   * @brief Constructor.
   */
  HistogramIntervalsColorSpacesInteractor(MainWindow *mw, MainView *v);

  //virtual void activate();

  //virtual void deactivate();
  
  /**
   * @warning p must be a HistogramIntervalsCSProcessor !
   * @warning takes ownership of @a p.
   */
  virtual void setProcessor(HistogramIntervalsProcessor *p);

protected:

  virtual HistogramIntervalsDialog *buildDialog(QWidget *parent);

  
protected slots:

  //virtual void updateImage(SegModel *);
  //virtual void updateToger(SegModel *);
  //virtual void updateSelection(SegModel *);

  //virtual void accept();
  //virtual void reject();


  //void changeTarget(intervals::Target t);

  //void changeIntervals();

protected:


  virtual void getKeptRegions(girl::regionDeque &regions);
  
  virtual void updateTarget(intervals::Target t);
  
  virtual void updateTarget(const SegModel *m, 
			    const girl::regionDeque &regions);
  
  //virtual void updateDraw();

  void deleteProcessors();

  void resetProcessors();

  void resetHistograms();

protected:

  std::vector<HistogramIntervalsCSProcessor *> m_processors;

};


#endif /* ! HISTOGRAMINTERVALSCOLORSPACESINTERACTOR_HPP */
