/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef HISTOGRAMINTERVALSDIALOG_HPP
#define HISTOGRAMINTERVALSDIALOG_HPP

#include <QDialog>

#include "IntervalsTypes.hpp"

namespace ise {
  class GrayScaleHistogram;
}


class HistogramIntervalsDialog : public QDialog
{
  Q_OBJECT

public:

  virtual ~HistogramIntervalsDialog() {}

  HistogramIntervalsDialog(QWidget *parent)
    : QDialog(parent)
  {}


  virtual void setHistogram(const ise::GrayScaleHistogram &h) = 0;

  virtual intervals::Target getTarget() const = 0;

  virtual void setTarget(intervals::Target t) = 0;

  /**
   * Return kept intervals in sorted increasing order.
   *
   * We have intervals[i].first<=intervals[i].second<intervals[i+1].first
   */
  virtual void getIntervals(intervals::IntervalCollection &intervals, 
			    intervals::ColorCollection &colors) const = 0;

  virtual void setIntervals(const intervals::IntervalCollection &intervals,
			    const intervals::ColorCollection &colors) = 0;
  

signals:
   
  void targetChanged(intervals::Target);

  void intervalsChanged();

  //void accepted();
  //void rejected();



};

#endif /* ! HISTOGRAMINTERVALSDIALOG_HPP */ 
