/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef HISTOGRAMINTERVALSINTERACTOR_HPP
#define HISTOGRAMINTERVALSINTERACTOR_HPP

#include <QObject>

class MainWindow;
class MainView;
class SegModel;

class HistogramIntervalsInteractor : public QObject
{
  Q_OBJECT

public:
  
  /**
   * @brief Destructor.
   */
  virtual ~HistogramIntervalsInteractor() {}

  /**
   * @brief Constructor.
   */
  HistogramIntervalsInteractor(MainWindow *mw, MainView *v)
    : QObject(),
      m_mainWindow(mw),
      m_view(v)
  {}

  virtual void activate() = 0;

  virtual void deactivate() = 0;

  
protected slots:

  virtual void updateImage(SegModel *) {}
  virtual void updateToger(SegModel *) {}
  virtual void updateSelection(SegModel *) {}

protected:

  MainWindow *m_mainWindow;
  MainView *m_view;

};

#endif /* ! HISTOGRAMINTERVALSINTERACTOR_HPP */
