/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef HISTOGRAMINTERVALSPROCESSOR_HPP
#define HISTOGRAMINTERVALSPROCESSOR_HPP

#include <girl/girlToger.hpp>

#include "IntervalsTypes.hpp"

namespace ise {
  class GrayScaleHistogram;
}

class MainWindow;
class MainView;
class SegModel;


class HistogramIntervalsProcessor
{
public:
  
  /**
   * @brief Destructor.
   */
  virtual ~HistogramIntervalsProcessor() {}

  /**
   * @brief Constructor.
   */
  HistogramIntervalsProcessor(MainWindow *mw, MainView *v)
    : m_mainWindow(mw),
      m_view(v)
  {}


  virtual void getHistogram(ise::GrayScaleHistogram &h) = 0;

  virtual void updateTarget(const SegModel *m, const girl::regionDeque &regions) = 0;

  virtual void getRegionsInIntervals(const intervals::IntervalCollection &intervals, 
				     girl::regionDeque &regions) = 0;



protected:

  MainWindow *m_mainWindow;
  MainView *m_view;

};

#endif /* ! HISTOGRAMINTERVALSPROCESSOR_HPP */
