/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef HISTOGRAMINTERVALSSIMPLEDIALOG_HPP
#define HISTOGRAMINTERVALSSIMPLEDIALOG_HPP

#include "HistogramIntervalsDialog.hpp"

#include "HistogramIntervalsWidget.hpp"


class HistogramIntervalsSimpleDialog : public HistogramIntervalsDialog
{
  Q_OBJECT

public:

  explicit HistogramIntervalsSimpleDialog(QWidget *parent);


  virtual void setHistogram(const ise::GrayScaleHistogram &h);

  virtual intervals::Target getTarget() const;

  virtual void setTarget(intervals::Target t);

  /**
   * Return kept intervals in sorted increasing order.
   *
   * We have intervals[i].first<=intervals[i].second<intervals[i+1].first
   */
  virtual void getIntervals(intervals::IntervalCollection &intervals, 
		    intervals::ColorCollection &colors) const;

  virtual void setIntervals(const intervals::IntervalCollection &intervals,
			    const intervals::ColorCollection &colors);

  

signals:
   
  //void targetChanged(intervals::Target);

  //void intervalsChanged();

  //void accepted();
  //void rejected();

protected:

  void buildGUI();

protected:

  HistogramIntervalsWidget *m_hiw;

};

#endif /* ! HISTOGRAMINTERVALSSIMPLEDIALOG_HPP */ 
