#ifndef IMAGECONCEPTEDITORDIALOG_HPP
#define IMAGECONCEPTEDITORDIALOG_HPP

#include <QDialog>
#include <QLineEdit>

#include <qiseTools/ColorButton.hpp>
#include <qiseTools/ImageConcept.hpp>


class ImageConceptEditorDialog : public QDialog
{
  Q_OBJECT
    
public:
  explicit ImageConceptEditorDialog(QWidget *parent = NULL);

  void setImageConcept(ImageConcept &imageConcept);				     

  void setEnabledColorButton(bool enable);

  /**
   * @brief Set focus on text edit to be able to edit the concept name right away.
   */ 
  void setFocusOnTextEdit();
						  
private slots:
  void accepted();
  void rejected();
  
private:
  
  ColorButton *m_colorButton;
  QLineEdit *m_nameLineEdit;
  ImageConcept *m_imageConcept;
};

#endif //IMAGECONCEPTEDITORDIALOG_HPP
