/*
  Copyright (C) 2013 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef IMAGECONCEPTSTATSDIALOG_HPP
#define IMAGECONCEPTSTATSDIALOG_HPP

#include <QDialog>
#include <QVector>

namespace girl {
  class toger;
}

class QCheckBox;
class QLabel;
class ImageConcept;


class ImageConceptStatsDialog : public QDialog
{
  Q_OBJECT

public:

  /**
   * Use pixels of @ img & concepts @a concepts
   */
  ImageConceptStatsDialog(const QImage &img, 
			  const QList<const ImageConcept *> &concepts, 
			  QWidget *parent=NULL);

  /**
   * Use regions of @a concepts in @a tog
   */
  ImageConceptStatsDialog(const girl::toger &tog,
			  const QList<const ImageConcept *> &concepts, 
			  QWidget *parent=NULL);


  //void setImage(const QImage *img);


protected slots:

  void updateStats();
  
protected:

  void computeNbPixels(const girl::toger &tog);
  void computeNbPixels(const QImage &img);
  void build();

protected:

  QList<const ImageConcept *> m_concepts;

  QVector<size_t> m_nbPixels;
  QVector<QCheckBox *> m_checkBoxes;
  QVector<QLabel *> m_percentsL;

};

#endif /* ! IMAGECONCEPTSTATSDIALOG_HPP */
