/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef INFOINTERACTOR_HPP
#define INFOINTERACTOR_HPP

#include <girl/girlToger.hpp>

#include "RegionSelectionInteractor.hpp"

#include <ise/iseSegmentationContext.hpp>

namespace ise {
  class Histogram1D;
}

class InfoDialog;


class InfoInteractor : public RegionSelectionInteractor
{
public:

  /**
   * @brief Constructor.
   */
  InfoInteractor(MainView *v, MainWindow *mw);

  virtual void activate();

  virtual void deactivate();

  virtual bool eventFilter(QObject *target, QEvent *event);

protected:

  friend class InfoDialog;

  const girl::regionDeque &getSelectedRegions() const;

  void getPerimeter(size_t &perimeter);
  void getArea(size_t &area);
  void getHistogram(int colorSpace, size_t channel, ise::Histogram1D &h);
  ise::SegmentationContext* getSegContext();

protected:
  InfoDialog *m_infoDialog;

};

#endif /* ! INFOINTERACTOR_HPP */
