/*
  Copyright (C) 2005-2009 Jerome Charton, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef INTERACTIVEREGULARSHAPESELECTEDSTATUS_HPP
#define INTERACTIVEREGULARSHAPESELECTEDSTATUS_HPP

#include <qiseTools/InteractiveShapeStatus.hpp>

class InteractiveRegularShapeSelectedStatus : public InteractiveShapeStatus
{
public:
  explicit InteractiveRegularShapeSelectedStatus(GLView *view) : InteractiveShapeStatus(view) {m_editionBox.setSelectedMode();}
  
  virtual InteractiveShapeStatus *onLeftClick(const QPoint &mouse, PaintingShape *shape);
  inline virtual InteractiveShapeStatus *onRightClick(const QPoint &/* mouse */, PaintingShape * /* shape */) {return this;}
  
  inline virtual InteractiveShapeStatus *onLeftRelease(const QPoint &/* mouse */, PaintingShape * /* shape */) {return this;}
  inline virtual InteractiveShapeStatus *onRightRelease(const QPoint &/* mouse */, PaintingShape * /* shape */) {return this;}
  
  inline virtual InteractiveShapeStatus *onLeftClickWithCtrl(const QPoint &/* mouse */, PaintingShape * /* shape */) {return this;}
  inline virtual InteractiveShapeStatus *onRightClickWithCtrl(const QPoint &/* mouse */, PaintingShape * /* shape */) {return this;}
  
  inline virtual InteractiveShapeStatus *onMove(const QPoint &/* mouse */, PaintingShape * /* shape */) {return this;}
  
  inline virtual InteractiveShapeStatus *onMoveWithLeftClick(const QPoint &/* mouse */, PaintingShape * /* shape */) {return this;}
  inline virtual InteractiveShapeStatus *onMoveWithRightClick(const QPoint &/* mouse */, PaintingShape * /* shape */) {return this;}
  
  virtual InteractiveShapeStatus *setSelected(bool isSelected);
  inline virtual bool isSelected() { return true; }
};

#endif /* ! INTERACTIVEREGULARSHAPEDRAWINGSTATUS_HPP */
