/*
  Copyright (C) 2005-2009 Jerome Charton, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include "InteractiveShapeMovePointStatus.hpp"

#include <QPoint>
#include <qiseTools/PaintingShape.hpp>

InteractiveShapeStatus *
InteractiveShapeMovePointStatus::onMoveWithLeftClick(const QPoint &mouse,
						     PaintingShape *shape)
{
  QPoint target = QPoint(mouse.x() + m_diffMouseCorner.x(), mouse.y() + m_diffMouseCorner.y());
  // Save the visual position of an other point than the point in move
  QPoint oldStaticPoint = shape->getTransformedPoint(shape->getPoints()[1-(m_pointIndex%2)]);
  shape->setPoint(m_pointIndex, target);
  // take the new visual position the static point
  QPoint newStaticPoint = shape->getTransformedPoint(shape->getPoints()[1-(m_pointIndex%2)]);
  // Restore the original visual postion
  shape->translate(oldStaticPoint - newStaticPoint);
  return this;
}
