/*
  Copyright (C) 2005-2009 Jerome Charton, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef INTERACTIVESHAPEMOVEPOINTSTATUS_HPP
#define INTERACTIVESHAPEMOVEPOINTSTATUS_HPP

#include "InteractiveShapeTransformStatus.hpp"

class InteractiveShapeMovePointStatus : public InteractiveShapeTransformStatus
{
  
public:
  
  InteractiveShapeMovePointStatus(GLView *view,
				  InteractiveShapeStatus *previousStatus,
				  QPoint &diffMouseCorner,
				  QPoint &source, QPoint &origin,
				  unsigned int pointIndex)
    : InteractiveShapeTransformStatus(view,
				      previousStatus,
				      diffMouseCorner,
				      source, origin),
      m_pointIndex(pointIndex)
  {}
  
  virtual InteractiveShapeStatus *onMoveWithLeftClick(const QPoint &mouse,
						      PaintingShape *shape);
  
private:
  
  unsigned int m_pointIndex;

};

#endif /* ! INTERACTIVESHAPEMOVEPOINTSTATUS_HPP */
