/*
  Copyright (C) 2005-2009 Jerome Charton, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include "InteractiveShapeResizeWidthStatus.hpp"

#include <QPoint>
#include <qiseTools/PaintingShape.hpp>

InteractiveShapeStatus *
InteractiveShapeResizeWidthStatus::onMoveWithLeftClick(const QPoint &mouse, PaintingShape *shape)
{
  QPoint target = QPoint(mouse.x() + m_diffMouseCorner.x(), mouse.y() + m_diffMouseCorner.y());
  shape->resizeX(m_origin, m_source, target);
  selectEditionMode(m_origin, m_source);
  return this;
}

void
InteractiveShapeResizeWidthStatus::selectEditionMode(QPoint &origin, QPoint &source) {
  if (origin.x() < source.x())
    m_editionBox.setOverRightSideMode();
  else
    m_editionBox.setOverLeftSideMode();
}
