/*
  Copyright (C) 2005-2009 Jerome Charton, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include "InteractiveShapeRotateStatus.hpp"

#include <QPoint>
#include <qiseTools/PaintingShape.hpp>

#include <cmath>

InteractiveShapeStatus *
InteractiveShapeRotateStatus::onMoveWithLeftClick(const QPoint &mouse, PaintingShape *shape)
{
  int xMouse = shape->getTransformedPoint(mouse).x()-shape->getCenter().x(),
    yMouse = shape->getTransformedPoint(mouse).y()-shape->getCenter().y(),
    
    xSource = m_source.x()-shape->getCenter().x(),
    ySource = m_source.y()-shape->getCenter().y();
  
  double teta1 = M_PI/2, teta2 = M_PI/2, teta;
  
  if (xMouse != 0)
    teta1 = atan((double)yMouse/(double)xMouse);
  
  if (xSource != 0)
    teta2 = atan((double)ySource/(double)xSource);

  teta = teta1-teta2;
  
  if (xMouse <= 0)
    teta = M_PI+teta;

  shape->setRotation(teta);
  return this;
}
