///////////////////////////////////////////////////////////////////////////////
// 
// MacroRepeat
// 
// This header provides macros for repeating code.
// 
///////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2004 Robert Geiman.
//
// Permission to copy, modify, and use this code for personal and commercial
// software is granted provided this copyright notice appears in all copies.
// This software is provided "as is" without any expressed or implied warranty.
//
// Any comments or questions can be sent to: rgeiman@buckeye-express.com
//
///////////////////////////////////////////////////////////////////////////////

#ifndef MACRO_REPEAT_H
#define MACRO_REPEAT_H


#define MACRO_EMPTY_SEPARATOR 
#define MACRO_COMMA_SEPARATOR ,
#define MACRO_SEMICOLAN_SEPARATOR ;
#define MACRO_BEGIN_PAREN_SEPARATOR (
#define MACRO_END_PAREN_SEPARATOR )

#define MACRO_EMPTY_MACRO(num)
#define MACRO_TEMPLATE_PARAMETER(num) typename A##num
#define MACRO_TEMPLATE_ARGUMENT(num) A##num
#define MACRO_FUNCTION_PARAMETER(num) A##num a##num
#define MACRO_FUNCTION_ARGUMENT(num) a##num


#define MACRO_REPEAT_0(begin_separator, separator, macro, end_separator) 
#define MACRO_REPEAT_1(begin_separator, separator, macro, end_separator) begin_separator macro(0) end_separator
#define MACRO_REPEAT_2(begin_separator, separator, macro, end_separator) MACRO_REPEAT_1(begin_separator, separator, macro, end_separator) separator macro(1) end_separator
#define MACRO_REPEAT_3(begin_separator, separator, macro, end_separator) MACRO_REPEAT_2(begin_separator, separator, macro, end_separator) separator macro(2) end_separator
#define MACRO_REPEAT_4(begin_separator, separator, macro, end_separator) MACRO_REPEAT_3(begin_separator, separator, macro, end_separator) separator macro(3) end_separator
#define MACRO_REPEAT_5(begin_separator, separator, macro, end_separator) MACRO_REPEAT_4(begin_separator, separator, macro, end_separator) separator macro(4) end_separator
#define MACRO_REPEAT_6(begin_separator, separator, macro, end_separator) MACRO_REPEAT_5(begin_separator, separator, macro, end_separator) separator macro(5) end_separator
#define MACRO_REPEAT_7(begin_separator, separator, macro, end_separator) MACRO_REPEAT_6(begin_separator, separator, macro, end_separator) separator macro(6) end_separator
#define MACRO_REPEAT_8(begin_separator, separator, macro, end_separator) MACRO_REPEAT_7(begin_separator, separator, macro, end_separator) separator macro(7) end_separator
#define MACRO_REPEAT_9(begin_separator, separator, macro, end_separator) MACRO_REPEAT_8(begin_separator, separator, macro, end_separator) separator macro(8) end_separator
#define MACRO_REPEAT_10(begin_separator, separator, macro, end_separator) MACRO_REPEAT_9(begin_separator, separator, macro, end_separator) separator macro(9) end_separator
#define MACRO_REPEAT_11(begin_separator, separator, macro, end_separator) MACRO_REPEAT_10(begin_separator, separator, macro, end_separator) separator macro(10) end_separator
#define MACRO_REPEAT_12(begin_separator, separator, macro, end_separator) MACRO_REPEAT_11(begin_separator, separator, macro, end_separator) separator macro(11) end_separator
#define MACRO_REPEAT_13(begin_separator, separator, macro, end_separator) MACRO_REPEAT_12(begin_separator, separator, macro, end_separator) separator macro(12) end_separator
#define MACRO_REPEAT_14(begin_separator, separator, macro, end_separator) MACRO_REPEAT_13(begin_separator, separator, macro, end_separator) separator macro(13) end_separator
#define MACRO_REPEAT_15(begin_separator, separator, macro, end_separator) MACRO_REPEAT_14(begin_separator, separator, macro, end_separator) separator macro(14) end_separator
#define MACRO_REPEAT_16(begin_separator, separator, macro, end_separator) MACRO_REPEAT_15(begin_separator, separator, macro, end_separator) separator macro(15) end_separator
#define MACRO_REPEAT_17(begin_separator, separator, macro, end_separator) MACRO_REPEAT_16(begin_separator, separator, macro, end_separator) separator macro(16) end_separator
#define MACRO_REPEAT_18(begin_separator, separator, macro, end_separator) MACRO_REPEAT_17(begin_separator, separator, macro, end_separator) separator macro(17) end_separator
#define MACRO_REPEAT_19(begin_separator, separator, macro, end_separator) MACRO_REPEAT_18(begin_separator, separator, macro, end_separator) separator macro(18) end_separator
#define MACRO_REPEAT_20(begin_separator, separator, macro, end_separator) MACRO_REPEAT_19(begin_separator, separator, macro, end_separator) separator macro(19) end_separator
#define MACRO_REPEAT_21(begin_separator, separator, macro, end_separator) MACRO_REPEAT_20(begin_separator, separator, macro, end_separator) separator macro(20) end_separator
#define MACRO_REPEAT_22(begin_separator, separator, macro, end_separator) MACRO_REPEAT_21(begin_separator, separator, macro, end_separator) separator macro(21) end_separator
#define MACRO_REPEAT_23(begin_separator, separator, macro, end_separator) MACRO_REPEAT_22(begin_separator, separator, macro, end_separator) separator macro(22) end_separator
#define MACRO_REPEAT_24(begin_separator, separator, macro, end_separator) MACRO_REPEAT_23(begin_separator, separator, macro, end_separator) separator macro(23) end_separator
#define MACRO_REPEAT_25(begin_separator, separator, macro, end_separator) MACRO_REPEAT_24(begin_separator, separator, macro, end_separator) separator macro(24) end_separator
#define MACRO_REPEAT_26(begin_separator, separator, macro, end_separator) MACRO_REPEAT_25(begin_separator, separator, macro, end_separator) separator macro(25) end_separator
#define MACRO_REPEAT_27(begin_separator, separator, macro, end_separator) MACRO_REPEAT_26(begin_separator, separator, macro, end_separator) separator macro(26) end_separator
#define MACRO_REPEAT_28(begin_separator, separator, macro, end_separator) MACRO_REPEAT_27(begin_separator, separator, macro, end_separator) separator macro(27) end_separator
#define MACRO_REPEAT_29(begin_separator, separator, macro, end_separator) MACRO_REPEAT_28(begin_separator, separator, macro, end_separator) separator macro(28) end_separator
#define MACRO_REPEAT_30(begin_separator, separator, macro, end_separator) MACRO_REPEAT_29(begin_separator, separator, macro, end_separator) separator macro(29) end_separator
#define MACRO_REPEAT_31(begin_separator, separator, macro, end_separator) MACRO_REPEAT_30(begin_separator, separator, macro, end_separator) separator macro(30) end_separator
#define MACRO_REPEAT_32(begin_separator, separator, macro, end_separator) MACRO_REPEAT_31(begin_separator, separator, macro, end_separator) separator macro(31) end_separator


#define MACRO_LIST(num, macro) MACRO_REPEAT_##num(MACRO_EMPTY_SEPARATOR, MACRO_COMMA_SEPARATOR, macro, MACRO_EMPTY_SEPARATOR)
#define MACRO_LIST_APPEND(num, macro) MACRO_REPEAT_##num(MACRO_COMMA_SEPARATOR, MACRO_COMMA_SEPARATOR, macro, MACRO_EMPTY_SEPARATOR)
#define MACRO_LIST_PREPEND(num, macro) MACRO_REPEAT_##num(MACRO_EMPTY_SEPARATOR, MACRO_COMMA_SEPARATOR, macro, MACRO_COMMA_SEPARATOR)
#define MACRO_BEGIN_PAREN(num, macro) MACRO_REPEAT_##num(MACRO_BEGIN_PAREN_SEPARATOR, MACRO_EMPTY_SEPARATOR, macro, MACRO_EMPTY_SEPARATOR)
#define MACRO_END_PAREN(num, macro) MACRO_REPEAT_##num(MACRO_END_PAREN_SEPARATOR, MACRO_EMPTY_SEPARATOR, macro, MACRO_EMPTY_SEPARATOR)
#define MACRO_REPEAT(num, macro) MACRO_REPEAT_##num(MACRO_EMPTY_SEPARATOR, MACRO_EMPTY_SEPARATOR, macro, MACRO_EMPTY_SEPARATOR)


#endif
