/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef MARKINTERACTOR_HPP
#define MARKINTERACTOR_HPP

#include <girl/girlToger.hpp>

#include <qiseTools/Interactor.hpp>

class MainView;
class MainWindow;
class MarkDialog;
class GLMarkLayer;
class SegModel;

class MarkInteractorDialog;


class MarkInteractor : public Interactor
{
  Q_OBJECT

public:

  /**
   * @brief Constructor.
   */
  MarkInteractor(MainView *v, MainWindow *mw);


  virtual bool eventFilter(QObject *target, QEvent *event);

  virtual void activate();

  virtual void deactivate();


protected slots:

  void changeMark(girl::toger::markFlags mark);
  void changeMode(bool strict);
  void changeBoundary(bool onlyOuter);
  void clearAllMarks();				      
  void markSelectedRegions();

  void activateDialog();
  void deactivateDialog();

  void changeSelection(SegModel *);


protected:
  
  //void update(SegModel *model, girl::toger::markFlags mark);

  void deleteDialog();


protected:
  MainView *m_view;
  MainWindow *m_mainWindow;

  MarkInteractorDialog *m_markDialog;
  GLMarkLayer *m_markLayer;
  girl::toger::markFlags m_mark;
  bool m_markOnlyOuterBoundary;
};



#endif /* ! MARKINTERACTOR_HPP */
