/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef MARKINTERACTORDIALOG_HPP
#define MARKINTERACTORDIALOG_HPP

#include <vector>

#include <girl/girlToger.hpp>

#include <QDialog>

class QCheckBox;
class QFrame;
class QPushButton;
class QRadioButton;

class MarkWidget;


class MarkInteractorDialog : public QDialog
{
  Q_OBJECT

public:

  explicit MarkInteractorDialog(QWidget *parent);

  girl::toger::markFlags getMark() const;
  void setMark(girl::toger::markFlags m);

  bool isAND() const;

  bool applyToAllBoundaries() const;
  void setApplyToAllBoundaries(bool a);
  
  void activate();
  void deactivate();


signals:

  void markChanged(girl::toger::markFlags mark);
  void modeChanged(bool strict);
  void boundaryChanged(bool onlyOuter);
  void clearAllMarks();	      
  void markSelectedRegions();


protected slots:

  void changeMark();
  void changeMode();
  void changeApply();
  

protected:

  void buildGUI();

protected:
  
  QFrame *m_frame1;
  QFrame *m_frame2;
  QFrame *m_frame3;
  QFrame *m_frame4;
  QFrame *m_frame5;

  MarkWidget *m_mw;

  QRadioButton *m_and;
  QRadioButton *m_or;
  
  QRadioButton *m_allBoundaries;
  QRadioButton *m_outerBoundaries;
  
  QPushButton *m_clearAllMarks;
  QPushButton *m_markSelectedRegions;
};


#endif /* ! MARKINTERACTORDIALOG_HPP */
