/*
  Copyright (C) 2011 Cedric Aguerre  aguerre@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef MERGEALGORITHMPARAMETERSDIALOG_HPP
#define MERGEALGORITHMPARAMETERSDIALOG_HPP

#include <QDialog>

namespace ise {
  class iseMergeAlgorithm;
}

class QDialogButtonBox;

class MainWindow;
class MergeAlgorithmPlugin;
class MergeAlgorithmWidgetInterface;

#include <qiseTools/MergeAlgorithmSettings.hpp>

class MergeAlgorithmParametersDialog : public QDialog
{
  Q_OBJECT

public:

  MergeAlgorithmParametersDialog(MainWindow *mainWindow,
				 MergeAlgorithmPlugin *mergeAlgorithmPlugin,
				 MergeAlgorithmWidgetInterface *widget);

protected slots:

  void accept();
  void reject();

protected:

  void buildGUI();  

protected:

  MergeAlgorithmPlugin *m_mergeAlgorithmPlugin;
  MergeAlgorithmWidgetInterface *m_widget;
  
  QDialogButtonBox *m_buttonBox;

  girl::shared_ptr<MergeAlgorithmSettings> m_mergeAlgorithmSettings;

};

#endif /* ! MERGEALGORITHMPARAMETERSDIALOG_HPP */
