/*
  Copyright (C) 2005-2013 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef MERGEALLEXCEPTSELECTIONCOMMAND_HPP
#define MERGEALLEXCEPTSELECTIONCOMMAND_HPP

#include <QCoreApplication> //for Q_DECLARE_TR_FUNCTIONS

#include "UndoCommand.hpp"
#include <qiseTools/SegModel.hpp>


class MergeAllExceptSelectionCommand : public virtual UndoCommand
{
  Q_DECLARE_TR_FUNCTIONS(MergeAllExceptSelectionCommand)

public:
  explicit MergeAllExceptSelectionCommand(SegModel *m);

  virtual void redo();
  virtual void undo();

  virtual bool doAble() const;

protected:
  
  SegModel::Memento m_memento;
};


#endif /* ! MERGEALLEXCEPTSELECTIONCOMMAND_HPP */
