/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef MERGECOMMAND_HPP
#define MERGECOMMAND_HPP

#include <QCoreApplication> //for Q_DECLARE_TR_FUNCTIONS

#include <girl/girlSharedPtr.hpp>
#include <qiseTools/SegModel.hpp>
#include "UndoCommand.hpp"

#include <qiseTools/MergeAlgorithmPlugin.hpp>
#include <qiseTools/MergeDriverPlugin.hpp>



class MergeCommand : public virtual UndoCommand
{
  Q_DECLARE_TR_FUNCTIONS(MergeCommand)

public:
  MergeCommand(SegModel *m,
	       MergeAlgorithmPlugin *mergeAlgo,
	       MergeDriverPlugin *mergeDriver);

  virtual void redo();
  virtual void undo();

  virtual bool doAble() const;

protected:
  MergeAlgorithmPlugin *m_mergeAlgoPlugin;
  MergeDriverPlugin *m_mergeDriverPlugin;
  girl::shared_ptr<MergeAlgorithmSettings> m_mergeAlgoSettings;
  girl::shared_ptr<MergeDriverSettings> m_mergeDriverSettings;

  SegModel::Memento m_memento;
};


#endif /* ! MERGECOMMAND_HPP */
