/*
  Copyright (C) 2005-2009 Jerome Charton, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef PAINTINGELLIPSE_HPP
#define PAINTINGELLIPSE_HPP

#include "PaintingRegularShape.hpp"

class SegView;
class QPainter;

class PaintingEllipse : public PaintingRegularShape
{
  
public:

  PaintingEllipse(const QPoint &p1, const QPoint &p2) :
    PaintingRegularShape(p1, p2) {}
  
  inline virtual PaintingShape *clone() {return new PaintingEllipse(m_p1, m_p2);}
  
  virtual void draw(const GLView *view, QPainter &painter);

protected: 
  virtual void getSegments(std::vector<std::vector<girl::point> > &segments, 
			   girl::tools::AABBox &shapeBBox);

};

#endif /* ! PAINTINGELLIPSE_HPP */
