/*
  Copyright (C) 2005-2010 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef PAINTINGPOLYGON_HPP
#define PAINTINGPOLYGON_HPP

#include "PaintingComplexShape.hpp"


class PaintingPolygon : public PaintingComplexShape
{
public:

  PaintingPolygon();

  explicit PaintingPolygon(const QVector<QPoint> &points)
    : PaintingComplexShape(points)
  {}

  virtual void draw(const GLView *view, QPainter &painter);

  virtual PaintingShape *clone()
  {
    return new PaintingPolygon(m_points);
  }
  
  virtual bool isUnder(const QPoint &point) const;

  //virtual void getSegmentationPath(int w, int h, girl::pathDeque &paths);

  //virtual void getScanlineSet(int w, int h, ScanlineSet &scanlineSet);

  //virtual void setPoint(unsigned int index, const QPoint &point);

  //virtual QVector<QPoint> getPoints() const;

  //virtual void translate(QPoint &source, const QPoint &target);

  //virtual void resize2D(QPoint &origin, QPoint &source, const QPoint &target);


protected:

    virtual void getSegments(std::vector<std::vector<girl::point> > &segments, 
			     girl::tools::AABBox &shapeBBox);

protected:


};


#endif /* ! PAINTINGPOLYGON_HPP */
