/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef PATHSINSERTIONCOMMAND_HPP
#define PATHSINSERTIONCOMMAND_HPP


#include <QCoreApplication> //for Q_DECLARE_TR_FUNCTIONS

#include "UndoCommand.hpp"
#include <qiseTools/SegModel.hpp>



class PathsInsertionCommand : public virtual UndoCommand
{
  Q_DECLARE_TR_FUNCTIONS(PathsInsertionCommand)
  
public:
  PathsInsertionCommand(SegModel *m,
			girl::pathDeque paths,
			bool insertOnebyOne= true);

  virtual void redo();
  virtual void undo();

  virtual bool doAble() const;

protected:

  girl::pathDeque m_paths;

  SegModel::Memento m_memento;

  bool m_insertOneByOne : 1;
};



#endif /* ! PATHSINSERTIONCOMMAND_HPP */
