/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef REGIONSELECTIONCOMMAND_HPP
#define REGIONSELECTIONCOMMAND_HPP

#include "UndoCommand.hpp"

#include <girl/girlToger.hpp>

#include <QCoreApplication>

class RegionSelectionCommand : public virtual UndoCommand
{
  Q_DECLARE_TR_FUNCTIONS(RegionSelectionCommand)

public:
  RegionSelectionCommand(SegModel *m,
			 const girl::regionDeque &newSelection);

  
  virtual void redo();
  virtual void undo();

  virtual bool doAble() const;

protected:
  girl::regionDeque m_previousSelection;
  girl::regionDeque m_newSelection;
};

#endif /* ! REGIONSELECTIONCOMMAND_HPP */
