/*
  Copyright (C) 2005-2010 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef REGIONSELECTIONINTERACTOR_HPP
#define REGIONSELECTIONINTERACTOR_HPP

#include <qiseTools/RegionSelectionBaseInteractor.hpp>

class MainView;
class MainWindow;
class SelectionSettingsDockWidget;


class RegionSelectionInteractor : public RegionSelectionBaseInteractor
{

public:

  RegionSelectionInteractor(MainView *v, MainWindow *mw);

  virtual void activate();

  virtual void deactivate();

  virtual bool eventFilter(QObject *target, QEvent *event);

protected:
  MainWindow *m_mainWindow;
  SelectionSettingsDockWidget *m_selectionSettingsWidget;
};



#endif /* ! REGIONSELECTIONINTERACTOR_HPP */
