/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef REGIONSVISUALIZER_HPP
#define REGIONSVISUALIZER_HPP


#include <girl/girlToger.hpp>

class MainWindow;
class MainView;
class SegModel;

class RegionsVisualizer
{
public:
  
  /**
   * @brief Destructor.
   */
  virtual ~RegionsVisualizer() {}

  /**
   * @brief Constructor.
   */
  RegionsVisualizer(MainWindow *mw, MainView *v)
    : m_mainWindow(mw),
      m_view(v)
  {}

  virtual void activate() = 0;

  virtual void deactivate() = 0;

  virtual void update(const SegModel *, 
		      const girl::regionDeque &regions) = 0;
  

protected:

  MainWindow *m_mainWindow;
  MainView *m_view;

};

#endif /* ! REGIONSVISUALIZER_HPP */
