/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include "SegmentInsertionDialog.hpp"

#include <QLabel>
#include <QDialogButtonBox>
#include <QVBoxLayout>

SegmentInsertionDialog::SegmentInsertionDialog(QWidget *parent)
  : QDialog(parent)
{
  setAttribute(Qt::WA_DeleteOnClose);

  buildGUI();
}

void
SegmentInsertionDialog::buildGUI()
{

  QLabel *label = new QLabel(tr("Move dropped segments keeping mouse button and key pressed:\nShift for translation, %1 for rotation.\n\nThen validate or cancel insertion at current position.\n")
#ifndef Q_OS_MAC
			     .arg(QString::fromLatin1("Ctrl"))
#else
			     .arg(QString::fromLatin1("Command"))
#endif 
			     , this);
 
  QDialogButtonBox *buttonBox = new QDialogButtonBox(QDialogButtonBox::Ok
						     | QDialogButtonBox::Cancel, Qt::Horizontal, this);  

  connect(buttonBox, SIGNAL(accepted()), this, SIGNAL(accepted()));
  connect(buttonBox, SIGNAL(rejected()), this, SIGNAL(rejected()));

 
  QVBoxLayout *vLayout = new QVBoxLayout();
  vLayout->addWidget(label);
  vLayout->addWidget(buttonBox);
  
  setLayout(vLayout);    
}
