/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGWATERSHEDINTERPIXELDIALOG_HPP
#define SEGMENTATIONCLUSTERINGWATERSHEDINTERPIXELDIALOG_HPP

#include <QDialog>

namespace ise {
  class SegmentationClustering;
  class SegmentationClusteringWatershedInterPixel;
}

class QSpinBox;
class WeightedChannelsColorSpaceWidget;


class SegmentationClusteringWatershedInterPixelDialog : public QDialog
{
  Q_OBJECT

public:
  SegmentationClusteringWatershedInterPixelDialog(ise::SegmentationClustering *segmentationClusteringWatershed,
						  QWidget *parent = NULL);

  
public slots:

  virtual void accept();
  virtual void reject();

protected:

  void buildGUI();
  void setGUI();
  void getGUI();

protected:

  ise::SegmentationClusteringWatershedInterPixel *m_segmentationClusteringWatershedInterPixel ;
  WeightedChannelsColorSpaceWidget *m_wccsw;
  QSpinBox *m_nbGradient;

};





#endif /* ! SEGMENTATIONCLUSTERINGWATERSHEDINTERPIXELDIALOG */
