/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SPLITDRIVERPARAMETERSDIALOG_HPP
#define SPLITDRIVERPARAMETERSDIALOG_HPP

#include <QDialog>

class MainWindow;
class SplitDriverFactory;
class SegModel;
class SplitDriverWidgetInterface;


class SplitDriverParametersDialog : public QDialog
{
  Q_OBJECT


  public:

  SplitDriverParametersDialog(MainWindow *mainWindow,
			      SplitDriverFactory *splitDriverFactory,
			      SplitDriverWidgetInterface *widget);

protected slots:

  void accept();
  void reject();


protected:

  void buildGUI();


protected:

  SplitDriverWidgetInterface *m_widget;
  SplitDriverFactory *m_splitDriverFactory;
};


#endif /* ! SPLITDRIVERPARAMETERSDIALOG_HPP */
