/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef UNDOCOMMAND_HPP
#define UNDOCOMMAND_HPP

#include <QUndoCommand>

class SegModel;

class UndoCommand : public virtual QUndoCommand
{

public:
  virtual ~UndoCommand() {}

  explicit UndoCommand(SegModel *m)
    : QUndoCommand(),
      m_model(m)
  {}

  UndoCommand(const UndoCommand &o)
    : QUndoCommand(),
      m_model(o.m_model)
  {}

  
  UndoCommand &operator=(const UndoCommand &o)
  {
    //QUndoCommand::operator=(o);
    m_model = o.m_model;
    return *this;
  }

  virtual bool doAble() const
  {
    return false;
  }

protected:
  SegModel *m_model;

};

#endif /* ! UNDOCOMMAND_HPP */
