/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef VIEWMOVER2_HPP
#define VIEWMOVER2_HPP

#include <QPoint>
#include <QCursor>

#include <qiseTools/Interactor.hpp>


class GLView;

class ViewMover2 : public Interactor
{
public:
  ViewMover2(GLView *view = NULL, GLView *dstView = NULL);

  virtual void activate();

  virtual void deactivate();

  void setViews(GLView *view, GLView *dstView);

  virtual bool eventFilter(QObject *object, QEvent *event);
  
protected:
  GLView *m_view;
  GLView *m_dstView;
  QCursor m_savedCursor;
  QPoint m_clickPos;
  bool m_isMoving;

};


#endif /* ! VIEWMOVER2_HPP */
