/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include <QApplication>
#include <QTranslator>
#include <QLibraryInfo>
#include <QLocale>
#include "MainWindow.hpp"


int
main(int argc, char *argv[])
{  
  //Q_INIT_RESOURCE(application);
  QApplication app(argc, argv);
  //MainWindow window;
  //  app.connect( &app, SIGNAL(lastWindowClosed()), &app, SLOT(quit()) );
  //window.show();


  QTranslator qtTranslator;
  qtTranslator.load(QString::fromLatin1("qt_") + QLocale::system().name(),
		    QLibraryInfo::location(QLibraryInfo::TranslationsPath));
  app.installTranslator(&qtTranslator);
  
  QTranslator qiseTranslator;
  qiseTranslator.load(QString::fromLatin1("qise_") + QLocale::system().name());
  app.installTranslator(&qiseTranslator);


  MainWindow *window = new MainWindow; //Must be allocated on heap (as Qt::WA_DeleteOnClose attribute is set) !!! 
  window->show();

  for (int i=1; i<argc; ++i) {
    const QString filename = QLatin1String(argv[i]);
    window->loadFile(filename);
  }

  return app.exec();
}



