/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef BUTTONTHRESHOLDER_HPP
#define BUTTONTHRESHOLDER_HPP

class QPushButton;
class QLabel;
#include <QWidget>
#include <girl/girlCommon.hpp>
#include "ColorSpaceRegistry.hpp"
#include "MainView.hpp"
#include <ise/iseThresholderData.hpp>

class GIRL_API ButtonThresholder : public QWidget
{
  Q_OBJECT
 public:
  
  ButtonThresholder(MainView *mainView, QWidget *parent);

  virtual ~ButtonThresholder() {}

  void setParameters(int colorSpace, int channel, const std::vector<int> &levels);

  void getParameters(int &colorSpace, int &channel, std::vector<int> &levels) const;

  void setParameters(const ise::ThresholderData &datas);

  void getParameters(ise::ThresholderData &datas) const;

 protected slots:

  void showThresholder();

 private:

  void buildGUI();

 private:

  MainView *m_mainView;
  QLabel *m_colorSpaceLabel;
  QLabel *m_colorSpaceValue;
  QLabel *m_channelLabel;
  QLabel *m_channelValue;
  QLabel *m_thresholdLabel;
  QLabel *m_thresholdValue;

  std::vector<int> m_levels;
  int m_colorSpace;
  int m_channel;
};

#endif /* ! BUTTONTHRESHOLDER_HPP */
