/*
  Copyright (C) 2010-2011 Remi Vieux  remi.vieux@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef REGIONFEATURECHECKBOXWEIGHTED_HPP_
#define REGIONFEATURECHECKBOXWEIGHTED_HPP_

/**
 * Combine a check box and a sliderspinbox
 */

#include <string>

#include <girl/girlCommon.hpp>

#include <QString>
#include <QWidget>


class QCheckBox;
class SliderSpinBoxWidget;

class GIRL_API CheckableSliderSpinBox : public QWidget
{
  Q_OBJECT

public:
  CheckableSliderSpinBox(const QString &text, QWidget *parent = NULL);

  bool isChecked() const;

  void setChecked(const bool);

  const std::string getText() const;

  double getWeight() const;

  void setWeight(const double);

protected:

  void build(const QString &text);

protected:
  QCheckBox *m_cb;
  SliderSpinBoxWidget * m_ssbw;

};

#endif /* REGIONFEATURECHECKBOXWEIGHTED_HPP_ */
