/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef CLUSTERERCMEANWIDGET_HPP
#define CLUSTERERCMEANWIDGET_HPP

#include "ClustererWidgetInterface.hpp"

class QSpinBox;
class QDoubleSpinBox;

class ClustererPlugin;

class GIRL_API ClustererCMeanWidget : public ClustererWidgetInterface
{

 public:
  ClustererCMeanWidget(MainView *mainView,
			      ClustererPlugin *Clusterer,
			      QWidget *parent = NULL);
  
  void setParameters(int nbClass, double weightingExponent, double tolerance);
  void getParameters(int &nbClass, double &weightingExponent, double &tolerance) const;
  
protected:

  void buildGUI();

protected:
  
  QSpinBox *m_nbClassesSB;
  QDoubleSpinBox *m_weightingExponent;
  QDoubleSpinBox *m_tolerance;
};

#endif /* ! CLUSTERERCMEANWIDGET_HPP */ 
