/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include "ClustererMeanShiftWidget.hpp"

#include <ise/iseClustererMeanShift.hpp>
#include <limits>

#include <QBoxLayout>
#include <QLabel>
#include <QDoubleSpinBox>

#include "ClustererPlugin.hpp"
#include "MainView.hpp"

ClustererMeanShiftWidget::ClustererMeanShiftWidget(MainView *mainView,
						       ClustererPlugin *clustererPlugin,
						       QWidget *parent)
  : ClustererWidgetInterface(mainView, clustererPlugin, parent)
  , m_sigmaR(NULL)
{
  assert(m_clustererPlugin);

  setWindowTitle(tr("ClustererMeanShift parameters..."));

  setAttribute(Qt::WA_DeleteOnClose);

  buildGUI();
}

void
ClustererMeanShiftWidget::buildGUI()
{
  m_sigmaR = new QDoubleSpinBox(this);
  QLabel *labelSigmaR = new QLabel(tr("SigmaR"), this);

  QGridLayout *gLayout = new QGridLayout;
  gLayout->addWidget(labelSigmaR, 0, 0);
  gLayout->addWidget(m_sigmaR, 0, 1);
  
  setLayout(gLayout);  
}

void
ClustererMeanShiftWidget::setParameters(float sigmaR)
{
  m_sigmaR->setValue(sigmaR);
}

void
ClustererMeanShiftWidget::getParameters(float &sigmaR) const
{
  sigmaR = m_sigmaR->value();
}
