/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef COLOR_BUTTON_HPP
#define COLOR_BUTTON_HPP

#include <girl/girlCommon.hpp>//GIRL_API

#include <QPushButton>


class GIRL_API ColorButton : public QPushButton
{
  Q_OBJECT

public:

  /**
   * @brief Constructor.
   *
   * Button is built with default style color.
   */
  explicit ColorButton(QWidget *parent = NULL);

  /**
   * @brief Constructor.
   *
   * Button is built with given color.
   */
  ColorButton(QRgb color, QWidget *parent = NULL);

  /**
   * @brief Set color of button.
   */
  void setColor(QRgb newColor);

  /**
   * @brief Get color of button.
   */
  QRgb getColor() const;


signals:

  void colorChanged(QRgb newColor);

protected slots:

  void getColorFromDialog();
  
  void setColorSS(QRgb newColor);

protected:
  QRgb m_color;

};

#endif /* ! COLOR_BUTTON_HPP */
