/*
  Copyright (C) 2005-2010 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include <QWidget>

#include <girl/girlCommon.hpp>//GIRL_API
#include <ise/iseConversion.hpp>


class QLabel;

class ColorSpaceChoiceWidget;


class GIRL_API ColorConvertWidget : public QWidget
{
  Q_OBJECT

public:

  /**
   * @brief Constructor.
   */
  ColorConvertWidget(QWidget *parent = NULL,
		     int conversion = ISE_RGB_to_RGB);

  void setRGB(int r, int g, int b);

  /**
   * Set color space according to iseConversion !
   */
  void setColorSpace(int cs);

  void setEnabledValues(bool enabled);
			    

protected slots:

  void changeColorSpace(int cs);

protected:

  void build();

  void setValues(int x, int y, int z);
  
protected:

  ColorSpaceChoiceWidget *m_cscw;
  QLabel *m_channelsValuesL;
  int m_r, m_g, m_b;
};


  
