/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef COLORGENERATOR_HPP
#define COLORGENERATOR_HPP

/**
 * initial code from Achille Braquelaire.
 */

#include <girl/girlCommon.hpp>
#include <QColor>

class GIRL_API ColorGenerator
{
public:
  
  ColorGenerator(int periodic = 1, int maxVal = 0xff);

  QRgb getNewColor();

  void reset(int periodic = 1, int maxVal = 0xff);


protected:

  struct Flt3
  {
    Flt3(float a=0.0f, float b=0.0f, float c=0.0f)
    {
      set(a, b, c);
    }

    void set(float a, float b, float c)
    {
      elts[0] = a;
      elts[1] = b;
      elts[2] = c;
    }


    float operator[](size_t i) const
    {
      return elts[i];
    }

    float &operator[](size_t i)
    {
      return elts[i];
    }


    float elts[3];
  };

  int fltToInt(float x);
  QRgb getColorFromFlt3(const Flt3 &x);
  void RGBtoHSV(Flt3 rgb, Flt3 &hsv);
  void HSVtoRGB(Flt3 hsv, Flt3 &rgb);
  void HSVSpiralInit();
  QRgb HSVSpiralGenerate();


protected:

  Flt3 m_currentRGB;
    
  int m_maxVal;
  int m_periodic;
};




#endif /* ! COLORGENERATOR_HPP */
