/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef COLORPOOL_HPP
#define COLORPOOL_HPP

#include <girl/girlCommon.hpp>
#include <QList>
#include <QColor>


class GIRL_API ColorPool
{
public:

  explicit ColorPool(size_t minNbColors=0);

  QRgb takeFreeColor();

  void restoreFreeColor(QRgb color);

  size_t size() const;

  void resize(size_t size);

  QRgb getColor(size_t i);


  static QRgb getRandomColor();

protected:
  
  void initColors();

protected:

  QList<QRgb> m_colors;

};


#endif /* ! COLORPOOL_HPP */
