/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include "ColorSpaceRegistry.hpp"

ColorSpaceRegistry::ColorSpaceMap ColorSpaceRegistry::ms_colorSpaces;


bool 
ColorSpaceRegistry::addColorSpace(const ColorSpaceDetails &csd)
{
    if (ms_colorSpaces.find(csd.iseColorSpace) ==  ms_colorSpaces.end()) {
      ms_colorSpaces[csd.iseColorSpace] = csd;
      return true;
    }
    return false;
}

const ColorSpaceDetails *
ColorSpaceRegistry::getColorSpace(int iseColorSpace)
  {
    ColorSpaceMap::const_iterator it = ms_colorSpaces.find(iseColorSpace);
    if (it != ms_colorSpaces.end())
      return &(it->second);
    return NULL;
  }


size_t
ColorSpaceRegistry::getNumColorSpaces() 
  {
    return ms_colorSpaces.size();
  }
  
ColorSpaceRegistry::ColorSpaceMap::const_iterator
ColorSpaceRegistry::begin() 
  {
    return ms_colorSpaces.begin();
  }

ColorSpaceRegistry::ColorSpaceMap::const_iterator
ColorSpaceRegistry::end() 
  {
    return ms_colorSpaces.end();
  }