/*
  Copyright (C) 2005-2010 Hugo Boujut, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#include "FalseColorIndex.hpp"

FalseColorIndex::FalseColorIndex() : m_regions(), m_toger(NULL)
{}

FalseColorIndex::FalseColorIndex(const girl::regionDeque &regions,
				 const girl::toger &tog)
  : m_regions(regions),
    m_toger(&tog)
{

}

void
FalseColorIndex::addRegion(const girl::region &region)
{
  girl::regionDeque::const_iterator it = m_regions.begin();
  girl::regionDeque::const_iterator itEnd = m_regions.end();

  for (; it != itEnd; ++it)
    if (*it == region)
      return;

  m_regions.push_back(region);
}

void
FalseColorIndex::removeRegion(const girl::region &region)
{
  girl::regionDeque::iterator it = m_regions.begin();
  girl::regionDeque::const_iterator itEnd = m_regions.end();

  for (; it != itEnd; ) {
    if (*it == region) {
      m_regions.erase(it);
      break;
    }
    ++it;
  }
}
