/*
  Copyright (C) 2005-2010 Hugo Boujut, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef FALSECOLORINDEX_HPP
#define FALSECOLORINDEX_HPP

#include <girl/girlToger.hpp>

#include <QColor>
#include <QList>

class GIRL_API FalseColorIndex 
{
public:

  FalseColorIndex();

  FalseColorIndex(const girl::regionDeque &regions,
		  const girl::toger &tog);

  virtual ~FalseColorIndex() { }

  virtual const QRgb& getColor(const QRgb &color) const = 0;

  const girl::toger &getToger() const { return *m_toger; }

  void setRegions(const girl::regionDeque &regions) { m_regions = regions; }
  const girl::regionDeque& getRegions() const { return m_regions; }
  void clearRegions() { m_regions.clear(); }
  void addRegion(const girl::region &region);
  void removeRegion(const girl::region &region);

protected:
  girl::regionDeque m_regions;
  const girl::toger *m_toger;
};

typedef QList<const FalseColorIndex *> FalseColorIndexList;

#endif //FALSECOLORINDEX_HPP
