/* 
 * Copyright (C) 2010-2011 Julian Roigt  boris.mansencal@labri.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation (Inc., 59
 * Temple Place - Suite 330, Boston, MA 02111-1307, USA); either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */
#ifndef FEATURECHOICEDIALOG_HPP
#define FEATURECHOICEDIALOG_HPP

#include <girl/girlCommon.hpp>
#include <girl/girlUnorderedSet.hpp>

#include <QDialog>
#include <vector>
#include "MainView.hpp"
//#include "FeatureTabSettingsInterface.hpp"
#include "FeatureData.hpp"
#include "FeatureComputerGUIInfo.hpp"

class QString;

class ImageFeatureComputerTabWidget;
class RegionFeatureComputerTabWidget;

class FeatureChoiceDialogSettings;
class FeatureTabWidget;

class GIRL_API FeatureChoiceDialog : public QDialog
{
  Q_OBJECT
  
public:
  
  FeatureChoiceDialog(MainView *mainView, QWidget *parent = NULL);

  virtual ~FeatureChoiceDialog()
  {
  }

 protected slots:
  
  void accept();
  void reject();
  void changedFeature();

 protected:

  void buildGUI();

 signals:

  void featureChanged();

protected:
  
  ImageFeatureComputerTabWidget *m_imageFeatureComputerWidget;
  RegionFeatureComputerTabWidget *m_regionFeatureComputerWidget;

  std::vector<FeatureTabWidget*> m_iftws;
  MainView *m_mainView;
  girl::shared_ptr<FeatureChoiceDialogSettings> m_featureChoiceDialogSettings;

  FeatureComputerGUIInfoPtr m_featureComputerGUIInfo;
  
};

#endif /* ! FEATURECHOICEDIALOG_HPP */
