/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

 */

#include "FeatureComputerTabWidget.hpp"
#include "FeatureTabWidget.hpp"

#include <QVBoxLayout>

FeatureComputerTabWidget::FeatureComputerTabWidget(MainView *mainView,
						   FeatureComputerGUIInfoPtr featureComputerGUIInfo,
						   QString name,
						   QWidget *parent)
  : FeatureTabWidget(mainView, featureComputerGUIInfo, name, parent)
  , m_fws()
{
  setAttribute(Qt::WA_DeleteOnClose);

  build();
}

void
FeatureComputerTabWidget::build()
{
  m_featuresLayout = new QVBoxLayout;
  m_featuresLayout->setAlignment(Qt::AlignTop);

  FeatureTabWidget::setLayout(m_featuresLayout);
}

void
FeatureComputerTabWidget::setLayout(QLayout *layout)
{
  m_featuresLayout->addLayout(layout);
}

void
FeatureComputerTabWidget::addWidget(FeatureListMultiPluginWidget *widget)
{
  m_fws.push_back(widget);
  connect(widget);
}

