/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef FEATURECOMPUTERTABWIDGET_HPP
#define FEATURECOMPUTERTABWIDGET_HPP

#include "FeatureTabWidget.hpp"
#include "FeatureListMultiPluginWidget.hpp"

#include <girl/girlCommon.hpp>
#include <QObject>
#include <QLayout>

class ImageFeatureTabWidget;
class ImageFeatureChoiceDialog;

class GIRL_API FeatureComputerTabWidget : public FeatureTabWidget
{
  Q_OBJECT

 public:
 

  virtual ~FeatureComputerTabWidget() {}

 protected:

   
  FeatureComputerTabWidget(MainView *mainView,
			   FeatureComputerGUIInfoPtr featureComputerGUIInfo,
			   QString name,
			   QWidget *parent = NULL);

  virtual void build();

  void setLayout(QLayout *layout);
  
  void addWidget(FeatureListMultiPluginWidget* widget);

  virtual void initWidget() = 0;

 protected:

  std::vector<FeatureListMultiPluginWidget*> m_fws;
  QVBoxLayout *m_featuresLayout;
};

#endif /* ! FEATURECOMPUTERTABWIDGET_HPP */
