/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
 * FeatureDataAlgo.hpp
 *
 *  Created on: Mar 4, 2011
 *      Author: vieux
 */

#ifndef FEATUREDATAALGO_HPP
#define FEATUREDATAALGO_HPP

#include <girl/girlSharedPtr.hpp>

#include <ise/iseFeatureComputer.hpp>

#include "FeatureData.hpp"

class FeatureDataAlgo
{
public:

  FeatureDataAlgo(const FeatureDataPtr &data, const girl::shared_ptr<ise::FeatureComputer> &algo)
   : m_data(data), m_algo(algo) {}

  ~FeatureDataAlgo() {};

  FeatureDataPtr
  infos() const { return m_data; }

  girl::shared_ptr<ise::FeatureComputer>
  algo() const { return m_algo; }

protected:

  FeatureDataPtr m_data;

  girl::shared_ptr<ise::FeatureComputer> m_algo;

};

#endif /* FEATUREDATAALGO_HPP */
