/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include "FeatureInterfaceWidget.hpp"
#include "FeatureData.hpp"
#include "FeatureComputerGUIInfo.hpp"
#include "FeaturePlugin.hpp"

void 
FeatureInterfaceWidget::getGUI(girl::shared_ptr<FeatureInterfaceSettings> settings) {
  assert(settings);
  settings->getWidgetConfig(this);
}

void 
FeatureInterfaceWidget::setGUI(const girl::shared_ptr<FeatureInterfaceSettings> settings) {
  assert(settings);
  settings->configureWidget(this);
}

bool 
FeatureInterfaceWidget::saveSettingsInPlugin() {
  if (m_plugin) {
    if (m_plugin->hasSettings()) {
      girl::shared_ptr<FeatureInterfaceSettings> s = m_plugin->getSettings();
      getGUI(s);
      assert(s);
      if (s->isValid()) {
	m_plugin->setSettings(s);
	return true;
      }
    }
    else {
      //no settings
      return true;
    }
    
  }
  return false;
}
