/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef FEATUREINTERFACEWIDGET_HPP
#define FEATUREINTERFACEWIDGET_HPP

#include <girl/girlCommon.hpp>
#include <cassert>

#include <QWidget>

#include "MainView.hpp"

#include "FeatureInterfaceSettings.hpp"
class FeatureData;
#include "FeatureComputerGUIInfo.hpp"

class GIRL_API FeatureInterfaceWidget : public QWidget
{
 public:
  
  virtual ~FeatureInterfaceWidget() {}

  void getGUI(girl::shared_ptr<FeatureInterfaceSettings> settings);

  void setGUI(const girl::shared_ptr<FeatureInterfaceSettings> settings);
  FeaturePlugin *plugin() const { return m_plugin; }

  bool saveSettingsInPlugin();

 protected:

  FeatureInterfaceWidget(MainView *mainView, girl::shared_ptr<FeatureComputerGUIInfo> featureComputerGUIInfo, FeaturePlugin* plugin, QWidget *parent)
    : QWidget(parent)
    , m_plugin(plugin)
    , m_mainView(mainView)
    , m_featureComputerGUIInfo(featureComputerGUIInfo)
  {
  }

  
 protected:

  FeaturePlugin *m_plugin;
  MainView *m_mainView;
  girl::shared_ptr<FeatureComputerGUIInfo> m_featureComputerGUIInfo;

};

#endif /* ! FEATUREINTERFACEWIDGET_HPP */
