/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef FEATURELISTONEPLUGINWIDGET_HPP
#define FEATURELISTONEPLUGINWIDGET_HPP

#include <girl/girlCommon.hpp>

#include <girl/girlHashFunc.hpp>
#include <girl/girlHashMap.hpp>

#include <QListWidget>
#include <QString>
#include "MainView.hpp"
#include "FeatureData.hpp"

#include "FeatureListPluginWidget.hpp"

#include <list>

class ImageFeatureCompositionPlugin;

class GIRL_API FeatureListOnePluginWidget : public FeatureListPluginWidget
{
  Q_OBJECT

 public:
 

  virtual ~FeatureListOnePluginWidget() {}
  
 protected:

  FeatureListOnePluginWidget(MainView *mainView, 
			     FeatureComputerGUIInfoPtr featureComputerGUIInfo,
			     ImageFeatureCompositionPlugin *plugin,
			     QWidget *parent = NULL);

  virtual void build();

 private:
	      
  virtual FeatureDialog* newCurrentDialog(FeatureDataPtr&);

 protected:

  ImageFeatureCompositionPlugin *m_plugin;

};

#endif /* ! FEATURELISTONEPLUGINWIDGET_HPP */
