/*
  Copyright (C) 2005-2011 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef FEATURETABPLUGIN_HPP
#define FEATURETABPLUGIN_HPP

#include <girl/girlCommon.hpp>
#include <girl/girlHashFunc.hpp>
#include <girl/girlHashMap.hpp>

#include "QIsePlugin.hpp"
#include <QString>

//#include <qiseTools/FeatureTabSettingsInterface.hpp>

#include <qiseTools/FeaturePlugin.hpp>
#include <ise/iseFeatureComputer.hpp>

#include <qiseTools/FeatureDialog.hpp>

#include <qiseTools/FeatureComputerGUIInfo.hpp>

class FeatureTabWidget;

class GIRL_API FeatureTabPlugin : public QIsePlugin
{
 public:

  virtual ~FeatureTabPlugin()
    {}

  FeatureTabWidget *parameterWidget(MainView *mainView, FeatureComputerGUIInfoPtr featureComputerGUIInfo, QWidget *parent)
  {
    FeatureTabWidget * w= createWidget(mainView, featureComputerGUIInfo, parent);
    //girl::shared_ptr<FeatureTabSettingsInterface> s = settings();
    //if (s != NULL)
    //  s->configureWidget(w);
    return w;
  }

  inline void setSegContext( ise::SegmentationContext * segContext)
  { 
    m_segContext = segContext; 
  }

  //inline std::string getUri() const { return m_uri; }

  //virtual girl::shared_ptr<FeatureTabSettingsInterface> createSettings() = 0;

 
  // void setSettings(girl::shared_ptr<FeatureTabSettingsInterface> settings)
  // {
  //   if (settings)
  //     m_settings = settings->clone();
  //   else
  //     m_settings = girl::shared_ptr<FeatureTabSettingsInterface>();
  // }  

  // girl::shared_ptr<FeatureTabSettingsInterface> getSettings()
  // {
  //   if (settings()) 
  //     return m_settings->clone();
  //   return girl::shared_ptr<FeatureTabSettingsInterface>();
  // }  

  // virtual bool hasSettings() const
  // {
  //   return true;
  // }

 protected : 
  FeatureTabPlugin( const QString &name,
			   const QIseVersion &pluginVersion,
			   const QIseVersion &qiseVersion,
			   QString path = QString::fromUtf8(""))
    : QIsePlugin(name, QString::fromUtf8("FeatureTab/")+path , pluginVersion, qiseVersion)
    , m_segContext(NULL)
    , m_uri("Tab")
    //, m_settings()
  {}
  
  virtual FeatureTabWidget* createWidget(MainView *mainView, FeatureComputerGUIInfoPtr featureComputerGUIInfo, QWidget *parent = NULL) = 0;

  // virtual girl::shared_ptr<FeatureTabSettingsInterface> settings() 
  // { 
  //   if (! m_settings)
  //     m_settings = createSettings();
  //   return m_settings; 
  // }

 private:
  
  FeatureTabPlugin();
  
 protected:
  
  ise::SegmentationContext *m_segContext;
  std::string m_uri;

  //girl::shared_ptr<FeatureTabSettingsInterface> m_settings;
};

#define FeatureTabPlugin_iid "org.girl.qise.FeatureTabPlugin/1.0"
Q_DECLARE_INTERFACE(FeatureTabPlugin, FeatureTabPlugin_iid)

#endif /* ! FEATURETABPLUGIN_HPP */
