/*
  Copyright (C) 2012 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef GLBLENDIMAGELAYER_HPP
#define GLBLENDIMAGELAYER_HPP

#include "GLImageLayer.hpp"

class GIRL_API GLBlendImageLayer : public GLImageLayer
{
public:
  /**
   * @brief Constructor.
   */
  explicit GLBlendImageLayer(GLView *v);
  
  /**
   * @brief Constructor.
   */
  GLBlendImageLayer(GLView *v, const QImage &image);

  /**
   * @brief Constructor.
   */
  GLBlendImageLayer(GLView *v, const QImage &image, float opacity);

  /**
   * @brief Set opacity used to draw selection.
   *
   * @a alpha 0.0f means all transparent, 1.0f means completely opaque.
   */
  void setOpacity(float alpha) { m_opacity = alpha; }

  /**
   * @brief Get opacity used to draw selection.
   *
   * @sa setOpacity.
   */
  float getOpacity() const { return m_opacity; }


  virtual void draw();

protected:

  float m_opacity;
};


#endif /* ! GLBLENDIMAGELAYER_HPP */
