/*
  Copyright (C) 2010-2011 Cédric Aguerre  aguerre@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef GLELLIPSE_HPP
#define GLELLIPSE_HPP

#include <QPoint>
#include <QColor>

class GLEllipse
{
public:

  GLEllipse();

  GLEllipse(const QPointF &pos, QColor color = QColor());

  const QPointF &getPosition() const;
  void setPosition(const QPointF &pos);

  void setColor(const QColor &c);

  void setFilled(bool b);

  void getRadii(qreal &rH, qreal &rV);

  void setRadii(qreal rH, qreal rV);

  void draw();

protected:

  QPointF m_pos;
  QColor m_color;
  qreal m_radiusH;
  qreal m_radiusV;
  bool m_filled;

protected:

  static bool m_LUTCreated;
  static const int NB_ANGLES = 360;
  static float m_sinLUT[NB_ANGLES];

  void buildLUT();
  float cosine(int a);
  float sine(int a);
};


#endif /* ! GLELLIPSE_HPP */
