/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef GLLAYER_HPP
#define GLLAYER_HPP

#include <girl/girlCommon.hpp>//GIRL_API

#include <QRect>

//#include "GLTransformation.hpp"

class GLView;


class GIRL_API GLLayer 
{
public:

  /**
   * @brief Destructor.
   *
   * Will remove layer from its GLView if any.
   */
  virtual ~GLLayer();

  
  /**
   * @brief Constructor.
   */
  GLLayer(GLView *v = NULL)
    : m_view(v) 
    //, m_transformation()
  {}
  

  GLView *getView()
  {
    return m_view;
  }
 
  void setView(GLView *v) { m_view = v; }
 

  virtual void draw() = 0;

  /*
  virtual const GLTransformation &getTransformation() const;
  virtual void setTransformation(const GLTransformation &);
  */

  virtual void boundingRect(QRectF &rect);   
  virtual bool intersects(const QPointF &pt);

protected:

  GLView *m_view;
  //GLTransformation m_transformation;

};

#endif /* ! GLLAYER_HPP */
