/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef GLLAYERMOVER_HPP
#define GLLAYERMOVER_HPP

#include <girl/girlCommon.hpp>//GIRL_API

#include <QObject>
#include <QPoint>


class QEvent;

class GLView;
class SegScene;
class GLLayer;


class GIRL_API GLLayerMover : public QObject
{
  Q_OBJECT

public:
  
  GLLayerMover(GLView *view = NULL, GLLayer *layer = NULL);

  void setView(GLView *view);

  void setLayer(GLLayer *layer);

  bool eventFilter(QObject *object, QEvent *event);


protected:
  GLView *m_view;
  GLLayer *m_layer;
  QPoint m_clickPos;
  bool m_isMoving;

};

#endif /* ! GLLAYERMOVER_HPP */
