/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef GLMARKLAYER_HPP
#define GLMARKLAYER_HPP

#include "GLTogerLayer.hpp"

class GIRL_API GLMarkLayer : public GLTogerLayer
{
public:

  /**
   * @brief Constructor.
   */
  explicit GLMarkLayer(GLView *v);

  /**
   * @brief Constructor.
   */
  GLMarkLayer(GLView *v, const SegModel *model);


  virtual void updateToger(const SegModel *model);

  /**
   *  @brief Clear all drawings
   */
  void clear();

  /**
   * @brief Set @mark as current mark.
   *
   * Will update drwn toger with @a model.
   */
  void setMark(girl::toger::markFlags mark, const SegModel *model)
  {
    m_mark = mark;
    updateToger(model);
  }

  girl::toger::markFlags getMark() const 
  {
    return m_mark;
  }

protected:

  girl::toger::markFlags m_mark;
};

#endif /* ! GLMARKLAYER_HPP */
