/*
  Copyright (C) 2010-2011 Cédric Aguerre  aguerre@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include "GLMultiSelectionLayer.hpp"


GLMultiSelectionLayer::GLMultiSelectionLayer(GLView *v)
  : GLLayer(v),
    m_activeLayer(NULL)
{
  m_layers.clear();
}

void
GLMultiSelectionLayer::setActiveLayer(std::string layerName)
{
  m_activeLayer = &(m_layers[layerName]);
  m_activeLayer->setView(m_view);
  m_activeLayerName = layerName;
}

void
GLMultiSelectionLayer::draw()
{
  std::map<std::string, GLSelectionLayer>::iterator mit = m_layers.begin();
  std::map<std::string, GLSelectionLayer>::iterator mend = m_layers.end();
  for ( ; mit != mend; ++mit)
    mit->second.draw();
}
