/*
  Copyright (C) 2010-2011 Cédric Aguerre  aguerre@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef GLMULTISELECTIONLAYER_HPP
#define GLMULTISELECTIONLAYER_HPP

#include "GLLayer.hpp"
#include "GLSelectionLayer.hpp"
#include "GLView.hpp"
#include <string>


class GIRL_API GLMultiSelectionLayer : public GLLayer
{
public:

  /**
   * @brief Constructor.
   */
  explicit GLMultiSelectionLayer(GLView *v);

  inline GLSelectionLayer *getActiveLayer()
  {
    assert(m_activeLayer);
    return m_activeLayer;
  }

  inline std::string getActiveLayerName()
  {
    assert(m_activeLayer);
    return m_activeLayerName;
  }

  void setActiveLayer(std::string layerName);
  
  virtual void draw();

protected:

  std::map<std::string, GLSelectionLayer> m_layers;
  GLSelectionLayer *m_activeLayer;
  std::string m_activeLayerName;
};

#endif /* ! GLMULTISELECTIONLAYER_HPP */
