/*
  Copyright (C) 2010-2011 Cédric Aguerre  aguerre@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef GLSELECTORPOINT_HPP
#define GLSELECTORPOINT_HPP

#include "GLEllipse.hpp"
#include <QPoint>
#include <QColor>

class GLSelectorPoint : public GLEllipse
{
public:

  GLSelectorPoint();

  GLSelectorPoint(const QPointF &pt, QColor color = QColor(), bool visible = true);

  qreal x() const;
  qreal y() const;

  void setRadius(int r);

  bool isVisible() const;
  void setVisible(bool b);

  void draw();

  bool operator==(const GLSelectorPoint &pt) const;
  bool operator!=(const GLSelectorPoint &pt) const;

protected:

  bool m_visible;
};


#endif /* ! GLSELECTORPOINT_HPP */
