/*
  Copyright (C) 2005-2009 Jerome Charton, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef GLSHAPESLAYER_HPP
#define GLSHAPESLAYER_HPP

#include <QPainter>
#include <list>

#include "GLLayer.hpp"
#include "GLInteractiveShape.hpp"

class GIRL_API GLShapesLayer : public GLLayer
{
  
public:
  
  typedef std::list<GLInteractiveShape*> shape_set_t;
  
  explicit GLShapesLayer(GLView *v);
  ~GLShapesLayer();
  
  virtual void draw();
  
  void setCurrentShape(GLInteractiveShape *shape);
  shape_set_t::iterator getFirstUnder(QPoint point);
  void setFirst(const shape_set_t::iterator &iterator);
  inline shape_set_t *getShapes() { return &m_shapes; }
  void deleteShape(shape_set_t::iterator &it);
  void deleteAllShapes();
  void deleteSelectedShapes();

protected:

  
protected:
  
  QPainter m_painter;
  shape_set_t m_shapes;
  shape_set_t m_selectedShapes;
  GLInteractiveShape *m_currentShape;
  
};

#endif /* ! GLSHAPESLAYER_HPP */

