/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include "GLTransformation.hpp"

#include "GLUtils.hpp"

GLTransformation::GLTransformation()
  :
  Transformation()
{

}

GLTransformation::GLTransformation(const Transformation &t)
  : 
  Transformation(t)
{

}


void
GLTransformation::apply() const
{
  glTranslatef(m_tx, m_ty, 0);
#if 0
  glRotatef(gradToDeg(m_alphaInRad), 0, 0, 1);
#else
  glTranslatef(m_cx, m_cy, 0);
  glRotatef(gradToDeg(m_alphaInRad), 0, 0, 1);
  glTranslatef(-m_cx, -m_cy, 0);
#endif
  glScalef(m_sX, m_sY, 1.0);
}
