/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include "GaussianPyramidWidget.hpp"

#include <QLabel>
#include <QSpinBox>
#include <QGridLayout>

GaussianPyramidWidget::GaussianPyramidWidget(MainView *mainView, 
					     PyramidFactory *pyramidFactory,
				   int numLevel,
				   int divider,
				   QWidget *parent)
  : PyramidWidget(mainView, pyramidFactory, numLevel, divider, parent)
{
  build();
}

void
GaussianPyramidWidget::build()
{
  QGridLayout *layout = new QGridLayout;
  layout->setAlignment(Qt::AlignTop);

  setLayout(layout);
}

void
GaussianPyramidWidget::setParameters(int numLevel, int divider)
{
  setData(numLevel, divider);
}

void
GaussianPyramidWidget::getParameters(int &numLevel, int &divider) const
{
  getData(numLevel, divider);
}


