/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include "Histogram1DWidget.hpp"

#include <iostream> //DEBUG

#include <cassert>
#include <QBoxLayout>
#include <QLabel>
#include <QPushButton>
#include <QMouseEvent>

#include <ise/iseHistogram1D.hpp>

#include "Histogram1DView.hpp"


Histogram1DWidget::Histogram1DWidget(QWidget *parent)
  : Histogram1DWidgetBase(parent)
{
  
  buildGUI();

}


Histogram1DWidget::Histogram1DWidget(const ise::Histogram1D &histo, QWidget *parent)
  : Histogram1DWidgetBase(parent)
{
  buildGUI();

  setHistogram(histo);
}

Histogram1DWidget::Histogram1DWidget(const ise::SparseHistogram1DD &histo, QWidget *parent)
  : Histogram1DWidgetBase(parent)
{
  buildGUI();

  setHistogram(histo);
}

void
Histogram1DWidget::buildGUI()
{

  Histogram1DWidgetBase::buildGUI(new Histogram1DView(this));
}


void
Histogram1DWidget::setMinMax(int min, int max)
{
  assert(m_view);
  m_view->setMinMax(min, max);
}

double
Histogram1DWidget::absoluteMin() const
{
  assert(m_view);
  return m_view->absoluteMin();
}

double
Histogram1DWidget::absoluteMax() const
{
  assert(m_view);
  return m_view->absoluteMax();
}

void
Histogram1DWidget::setHistogram(const ise::Histogram1D &histo)
{
  Histogram1DWidgetBase::setHistogram(histo);
}

void
Histogram1DWidget::setHistogram(const ise::SparseHistogram1DD &histo)
{
  Histogram1DWidgetBase::setHistogram(histo);
}
