/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef HISTOGRAM1DWIDGET_HPP
#define HISTOGRAM1DWIDGET_HPP

#include <limits>

#include <girl/girlCommon.hpp>//GIRL_API
#include <ise/iseSparseHistogram1D.hpp>

#include <QWidget>

namespace ise {
  class Histogram1D;
}

#include "Histogram1DWidgetBase.hpp"

class Histogram1DView;
class QLabel;


class GIRL_API Histogram1DWidget : public Histogram1DWidgetBase
{
  Q_OBJECT

public:

  explicit Histogram1DWidget(QWidget *parent = NULL);

  Histogram1DWidget(const ise::Histogram1D &histo, QWidget *parent = NULL);
  
  Histogram1DWidget(const ise::SparseHistogram1DD &histo, QWidget *parent = NULL);
  

  /**
   * Set a new Histogram1D.
   * Will do a setMinMax().
   */
  virtual void setHistogram(const ise::Histogram1D &histo);

  virtual void setHistogram(const ise::SparseHistogram1DD &histo);

  
  //template <typename K, typename T> void setHistogram(const ise::SparseHistogram1D<K, T> &h);



  /**
   * Change aboslute min & max of histogram view,
   * without changing the underlying Histogram1D.
   * It is useful to move the levels outside the underlying Histogram1D limits
   * [when we change of color space, we can then transform the levels, before setting a new histogram]
   */
  virtual void setMinMax(int min, int max);
  
  double absoluteMin() const;

  double absoluteMax() const;


protected:  

  void buildGUI();

protected:  

};



#endif /* ! HISTOGRAM1DWIDGET_HPP */
