/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef HISTOGRAM1DWIDGETBASE_HPP
#define HISTOGRAM1DWIDGETBASE_HPP


#include <ise/iseSparseHistogram1D.hpp>

#include <QWidget>

namespace ise {
  class Histogram1D;
}

class Histogram1DView;
class QLabel;


class Histogram1DWidgetBase : public QWidget
{
  Q_OBJECT

public:


  explicit Histogram1DWidgetBase(QWidget *parent = NULL);


  virtual void setHistogram(const ise::Histogram1D &histo);

  virtual void setHistogram(const ise::SparseHistogram1DD &histo);

  virtual const ise::SparseHistogram1DD &getHistogram() const;

protected:  

  void buildGUI(Histogram1DView *v);

  virtual void mouseMoveEvent(QMouseEvent *event); 

  virtual bool eventFilter(QObject *object, QEvent *event);

protected:  

  Histogram1DView *m_view;
  QLabel *m_pos;

};



#endif /* ! HISTOGRAM1DWIDGETBASE_HPP */
