#ifndef IMAGECONCEPT_HPP
#define IMAGECONCEPT_HPP

#include <QString>
#include <QColor>

#include <qiseTools/FalseColorIndex.hpp>


enum ImageConceptState {NORMAL_CONCEPT = 0, DEFAULT_CONCEPT = 1};

class GIRL_API ImageConcept : public FalseColorIndex {
public:
  ImageConcept();

  ImageConcept(const QString &name,
	       const QRgb &color,
	       const girl::toger &tog,
	       const girl::regionDeque &regions);


  const QString& getName() const { return m_name; }
  void setName(const QString &name) { m_name = name; }  

  virtual const QRgb& getColor(const QRgb &/*color*/) const { return m_color; }
  void setColor(const QRgb &color) { m_color = color; }

  QRgb color() const { return m_color; }

protected:
  QString m_name;
  QRgb m_color;
};


#endif //IMAGECONCEPT_HPP
