/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

 */
#ifndef IMAGEFEATUREBINARYWIDGET_HPP
#define IMAGEFEATUREBINARYWIDGET_HPP

#include <girl/girlCommon.hpp>

#include "ImageFeaturesWidget.hpp"
#include "QIsePluginList.hpp"
#include "ImageFeatureBinaryPlugin.hpp"
#include "PluginRegistry.hpp"

class GIRL_API ImageFeatureBinaryWidget : public ImageFeatureColorimetricWidget
{
public:
  ImageFeatureBinaryWidget(ise::SegmentationContext *segContext,
			    QString name,
			    QWidget *parent)
    : ImageFeatureColorimectricWidget(segContext, name, parent)
  {
    loadPlugins();
  }

  void loadPlugins()
  {
    QIsePluginList<ImageFeatureBinaryPlugin*>::iterator it = PluginRegistry::getImageFeatureBinaryPlugin().begin();
    const QIsePluginList<ImageFeatureBinaryPlugin*>::iterator itEnd = PluginRegistry::getImageFeatureBinaryPlugin().end();
    for (size_t i = 0; it != itEnd; ++it) {
      QListWidgetItem *item = new QListWidgetItem((*it)->name());
      m_list->addItem(item);
      std::pair<PluginContainer::iterator, bool> insertOk = m_plugins.insert(std::make_pair(i, *it));
      assert(insertOk.second);
      ++i;
    }
  }
};

#endif /* ! IMAGEFEATUREBINARYWIDGET_HPP */
