/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

 */
#ifndef IMAGEFEATURECOLORIMETRICWIDGET_HPP
#define IMAGEFEATURECOLORIMETRICWIDGET_HPP

#include <girl/girlCommon.hpp>
#include <QListWidgetItem>

#include "FeatureListMultiPluginWidget.hpp"
#include "QIsePluginList.hpp"
#include "ImageFeatureColorimetricPlugin.hpp"
#include "PluginRegistry.hpp"
#include "ImageFeaturePlugin.hpp"

#include <ise/iseImageFeatureColorimetricComputer.hpp>

class GIRL_API ImageFeatureColorimetricWidget : public FeatureListMultiPluginWidget
{
public:
  ImageFeatureColorimetricWidget(MainView *mainView,
				 FeatureComputerGUIInfoPtr featureComputerGUIInfo, 
				 QString name,
				 QWidget *parent)
    : FeatureListMultiPluginWidget(mainView, featureComputerGUIInfo, name, parent)
  {
    loadPlugins();

    initWidget();
  }

  virtual ~ImageFeatureColorimetricWidget() {}

 protected:

  virtual void loadPlugins()
  {
    //size_t i = 0;
    
    QIsePluginList<ImageFeatureColorimetricPlugin*>::iterator it = PluginRegistry::getImageFeatureColorimetricPlugin().begin();
    const QIsePluginList<ImageFeatureColorimetricPlugin*>::iterator itEnd = PluginRegistry::getImageFeatureColorimetricPlugin().end();
    for ( ; it != itEnd; ++it) {
      addPlugin(static_cast<FeaturePlugin*>(*it));
      // QListWidgetItem *item = new QListWidgetItem((*it)->name());
      // m_list->addItem(item);
      // std::pair<PluginContainer::iterator, bool> insertOk = m_plugins.insert(std::make_pair(i, *it));
      // assert(insertOk.second);
      // ++i;
    }
    
    QIsePluginList<ImageFeatureBinaryPlugin*>::iterator it2 = PluginRegistry::getImageFeatureBinaryPlugin().begin();
    const QIsePluginList<ImageFeatureBinaryPlugin*>::iterator itEnd2 = PluginRegistry::getImageFeatureBinaryPlugin().end();
    for ( ; it2 != itEnd2; ++it2) {
      addPlugin(static_cast<FeaturePlugin*>(*it2));
      // QListWidgetItem *item = new QListWidgetItem((*it2)->name());
      // m_list->addItem(item);
      // std::pair<PluginContainer::iterator, bool> insertOk = m_plugins.insert(std::make_pair(i, *it2));
      // assert(insertOk.second);
      // ++i;
    }
  }

  virtual void getFeatureInfos(std::vector<FeatureDataPtr> &infos) const {
    m_featureComputerGUIInfo->getFeatureComputersInfo<ise::ImageFeatureColorimetricComputer>(infos);
  }

};

#endif /* ! IMAGEFEATURECOLORIMETRICWIDGET_HPP */
