/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

 */
#ifndef IMAGEFEATURECOMPOSITIONGLOBALWIDGET_HPP
#define IMAGEFEATURECOMPOSITIONGLOBALWIDGET_HPP

#include <girl/girlCommon.hpp>
#include <ise/iseImageFeatureGlobal.hpp>
#include "FeatureListOnePluginWidget.hpp"

class ImageFeatureCompositionGlobalWidget : public FeatureListOnePluginWidget
{
  
public:

  ImageFeatureCompositionGlobalWidget(MainView *mainView,
				      FeatureComputerGUIInfoPtr featureComputerGUIInfo,
				      ImageFeatureCompositionPlugin* plugin, 
				      QWidget *parent)
    : FeatureListOnePluginWidget(mainView, featureComputerGUIInfo, plugin, parent)
  {
    initWidget();
  }

  virtual ~ImageFeatureCompositionGlobalWidget() {}

protected:

  virtual void getFeatureInfos(std::vector<FeatureDataPtr> &infos) const {
    m_featureComputerGUIInfo->getFeatureComputersInfo<ise::ImageFeatureGlobal>(infos);
  }
};

#endif /* ! IMAGEFEATURECOMPOSITIONGLOBALWIDGET_HPP */
