/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef IMAGEFEATURECOMPOSITIONTABWIDGET_HPP
#define IMAGEFEATURECOMPOSITIONTABWIDGET_HPP

#include <girl/girlCommon.hpp>

#include "FeatureTabWidget.hpp"
#include "FeatureTabPlugin.hpp"
#include "MainView.hpp"
#include "ImageFeatureCompositionPlugin.hpp"
#include "FeatureListOnePluginWidget.hpp"

class GIRL_API ImageFeatureCompositionTabWidget : public FeatureTabWidget
{
  Q_OBJECT
    public:

  ImageFeatureCompositionTabWidget(MainView *mainView,
				   FeatureComputerGUIInfoPtr featureComputerGUIInfo,
				   QString name,
				   QWidget *parent = NULL);

  virtual ~ImageFeatureCompositionTabWidget() {}

  virtual void initWidget();

 protected:
  
  virtual void build();

 private:

  std::vector<FeatureListOnePluginWidget*> m_widgets;
};

#endif /* !  IMAGEFEATURECOMPOSITIONTABWIDGET_HPP */
