/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef IMAGEFEATURECOMPOSITIONWIDGETINTERFACE_HPP
#define IMAGEFEATURECOMPOSITIONWIDGETINTERFACE_HPP

#include <girl/girlCommon.hpp>

#include "ImageFeatureWidgetInterface.hpp"
#include "FeatureData.hpp"
#include "FeatureComputerGUIInfo.hpp"

class GIRL_API ImageFeatureCompositionWidgetInterface : public ImageFeatureWidgetInterface
{
 public:
  
  ImageFeatureCompositionWidgetInterface(MainView *mainView, 
					 FeatureComputerGUIInfoPtr &featureComputerGUIInfo, 
					 QString name, 
					 ImageFeaturePlugin *imageFeaturePlugin, 
					 QWidget *parent = NULL)
    : ImageFeatureWidgetInterface(mainView, featureComputerGUIInfo, name, imageFeaturePlugin, parent)
    {}

  virtual ~ImageFeatureCompositionWidgetInterface() {}

  virtual void build() = 0;
  virtual bool isValid() = 0 ;
  virtual void addNewFeatureData(FeatureDataPtr data) { 
    addData(data);
  };

  virtual void addData(FeatureDataPtr datas) = 0;

};

#endif  /* ! IMAGEFEATURECOMPOSITIONWIDGETINTERFACE_HPP */
