/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef IMAGEFEATUREGLOBALWIDGET_HPP
#define IMAGEFEATUREGLOBALWIDGET_HPP

#include "ImageFeatureCompositionWidgetInterface.hpp"
#include "FeatureData.hpp"
#include <QPushButton>
#include <QLabel>
#include <QHBoxLayout>
#include <QString>

#include "MainView.hpp"

#include <QListWidget>

class GIRL_API ImageFeatureGlobalWidget : public ImageFeatureCompositionWidgetInterface
{
  Q_OBJECT

    typedef girl::hashMap<std::string, FeatureDataPtr > FeatureDataContainer;

 public:
  
  ImageFeatureGlobalWidget(MainView *mainView,
			   FeatureComputerGUIInfoPtr featureComputerGUIInfo,
			   QString name,
			   ImageFeaturePlugin *plugin,
			   QWidget *parent = NULL);

  void setParameters(const std::vector<ise::ImageFeatureComputerPtr > &algos);
  void getParameters(std::vector<ise::ImageFeatureComputerPtr > &algos) const;
  
  virtual bool isValid() {
    return m_listToCompute->count() > 0;
  }

 protected:
  
  virtual void build();
  
  virtual void addData(FeatureDataPtr data);

  void initWidget();

public slots:

  void addItem();
  void deleteItem();

 private:
  
  void addItemToCompute(FeatureDataPtr data);
  

 protected:
  
  QListWidget *m_list;
  QListWidget *m_listToCompute;

  FeatureDataContainer m_datas;
  FeatureDataContainer m_settings;
};

#endif /* ! IMAGEFEATURESWIDGET_HPP */
