/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

/**
 * @file ImageFeatureLinearCombinationSimpleWidget.hpp
 * @brief
 */

#ifndef IMAGEFEATURELINEARCOMBINATIONSIMPLEWIDGET_HPP
#define IMAGEFEATURELINEARCOMBINATIONSIMPLEWIDGET_HPP


#include <girl/girlCommon.hpp>

#include "ImageFeatureCompositionWidgetInterface.hpp"
#include "FeatureData.hpp"
#include "MultiCheckLabelSliderSpinBoxWidget.hpp"

#include <QWidget>

class QComboBox;

class GIRL_API ImageFeatureLinearCombinationSimpleWidget : public ImageFeatureCompositionWidgetInterface
{
  Q_OBJECT
 public:

  ImageFeatureLinearCombinationSimpleWidget(MainView *mainView,
					    FeatureComputerGUIInfoPtr featureComputerGUIInfo,
					    QString name,
					    ImageFeaturePlugin *plugin,
					    QWidget *parent = NULL);

  void setParameters(const std::vector<ise::ImageFeatureComputerPtr > &datas, const std::vector<double> &weight, int dim);
  void getParameters(std::vector<ise::ImageFeatureComputerPtr> &datas, std::vector<double> &weight, int &dim) const;

  virtual bool isValid() {
    return true;
  }

 protected:
  
  virtual void build();
  
  void initWidget();

 private:
  
  void addItem(girl::shared_ptr<FeatureData> data, double weight, bool checked = false);

 private slots:

  void populateMultiCheckLabel();

 public slots:

  virtual void addData(girl::shared_ptr<FeatureData> data);
  
 private:

  MultiCheckLabelSliderSpinBoxWidget *m_mclssbw;
  QComboBox *m_combo;

  typedef girl::hashMap<std::string, girl::shared_ptr<FeatureData> > FeatureDataContainer;
  FeatureDataContainer m_settings;

  std::multimap<QString, girl::shared_ptr<FeatureData> > m_datas;
};

#endif /* !  IMAGEFEATURELINEARCOMBINATIONSIMPLEWIDGET_HPP */
