/*
  Copyright (C) 2005-2011 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef IMAGEFEATURELINEARCOMBINATIONSIMPLESETTINGS_HPP
#define IMAGEFEATURELINEARCOMBINATIONSIMPLESETTINGS_HPP

#include <girl/girlCommon.hpp>
#include "ImageFeatureTabSettingsInterface.hpp"
#include "ImageFeatureLinearCombinationSimpleWidget.hpp"

class GIRL_API ImageFeatureLinearCombinationSimpleSettings : public ImageFeatureTabSettingsInterface{

 public:

  virtual void configureWidget(ImageFeatureTabWidget *widget)
  {
    static_cast<ImageFeatureLinearCombinationSimpleWidget *>(widget)->setGUI(m_settings);
  }

  void getWidgetConfig(const ImageFeatureTabWidget *widget)
  {
    static_cast<const ImageFeatureLinearCombinationSimpleWidget *>(widget)->getGUI(m_settings);
  }

  void configureAlgo(girl::shared_ptr<ise::ImageFeatureComputer> algo) 
  {
    girl::static_pointer_cast<ise::ImageFeatureLinearCombination>(algo)->setParameters(m_settings);
  }

 private:

  std::vector< std::string > m_settings;

};

#endif /* ! IMAGEFEATURELINEARCOMBINATIONSIMPLEWIDGETSETTINGS_HPP */
