/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef IMAGEFEATUREORIENTATIONWIDGET_HPP
#define IMAGEFEATUREORIENTATIONWIDGET_HPP

#include "ImageFeatureWidgetInterface.hpp"

#include <ise/iseImageFeatureOrientation.hpp>

#include <map>
#include <vector>

class QString;
class QSpinBox;

class GIRL_API ImageFeatureOrientationWidget : public ImageFeatureWidgetInterface
{
  Q_OBJECT

public:

  /**
   * @brief Constructor.
   */ 
  ImageFeatureOrientationWidget(MainView *mainView,
				FeatureComputerGUIInfoPtr featureComputerGUIInfo,  
				QString name, 
				ImageFeaturePlugin *imageFeaturePlugin, 
				QWidget *parent = NULL);

  virtual ~ImageFeatureOrientationWidget()
  {
  }

  virtual void build();
  virtual bool isValid();

  void setParameters(int multiresolution);
  void getParameters(int &multiresolution) const;

private:

  QSpinBox *m_multiresolution;

};

#endif /* ! IMAGEFEATUREORIENTATIONWIDGET_HPP */
