/*
  Copyright (C) 2005-2011 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef IMAGEFEATUREPLUGIN_HPP
#define IMAGEFEATUREPLUGIN_HPP

#include <girl/girlCommon.hpp>

#include "FeaturePlugin.hpp"

/**
 * Interface for plugins which implements an ImageFeature
 */
class GIRL_API ImageFeaturePlugin : public FeaturePlugin
{
 public:
  
  virtual ~ImageFeaturePlugin() {}
  
 protected:
  
  ImageFeaturePlugin(const QString &name,
		     const std::string &uri,
		     const QIseVersion &pluginVersion,
		     const QIseVersion &qiseVersion,
		     QString path = QString::fromUtf8(""))
    : FeaturePlugin(name, 
		    pluginVersion, 
		    qiseVersion,
		    (QString::fromUtf8("Feature/") + path))
    , m_uri(uri)
    {}
  
 protected:

  std::string m_uri;
};

#define ImageFeaturePlugin_iid "org.girl.qise.ImageFeaturePlugin/1.0"
Q_DECLARE_INTERFACE(ImageFeaturePlugin, ImageFeaturePlugin_iid)

#endif /* ! IMAGEFEATUREPLUGIN_HPP */
