/*
  Copyright (C) 2005-2011 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef IMAGEFEATURETEXTONSETTINGS_HPP
#define IMAGEFEATURETEXTONSETTINGS_HPP

//#include "ImageFeatureSettingsInterface.hpp"
#include "ImageFeatureTextonWidget.hpp"
#include <ise/iseImageFeatureTexton.hpp>

class ImageFeatureTextonSettings : public FeatureInterfaceSettings//ImageFeatureSettingsInterface 
{
  
public:
  
  ImageFeatureTextonSettings() 
    : FeatureInterfaceSettings()//ImageFeatureSettingsInterface()
    , m_windowSize(0)
  {
  }

  virtual void configureWidget(FeatureInterfaceWidget *widget) const
  {
    static_cast<ImageFeatureTextonWidget *>(widget)->setParameters(m_windowSize);
  }
  
  virtual void getWidgetConfig(const FeatureInterfaceWidget *widget)
  {
    static_cast<const ImageFeatureTextonWidget *>(widget)->getParameters(m_windowSize);
  }

  virtual void configureAlgo(girl::shared_ptr<ise::FeatureComputer> algo) const
  {
    girl::shared_ptr<ise::ImageFeatureTexton> algorithm = girl::static_pointer_cast<ise::ImageFeatureTexton>(algo);
    algorithm->setParameters(m_windowSize);
  }
  
  virtual girl::shared_ptr<FeatureInterfaceSettings> clone() const
  {
    girl::shared_ptr<ImageFeatureTextonSettings> p(new ImageFeatureTextonSettings);

    *p = *this;

    return p;
  }

  virtual bool isValid() const
  {
    return (m_windowSize > 0); //B: ???
  }
  
private:
  
  int m_windowSize;
};

#endif /* ! IMAGEFEATURETEXTONSETTINGS_HPP */
