/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef IMAGEFEATUREVIEWDOCKWIDGET_HPP
#define IMAGEFEATUREVIEWDOCKWIDGET_HPP

#include <QDockWidget>

#include <girl/girlCommon.hpp>//GIRL_API

class QLabel;
class ImageFeatureChoiceWidget;
class MainView;
class QTableWidget;

#include <girlTools/girlToolsImageFeature.hpp>

class GIRL_API ImageFeatureViewDockWidget : public QDockWidget
{
  Q_OBJECT

 public:

  /**
   * @brief Constructor.
   */
  ImageFeatureViewDockWidget(MainView *mainView = NULL, QWidget *parent = NULL);

  /**
   * Set coordonate.
   */
  void setCoord(int x, int y);

 public slots:

  void changeImageFeatureUri();

  void rebuild();

 protected:

  void build();

  void setValues(const girl::tools::PixelFromImage<girl::tools::ImageFeature::type> &values);

  void initTable();

 protected:

  MainView *m_mainView;

  QTableWidget *m_channelsValues;

  ImageFeatureChoiceWidget *m_ifcw;

  girl::shared_ptr<girl::tools::ImageFeature> m_imgF;

  int m_x;
  int m_y;
};

#endif /* ! IMAGEFEATUREVIEWDOCKWIDGET_HPP */
