/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef IMAGEFEATUREWIDGETINTERFACE_HPP
#define IMAGEFEATUREWIDGETINTERFACE_HPP

#include <girl/girlCommon.hpp>

#include <QString>

#include "FeatureInterfaceWidget.hpp"
#include "ImageFeaturePlugin.hpp"

class GIRL_API ImageFeatureWidgetInterface : public FeatureInterfaceWidget
{
  //Q_OBJECT

 public:
  ImageFeatureWidgetInterface(MainView *mainView, 
			      FeatureComputerGUIInfoPtr featureComputerGUIInfo,
			      QString name, 
			      ImageFeaturePlugin *imageFeaturePlugin, 
			      QWidget *parent = NULL)
    : FeatureInterfaceWidget(mainView, featureComputerGUIInfo, imageFeaturePlugin, parent)
    , m_name(name)
  {
  }

  virtual ~ImageFeatureWidgetInterface() {}

  inline QString name() const { return m_name; }

protected:

  virtual void build() = 0;

protected:

  QString m_name;
};

#endif /* ! IMAGEFEATUREWIDGETINTERFACE_HPP */
