/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef IMAGE_TOOLS_HPP
#define IMAGE_TOOLS_HPP

#include <girl/girlToger.hpp>
#include <girlTools/girlToolsImage.hpp>
#include <QImage>

extern GIRL_API void QImage_to_girlToolsImage(const QImage &qimage, girl::tools::Image &img);

extern GIRL_API void girlToolsImage_to_QImage(const girl::tools::Image &image, QImage &qimage);

extern GIRL_API void getTogerFromImageLabel(const QImage &qimage, girl::toger &tog);


//output @a mat is of type CV_8UC3, in BGR !
extern GIRL_API void QImage_to_CvMat(const QImage &qimage, cv::Mat &mat);

//input @a mat must be of type CV_8UC3, in BGR !
extern GIRL_API void CvMat_to_QImage(const cv::Mat &mat, QImage &qimage);

#endif /* ! IMAGE_TOOLS_HPP */
