/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef INSTANTFEATUREDIALOG_HPP
#define INSTANTFEATUREDIALOG_HPP

#include <QDialog>
#include <QListWidget>

#include "QIsePluginList.hpp"
#include "FeaturePlugin.hpp"
#include "MainView.hpp"
#include "FeatureComputerGUIInfo.hpp"
#include "FeatureData.hpp"

class InstantFeatureDialog : public QDialog
{
  Q_OBJECT
public:

  InstantFeatureDialog(MainView *mainView, FeatureComputerGUIInfoPtr featureComputerGUIInfo, QIsePluginList<FeaturePlugin*> &listPlugin, FeatureDataPtr &data, QWidget *parent = NULL);

  virtual ~InstantFeatureDialog() {}

protected:

  void buildGUI();

public slots:

  void accept();

private:

  MainView *m_mainView;
  FeatureComputerGUIInfoPtr m_featureComputerGUIInfo;
  QListWidget *m_list;
  QIsePluginList<FeaturePlugin*> &m_listPlugin;
  FeatureDataPtr &m_data;
};

#endif /* ! INSTANTFEATUREDIALOG_HPP */
