/*
  Copyright (C) 2010 Cédric Aguerre  aguerre@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef MERGEALGORITHMMINCUTWIDGET_HPP
#define MERGEALGORITHMMINCUTWIDGET_HPP

#include "MergeAlgorithmWidgetInterface.hpp"
#include <ise/iseMinCutMergeAlgorithm.hpp>


class MaxFlowSourceSelectionWidget;
class MaxFlowSimilarityWidget;


class GIRL_API MergeAlgorithmMinCutWidget : public MergeAlgorithmWidgetInterface
{
  Q_OBJECT

public:
  MergeAlgorithmMinCutWidget(MergeAlgorithmPlugin *mergeAlgorithm, QWidget *parent = NULL);

  virtual void setMainView(MainView *v);
  
  void getParameters(ise::MinCutMergeAlgorithm::SourceSinkSelectionMethod &method, std::vector<long> &sourceIds, std::vector<long> &sinkIds, ise::MinCutMergeAlgorithm::AreaFilter &filter, long &filterValue, ise::MinCutMergeAlgorithm::SimilarityCriterion &criterion, int &conversion, std::vector<double> &weights, double &threshold) const;

  void setParameters(ise::MinCutMergeAlgorithm::SourceSinkSelectionMethod method, const std::vector<long> &sourceIds, const std::vector<long> &sinkIds, ise::MinCutMergeAlgorithm::AreaFilter filter, long filterValue, ise::MinCutMergeAlgorithm::SimilarityCriterion criterion, int conversion, const std::vector<double> &weights, double threshold);

protected:

  void buildGUI();

 private:

  MaxFlowSourceSelectionWidget *m_sourceSelectionW;
  MaxFlowSimilarityWidget *m_similarityW;
};


#endif /* ! MERGEALGORITHMMINCUTWIDGET_HPP */
