/*
 * MergeDriverDefaultWidget.cpp
 *
 *  Created on: Sep 24, 2010
 *      Author: vieux
 */
#include <QHBoxLayout>
#include <QLabel>

#include <ise/iseMergeDriverDefault.hpp>
#include "MergeDriverFactory.hpp"
#include "MergeDriverDefaultWidget.hpp"

MergeDriverDefaultWidget::MergeDriverDefaultWidget(ise::SegmentationContext *segContext,
    MergeDriverFactory *mergeDriverFactory,
    QWidget *parent)
: MergeDriverWidgetInterface(segContext, mergeDriverFactory, parent),
  m_regionFeatureChoiceWidget(NULL)
{
  buildGUI();
}


void
MergeDriverDefaultWidget::buildGUI()
{
  //  QLabel *label = new QLabel(tr("Choose Region Feature"), this);
  m_regionFeatureChoiceWidget = new RegionFeatureChoiceWidget(m_segContext, this);

  QHBoxLayout *layout = new QHBoxLayout;
  //  layout->addWidget(label);
  layout->addWidget(m_regionFeatureChoiceWidget);
  setLayout(layout);
}

void
MergeDriverDefaultWidget::setGUI()
{
  assert(m_mergeDriverFactory);
  girl::shared_ptr<ise::MergeDriverDefault> algo = girl::static_pointer_cast<ise::MergeDriverDefault>(m_mergeDriverFactory->getNewMergeDriver());

  std::vector<std::string> uris;
  algo->getRegSetUris(uris);
  std::vector<double> weights;
  algo->getRegSetWeights(weights);
  assert(m_regionFeatureChoiceWidget);
  m_regionFeatureChoiceWidget->setRegionFeaturesInfo(uris, weights);

}

void
MergeDriverDefaultWidget::getGUI()
{
  assert(m_mergeDriverFactory);
  std::vector<std::string> uris;
  std::vector<double> weights;
  m_regionFeatureChoiceWidget->getRegionFeaturesInfo(uris, weights);
  girl::shared_ptr<ise::MergeDriverDefault> algo = girl::static_pointer_cast<ise::MergeDriverDefault>(m_mergeDriverFactory->getNewMergeDriver());
  algo->setRegSetUris(uris);
  algo->setRegSetWeights(weights);
  m_mergeDriverFactory->saveParameters(algo);
}
