#ifndef MERGEDRIVERFACTORY_HPP
#define MERGEDRIVERFACTORY_HPP

#include <girl/girlSharedPtr.hpp>
#include <girl/girlCommon.hpp>//GIRL_API

#include <ise/iseMergeDriver.hpp>

namespace ise {
  class SegmentationContext;
}

class MergeDriverWidgetInterface;

class GIRL_API MergeDriverFactory
{
  
public:

  virtual ~MergeDriverFactory() {}
    
  virtual girl::shared_ptr<ise::MergeDriver> getNewMergeDriver() = 0;
  
  virtual void saveParameters(const girl::shared_ptr<ise::MergeDriver>& md) = 0;
  
  virtual MergeDriverWidgetInterface *parameterWidget() = 0;
  
  virtual void setSegContext(ise::SegmentationContext *segContext) = 0;
  
  
};

#endif /* ! MERGEDRIVERFACTORY_HPP */
