/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#include "MergeDriverSettings.hpp"

#include "MergeDriverWidgetInterface.hpp"

void MergeDriverSettings::configureWidget(MergeDriverWidgetInterface *widget) const
{
  widget->setNeighbouringModes(m_neighbourhoodMode);
  widget->setMarkFlags(m_neighbourhoodMark);
}

void MergeDriverSettings::getWidgetConfig(const MergeDriverWidgetInterface *widget)
{
  m_neighbourhoodMode = widget->getNeighbouringModes();
  m_neighbourhoodMark = widget->getMarkFlags();
}

void MergeDriverSettings::configureAlgo(girl::shared_ptr<ise::MergeDriver> algo) const
{
  algo->setNeighbourhood(m_neighbourhoodMode, m_neighbourhoodMark);
}

 
