/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

 */

#ifndef MERGEDRIVERSIZEFILTERINGWIDGET_HPP
#define MERGEDRIVERSIZEFILTERINGWIDGET_HPP

#include "MergeDriverWidgetInterface.hpp"

namespace ise {
  //  class MergeDriver;
  //  class MergeDriverSizeFiltering;
  class SegmentationContext;
}

class QDoubleSpinBox;

class AreaIntervalsWidget;
class MergeDriverWidget;
class RegionFeatureChoiceWidget;
class SliderSpinBoxWidget;
class WeightedChannelsColorSpaceWidget;


class GIRL_API MergeDriverSizeFilteringWidget : public MergeDriverWidgetInterface
{
  Q_OBJECT

public:
  MergeDriverSizeFilteringWidget(ise::SegmentationContext *segContext,
      MergeDriverFactory *mergeDriverFactory,
      QWidget *parent = NULL);


  virtual void setGUI();
  virtual void getGUI();

protected:

  void buildGUI();

protected slots:

  void checkValidity();

protected:
  MergeDriverWidget *m_mergeDriverWidget;
  AreaIntervalsWidget *m_aiw;
  //  WeightedChannelsColorSpaceWidget *m_wccsw;
  RegionFeatureChoiceWidget *m_rfcw;
  SliderSpinBoxWidget *m_thresholdSB;

};


#endif /* ! MERGEDRIVERSIZEFILTERINGWIDGET_HPP */
