/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef MERGEDRIVERWIDGET_HPP
#define MERGEDRIVERWIDGET_HPP

#include <girl/girlToger.hpp>
#include <QWidget>

class QCheckBox;

namespace ise {
  class MergeDirver;
}

class MarkWidget;

class GIRL_API MergeDriverWidget : public QWidget
{
  Q_OBJECT

public:
  explicit MergeDriverWidget(QWidget *parent = NULL);

  girl::toger::neighbouringModes getNeighbouringMode() const;
  void setNeighbouringMode(girl::toger::neighbouringModes);

  girl::toger::markFlags getMarkFlag() const;
  void setMarkFlag(girl::toger::markFlags);


signals:

  void parametersChanged();

protected:

  void buildGUI();

protected:

  QCheckBox *m_direct;
  QCheckBox *m_inner;
  QCheckBox *m_outer;

  MarkWidget *m_mw;
};

#endif /* ! MERGEDRIVERWIDGET_HPP */
