/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef MINIVIEW_HPP
#define MINIVIEW_HPP

#include <map>
#include "SegView.hpp"

class GLImageLayer;
class GLSelectionLayer;
class GLSegmentLayer;


class GIRL_API MiniView : public SegView
{
  Q_OBJECT

public:

  MiniView(QWidget *parent = NULL, SegModel *model = NULL);

  /**
   * @warning to nothing to previous set model.
   */
  virtual void setModel(SegModel *model);

  virtual void paintGL();

public slots:

  void updateRect(const QRectF &modelRectangle, const QRectF &observedViewRectangle);


protected slots:

  virtual void changeImage(SegModel *);
  virtual void changeToger(SegModel *);
  virtual void changeSelection(SegModel *);
  virtual void changeSelectionType(SegModel *);

protected:

  void changeRects(const QRectF &modelRectangle, const QRectF &observedViewRectangle);

  virtual void resizeGL(int w, int h);



protected:

  GLImageLayer *m_imageLayer;
  GLSegmentLayer *m_togerLayer;
  GLSelectionLayer *m_selectionLayer;

  QRectF m_modelRectangle;
  QRectF m_observedViewRectangle;

};


#endif /* ! MINIVIEW_HPP */
