/*
 * OrientationChoiceWidget.cpp
 *
 *  Created on: Sep 28, 2010
 *      Author: vieux
 */

#include "OrientationChoiceWidget.hpp"

#include <QComboBox>
#include <QHBoxLayout>
#include <QLabel>

OrientationChoiceWidget::OrientationChoiceWidget(QWidget *parent)
: QWidget(parent),
  m_orientationCombo(NULL)
{
  build();
}

void
OrientationChoiceWidget::build()
{
  m_orientationCombo = new QComboBox(this);
  m_orientationCombo->addItem(tr("Horizontal"));
  m_orientationCombo->addItem(tr("Vertical"));
  m_orientationCombo->addItem(tr("Diagonal45"));
  m_orientationCombo->addItem(tr("Diagonal135"));

  connect(m_orientationCombo, SIGNAL(currentIndexChanged(int)),
      this, SLOT(changeOrientation(int)));

  QLabel *label = new QLabel(tr("Orientation:"), this);
  QHBoxLayout *hbox = new QHBoxLayout;

  hbox->addWidget(label);
  hbox->addWidget(m_orientationCombo);
  hbox->addStretch();
  hbox->setMargin(0);
  this->setLayout(hbox);
}

void
OrientationChoiceWidget::setOrientation(ise::RunLengthExtractor::Orientation ori)
{
  m_orientationCombo->setCurrentIndex(ori);
}

ise::RunLengthExtractor::Orientation
OrientationChoiceWidget::getOrientation() const
{
  assert(m_orientationCombo->currentIndex() != -1);
  return static_cast<ise::RunLengthExtractor::Orientation>(m_orientationCombo->currentIndex());
}

void
OrientationChoiceWidget::changeOrientation(int orientation)
{
  emit orientationChanged(orientation);
}
