/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

/*
 * OrientationChoiceWidget.hpp
 *
 *  Created on: Sep 28, 2010
 *      Author: vieux
 */

#ifndef ORIENTATIONCHOICEWIDGET_HPP_
#define ORIENTATIONCHOICEWIDGET_HPP_

#include <ise/iseRunLengthExtractor.hpp>

#include <QWidget>

class QComboBox;

/**
 * Widget to choose orientation: horizontal, vertical, diago45, diago135,
 * for algorithms such as the ones based on run lengths
 */
class GIRL_API OrientationChoiceWidget : public QWidget
{
  Q_OBJECT
public:
  /**
   * @brief Constructor
   */
  explicit OrientationChoiceWidget(QWidget *parent);

  /**
   * Set orientation according to ise::RunLengthExtractor::Orientation
   */
  void setOrientation(ise::RunLengthExtractor::Orientation ori);

  /**
   * Get orientation according to ise::RunLengthExtractor::Orientation
   */
  ise::RunLengthExtractor::Orientation getOrientation() const;

signals:

  void orientationChanged(int orientation);

protected slots:

  void changeOrientation(int orientation);

protected:

  void build();

protected:
  QComboBox *m_orientationCombo;

};

#endif /* ORIENTATIONCHOICEWIDGET_HPP_ */
