/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef PYRAMIDFACTORY_HPP
#define PYRAMIDFACTORY_HPP

#include <girl/girlSharedPtr.hpp>
#include <girl/girlCommon.hpp>//GIRL_API

class PyramidWidget;
#include "PyramidSettingsInterface.hpp"
class QWidget;
class MainView;

namespace ise {
  class Pyramid;
}

class SettingsInterface;

class GIRL_API PyramidFactory
{
public:

  virtual ~PyramidFactory() {}
  
  virtual girl::shared_ptr<ise::Pyramid> getNewPyramid() = 0;

  virtual PyramidWidget *parameterWidget(MainView *mainView, int numLevel, int divider, QWidget *parent = NULL) = 0;
  
  //virtual void saveParameters(const girl::shared_ptr<ise::Pyramid>& sd) = 0;
  virtual girl::shared_ptr<PyramidSettingsInterface> settings() = 0;
};

#endif /* ! PYRAMIDFACTORY_HPP */
