#ifndef QISEPLUGINDEPENDANCESSOLVER_HPP
#define QISEPLUGINDEPENDANCESSOLVER_HPP

#include <QList>
#include <QVector>

#include "QIsePlugin.hpp"

#include "QIsePluginList.hpp"

class GIRL_API QIsePluginDependancesSolver {
  
public:
  
  QIsePluginDependancesSolver() : m_pluginsLists() {}
  
  inline void addPluginList(QIsePluginList<QIsePlugin *> *pluginsList)
  {m_pluginsLists.push_back(pluginsList);}
  
  void resolveDependances(QList<std::pair<plugin_status, QString> > &logMessages);

private:
  /*
  QList<const QIsePlugin *> getBestPlugins(QVector<QList<const QIsePlugin *> > lists) const;

  void tryToAdd(int index,
		QVector<QList<const QIsePlugin *> > lists,
		QList<QList<const QIsePlugin *> > &results,
		QList<const QIsePlugin *> inBuilding = QList<const QIsePlugin *>()) const;
  
  bool areCompatible(const QList<const QIsePlugin *> &plugins1,
		     const QList<const QIsePlugin *> &plugins2) const;
  */
  void fillMap(const QList<const QIsePlugin*> &list,
	       QMap<QString, QList<const QIsePlugin *> > &map) const;
  
  void fillMap(QMap<QString, QList<const QIsePlugin *> > &map) const;
  
  /*
  bool mergeWith(QList<const QIsePlugin *> &dest,
		 const QList<const QIsePlugin *> &pluginsToAdd) const;
  
  const QList<const QIsePlugin *> &compare(const QList<const QIsePlugin *> &plugins1,
					   const QList<const QIsePlugin *> &plugins2) const;
  
  std::pair<int, int> getScore(const QList<const QIsePlugin *> &plugins) const;

  QList<const QIsePlugin *> dependancesList(const QIsePlugin *plugin) const;
  */
  
  bool dependancesAreSatisfies(const QIsePlugin *plugin,
			       QList<std::pair<plugin_status, QString> > &logMessages,
			       QList<const QIsePlugin *> parents = QList<const QIsePlugin *>()) const;
  
  //bool isLoadable(const QIsePlugin *plugin) const;
  
private:
  
  QVector<QIsePluginList<QIsePlugin *> *> m_pluginsLists;
  
};

#endif /* ! QISEPLUGINDEPENDANCESSOLVER_HPP */
