#ifndef QISEPLUGINLOADER_HPP
#define QISEPLUGINLOADER_HPP

#include <QList>
#include <QString>

class QIsePlugin;

class QDir;

typedef enum{
  LOADED = 0,
  DEPRECATED = 1,
  DEPENDANCES_UNSATISFIED = 2,
  CONFLICT = 3,
  UNLOADABLE = 4
} plugin_status;

template<class T> // T is a QIsePlugin *
class QIsePluginList : public QList<T> {
  
public:
  
  QIsePluginList() {}
  
  QIsePluginList(const QDir & pluginsDir,
		 QList<std::pair<plugin_status, QString> >& logMessages,
		 bool resolveVersion);
  
  void load(const QDir & pluginDir,
	    QList<std::pair<plugin_status, QString> >& logMessages,
	    bool resolveVersion);

  void resolveVersioning(QList<std::pair<plugin_status, QString> >& logMessages);
  
  QIsePluginList<QIsePlugin *> getGenericList();
  
  void importGenericList(QIsePluginList<QIsePlugin *>);

private:

};

#include "QIsePluginList.hxx"

#endif /* ! PLUGINLOADER_HPP */
