#ifndef QISEVERSION_HPP
#define QISEVERSION_HPP

#include <girl/girlCommon.hpp>//GIRL_API

#include <QMetaType>


class GIRL_API QIseVersion
{
  
public:

  QIseVersion(unsigned int major = 0,
	      unsigned int minor = 0,
	      unsigned int micro = 0)
    :  m_major(major),
       m_minor(minor),
       m_micro(micro) {}
  
  inline unsigned int major() const {return m_major;}
  inline unsigned int minor() const {return m_minor;}
  inline unsigned int micro() const {return m_micro;}
  
  inline unsigned int setMajor(unsigned int major) {return m_major = major;}
  inline unsigned int setMinor(unsigned int minor) {return m_minor = minor;}
  inline unsigned int setMicro(unsigned int micro) {return m_micro = micro;}
  
  bool operator<(const QIseVersion &v) const;
  bool operator<=(const QIseVersion &v) const;
  bool operator>(const QIseVersion &v) const;
  bool operator>=(const QIseVersion &v) const;
  bool operator!=(const QIseVersion &v) const;
  bool operator==(const QIseVersion &v) const;
  
private:
  
  unsigned int m_major;
  unsigned int m_minor;
  unsigned int m_micro;
  
};

static const QIseVersion QISE_VERSION = QIseVersion(1);

Q_DECLARE_METATYPE(QIseVersion)

#endif /* ! QISEVERSION_HPP */
