#ifndef QUANTIFICATIONTHRESHOLDERPLUGIN_HPP
#define QUANTIFICATIONTHRESHOLDERPLUGIN_HPP

#include "QIsePlugin.hpp"

#include <QString>

#include <ise/iseQuantificationThresholder.hpp>

#include <qiseTools/QuantificationThresholderFactory.hpp>

class GIRL_API QuantificationThresholderPlugin : public QIsePlugin,
						 public QuantificationThresholderFactory
{
  
public:
  
  virtual ~QuantificationThresholderPlugin()
  {}
  
  virtual girl::shared_ptr<ise::QuantificationThresholder> getNewQuantificationThresholder() = 0;
  
  inline void setSegContext(ise::SegmentationContext *segContext)
  {
    m_segContext = segContext;
  }
  
  virtual bool hasSettings() const
  {
    return false;
  }


protected:
  
  QuantificationThresholderPlugin(const QString &name,
				  const QIseVersion &pluginVersion,
				  const QIseVersion &qiseVersion,
				  QString path = QString::fromUtf8(""))
    : QIsePlugin(name, (QString::fromUtf8("QuantificationThresholder/") + path),
		 pluginVersion, qiseVersion)
    , m_segContext(NULL)
  {}
  
private:
  
  QuantificationThresholderPlugin();

protected:

  ise::SegmentationContext *m_segContext;
};

#define QuantificationThresholderPlugin_iid "org.girl.qise.QuantificationThresholderPlugin/1.0"
Q_DECLARE_INTERFACE(QuantificationThresholderPlugin, QuantificationThresholderPlugin_iid)

#endif /* ! QUANTIFICATIONTHRESHOLDERPLUGIN_HPP */
