/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef QUANTIFICATIONTHRESHOLDSWIDGET_HPP
#define QUANTIFICATIONTHRESHOLDSWIDGET_HPP

#include <vector>
#include <girl/girlCommon.hpp>


#include "SegmentationClusteringWidgetInterface.hpp"


class QuantificationThresholdsWidgetAux;

class MainView;
class SegmentationClusteringPlugin;


class GIRL_API QuantificationThresholdsWidget : public SegmentationClusteringWidgetInterface
{
  Q_OBJECT

public:

  /**
   * @brief Destructor.
   */
  ~QuantificationThresholdsWidget();

  /**
   * @brief Constructor.
   */
  QuantificationThresholdsWidget(MainView *v, 
				 SegmentationClusteringPlugin *segmentationClustering,
				 QWidget *parent = NULL);


  void setParameters(int colorSpaceConversion, 
		     int channel,
		     const std::vector<int> &thresholds);

  void getParameters(int &colorSpaceConversion, 
		     int &channel,
		     std::vector<int> &thresholds) const;

  void setParameters(int colorSpaceConversion, 
		     const std::vector< std::vector<int> > &thresholds);
					      
  void getParameters(int &colorSpaceConversion, 
		     std::vector< std::vector<int> > &thresholds) const;


  void activate();
  void deactivate();

protected:
  
  void buildGUI();

protected:

  QuantificationThresholdsWidgetAux *m_qtwa;
};

#endif /* ! QUANTIFICATIONTHRESHOLDSWIDGET_HPP */
