/*
  Copyright (C) 2010-2011 Cédric Aguerre  aguerre@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef RECTANGLESELECTOR_HPP
#define RECTANGLESELECTOR_HPP


#include <qiseTools/ShapeSelector.hpp>

class SegView;

class GIRL_API RectangleSelector : public ShapeSelector
{

public:

  explicit RectangleSelector(SegView *v);

  ~RectangleSelector();

  virtual void addPoint(const QPointF &ptf);

  // return true is selector is modified
  virtual bool visit(const QPointF &ptf);

  virtual void update(const QPointF &ptf);

  // return true is selection has changed
  virtual bool finalize(SelectorModifier modifier);

  // return true if abort() has an effect (something changes)
  virtual bool abort();

  // return true if terminate() has an effect (something changes)
  virtual bool terminate(SelectorModifier modifier, bool closedRegion);

  virtual void getSegments(std::vector<std::vector<girl::point> > &segments, girl::tools::AABBox &shapeBBox);

  void setPoints(const QPointF &p1, const QPointF &p2);

  void getPoints(QPointF &p1, QPointF &p2) const;

protected:

  void updateDraw();

protected:

  QPointF m_p1, m_p2;
};


#endif //RECTANGLESELECTOR_HPP
