/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#include "RegionBinaryFunctionWithRegSetSettings.hpp"

#include <cassert>
#include <ise/iseRegionBinaryFunctionWithRegSet.hpp>
#include "RegionBinaryFunctionWithRegSetWidget.hpp"

void
RegionBinaryFunctionWithRegSetSettings::configureWidget(RegionBinaryFunctionWidget *w) const
{
  RegionBinaryFunctionWithRegSetWidget *widget =
      static_cast<RegionBinaryFunctionWithRegSetWidget *>(w);
  assert(widget);
  widget->setParameters(m_regSet);

}

void
RegionBinaryFunctionWithRegSetSettings::getWidgetConfig(const RegionBinaryFunctionWidget *w)
{
  const RegionBinaryFunctionWithRegSetWidget *widget =
      static_cast<const RegionBinaryFunctionWithRegSetWidget *>(w);
  assert(widget);
  widget->getParameters(m_regSet);

}

void
RegionBinaryFunctionWithRegSetSettings::configureAlgo(girl::shared_ptr<ise::RegionBinaryFunction> r) const
{
  girl::shared_ptr<ise::RegionBinaryFunctionWithRegSet> regSet =
      girl::static_pointer_cast<ise::RegionBinaryFunctionWithRegSet>(r);

  assert(regSet);
  regSet->setRegSet(m_regSet);

}

girl::shared_ptr<RegionBinaryFunctionSettings> 
RegionBinaryFunctionWithRegSetSettings::clone() const
{
  girl::shared_ptr<RegionBinaryFunctionWithRegSetSettings> p(new RegionBinaryFunctionWithRegSetSettings);

  *p = *this;

  return p;
}

bool
RegionBinaryFunctionWithRegSetSettings::isValid() const
{
  return (m_regSet != girl::shared_ptr<ise::RegionSetInterface>() );
}
