/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef REGIONBINARYFUNCTIONWITHREGSETSETTINGS_HPP_
#define REGIONBINARYFUNCTIONWITHREGSETSETTINGS_HPP_

#include <girl/girlCommon.hpp>
#include <girl/girlSharedPtr.hpp>

#include "RegionBinaryFunctionPlugin.hpp" // for RegionBinaryFunctionSettings

namespace ise
{
  class RegionBinaryFunction;
  class RegionSetInterface;
}

class RegionBinaryFunctionWidget;
/**
 * Common settings to all region binary function with reg set
 * The settings store the region set
 */
class GIRL_API RegionBinaryFunctionWithRegSetSettings : public RegionBinaryFunctionSettings
{
public:

  virtual void configureWidget(RegionBinaryFunctionWidget *) const;

  virtual void getWidgetConfig(const RegionBinaryFunctionWidget *);

  virtual void configureAlgo(girl::shared_ptr<ise::RegionBinaryFunction>) const;

  virtual girl::shared_ptr<RegionBinaryFunctionSettings> clone() const;

  virtual bool isValid() const;

protected:

  girl::shared_ptr<ise::RegionSetInterface> m_regSet;
};

#endif /* REGIONBINARYFUNCTIONWITHREGSETSETTINGS_HPP_ */
