/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
/*
 * RegionBinaryFunctionWithRegSetWeightWidget.cpp
 *
 *  Created on: Jan 4, 2011
 *      Author: vieux
 */

#include "RegionBinaryFunctionWithRegSetWeightWidget.hpp"

#include <QVBoxLayout>

RegionBinaryFunctionWithRegSetWeightWidget::RegionBinaryFunctionWithRegSetWeightWidget(MainView *mainView/*ise::SegmentationContext *segContext*/,
										     QWidget *parent)
  : RegionBinaryFunctionWithRegSetWidget(mainView/*segContext*/, parent),
  m_weights(NULL)
{
  buildGUI();
}

RegionBinaryFunctionWithRegSetWeightWidget::~RegionBinaryFunctionWithRegSetWeightWidget()
{
}

void
RegionBinaryFunctionWithRegSetWeightWidget::buildGUI()
{
  m_weights = new WeightsSetupWidget(this);
  m_mainLayout->addWidget(m_weights);
  connect(m_combo, SIGNAL(currentIndexChanged(int)), this, SLOT(changeRegionSet(int)));

  const int index = m_combo->currentIndex();
  if (index != -1) {
    m_weights->show();
    changeRegionSet(index);
  }
  else {
    m_weights->hide();
  }
}

void
RegionBinaryFunctionWithRegSetWeightWidget::changeRegionSet(int)
{
  girl::shared_ptr<ise::RegionSetInterface> regSet;
  assert(m_combo);
  //m_combo->getGUI(regSet);
  regSet = girl::static_pointer_cast<ise::RegionSetInterface>(m_combo->regionFeatureComputerPtr());
  assert(m_weights);
  m_weights->setRegionSet(regSet);
}
