/*
 * RegionBinaryFunctionWithRegSetWidget.hpp
 *
 *  Created on: Dec 14, 2010
 *      Author: vieux
 */

#ifndef REGIONBINARYFUNCTIONWITHREGSETWIDGET_HPP_
#define REGIONBINARYFUNCTIONWITHREGSETWIDGET_HPP_

#include <cassert>
#include <girl/girlSharedPtr.hpp>

#include "RegionBinaryFunctionWidget.hpp"
//#include "RegionSetInterfaceChoiceCombo.hpp"
#include "RegionFeatureChoiceComboWidget.hpp"
#include "MainView.hpp"

namespace ise
{
  class SegmentationContext;
}

class QVBoxLayout;
class QWidget;

/**
 * Widget for all Region Binary Functions which yields a region set
 */
class GIRL_API RegionBinaryFunctionWithRegSetWidget : public RegionBinaryFunctionWidget
{
public:

  RegionBinaryFunctionWithRegSetWidget(MainView *mainView/*ise::SegmentationContext *segContext*/, QWidget *parent);

  virtual
  ~RegionBinaryFunctionWithRegSetWidget();

  void
  buildGUI();

  inline void
  setParameters(const girl::shared_ptr<ise::RegionSetInterface>& regSet)
  {
    assert(m_combo);
    //m_combo->setGUI(regSet);
    m_combo->setRegionFeatureComputerPtr(girl::static_pointer_cast<ise::FeatureComputer>(regSet));
  }

  inline void
  getParameters(girl::shared_ptr<ise::RegionSetInterface>& regSet) const
  {
    assert(m_combo);
    regSet = girl::static_pointer_cast<ise::RegionSetInterface>(m_combo->regionFeatureComputerPtr());
    //m_combo->getGUI(regSet);
  }

protected:

  //ise::SegmentationContext *m_segContext;
  MainView *m_mainView;

  QVBoxLayout *m_mainLayout;

  RegionFeatureChoiceComboWidget *m_combo;
};

#endif /* REGIONBINARYFUNCTIONWITHREGSETWIDGET_HPP_ */
