/*
  Copyright (C) 2010-2011 Remi Vieux  remi.vieux@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include "RegionFeatureChoiceDialog.hpp"
#include "MainView.hpp"

#include <QVBoxLayout>
#include <QDialogButtonBox>
#include <QString>
#include <QLabel>
#include <QGroupBox>

RegionFeatureChoiceDialog::RegionFeatureChoiceDialog(MainView *mainView, QWidget *parent)
  : QDialog(parent)
  , m_rflmpw(NULL)
  , m_mainView(mainView)
{
  setWindowTitle(tr("Region Features choices"));

  buildGUI();
}

void
RegionFeatureChoiceDialog::buildGUI()
{
  QVBoxLayout *layout = new QVBoxLayout;
  layout->setAlignment(Qt::AlignTop);

  m_rflmpw = new RegionFeatureListMultiPluginWidget(m_mainView, tr("Region Features"), this);

  layout->addWidget(m_rflmpw);

  QDialogButtonBox *buttonBox = new QDialogButtonBox(QDialogButtonBox::Ok
                                                     | QDialogButtonBox::Cancel, Qt::Horizontal, this);

  connect(buttonBox, SIGNAL(accepted()), this, SLOT(accept()));
  connect(buttonBox, SIGNAL(rejected()), this, SLOT(reject()));
  layout->addWidget(buttonBox);

  setLayout(layout);
}

void
RegionFeatureChoiceDialog::accept()
{

  //m_rflmpw->setSegContext(m_mainView->model()->getSegContextPtr());
  m_rflmpw->compute();
  QDialog::accept();
}

void
RegionFeatureChoiceDialog::reject()
{
  QDialog::reject();
}

// void
// RegionFeatureChoiceDialog::addData(RegionFeatureDataPtr data)
// {
//   m_datas.push_back(data);
// }

// void
// RegionFeatureChoiceDialog::controlExistTitle(const std::string &title)
// {
//   size_t size = m_datas.size();
//   for (size_t i = 0 ; i < size ; ++i) {
//     if (m_datas[i]->setting()->title() == title)
//       return true;
//   }
//   return false;
// }
