/*
 * RegionFeatureClustererWidget.hpp
 *
 *  Created on: Apr 15, 2011
 *      Author: vieux
 */

#ifndef REGIONFEATURECLUSTERERWIDGET_HPP_
#define REGIONFEATURECLUSTERERWIDGET_HPP_


#include <girl/girlCommon.hpp>
#include <girl/girlSharedPtr.hpp>


namespace ise {
  class RegionSetInterface;
  class Clusterer;
}

class ClustererWidgetInterface;
class MainView;
class PluginIndexChoiceWidget;
class WeightsSetupWidget;

#include <QWidget>
#include <QVBoxLayout>
#include <QList>


/**
 * Widget to choose region features to cluster
 */
class GIRL_API RegionFeatureClustererWidget : public QWidget
{

  Q_OBJECT

public:
  RegionFeatureClustererWidget(MainView *mainView,
      QWidget *parent = NULL);

  virtual
  ~RegionFeatureClustererWidget();


  void
  getParameters(std::vector<girl::shared_ptr<ise::RegionSetInterface> > &regSets,
      std::vector<bool> &mask,
      girl::shared_ptr<ise::Clusterer> &clusterer);


  protected slots:

  void showWidget(int);

protected:

  void buildGUI();

protected:

  MainView *m_mainView;

  PluginIndexChoiceWidget *m_clustererCombo;

  ClustererWidgetInterface *m_clustererWidget;

  QVBoxLayout *m_clustererLayout;
  QVBoxLayout *m_weightsLayout;
  QVBoxLayout *m_mainLayout;

  QList<WeightsSetupWidget*> m_weights;


};

#endif /* REGIONFEATURECLUSTERERWIDGET_HPP_ */
