/*
  Copyright (C) 2010-2011 Remi Vieux  remi.vieux@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef REGIONFEATURECOLORIMETRICMOMENTSDIALOG_HPP_
#define REGIONFEATURECOLORIMETRICMOMENTSDIALOG_HPP_

#include <ise/iseRegionFeatureColorimetricMoment.hpp>

#include "RegionFeatureComputerDialog.hpp"
#include "ColorSpaceChoiceWidget.hpp"

class GIRL_API RegionFeatureColorimetricMomentsDialog : public RegionFeatureComputerDialog
{
  Q_OBJECT

public:
  RegionFeatureColorimetricMomentsDialog(ise::SegmentationContext *segContext,
      QString name,
      girl::shared_ptr<ise::RegionFeatureComputer> featureComputer,
      QWidget *parent)
  : RegionFeatureComputerDialog(segContext, name, parent),
    m_featureComputer(girl::static_pointer_cast<ise::RegionFeatureColorimetricMoment>(featureComputer)),
    m_csw(NULL)
  {
    build();
    setGui();
  }

  virtual
  ~RegionFeatureColorimetricMomentsDialog() {}


  void build();

  virtual void setGui()
  {
    assert(m_featureComputer);
    assert(m_csw);
    int colorSpace;
    m_featureComputer->getParameters(colorSpace);
    m_csw->setColorSpace(colorSpace);
  }

  virtual void getGui()
  {
    assert(m_featureComputer);
    assert(m_csw);
    m_featureComputer->setParameters(m_csw->getColorSpace());
  }

  inline girl::shared_ptr<ise::RegionFeatureComputer>  getFeatureComputer() const { return m_featureComputer; }

private:

  girl::shared_ptr<ise::RegionFeatureColorimetricMoment> m_featureComputer;

  ColorSpaceChoiceWidget *m_csw;

};

#endif /* REGIONFEATURECOLORIMETRICMOMENTSDIALOG_HPP_ */
