/*
  Copyright (C) 2010-2011 Remi Vieux  remi.vieux@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef REGIONFEATURECOMPUTERDIALOG_HPP_
#define REGIONFEATURECOMPUTERDIALOG_HPP_

#include <ise/iseRegionFeatureComputer.hpp>
#include <ise/iseSegmentationContext.hpp>

#include <QDialog>
#include <QWidget>
#include <QString>

class GIRL_API RegionFeatureComputerDialog : public QDialog
{
  Q_OBJECT

public:

  RegionFeatureComputerDialog(ise::SegmentationContext *segContext, QString name, QWidget *parent = NULL)
  : QDialog(parent),
    m_segContext(segContext),
    m_name(name)
  {}

  virtual ~RegionFeatureComputerDialog() {}

  virtual void setGui() = 0;

  virtual void getGui() = 0;

  virtual girl::shared_ptr<ise::RegionFeatureComputer> getFeatureComputer() const = 0;

  QString name() const { return m_name; }

protected:

  virtual void build() = 0;

protected:

  ise::SegmentationContext *m_segContext;
  QString m_name;
};

#endif /* REGIONFEATURECOMPUTERDIALOG_HPP_ */
