/*
  Copyright (C) 2010-2011 Remi Vieux  remi.vieux@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef REGIONFEATURECOMPUTERFACTORY_HPP_
#define REGIONFEATURECOMPUTERFACTORY_HPP_

#include <girl/girlCommon.hpp>
#include <girl/girlSharedPtr.hpp>

namespace ise {
  class RegionFeatureComputer;
  class SegmentationContext;
}

class MainView;
class RegionFeatureComputerDialog;

class GIRL_API RegionFeatureComputerFactory {

public:

  virtual girl::shared_ptr<ise::RegionFeatureComputer> getNewRegionFeatureComputer() = 0;

  virtual void saveParameters(const girl::shared_ptr<ise::RegionFeatureComputer> &sd) = 0;

  virtual RegionFeatureComputerDialog* parameterWidget(ise::SegmentationContext *segContext, QWidget *parent = NULL) = 0;

  virtual void setSegContext(ise::SegmentationContext *segContext) = 0;

};

#endif /* REGIONFEATURECOMPUTERFACTORY_HPP_ */
