/*
  Copyright (C) 2010-2011 Remi Vieux  remi.vieux@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef REGIONFEATURECOMPUTERPLUGIN_HPP_
#define REGIONFEATURECOMPUTERPLUGIN_HPP_

#include "QIsePlugin.hpp"

#include <ise/iseRegionFeatureComputer.hpp>

#include <qiseTools/RegionFeatureComputerDialog.hpp>
#include <qiseTools/RegionFeatureComputerFactory.hpp>

class GIRL_API RegionFeatureComputerPlugin : public QIsePlugin,
                                             public RegionFeatureComputerFactory
{

public:
  virtual ~RegionFeatureComputerPlugin() {}

  virtual girl::shared_ptr<ise::RegionFeatureComputer> getNewRegionFeatureComputer() = 0;

  virtual void saveParameters(const girl::shared_ptr<ise::RegionFeatureComputer> &sa) = 0;

  virtual RegionFeatureComputerDialog* parameterWidget(ise::SegmentationContext *segContext, QWidget *parent) = 0;

  inline void setSegContext(ise::SegmentationContext *sc) { m_segContext = sc; }

 // inline int getIseImageFeature ??

protected:

  RegionFeatureComputerPlugin(const QString &name,
                              const QIseVersion &pluginVersion,
                              const QIseVersion &qiseVersion,
                              QString path = QString::fromUtf8(""))
  : QIsePlugin(name,
      (QString::fromUtf8("RegionFeatureComputer/") + path),
      pluginVersion,
      qiseVersion),
      m_segContext(NULL)
  {}

private:
  RegionFeatureComputerPlugin();

protected:
  ise::SegmentationContext *m_segContext;

};

#define RegionFeatureComputerPlugin_iid "org.girl.qise.RegionFeatureComputerPlugin/1.0"
Q_DECLARE_INTERFACE(RegionFeatureComputerPlugin, RegionFeatureComputerPlugin_iid)

#endif /* REGIONFEATURECOMPUTERPLUGIN_HPP_ */
