/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

 */

#include "PluginRegistry.hpp"
#include "RegionFeatureComputerTabWidget.hpp"
#include "RegionFeatureWidget.hpp"

#include <QVBoxLayout>

RegionFeatureComputerTabWidget::RegionFeatureComputerTabWidget(MainView *mainView,
							       FeatureComputerGUIInfoPtr featureComputerGUIInfo,
							       QString name,
							       QWidget *parent)
  : FeatureComputerTabWidget(mainView, featureComputerGUIInfo, name, parent)
{
  setAttribute(Qt::WA_DeleteOnClose);

  buildGUI();

  initWidget();
}

void
RegionFeatureComputerTabWidget::buildGUI()
{
  QVBoxLayout *featuresLayout = new QVBoxLayout;
  featuresLayout->setAlignment(Qt::AlignTop);

  m_widget = new RegionFeatureWidget(m_mainView, m_featureComputerGUIInfo, "RegionFeature", this);

  addWidget(m_widget);
  featuresLayout->addWidget(m_widget);

  setLayout(featuresLayout);

  setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
}

void
RegionFeatureComputerTabWidget::initWidget()
{
  m_widget->initWidget();
}
