/*
  Copyright (C) 2010-2011 Remi Vieux  remi.vieux@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

 */

#ifndef REGIONFEATURECONTEXTUALDIALOG_HPP_
#define REGIONFEATURECONTEXTUALDIALOG_HPP_

#include <girl/girlCommon.hpp>

#include <ise/iseRegionFeatureNeighbourhoodContext.hpp>

#include "RegionFeatureComputerDialog.hpp"

class SliderSpinBoxWidget;

/**
 * Class to set parameters of the FeatureComputer iseRegionFeatureNeighbourhoodContext
 *
 */
class GIRL_API RegionFeatureContextualDialog : public RegionFeatureComputerDialog
{

  Q_OBJECT

public:
  RegionFeatureContextualDialog(ise::SegmentationContext *segContext,
      QString name,
      girl::shared_ptr<ise::RegionFeatureComputer> featureComputer,
      QWidget *parent = NULL) :
        RegionFeatureComputerDialog(segContext, name, parent),
        m_featureComputer(girl::static_pointer_cast<ise::RegionFeatureNeighbourhoodContext>(featureComputer))
  {
  //  setWindowTitle(tr("Contextual Features parameters..."));
    build();
    setGui();
  }

  virtual
  ~RegionFeatureContextualDialog() {}


  virtual void
  setGui();

  virtual void
  getGui();

  virtual inline
  girl::shared_ptr<ise::RegionFeatureComputer> getFeatureComputer() const
  {
    return m_featureComputer;
  }


protected:

  virtual void
  build();

private:
  girl::shared_ptr<ise::RegionFeatureNeighbourhoodContext> m_featureComputer;

  SliderSpinBoxWidget *m_numBinsSlider;
  SliderSpinBoxWidget *m_startAngleSlider;


};

#endif /* REGIONFEATURECONTEXTUALDIALOG_HPP_ */
