/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef REGIONFEATURELISTMULTIPLUGINWIDGET_HPP
#define REGIONFEATURELISTMULTIPLUGINWIDGET_HPP

#include <girl/girlHashFunc.hpp>
#include <girl/girlHashMap.hpp>

#include <QHBoxLayout>
#include <QLabel>
#include <QListWidget>
#include <QPushButton>
#include <QString>

#include <ise/iseSegmentationContext.hpp>
#include "RegionFeatureDialog.hpp"
#include "FeatureData.hpp"
#include "MainView.hpp"

#include "RegionFeatureListPluginWidget.hpp"
#include "RegionSetInterfacePlugin.hpp"

#include <map>

class RegionFeatureListMultiPluginSettings;

class GIRL_API RegionFeatureListMultiPluginWidget : public RegionFeatureListPluginWidget
{
  //Q_OBJECT

 public:

  virtual ~RegionFeatureListMultiPluginWidget() {}

  virtual void loadPlugins();

 protected:

  virtual void build();
	   
 private:

  virtual RegionFeatureDialog * newCurrentDialog(RegionFeatureDataPtr&);

 protected:
  
  RegionFeatureListMultiPluginWidget(MainView *mainView = NULL,
				    QString name = tr(""),
				    QWidget *parent = NULL);


  QListWidget *m_list;

  typedef girl::hashMap<size_t, RegionSetInterfacePlugin*> PluginContainer;
  PluginContainer m_plugins;

};

#endif /* ! REGIONFEATURELISTMULTIPLUGINWIDGET_HPP */
