/*
  Copyright (C) 2010-2011 Remi Vieux  remi.vieux@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef REGIONFEATUREWIDGET_HPP
#define REGIONFEATUREWIDGET_HPP

#include <ise/iseRegionSetInterface.hpp>

class GIRL_API RegionFeatureWidget : public FeatureListMultiPluginWidget
{
 public:

  RegionFeatureWidget(MainView *mainView,
		      FeatureComputerGUIInfoPtr featureComputerGUIInfo, 
		      QString name,
		      QWidget *parent)
    : FeatureListMultiPluginWidget(mainView, featureComputerGUIInfo, name, parent)
    {
      loadPlugins();
    }

  virtual void loadPlugins()
  {
    QIsePluginList<RegionSetInterfacePlugin*>::iterator it = PluginRegistry::getRegionSetPlugin().begin();
    QIsePluginList<RegionSetInterfacePlugin*>::const_iterator itEnd = PluginRegistry::getRegionSetPlugin().end();
    for (/*size_t i = 0*/ ; it != itEnd ; ++it/*, ++i*/) {
      addPlugin(static_cast<FeaturePlugin*>(*it));
      // QListWidgetItem *item = new QListWidgetItem((*it)->name());
      // m_list->addItem(item);

      // std::pair<PluginContainer::iterator, bool> insertOk = m_plugins.insert(std::make_pair(i, *it));
      // assert(insertOk.second);
    }
  }

  virtual void getFeatureInfos(std::vector<FeatureDataPtr> &infos) const {
    m_featureComputerGUIInfo->getFeatureComputersInfo<ise::RegionSetInterface>(infos);
  }
};

#endif /* REGIONFEATUREWIDGET_HPP_ */
