/*
 * RegionSetInterfaceChoiceCombo.hpp
 *
 *  Created on: Dec 14, 2010
 *      Author: vieux
 */

#ifndef REGIONSETINTERFACECHOICECOMBO_HPP_
#define REGIONSETINTERFACECHOICECOMBO_HPP_

#include <girl/girlCommon.hpp>
#include <girl/girlSharedPtr.hpp>

#include <QWidget>


namespace ise
{
  class RegionSetInterface;
  class SegmentationContext;
}

class QComboBox;

/**
 * Choose from the available RegionSet registered in the Segmentation
 * context using a ComboBox
 */
class GIRL_API RegionSetInterfaceChoiceCombo : public QWidget
{
  Q_OBJECT

public:

  RegionSetInterfaceChoiceCombo(ise::SegmentationContext *segContext, QWidget *parent);

  virtual ~RegionSetInterfaceChoiceCombo();


  void
  getGUI(girl::shared_ptr<ise::RegionSetInterface>&) const;

  void
  setGUI(const girl::shared_ptr<ise::RegionSetInterface>);


  int currentIndex() const;

 signals:
  
  void currentIndexChanged(int);

protected:
  void
  buildGUI();


private:

  ise::SegmentationContext *m_segContext;
  QComboBox *m_combo;

};

#endif /* REGIONSETINTERFACECHOICECOMBO_HPP_ */
