/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
#include "RegionSetInterfaceMomentChoiceWidget.hpp"

#include <cassert>

#include <ise/iseSegmentationContext.hpp>
#include <ise/iseRegionSetInterfaceMoments.hpp>

#include <QComboBox>


RegionSetInterfaceMomentChoiceWidget::RegionSetInterfaceMomentChoiceWidget(ise::SegmentationContext* segContext,
    QWidget *parent)
 : RessourceByUriChoiceWidget(segContext, tr("Moment"), parent)
{
}

RegionSetInterfaceMomentChoiceWidget::~RegionSetInterfaceMomentChoiceWidget()
{
  // TODO Auto-generated destructor stub
}

void
RegionSetInterfaceMomentChoiceWidget::selectRessources()
{
  assert(m_segContext);
  ise::FeatureComputer::FeatureComputerListType uris;
  m_segContext->getRegionSetUris(uris);
  ise::FeatureComputer::FeatureComputerListType::const_iterator it = uris.begin();
  const ise::FeatureComputer::FeatureComputerListType::const_iterator itEnd = uris.end();
  for ( ; it != itEnd; ++it) {
    const girl::shared_ptr<ise::RegionSetInterface> regSet =
        m_segContext->getRegionSet(*it);

    const girl::shared_ptr<ise::RegionSetInterfaceMoments> momentRegSet =
        girl::static_pointer_cast<ise::RegionSetInterfaceMoments>(regSet);
    if (momentRegSet) {
      m_combo->addItem(it->c_str());
    }
  }
}
