/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef REGIONSETINTERFACEPLUGIN_HPP_
#define REGIONSETINTERFACEPLUGIN_HPP_

#include <girl/girlCommon.hpp>

#include "FeaturePlugin.hpp"

/**
 * Interface for all plugins of a RegionSetInterface
 */
class GIRL_API RegionSetInterfacePlugin : public FeaturePlugin
{
public:

  virtual ~RegionSetInterfacePlugin() {}

protected:
  RegionSetInterfacePlugin(const QString& name,
			   const QIseVersion& pluginVersion,
			   const QIseVersion& qiseVersion,
			   QString path = QString::fromUtf8(""))
    : FeaturePlugin(name,
		    pluginVersion,
		    qiseVersion,
		    (QString::fromUtf8("RegionSetInterface/") + path))
    {}
  
};

#define RegionSetInterfacePlugin_iid "org.girl.qise.RegionSetInterfacePlugin/1.0"
Q_DECLARE_INTERFACE(RegionSetInterfacePlugin, RegionSetInterfacePlugin_iid)

#endif /* REGIONSETINTERFACEPLUGIN_HPP_ */
