/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "RegionSetInterfaceSettings.hpp"

#include <ise/iseRegionSetInterface.hpp>

#include "RegionSetInterfaceWidget.hpp"


void
RegionSetInterfaceSettings::configureWidget(RegionSetInterfaceWidget *widget) const
{
  doConfigureWidget(widget);
}

void
RegionSetInterfaceSettings::getWidgetConfig(const RegionSetInterfaceWidget *widget)
{
  doGetWidgetConfig(widget);
}

void
RegionSetInterfaceSettings::configureAlgo(girl::shared_ptr<ise::RegionSetInterface> algo) const
{
  assert(algo);
  doConfigureAlgo(algo);
}
 

girl::shared_ptr<RegionSetInterfaceSettingsBase>
RegionSetInterfaceSettings::clone() const
{
  girl::shared_ptr<RegionSetInterfaceSettings> p = girl::static_pointer_cast<RegionSetInterfaceSettings>( doClone() );

  *p = *this;

  return p;
}

bool
RegionSetInterfaceSettings::isValid() const
{
  bool valid = doIsValid();
  //valid &= (m_segContext != NULL); //B ???
  return valid;
}
