/* 
 * Copyright (C) 2010-2011 Remi Vieux  remi.vieux@labri.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation (Inc., 59
 * Temple Place - Suite 330, Boston, MA 02111-1307, USA); either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef REGIONSETPARAMETERSWIDGET_HPP_
#define REGIONSETPARAMETERSWIDGET_HPP_

#include <girl/girlCommon.hpp>
#include <girl/girlSharedPtr.hpp>

#include <ise/iseRegionSetInterface.hpp>
#include <ise/iseRegionSetParameters.hpp>

#include <QGroupBox>
#include <QList>
#include <QWidget>

class SliderSpinBoxWidget;

/**
 * Class to set up parameters associated to a region set
 */
class GIRL_API RegionSetParametersWidget : public QWidget
{
  Q_OBJECT

public:

  RegionSetParametersWidget(girl::shared_ptr<ise::RegionSetInterface> regSet,
			    ise::RegionSetParameters &params,
			    QWidget *parent = NULL);

  virtual ~RegionSetParametersWidget();

  void setGUI();
  void getGUI();

protected slots:

  void setAll0();
  void setAll1();

protected:

  void buildGUI();

  void setAll(double v);

protected:

  const girl::shared_ptr<ise::RegionSetInterface> m_regSet;
  ise::RegionSetParameters &m_params;

  QList<SliderSpinBoxWidget*> m_sliders;
  QGroupBox *m_groupBox;
};

#endif /* REGIONSETPARAMETERSWIDGET_HPP_ */
