/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef REGIONSTRICTWEAKORDERINGCOMBOWIDGET_HPP
#define REGIONSTRICTWEAKORDERINGCOMBOWIDGET_HPP

#include <QWidget>

#include <ise/iseSegmentationContext.hpp>
#include "MainView.hpp"

class PluginIndexChoiceWidget;
class RegionStrictWeakOrderingPlugin;


/*
 Warning: this structure is duplicated in RegionBinaryFunctionComboWidget.

*/

class GIRL_API RegionStrictWeakOrderingComboWidget : public QWidget
{
  Q_OBJECT

public:

  RegionStrictWeakOrderingComboWidget(MainView *mainView/*ise::SegmentationContext *segContext*/, QWidget *parent = NULL);

  RegionStrictWeakOrderingPlugin *getRegionStrictWeakOrderingPlugin() const;

  void setRegionStrictWeakOrderingPlugin(RegionStrictWeakOrderingPlugin *p);
  
  void setText(const QString &title);

signals:

  void pluginChanged();

protected slots:

  void pluginChangedTo(int);
  
protected:

  void buildGUI();

  void setPlugin(int index);

  void initPlugin();

protected:
  MainView *m_mainView;
  //ise::SegmentationContext *m_segContext;
  PluginIndexChoiceWidget *m_pcw;
  int m_previousIndex;
};

#endif /* ! REGIONSTRICTWEAKORDERINGCOMBOWIDGET_HPP */
