/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef REGIONSTRICTWEAKORDERINGWITHUNARYFUNCTIONSWIDGET_HPP
#define REGIONSTRICTWEAKORDERINGWITHUNARYFUNCTIONSWIDGET_HPP


#include <ise/iseSegmentationContext.hpp>

#include "RegionStrictWeakOrderingWidget.hpp"
#include "RegionUnaryFunctionPlugin.hpp"
#include "MainView.hpp"

class RegionUnaryFunctionComboWidget;
class QGridLayout;
class QLabel;
class QPushButton;

class LineWidget;



class GIRL_API RegionStrictWeakOrderingWithUnaryFunctionsWidget : public RegionStrictWeakOrderingWidget
{
  Q_OBJECT

public:

  RegionStrictWeakOrderingWithUnaryFunctionsWidget(MainView *mainView/*ise::SegmentationContext *segContext*/, 
						   RegionStrictWeakOrderingPlugin *plugin = NULL, 
						   QWidget *parent = NULL);

  typedef std::vector<RegionUnaryFunctionPlugin *> UnaryFctPluginCollection;

  void setRegionUnaryFuntionPlugins(const UnaryFctPluginCollection &plugins);

  void getRegionUnaryFuntionPlugins(UnaryFctPluginCollection &plugins) const;


protected slots:

  void addUnaryFunction();

  void upWidget();
  void downWidget();
  void delWidget();

protected:

  void buildGUI();

  int getLine(LineWidget *lw);
  LineWidget *getLineWidget(int line);
  const LineWidget *getLineWidget(int line) const;
  void swapLines(int line1, int line2);

  void delWidget(int line, LineWidget *lineWidget);
  void delWidget(int line);

protected:

  //ise::SegmentationContext *m_segContext;
  MainView *m_mainView;
  QGridLayout *m_linesLayout;
  int m_rowCount;

};
  
class LineWidget : public QWidget
{
  Q_OBJECT

  public:
  LineWidget(MainView *mainView/*ise::SegmentationContext *segContext*/, QWidget *parent = NULL);

  void setIndex(int index);
    
  RegionUnaryFunctionPlugin *getRegionUnaryFunctionPlugin() const;
    
  void setRegionUnaryFunctionPlugin(RegionUnaryFunctionPlugin *p);

signals:
    
  void upClicked();
  void downClicked();
  void delClicked();

protected:
  QLabel *m_indexLabel;
  QPushButton *m_upButton;
  QPushButton *m_downButton;
  QPushButton *m_delButton;
  RegionUnaryFunctionComboWidget *m_rufcw;
  QGridLayout *m_gLayout;
};

#endif /* ! REGIONSTRICTWEAKORDERINGWITHUNARYFUNCTIONSWIDGET_HPP */
