/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

/*
 * RegionUnaryFunctionWidget.hpp
 *
 *  Created on: Dec 13, 2010
 *      Author: vieux
 */

#ifndef REGIONUNARYFUNCTIONWIDGET_HPP_
#define REGIONUNARYFUNCTIONWIDGET_HPP_

#include <girl/girlCommon.hpp>

#include "RegionUnaryFunctionPlugin.hpp" // ou pas ?

#include <QWidget>

class GIRL_API RegionUnaryFunctionWidget : public QWidget
{

public:

  RegionUnaryFunctionWidget(QWidget *parent) :
    QWidget(parent)
  {}

  virtual void
  buildGUI() = 0;

  void
  getGUI(girl::shared_ptr<RegionUnaryFunctionSettings> settings) const
  {
    assert(settings);
    settings->getWidgetConfig(this);
  }

  void
  setGUI(const girl::shared_ptr<RegionUnaryFunctionSettings> settings)
  {
    assert(settings);
    settings->configureWidget(this);
  }


};

#endif /* REGIONUNARYFUNCTIONWIDGET_HPP_ */
