/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "RegionUnaryFunctionWithRegSetWidget.hpp"


#include <QVBoxLayout>
#include "MainView.hpp"

RegionUnaryFunctionWithRegSetWidget::RegionUnaryFunctionWithRegSetWidget(/*ise::SegmentationContext *segContext*/MainView *mainView, QWidget *parent)
 : RegionUnaryFunctionWidget(parent),
   m_mainView(mainView),
   m_mainLayout(NULL),
   //m_segContext(segContext),
   m_combo(NULL)
{
  buildGUI();
}

RegionUnaryFunctionWithRegSetWidget::~RegionUnaryFunctionWithRegSetWidget()
{

}


void
RegionUnaryFunctionWithRegSetWidget::buildGUI()
{
  assert(m_mainView);
  assert(m_mainView->model());

  m_mainLayout = new QVBoxLayout;
  //m_combo = new RegionSetInterfaceChoiceCombo(m_segContext, this);

  m_combo = new RegionFeatureChoiceComboWidget(m_mainView, m_mainView->model()->getFeatureComputerGUIInfo(), this, true);

  m_mainLayout->addWidget(m_combo);

  setLayout(m_mainLayout);
}

