/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux remi.vieux@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
/*
 * RegionUnaryFunctionWithRegSetWidget.hpp
 *
 *  Created on: Dec 14, 2010
 *      Author: vieux
 */

#ifndef REGIONUNARYFUNCTIONWITHREGSETWIDGET_HPP_
#define REGIONUNARYFUNCTIONWITHREGSETWIDGET_HPP_

#include <cassert>
#include <girl/girlSharedPtr.hpp>

#include "RegionUnaryFunctionWidget.hpp"
//#include "RegionSetInterfaceChoiceCombo.hpp"
#include "RegionFeatureChoiceComboWidget.hpp"

namespace ise
{
  class SegmentationContext;
}

class QWidget;
class QVBoxLayout;
class MainView;
/**
 * Widget for all Region Unary Functions which yields a region set
 */
class GIRL_API RegionUnaryFunctionWithRegSetWidget : public RegionUnaryFunctionWidget
{

public:

  RegionUnaryFunctionWithRegSetWidget(/*ise::SegmentationContext *segContext*/MainView *mainView, QWidget *parent);

  virtual
  ~RegionUnaryFunctionWithRegSetWidget();

  void
  buildGUI();

  inline void
  setParameters(const girl::shared_ptr<ise::RegionSetInterface>& regSet)
  {
    assert(m_combo);
    //m_combo->setGUI(regSet);
    m_combo->setRegionFeatureComputerPtr(girl::static_pointer_cast<ise::FeatureComputer>(regSet));
  }

  inline void
  getParameters(girl::shared_ptr<ise::RegionSetInterface>& regSet) const
  {
    assert(m_combo);
    //m_combo->getGUI(regSet);
    regSet = girl::static_pointer_cast<ise::RegionSetInterface>(m_combo->regionFeatureComputerPtr());
  }

protected:

  MainView *m_mainView;

  QVBoxLayout *m_mainLayout;

  //ise::SegmentationContext *m_segContext;

  RegionFeatureChoiceComboWidget/*RegionSetInterfaceChoiceCombo*/ *m_combo;

};

#endif /* REGIONUNARYFUNCTIONWITHREGSETWIDGET_HPP_ */
