/*
  Copyright (C) 2005-2011 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef REGIONUNARYPREDICATETHRESHOLDWIDGET_HPP_
#define REGIONUNARYPREDICATETHRESHOLDWIDGET_HPP_

#include <qiseTools/RegionUnaryPredicateWidget.hpp>

#include <ise/iseComparisonFunction.hpp>
#include "MainView.hpp"

class ComparisonFunctionWidget;
class QLineEdit;
class RegionUnaryFunctionComboWidget;
class RegionUnaryFunctionPlugin;



class GIRL_API RegionUnaryPredicateThresholdWidget : public RegionUnaryPredicateWidget
{
  Q_OBJECT

public:

  RegionUnaryPredicateThresholdWidget(MainView *mainView,/*ise::SegmentationContext *segContext,*/ 
				      RegionUnaryPredicatePlugin *plugin = NULL, 
				      QWidget *parent = NULL);

  RegionUnaryFunctionPlugin *getRegionUnaryFunctionPlugin() const;

  void setRegionUnaryFunctionPlugin(RegionUnaryFunctionPlugin *p);
  
  ise::ComparisonOperator getComparisonOperator() const;

  void setComparisonOperator(ise::ComparisonOperator c);

  double getThreshold() const;

public slots:

  void setThreshold(double th);


signals:
  
  void pluginChanged();
  void comparisonOperatorChanged();
  void thresholdChanged(double);
    
protected slots:

  void signalThresholdChanged();

protected:

  void buildGUI();

protected:
  //ise::SegmentationContext *m_segContext;
  MainView *m_mainView;
  RegionUnaryFunctionComboWidget *m_rufcw;
  ComparisonFunctionWidget *m_cfw;
  QLineEdit *m_threshold;
  
};


#endif /* ! REGIONUNARYPREDICATETHRESHOLDWIDGET_HPP_ */
