/*
  Copyright (C) 2005-2010 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef REGIONUNARYPREDICATEWIDGET_HPP
#define REGIONUNARYPREDICATEWIDGET_HPP

#include <girl/girlCommon.hpp>//GIRL_API

#include <QWidget>
#include "RegionUnaryPredicateSettings.hpp"

class RegionUnaryPredicatePlugin;


class GIRL_API RegionUnaryPredicateWidget : public QWidget
{

public:

  RegionUnaryPredicateWidget(RegionUnaryPredicatePlugin *plugin = NULL, QWidget *parent = NULL)
    : QWidget(parent),
    m_plugin(plugin)
    {
      
    }
    
  virtual void getGUI(girl::shared_ptr<RegionUnaryPredicateSettings> settings) const
  {
    assert(settings);
    settings->getWidgetConfig(this);
  }

  virtual void setGUI(const girl::shared_ptr<RegionUnaryPredicateSettings> settings)
  {
    assert(settings);
    settings->configureWidget(this);
  }
  
protected:
  RegionUnaryPredicatePlugin *m_plugin;
};
  

#endif /* ! REGIONUNARYPREDICATEWIDGET_HPP */
