/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
/*
 * RessourceByUriChoiceWidget.cpp
 *
 *  Created on: Dec 3, 2010
 *      Author: vieux
 */

#include "RessourceByUriChoiceWidget.hpp"
#include <QComboBox>
#include <QHBoxLayout>
#include <QLabel>

RessourceByUriChoiceWidget::RessourceByUriChoiceWidget(ise::SegmentationContext* segContext, const QString& name, QWidget *parent)
:
QWidget(parent),
m_segContext(segContext),
m_label(NULL),
m_combo(NULL)
{
  build(name);
}

RessourceByUriChoiceWidget::~RessourceByUriChoiceWidget()
{
  // TODO Auto-generated destructor stub
}


void
RessourceByUriChoiceWidget::build(const QString& name)
{
  m_combo = new QComboBox(this);
  m_label = new QLabel(name, this);
  QHBoxLayout *layout = new QHBoxLayout;
  layout->addWidget(m_combo);
  layout->addStretch();
  this->setLayout(layout);

  //connect(m_combo, SIGNAL(currentIndexChanged(QString), this, SLOT(change)))
}

ise::URI
RessourceByUriChoiceWidget::selectedURI() const
{
  return m_combo->itemText(m_combo->currentIndex()).toStdString();
}

void
RessourceByUriChoiceWidget::setSelectedURI(const ise::URI& uri)
{
  m_combo->setCurrentIndex(m_combo->findText(uri.c_str()));
}
