/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

 */
/*
 * RessourceByUriChoiceWidget.hpp
 *
 *  Created on: Dec 3, 2010
 *      Author: vieux
 */

#ifndef RESSOURCEBYURICHOICEWIDGET_HPP_
#define RESSOURCEBYURICHOICEWIDGET_HPP_

#include <girl/girlCommon.hpp>
#include <ise/iseURI.hpp>

#include <QWidget>

namespace ise {
  class SegmentationContext;
}

class QComboBox;
class QLabel;
/**
 * Subclass this class to display a choice of selected ressources which are registered
 * in the segContext by their URI
 */
class GIRL_API RessourceByUriChoiceWidget : public QWidget
{
public:

  virtual
  ~RessourceByUriChoiceWidget();

  void
  setSelectedURI(const ise::URI& uri);

  ise::URI
  selectedURI() const;

protected:

  RessourceByUriChoiceWidget(ise::SegmentationContext* segContext,
      const QString& name,
      QWidget *parent);


  void
  build(const QString& name);

protected:
  /**
   * Subclass this function to apply the selection of ressources that you want to get from
   * the SegContext
   */
  virtual void
  selectRessources() = 0;

protected:

  ise::SegmentationContext *m_segContext;

  QLabel *m_label;

  QComboBox *m_combo;

};

#endif /* RESSOURCEBYURICHOICEWIDGET_HPP_ */
