/*
  Copyright (C) 2005-2009 Jerome Charton, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SCANLINESETCONSTLINESITERATOR_HPP
#define SCANLINESETCONSTLINESITERATOR_HPP

#include <girl/girlPoint.hpp>
#include <vector>
#include <utility> //pair

#include "ScanlineSet.hpp"

class GIRL_API ScanlineSetConstLinesIterator
{
public:

  typedef std::pair<girl::point, girl::point> scanline;


  explicit ScanlineSetConstLinesIterator(const ScanlineSet *scanLineSet)
    : m_scanlineSet(scanLineSet),
      m_lineIndice(static_cast<unsigned int>(-1)) //B: boggus value on purpose
  {
  }

  scanline operator*();
  ScanlineSetConstLinesIterator operator+= (unsigned int n);
  ScanlineSetConstLinesIterator &operator++();
  
  void setBegin();
  void setEnd();

  friend bool GIRL_API operator==(const ScanlineSetConstLinesIterator &it1, const ScanlineSetConstLinesIterator &it2);

  friend bool operator!=(const ScanlineSetConstLinesIterator &it1, const ScanlineSetConstLinesIterator &it2)
  {
    return !(it1 == it2);
  }

protected:
  const ScanlineSet *m_scanlineSet;
  unsigned int m_lineIndice;
  ScanlineSet::line_t::const_iterator m_pairIterator;
};

#endif /*! SCANLINESETCONSTLINESITERATOR_HPP */
