/*
  Copyright (C) 2005-2009 Jerome Charton, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SCANLINESETCONSTPERIMETERITERATOR_HPP
#define SCANLINESETCONSTPERIMETERITERATOR_HPP

#include <girl/girlPoint.hpp>
#include <girl/girlDirection.hpp>
#include <utility> //pair

class ScanlineSet;

class ScanlineSetConstPerimeterIterator
{
public:
  explicit ScanlineSetConstPerimeterIterator(const ScanlineSet *scanLineSet) : m_scanlineSet(scanLineSet) {}
  
  const girl::point &operator*();
  ScanlineSetConstPerimeterIterator &operator+= (unsigned int n);
  ScanlineSetConstPerimeterIterator &operator++();
  
  void setBegin();
  void setEnd();
  
  friend inline bool operator==(const ScanlineSetConstPerimeterIterator &it1, const ScanlineSetConstPerimeterIterator &it2)
  {
    return it1.m_currentPoint == it2.m_currentPoint;
  }
  
  friend inline bool operator!=(const ScanlineSetConstPerimeterIterator &it1, const ScanlineSetConstPerimeterIterator &it2)
  {
    return it1.m_currentPoint != it2.m_currentPoint;
  }
  
protected:
  const ScanlineSet *m_scanlineSet;
  girl::point m_currentPoint;

};

#endif /*! SCANLINESETCONSTPERIMETERITERATOR_HPP */
