/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGBINARYRELAXATIONWIDGET_HPP
#define SEGMENTATIONCLUSTERINGBINARYRELAXATIONWIDGET_HPP

#include "SegmentationClusteringWidgetInterface.hpp"

class SegmentationClusteringPlugin;
class SliderSpinBoxWidget;

class GIRL_API SegmentationClusteringBinaryRelaxationWidget : public SegmentationClusteringWidgetInterface
{

public:
  
  SegmentationClusteringBinaryRelaxationWidget(MainView *mainView,
					       SegmentationClusteringPlugin *segmentationClustering,
					       QWidget *parent = NULL);
  
  void setParameters(double init, double relax1, double relax2);
  void getParameters(double &init, double &relax1, double &relax2) const;

protected:

  void buildGUI();

protected:
  
  SliderSpinBoxWidget *m_initSB;
  SliderSpinBoxWidget *m_relax1SB;
  SliderSpinBoxWidget *m_relax2SB;

};

#endif /* ! SEGMENTATIONCLUSTERINGBINARYRELAXATIONWIDGET_HPP */ 
