#ifndef SEGMENTATIONCLUSTERINGFACTORY_HPP
#define SEGMENTATIONCLUSTERINGFACTORY_HPP

#include <girl/girlSharedPtr.hpp>
#include <girl/girlCommon.hpp>//GIRL_API

class QWidget;

namespace ise {
  class SegmentationClustering;
  class SegmentationContext;
}

class MainView;
class SegmentationClusteringWidgetInterface;
class SettingsInterface;

#include "SegmentationClusteringWidgetSettingsInterface.hpp"

class GIRL_API SegmentationClusteringFactory
{
  
public:
  virtual ~SegmentationClusteringFactory() {}
  
  virtual girl::shared_ptr<ise::SegmentationClustering> getNewSegmentationClustering() = 0;
  
  virtual SegmentationClusteringWidgetInterface *parameterWidget(MainView *mainView, QWidget *parent = NULL) = 0;
  
  virtual void setSegContext(ise::SegmentationContext *segContext) = 0;
  
  virtual girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface> settings() = 0;
  
};

#endif /* ! SEGMENTATIONCLUSTERINGFACTORY_HPP */
