/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGIMAGEFEATURECLUSTERERWIDGET_HPP
#define SEGMENTATIONCLUSTERINGIMAGEFEATURECLUSTERERWIDGET_HPP

#include "SegmentationClusteringWidgetInterface.hpp"

#include <ise/iseClusterer.hpp>

#include <ise/iseImageFeatureComputer.hpp>

class QSpinBox;

class SegmentationClusteringPlugin;
class ImageFeatureChoiceWidget;
class PluginIndexChoiceWidget;
class ClustererWidgetInterface;

class GIRL_API SegmentationClusteringImageFeatureClustererWidget : public SegmentationClusteringWidgetInterface
{

  Q_OBJECT

 public:

  SegmentationClusteringImageFeatureClustererWidget(MainView *mainView,
				       SegmentationClusteringPlugin *segmentationClustering,
				       QWidget *parent = NULL);
  
  void setParameters(girl::shared_ptr<ise::Clusterer> activeClusterer, const ise::FeatureComputerPtr &algo);
  void getParameters(girl::shared_ptr<ise::Clusterer> &activeClusterer, ise::FeatureComputerPtr &data) const;

 protected slots:
  
  void showWidget(int);

protected:

  void buildGUI();

protected:
  
  ImageFeatureChoiceWidget *m_ifcw;

  PluginIndexChoiceWidget *m_clustererCB;

  std::map<QString, ClustererWidgetInterface*> m_clusterer;
  ClustererWidgetInterface* m_activeClustererWidget;
};

#endif /* ! SEGMENTATIONCLUSTERINGIMAGEFEATURECLUSTERERWIDGET_HPP */ 
