/*
  Copyright (C) 2005-2010 Jean-Philippe Domenger, Boris Mansencal,
  Julian Roigt, Remi Vieux boris.mansencal@labri.fr
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef SEGMENTATIONCLUSTERINGLOCALTHRESHOLDERFACTORY_HPP
#define SEGMENTATIONCLUSTERINGLOCALTHRESHOLDERFACTORY_HPP

#include <girl/girlSharedPtr.hpp>
#include <girl/girlCommon.hpp>

class QWidget;

namespace ise {
  class SegmentationClusteringLocalThresholder;
  class SegmentationContext;
}

class SegmentationClusteringLocalThresholderWidget;
#include "SegmentationClusteringLocalThresholderWidgetSettingsInterface.hpp"

class GIRL_API SegmentationClusteringLocalThresholderFactory
{
public:

  virtual ~SegmentationClusteringLocalThresholderFactory() {}
  
  virtual girl::shared_ptr<ise::SegmentationClusteringLocalThresholder> create() = 0;
  
  virtual void saveParameters(const girl::shared_ptr<SegmentationClusteringLocalThresholderWidgetSettingsInterface> &sd) = 0;
  
  virtual void setSegContext(ise::SegmentationContext *segContext) = 0;

protected:

  virtual SegmentationClusteringLocalThresholderWidget *parameterWidget(QWidget *parent = NULL) = 0;


  
};

#endif /* ! SEGMENTATIONCLUSTERINGLOCALTHRESHOLDERFACTORY_HPP */
