/*
  Copyright (C) 2005-2010 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGLOCALTHRESHOLDERSAUVOLAWIDGET_HPP
#define SEGMENTATIONCLUSTERINGLOCALTHRESHOLDERSAUVOLAWIDGET_HPP

#include <girl/girlCommon.hpp>

#include "SegmentationClusteringLocalThresholderPlugin.hpp"
#include "SegmentationClusteringLocalThresholderWidget.hpp"
#include <ise/iseSegmentationClusteringLocalThresholderSauvola.hpp>

class QDoubleSpinBox;
class QSpinBox;

class GIRL_API SegmentationClusteringLocalThresholderSauvolaWidget : public SegmentationClusteringLocalThresholderWidget
{
 public:  
 
  SegmentationClusteringLocalThresholderSauvolaWidget(SegmentationClusteringLocalThresholderPlugin *segmentationClusteringLocalThresholderPlugin, QWidget *parent = NULL);

  void setParameters(size_t windowSize, float R, float k);
  void getParameters(size_t &windowSize, float &R, float &k) const;

protected:
  
  virtual void build();

private:

  QSpinBox *m_windowSize;
  QDoubleSpinBox *m_R;
  QDoubleSpinBox *m_k;
};

#endif /* !  SEGMENTATIONCLUSTERINGLOCALTHRESHOLDERSAUVOLAWIDGET_HPP */
