/*
  Copyright (C) 2005-2011 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGLOCALTHRESHOLDERWIDGET_HPP
#define SEGMENTATIONCLUSTERINGLOCALTHRESHOLDERWIDGET_HPP

#include <QWidget>
#include <girl/girlCommon.hpp>
#include "SegmentationClusteringLocalThresholderWidgetSettingsInterface.hpp"

#include "SegmentationClusteringLocalThresholderPlugin.hpp"



class GIRL_API SegmentationClusteringLocalThresholderWidget : public QWidget
{
public:
  
  SegmentationClusteringLocalThresholderWidget(SegmentationClusteringLocalThresholderPlugin *segmentationClusteringLocalThresholderPlugin,
					       QWidget *parent = NULL)
    : QWidget(parent)
    , m_segmentationClusteringLocalThresholderPlugin(segmentationClusteringLocalThresholderPlugin)
  {
    hide();
  }

  virtual ~SegmentationClusteringLocalThresholderWidget() {}
  
  void setGUI(const girl::shared_ptr<SegmentationClusteringLocalThresholderWidgetSettingsInterface> settings)
  {
    settings->configureWidget(this);
  }

  void getGUI(girl::shared_ptr<SegmentationClusteringLocalThresholderWidgetSettingsInterface> settings)
  {
    settings->getWidgetConfig(this);
  }
  
  virtual void build() = 0;
  
  SegmentationClusteringLocalThresholderPlugin *getPlugin() { return m_segmentationClusteringLocalThresholderPlugin;}

  void saveSettingsInPlugin()
  {
    girl::shared_ptr<SegmentationClusteringLocalThresholderWidgetSettingsInterface> s = 
      m_segmentationClusteringLocalThresholderPlugin->getSettings();
    getGUI(s);
    m_segmentationClusteringLocalThresholderPlugin->setSettings(s);
  }

protected:

  SegmentationClusteringLocalThresholderPlugin *m_segmentationClusteringLocalThresholderPlugin;
};

#endif /* ! SEGMENTATIONCLUSTERINGLOCALTHRESHOLDERWIDGET_HPP */
