/*
  Copyright (C) 2005-2011 Julian Roigt  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGLOCALTHRESHOLDSWIDGET_HPP
#define SEGMENTATIONCLUSTERINGLOCALTHRESHOLDSWIDGET_HPP

#include <girl/girlSharedPtr.hpp>

#include <ise/iseSegmentationClusteringLocalThresholder.hpp>

#include <map>

#include "PluginIndexChoiceWidget.hpp"

#include "SegmentationClusteringLocalThresholderPlugin.hpp"
#include "SegmentationClusteringLocalThresholderWidget.hpp"
#include "SegmentationClusteringWidgetInterface.hpp"

class MainView;
class SegmentationClusteringPlugin;
class SegModel;

class GIRL_API SegmentationClusteringLocalThresholdsWidget : public SegmentationClusteringWidgetInterface
{
  Q_OBJECT

public:

  /**
   * @brief Constructor.
   */
  SegmentationClusteringLocalThresholdsWidget(MainView *v, 
				 SegmentationClusteringPlugin *segmentationClustering,
				 QWidget *parent = NULL);

  void setParameters(std::string m_name);

  void getParameters(girl::shared_ptr<ise::SegmentationClusteringLocalThresholder> &activeThresholder, std::string &m_name) const;

protected slots:

  void showWidget(int);

protected:
  
  void buildGUI();

protected:
  
  PluginIndexChoiceWidget *m_thresholdersCB;
  
  std::map<QString, SegmentationClusteringLocalThresholderWidget* > m_thresholders;
  SegmentationClusteringLocalThresholderWidget* m_activeThresholderWidget;

};

#endif /* ! SEGMENTATIONCLUSTERINGLOCALTHRESHOLDSWIDGET_HPP */
