/*
  Copyright (C) 2005-2011 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGLOCALTHRESHOLDSWIDGETSETTINGS_HPP
#define SEGMENTATIONCLUSTERINGLOCALTHRESHOLDSWIDGETSETTINGS_HPP

#include "SegmentationClusteringWidgetSettingsInterface.hpp"
#include "SegmentationClusteringLocalThresholdsWidget.hpp"
#include <ise/iseSegmentationClusteringLocalThresholds.hpp>
#include <ise/iseSegmentationClusteringLocalThresholder.hpp>
class SegmentationClusteringLocalThresholdsWidgetSettings : public SegmentationClusteringWidgetSettingsInterface {
  
public:
  
  SegmentationClusteringLocalThresholdsWidgetSettings() 
    : SegmentationClusteringWidgetSettingsInterface()
  {
  }

  virtual void configureWidget(SegmentationClusteringWidgetInterface *widget) const
  {
    static_cast<SegmentationClusteringLocalThresholdsWidget*>(widget)->setParameters(m_name);
  }
  
  virtual void getWidgetConfig(const SegmentationClusteringWidgetInterface *widget)
  {
    static_cast<const SegmentationClusteringLocalThresholdsWidget*>(widget)->getParameters(m_activeThresholder, m_name);
  }

  virtual void configureAlgo(girl::shared_ptr<ise::SegmentationClustering> algo) const
  {
    girl::shared_ptr<ise::SegmentationClusteringLocalThresholds> algorithm = girl::static_pointer_cast<ise::SegmentationClusteringLocalThresholds>(algo);
    algorithm->setParams(girl::shared_ptr<ise::SegmentationClusteringLocalThresholder>(m_activeThresholder));
  }
  
  virtual girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface> clone() const
  {
    girl::shared_ptr<SegmentationClusteringLocalThresholdsWidgetSettings> p(new SegmentationClusteringLocalThresholdsWidgetSettings);

    *p = *this;

    return p;
  }

  virtual bool isValid() const
  {
    return (m_activeThresholder != girl::shared_ptr<ise::SegmentationClusteringLocalThresholder>() ); //B:???
  }
  

private:

  girl::shared_ptr<ise::SegmentationClusteringLocalThresholder> m_activeThresholder;
  std::string m_name;
  
};

#endif /* ! SEGMENTATIONCLUSTERINGLOCALTHRESHOLDSWIDGETSETTINGS_HPP */
