/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGMANUALWIDGET_HPP
#define SEGMENTATIONCLUSTERINGMANUALWIDGET_HPP

#include "SegmentationClusteringWidgetInterface.hpp"
#include "SegmentationClusteringLocalThresholderWidget.hpp"
#include "SegmentationClusteringLocalThresholderPlugin.hpp"
#include "QuantificationThresholderPlugin.hpp"
#include "SegmentationClusteringPlugin.hpp"

class QComboBox;
#include <QMap>

namespace ise {
  class SegmentationClusteringManual;
}

class SegmentationClusteringFactory;

class GIRL_API SegmentationClusteringManualWidget : public SegmentationClusteringWidgetInterface
{
  Q_OBJECT
public:
  SegmentationClusteringManualWidget(MainView *mainView,
				     SegmentationClusteringFactory *segmentationClustering,
				     QWidget *parent = NULL);

  virtual void setGUI();
  virtual void getGUI();
  
protected:

  void buildGUI();
 
  void addLocalThresholder(const QString& name, SegmentationClusteringLocalThresholderWidget *thresholderWidget);
  void addQuantificationThresholder(const QString& name);
  void addSegmentationClustering(const QString& name, SegmentationClusteringPlugin *segPlugin);							
 
 protected slots:
  
  void populateThreshold();
  void populateSegmentation();

 private slots:
  void showDialogSeg();

protected:
 
  QComboBox *m_thresholdType;
  QComboBox *m_threshold;
  QComboBox *m_segmentation;
  
  QMap<QString, SegmentationClusteringLocalThresholderWidget*> m_localThresholders;
  //QMap<QString, SegmentationClusteringPlugin*> m_segmentationClusteringPlugin;
};
#endif /* ! SEGMENTATIONCLUSTERINGMANUALWIDGET_HPP */
