/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGMARKOVWIDGET_HPP
#define SEGMENTATIONCLUSTERINGMARKOVWIDGET_HPP

#include "SegmentationClusteringWidgetInterface.hpp"

class QSpinBox;
class SegmentationClusteringPlugin;
class QDoubleSpinBox;



class GIRL_API SegmentationClusteringMarkovWidget : public SegmentationClusteringWidgetInterface
{

 public:
  SegmentationClusteringMarkovWidget(MainView *mainView,
				      SegmentationClusteringPlugin *segmentationClustering,
				      QWidget *parent = NULL);
  
  void setParameters(double potential, double thresholdSegInit);
  void getParameters(double &potential, double &thresholdSegInit) const;

protected:

  void buildGUI();

protected:
  
  QDoubleSpinBox *m_potentialSB;
  QSpinBox *m_thresholdSegInitSB;

};

#endif /* ! SEGMENTATIONCLUSTERINGMARKOVWIDGET_HPP */ 
