/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGPARAMETERSDIALOGSETTINGS_HPP
#define SEGMENTATIONCLUSTERINGPARAMETERSDIALOGSETTINGS_HPP

#include "SettingsInterface.hpp"

class SegmentationClusteringParametersDialogSettings : public SettingsInterface
{
public:

  SegmentationClusteringParametersDialogSettings()
  {
  }

  virtual void setParameters(Settingable* dialog) {
    static_cast<SegmentationClusteringParametersDialog*>(dialog)->setParameters(m_settings);
  }

  virtual void getParameters(Settingable* dialog) {
    static_cast<SegmentationClusteringParametersDialog*>(dialog)->getParameters(m_settings);
  }

  virtual void getParameters(girl::shared_ptr<ise::Algo> algo) {
    m_settings->getParameters(algo);
  }

private:

  girl::shared_ptr<SettingsInterface> m_settings;
};

#endif /* ! SEGMENTATIONCLUSTERINGPARAMETERSDIALOGSETTINGS_HPP */
