/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGRLSAWIDGET_HPP
#define SEGMENTATIONCLUSTERINGRLSAWIDGET_HPP

#include "SegmentationClusteringWidgetInterface.hpp"
#include "ButtonThresholder.hpp"

class QSpinBox;
class QLabel;
class QGroupBox;

namespace ise {
  class SegmentationClusteringRLSA;
}

class SegmentationClusteringPlugin;

class GIRL_API SegmentationClusteringRLSAWidget : public SegmentationClusteringWidgetInterface
{

public:
  SegmentationClusteringRLSAWidget(MainView *mainView,
				   SegmentationClusteringPlugin *segmentationClustering,
				   QWidget *parent = NULL);

  void setParameters(int colorSpace, int channel, const std::vector<int> &levels, int horizontal, int s, int vertical);
  void getParameters(int &colorSpace, int &channel, std::vector<int> &levels, int &horizontal, int &s, int &vertical) const;

 protected:

  void buildGUI();
 
 protected:
 
  QSpinBox *m_C_horizontal;
  QSpinBox *m_C_s;
  QSpinBox *m_C_vertical;
  QGroupBox *m_group;
 
  ButtonThresholder *m_thresholder;
};
#endif /* ! SEGMENTATIONCLUSTERINGRLSAWIDGET_HPP */
