/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGRXYCWIDGET_HPP
#define SEGMENTATIONCLUSTERINGRXYCWIDGET_HPP

#include "SegmentationClusteringWidgetInterface.hpp"
#include "ButtonThresholder.hpp"
#include <ise/iseThresholderData.hpp>


namespace ise {
  class SegmentationClusteringRXYC;
}

class SegmentationClusteringPlugin;
class QSpinBox;

class GIRL_API SegmentationClusteringRXYCWidget : public SegmentationClusteringWidgetInterface
{

public:
  SegmentationClusteringRXYCWidget(MainView *mainView,
				   SegmentationClusteringPlugin *segmentationClustering,
				   QWidget *parent = NULL);

  void setParameters(const ise::ThresholderData &data, int iteration);
  void getParameters(ise::ThresholderData &data, int &iteration) const;

 protected:

  void buildGUI();
 
protected:

  QSpinBox *m_iteration;
 
  ButtonThresholder *m_thresholder;
};
#endif /* ! SEGMENTATIONCLUSTERINGRXYCWIDGET_HPP */
