/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include "SegmentationClusteringRegionGrowingWidget.hpp"
#include "SegmentationClusteringRegionGrowingWidgetSettings.hpp"

#include <ise/iseSegmentationClusteringRegionGrowing.hpp>

#include <QBoxLayout>
#include <QLabel>
#include <QSpinBox>

#include "SegmentationClusteringPlugin.hpp"

SegmentationClusteringRegionGrowingWidget::SegmentationClusteringRegionGrowingWidget(MainView *mainView,
										     SegmentationClusteringPlugin *segmentationClusteringPlugin,
										     QWidget *parent)
  : SegmentationClusteringWidgetInterface(mainView, segmentationClusteringPlugin, parent)
  , m_thresholdSB(NULL)
{

  setWindowTitle(tr("Region growing parameters..."));

  setAttribute(Qt::WA_DeleteOnClose);

  buildGUI();
}

void
SegmentationClusteringRegionGrowingWidget::buildGUI()
{
  QLabel *thresholdLabel = new QLabel(tr("Graylevel threshold:"), this);
  m_thresholdSB = new QSpinBox(this);
  m_thresholdSB->setMinimum(0);
  //m_thresholdSB->setMaximum(255); //only valid if 8-bit ...
  
  QHBoxLayout *hbox1 = new QHBoxLayout;
  hbox1->addWidget(thresholdLabel);
  hbox1->addWidget(m_thresholdSB);

  setLayout(hbox1);  
}

void
SegmentationClusteringRegionGrowingWidget::setParameters(double threshold)
{
  m_thresholdSB->setValue(threshold);
}

void
SegmentationClusteringRegionGrowingWidget::getParameters(double &threshold) const
{
  threshold = m_thresholdSB->value();
}



