/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef SEGMENTATIONCLUSTERINGREGULARGRIDWIDGET
#define SEGMENTATIONCLUSTERINGREGULARGRIDWIDGET

#include "SegmentationClusteringWidgetInterface.hpp"

namespace ise {
  class RegularGridPartitionner;
}

class QSpinBox;


class GIRL_API SegmentationClusteringRegularGridWidget : public SegmentationClusteringWidgetInterface
{

public:
   SegmentationClusteringRegularGridWidget(MainView *mainView,
					   SegmentationClusteringPlugin *segmentationClustering,
					   QWidget *parent = NULL);

   void setParameters(int width, int height);
   void getParameters(int &width, int &height) const;

protected:

  void buildGUI();

protected:
  ise::RegularGridPartitionner *m_segClust;
  QSpinBox *m_widthEntry;
  QSpinBox *m_heightEntry;

};

#endif /* ! SEGMENTATIONCLUSTERINGREGULARGRIDWIDGET_HPP */
