/*
  Copyright (C) 2005-2011 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGSETTINGSIMAGEFEATURECLUSTERER_HPP
#define SEGMENTATIONCLUSTERINGSETTINGSIMAGEFEATURECLUSTERER_HPP

#include "SegmentationClusteringWidgetSettingsInterface.hpp"
#include "SegmentationClusteringImageFeatureClustererWidget.hpp"
#include <ise/iseSegmentationClusteringImageFeatureClusterer.hpp>

class SegmentationClusteringSettingsImageFeatureClusterer : public SegmentationClusteringWidgetSettingsInterface {
  
public:
  
  SegmentationClusteringSettingsImageFeatureClusterer() 
    : SegmentationClusteringWidgetSettingsInterface()
  {
  }

  virtual void configureWidget(SegmentationClusteringWidgetInterface *widget) const
  {
    static_cast<SegmentationClusteringImageFeatureClustererWidget*>(widget)->setParameters(m_clusterer, m_algo);
  }
  
  virtual void getWidgetConfig(const SegmentationClusteringWidgetInterface *widget)
  {
    static_cast<const SegmentationClusteringImageFeatureClustererWidget*>(widget)->getParameters(m_clusterer, m_algo);
  }

  virtual void configureAlgo(girl::shared_ptr<ise::SegmentationClustering> algo) const
  {
    girl::shared_ptr<ise::SegmentationClusteringImageFeatureClusterer> algorithm = girl::static_pointer_cast<ise::SegmentationClusteringImageFeatureClusterer>(algo);
    algorithm->setParameters(girl::static_pointer_cast<ise::ImageFeatureComputer>(m_algo), m_clusterer);
  }
  
  virtual girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface> clone() const
  {
    girl::shared_ptr<SegmentationClusteringSettingsImageFeatureClusterer> p(new SegmentationClusteringSettingsImageFeatureClusterer);

    *p = *this;

    return p;
  }
  
  virtual bool isValid() const
  {
    return true; //B:???
  }

private:
  
  girl::shared_ptr<ise::Clusterer> m_clusterer;
  ise::FeatureComputerPtr m_algo;

};

#endif /* ! SEGMENTATIONCLUSTERINGSETTINGSIMAGEFEATURECLUSTERER_HPP */
