/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include "SegmentationClusteringShapeCCWidget.hpp"
#include "SegmentationClusteringShapeCCWidgetSettings.hpp"

#include <cassert>
#include <QGridLayout>

#include <ise/iseSegmentationClusteringShapeCC.hpp>

#include <qiseTools/SegmentationClusteringPlugin.hpp>

#include <QLabel>
#include <QComboBox>


SegmentationClusteringShapeCCWidget::SegmentationClusteringShapeCCWidget(MainView *mainView,
									 SegmentationClusteringPlugin *segmentationClusteringPlugin,
									 QWidget *parent)
  : SegmentationClusteringWidgetInterface(mainView, segmentationClusteringPlugin, parent)
  , m_Shapes(NULL)
{

  setWindowTitle(tr("ShapeCC parameters..."));

  setAttribute(Qt::WA_DeleteOnClose);

  buildGUI();
}

void
SegmentationClusteringShapeCCWidget::buildGUI()
{
  QGridLayout *layout = new QGridLayout();
  
  QLabel *ShapesLabel = new QLabel(tr("Shapes :"), this);
  m_Shapes = new QComboBox(this);
  m_Shapes->addItem(tr("Circles"));
  m_Shapes->addItem(tr("ConvexHull"));
  m_Shapes->addItem(tr("Ellipse"));
  m_Shapes->addItem(tr("RotatedRect"));
  m_Shapes->addItem(tr("Box"));
  layout->addWidget(ShapesLabel, 0, 0);
  layout->addWidget(m_Shapes, 0, 1);


  setLayout(layout);
}

void
SegmentationClusteringShapeCCWidget::setParameters(std::string shape)
{
  int pos = m_Shapes->findText(shape.c_str());
  m_Shapes->setCurrentIndex(pos);
}

void
SegmentationClusteringShapeCCWidget::getParameters(std::string &shape) const
{
  shape = m_Shapes->currentText().toStdString();
}


