/*
  Copyright (C) 2005-2011 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SEGMENTATIONCLUSTERINGSHAPECCWIDGETSETTINGS_HPP
#define SEGMENTATIONCLUSTERINGSHAPECCWIDGETSETTINGS_HPP

#include "SegmentationClusteringWidgetSettingsInterface.hpp"
#include "SegmentationClusteringShapeCCWidget.hpp"
#include <ise/iseSegmentationClusteringShapeCC.hpp>

class SegmentationClusteringShapeCCWidgetSettings : public SegmentationClusteringWidgetSettingsInterface {
  
public:
  
  SegmentationClusteringShapeCCWidgetSettings() 
    : SegmentationClusteringWidgetSettingsInterface()
    , m_shape("Box")
  {
  }

  virtual void configureWidget(SegmentationClusteringWidgetInterface *widget) const
  {
    static_cast<SegmentationClusteringShapeCCWidget*>(widget)->setParameters(m_shape);
  }
  
  virtual void getWidgetConfig(const SegmentationClusteringWidgetInterface *widget)
  {
    static_cast<const SegmentationClusteringShapeCCWidget*>(widget)->getParameters(m_shape);
  }

  virtual void configureAlgo(girl::shared_ptr<ise::SegmentationClustering> algo) const
  {
    girl::shared_ptr<ise::SegmentationClusteringShapeCC> algorithm = girl::static_pointer_cast<ise::SegmentationClusteringShapeCC>(algo);
    algorithm->setParameters(m_shape);
  }
  
  virtual girl::shared_ptr<SegmentationClusteringWidgetSettingsInterface> clone() const
  {
    girl::shared_ptr<SegmentationClusteringShapeCCWidgetSettings> p(new SegmentationClusteringShapeCCWidgetSettings);

    *p = *this;

    return p;
  }

  virtual bool isValid() const
  {
    return true; //B:???
  }


private:
  
  std::string m_shape;
};

#endif /* ! SEGMENTATIONCLUSTERINGSHAPECCWIDGETSETTINGS_HPP */
