/*
  Copyright (C) 2005-2011 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#ifndef SEGMENTATIONCLUSTERINGSPATIALMEANSHIFTWIDGET_HPP
#define SEGMENTATIONCLUSTERINGSPATIALMEANSHIFTWIDGET_HPP

#include "SegmentationClusteringWidgetInterface.hpp"

#include "ImageFeatureChoiceWidget.hpp"

namespace ise {
  class SegmentationClusteringSpatialMeanShift;
}

class QSpinBox;
class QCheckBox;
class QDoubleSpinBox;


class GIRL_API SegmentationClusteringSpatialMeanShiftWidget : public SegmentationClusteringWidgetInterface
{
public:

  SegmentationClusteringSpatialMeanShiftWidget(MainView *mainView,
					       SegmentationClusteringPlugin *segmentationClustering,
					       QWidget *parent = NULL);

  
  void setParameters(float sigmaR, float sigmaS, int minRegion, bool fuseRegion, const ise::FeatureComputerPtr &algo);
  void getParameters(float &sigmaR, float &sigmaS, int &minRegion, bool &fuseRegion, ise::FeatureComputerPtr &data) const ;

protected:

  void buildGUI();

protected:

  QDoubleSpinBox *m_sigmaR;
  QDoubleSpinBox *m_sigmaS;
  QDoubleSpinBox *m_minRegion;
  QCheckBox *m_fuseRegion;
  ImageFeatureChoiceWidget *m_ifcw;

};

#endif /* ! SEGMENTATIONCLUSTERINGSPATIALMEANSHIFTWIDGET_HPP */ 
