/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SELECTOROPTIONSWIDGET_HPP
#define SELECTOROPTIONSWIDGET_HPP

#include <girl/girlCommon.hpp>
#include <qiseTools/ShapeSelector.hpp>

#include <QWidget>
class QAction; 
class QComboBox;

class GIRL_API SelectorOptionsWidget : public QWidget
{
  Q_OBJECT

public:

  /**
   * @brief Constructor.
   */
  explicit SelectorOptionsWidget(QWidget *parent);


  ShapeSelector::SelectorMode getSelectorMode() const;
  ShapeSelector::SelectorRegionComputer getSelectorRegionComputer() const;
  ShapeSelector::SelectorType getSelectorType() const;

signals:

  void selectorModeChanged(ShapeSelector::SelectorMode mode);
  void selectorTypeChanged(ShapeSelector::SelectorType type);
  void selectorRegionComputerChanged(ShapeSelector::SelectorRegionComputer rc);

protected slots:

  void changeSelectionMode();
  void changeSelectionType();
  void changeSelectorRegionComputer(const QString &s);

protected:
  
  void buildGUI();

protected:

  ShapeSelector::SelectorType m_type;

  QAction *m_selectionModeReplaceAction;
  QAction *m_selectionModeAddAction;
  QAction *m_selectionModeSubtractAction;
  QAction *m_selectionModeIntersectAction;
  QAction *m_lastSelectionModeAction;

  QAction *m_selectionTypeRectangleAction;
  QAction *m_selectionTypeEllipseAction;
  QAction *m_selectionTypeFreeAction;
  QAction *m_selectionTypeLineAction;
  QAction *m_lastSelectionTypeAction;

  QComboBox *m_rcCombo;
  
};


#endif /* SELECTOROPTIONSWIDGET_HPP */
