/*
  Copyright (C) 2005-2011 Julian Roigt, Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef SETTINGSINTERFACETEMPLATE_HXX
#define SETTINGSINTERFACETEMPLATE_HXX

#include <girl/girlCommon.hpp>
#include <girl/girlSharedPtr.hpp>

template<class WIDGET, class ISE>
class GIRL_API SettingsInterfaceTemplate
{
  
public:

  virtual ~SettingsInterfaceTemplate() {}
  
  virtual void configureWidget(WIDGET *widget) const = 0;

  virtual void getWidgetConfig(const WIDGET *widget) = 0;

  virtual void configureAlgo(girl::shared_ptr<ISE> algo) const = 0 ;

  virtual girl::shared_ptr<SettingsInterfaceTemplate > clone() const = 0;

  virtual bool isValid() const = 0;

};

#endif /* ! SETTINGSINTERFACETEMPLATE_HXX */
