/*
  Copyright (C) 2005-2009 Boris Mansencal  boris.mansencal@labri.fr

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include "SplitDriverRecursiveDefaultWidget.hpp"

#include <ise/iseSplitDriverRecursiveDefault.hpp>

#include <QBoxLayout>
#include <QLabel>

#include "SplitDriverPlugin.hpp"

#include "SliderSpinBoxWidget.hpp"

SplitDriverRecursiveDefaultWidget::SplitDriverRecursiveDefaultWidget(SplitDriverPlugin *splitDriverPlugin,
								     QWidget *parent)
  : SplitDriverWidgetInterface(splitDriverPlugin, parent),
    //m_homogeneitySB(NULL),
    m_thresholdSB(NULL)
{
  assert(m_splitDriverPlugin);

  //setAttribute(Qt::WA_DeleteOnClose);

  buildGUI();

  setGUI();
}
							   

void
SplitDriverRecursiveDefaultWidget::buildGUI()
{
  /*
  QLabel *homLabel = new QLabel(tr("Homogeneity: "), this);
  m_homogeneitySB = new QDoubleSpinBox(this);
  QHBoxLayout *hLayout1 = new QHBoxLayout;
  hLayout1->addWidget(homLabel);
  hLayout1->addWidget(m_homogeneitySB);
  m_homogeneitySB->setMinimum(0.0);
  m_homogeneitySB->setMaximum(1.0);
  m_homogeneitySB->setDecimals(3);
  m_homogeneitySB->setSingleStep(0.01);
  */

  QLabel *homLabel = new QLabel(tr("Threshold: "), this);
  m_thresholdSB = new SliderSpinBoxWidget(this);
  QHBoxLayout *hLayout2 = new QHBoxLayout;
  hLayout2->addWidget(homLabel);
  hLayout2->addWidget(m_thresholdSB);
  m_thresholdSB->setMinimum(0.0);
  m_thresholdSB->setMaximum(1.0);
  m_thresholdSB->setDecimals(3);
  m_thresholdSB->setSingleStep(0.01);
  

  QVBoxLayout *vLayout = new QVBoxLayout();
  //vLayout->addItem(hLayout1);
  vLayout->addItem(hLayout2);
  
  setLayout(vLayout);  
}


void
SplitDriverRecursiveDefaultWidget::setGUI()
{
  assert(m_splitDriverPlugin);

  double th = 0.0;
  //TODO !!!
  m_thresholdSB->setValue(th);
}

void
SplitDriverRecursiveDefaultWidget::getGUI()
{
  assert(m_splitDriverPlugin);

  //const double hom = m_homogeneitySB->value();
  //const double th = m_thresholdSB->value();
  //TODO !!!

}



