/* 
 * Copyright (C) 2010-2011 Boris Mansencal, Hugo Boujut, Remi Vieux  boris.mansencal@labri.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation (Inc., 59
 * Temple Place - Suite 330, Boston, MA 02111-1307, USA); either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */
#include "ThresholdedColorIndex.hpp"
//#include "QuantificationThresholdsDialog.hpp"

ThresholdedColorIndex::ThresholdedColorIndex() 
  : FalseColorIndex(), m_hash(NULL)
{}

ThresholdedColorIndex::ThresholdedColorIndex(HashType &hash,
					     const girl::regionDeque regions,
					     const girl::toger &tog) 
 : FalseColorIndex(regions, tog), m_hash(NULL)
{
  setHash(hash);
}

const QRgb&
ThresholdedColorIndex::getColor(const QRgb &color) const 
{
  return (*m_hash)[color].thresholdedColor;
}
