
TARGET = qiseTools-1.0
TEMPLATE = lib

DEFINES += QISE_LIBRARY

QT+=opengl

DEFINES += WITHOUT_GLEW

!contains(DEFINES, WITHOUT_GLEW) {
  GLEW_INCLUDEPATH=
  GLEW_LIBS=-lGLEW
  macx-g++ {
    GLEW_INCLUDEPATH+=/sw/include
    GLEW_LIBS=-L/sw/lib -lGLEW
  }
  INCLUDEPATH += $$GLEW_INCLUDEPATH
  LIBS += $$GLEW_LIBS
}

HEADERS += \
           qiseTools/AreaIntervalsWidget.hpp \
           qiseTools/ColorButton.hpp \
           qiseTools/ColorConvertWidget.hpp \
           qiseTools/ColorGenerator.hpp \
           qiseTools/ColorSpaceChoiceWidget.hpp \
           qiseTools/ColorSpaceRegistry.hpp \
           qiseTools/ColorSpacesChannelsChoiceWidget.hpp \
           qiseTools/EditionBox.hpp \
           qiseTools/FalseColorImageBuilderThread.hpp \
           qiseTools/FalseColorIndex.hpp \
           qiseTools/GLColor.hpp \
           qiseTools/GLImage.hpp \
           qiseTools/GLImageLayer.hpp \
           qiseTools/GLInteractiveShape.hpp \
           qiseTools/GLLayer.hpp \
           qiseTools/GLLayerMover.hpp \
           qiseTools/GLMarkLayer.hpp \
           qiseTools/GLMovableSegmentLayer.hpp \
           qiseTools/GLRectangleLayer.hpp \
           qiseTools/GLSegmentLayer.hpp \
           qiseTools/GLSelectionLayer.hpp \
           qiseTools/GLShapesLayer.hpp \
           qiseTools/GLTogerLayer.hpp \
           qiseTools/GLTogerPainter.hpp \
           qiseTools/GLTransformation.hpp \
           qiseTools/GLUtils.hpp \
           qiseTools/GLView.hpp \
           qiseTools/HistogramThresholdsView.hpp \
           qiseTools/HistogramView.hpp \
           qiseTools/ImageFeatureRegistry.hpp \
           qiseTools/ImageFeaturesWidget.hpp \
           qiseTools/ImagePainter.hpp \
           qiseTools/InteractiveShapeStatus.hpp \
           qiseTools/LevelBackgroundItem.hpp \
           qiseTools/LevelItem.hpp \
           qiseTools/MainView.hpp \
           qiseTools/MarkWidget.hpp \
           qiseTools/MergeAlgorithmFactory.hpp \
           qiseTools/MergeAlgorithmPlugin.hpp \
           qiseTools/MergeAlgorithmWidgetInterface.hpp \
           qiseTools/MergeDriverColorDistanceWidget.hpp \
           qiseTools/MergeDriverColorHomogeneityWidget.hpp \
           qiseTools/MergeDriverFactory.hpp \
           qiseTools/MergeDriverPlugin.hpp \
           qiseTools/MergeDriverGeoColorWidget.hpp \
           qiseTools/MergeDriverGradientWidget.hpp \
           qiseTools/MergeDriverSimpleWidget.hpp \
           qiseTools/MergeDriverSizeFilteringWidget.hpp \
           qiseTools/MergeDriverTangentVarianceWidget.hpp \
           qiseTools/MergeDriverThresholdsWidget.hpp \
           qiseTools/MergeDriverWidget.hpp \
           qiseTools/MergeDriverWidgetInterface.hpp \
           qiseTools/MiniView.hpp \
           qiseTools/PaintingShape.hpp \
           qiseTools/PluginRegistry.hpp \
           qiseTools/QIsePlugin.hpp \
           qiseTools/QIsePluginDependance.hpp \
           qiseTools/QIsePluginDependancesSolver.hpp \
           qiseTools/QIsePluginList.hpp \
           qiseTools/QIsePluginList.hxx \
           qiseTools/QIseVersion.hpp \
           qiseTools/QuantificationCAGWidget.hpp \
           qiseTools/QuantificationKMeansWidget.hpp \
           qiseTools/SegmentationClusteringCvKMeansWidget.hpp \
           qiseTools/SegmentationClusteringGenericKMeansWidget.hpp \
           qiseTools/QuantificationNbColorsWidget.hpp \
           qiseTools/QuantificationThresholderFactory.hpp \
           qiseTools/QuantificationThresholderPlugin.hpp \
           qiseTools/QuantificationThresholdsWidget.hpp \
           qiseTools/QuantificationUniformWidget.hpp \
           qiseTools/RegionBorderBuilderThread.hpp \
           qiseTools/ScanlineSetConstExternalPerimeterIterator.hpp \
           qiseTools/ScanlineSetConstLinesIterator.hpp \
           qiseTools/ScanlineSetConstPerimeterIterator.hpp \
           qiseTools/ScanlineSet.hpp \
           qiseTools/SegmentationClusteringBinaryRelaxationWidget.hpp \
           qiseTools/SegmentationClusteringFactory.hpp \
           qiseTools/SegmentationClusteringPlugin.hpp \
           qiseTools/SegmentationClusteringLocalThresholdsWidget.hpp \
           qiseTools/SegmentationClusteringLocalThresholderWidget.hpp \
           qiseTools/SegmentationClusteringLocalThresholderPlugin.hpp \
           qiseTools/SegmentationClusteringLocalThresholderFactory.hpp \
           qiseTools/SegmentationClusteringLocalThresholderWhiteWidget.hpp \
           qiseTools/SegmentationClusteringLocalThresholderBernsenWidget.hpp \
           qiseTools/SegmentationClusteringLocalThresholderNiblackWidget.hpp \
           qiseTools/SegmentationClusteringLocalThresholderSauvolaWidget.hpp \
           qiseTools/SegmentationClusteringMarkovWidget.hpp \
           qiseTools/SegmentationClusteringParametersDialog.hpp \
           qiseTools/SegmentationClusteringRegionGrowingWidget.hpp \
           qiseTools/SegmentationClusteringWatershedWidget.hpp \
           qiseTools/SegmentationClusteringNormalizedCutWidget.hpp \
           qiseTools/SegmentationClusteringWidgetInterface.hpp \
           qiseTools/SegmentationClusteringMeanShiftWidget.hpp \
           qiseTools/SegmentationClusteringShapeCCWidget.hpp \
           qiseTools/SegmentationClusteringSpatialMeanShiftWidget.hpp \
           qiseTools/SegmentationClusteringManualWidget.hpp \
           qiseTools/SegmentsTransformer.hpp \
           qiseTools/SegModel.hpp \
           qiseTools/SegView.hpp \
           qiseTools/SliderSpinBoxWidget.hpp \
           qiseTools/SplitAlgorithmFactory.hpp \
           qiseTools/SplitAlgorithmPlugin.hpp \
           qiseTools/SplitAlgorithmWidgetInterface.hpp \
           qiseTools/SplitDriverFactory.hpp \
           qiseTools/SplitDriverPlugin.hpp \
           qiseTools/SplitDriverRecursiveDefaultWidget.hpp \
           qiseTools/SplitDriverWidgetInterface.hpp \
           qiseTools/SplitMergeAlgorithmFactory.hpp \
           qiseTools/SplitMergeAlgorithmPlugin.hpp \
           qiseTools/SplitMergeAlgorithmWidgetInterface.hpp \
           qiseTools/ThresholdedColorIndex.hpp \
           qiseTools/Transformation.hpp \
           qiseTools/WeightedChannelsColorSpaceWidget.hpp \
           qiseTools/ImageFeatureChoiceWidget.hpp \
           qiseTools/ImageFeaturesDialog.hpp \
           qiseTools/ImageFeaturePlugin.hpp \
           qiseTools/ImageFeatureFactory.hpp \
           qiseTools/ImageFeatureOrientationDialog.hpp \
           qiseTools/ImageFeatureTextonDialog.hpp \
           qiseTools/ImageFeatureColorSpaceDialog.hpp \
           qiseTools/SegmentationClusteringRLSAWidget.hpp \
           qiseTools/SegmentationClusteringRXYCWidget.hpp \
           q
           
SOURCES += \
           qiseTools/AreaIntervalsWidget.cpp \
           qiseTools/ColorButton.cpp \
           qiseTools/ColorConvertWidget.cpp \
           qiseTools/ColorGenerator.cpp \
           qiseTools/ColorSpaceChoiceWidget.cpp \
           qiseTools/ColorSpaceRegistry.cpp \
           qiseTools/ColorSpacesChannelsChoiceWidget.cpp \
           qiseTools/EditionBox.cpp \
           qiseTools/FalseColorImageBuilderThread.cpp \
           qiseTools/FalseColorIndex.cpp \
           qiseTools/GLImage.cpp \
           qiseTools/GLImageLayer.cpp \
           qiseTools/GLInteractiveShape.cpp \
           qiseTools/GLLayer.cpp \
           qiseTools/GLLayerMover.cpp \
           qiseTools/GLMarkLayer.cpp \
           qiseTools/GLMovableSegmentLayer.cpp \
           qiseTools/GLRectangleLayer.cpp \
           qiseTools/GLSegmentLayer.cpp \
           qiseTools/GLSelectionLayer.cpp \
           qiseTools/GLShapesLayer.cpp \
           qiseTools/GLTogerLayer.cpp \
           qiseTools/GLTogerPainter.cpp \
           qiseTools/GLTransformation.cpp \
           qiseTools/GLView.cpp \
           qiseTools/HistogramThresholdsView.cpp \
           qiseTools/HistogramView.cpp \
           qiseTools/ImageFeatureRegistry.cpp \
           qiseTools/ImageFeaturesWidget.cpp \
           qiseTools/ImagePainter.cpp \
           qiseTools/LevelBackgroundItem.cpp \
           qiseTools/LevelItem.cpp \
           qiseTools/MainView.cpp \
           qiseTools/MarkWidget.cpp \
           qiseTools/MergeDriverColorDistanceWidget.cpp \
           qiseTools/MergeDriverColorHomogeneityWidget.cpp \
           qiseTools/MergeDriverGeoColorWidget.cpp \
           qiseTools/MergeDriverGradientWidget.cpp \
           qiseTools/MergeDriverSimpleWidget.cpp \
           qiseTools/MergeDriverSizeFilteringWidget.cpp \
           qiseTools/MergeDriverTangentVarianceWidget.cpp \
           qiseTools/MergeDriverThresholdsWidget.cpp \
           qiseTools/MergeDriverWidget.cpp \
           qiseTools/MiniView.cpp \
           qiseTools/PaintingShape.cpp \
           qiseTools/PluginRegistry.cpp \
           qiseTools/QIsePluginDependance.cpp \
           qiseTools/QIsePluginDependancesSolver.cpp \
           qiseTools/QIseVersion.cpp \
           qiseTools/QuantificationCAGWidget.cpp \
           qiseTools/QuantificationKMeansWidget.cpp \
           qiseTools/SegmentationClusteringCvKMeansWidget.cpp \
           qiseTools/SegmentationClusteringGenericKMeansWidget.cpp \
           qiseTools/QuantificationNbColorsWidget.cpp \
           qiseTools/QuantificationThresholdsWidget.cpp \
           qiseTools/QuantificationUniformWidget.cpp \
           qiseTools/RegionBorderBuilderThread.cpp \
           qiseTools/ScanlineSetConstExternalPerimeterIterator.cpp \
           qiseTools/ScanlineSetConstLinesIterator.cpp \
           qiseTools/ScanlineSetConstPerimeterIterator.cpp \
           qiseTools/ScanlineSet.cpp \
           qiseTools/SegmentationClusteringBinaryRelaxationWidget.cpp \
           qiseTools/SegmentationClusteringLocalThresholdsWidget.cpp \
           qiseTools/SegmentationClusteringLocalThresholderWhiteWidget.cpp \
           qiseTools/SegmentationClusteringLocalThresholderBernsenWidget.cpp \
           qiseTools/SegmentationClusteringLocalThresholderNiblackWidget.cpp \
           qiseTools/SegmentationClusteringLocalThresholderSauvolaWidget.cpp \
           qiseTools/SegmentationClusteringMarkovWidget.cpp \
           qiseTools/SegmentationClusteringParametersDialog.cpp \
           qiseTools/SegmentationClusteringRegionGrowingWidget.cpp \
           qiseTools/SegmentationClusteringWatershedWidget.cpp \
           qiseTools/SegmentationClusteringNormalizedCutWidget.cpp \
           qiseTools/SegmentationClusteringMeanShiftWidget.cpp \
           qiseTools/SegmentationClusteringShapeCCWidget.cpp \
           qiseTools/SegmentationClusteringSpatialMeanShiftWidget.cpp \
           qiseTools/SegmentationClusteringManualWidget.cpp \
           qiseTools/SegmentsTransformer.cpp \
           qiseTools/SegModel.cpp \
           qiseTools/SegView.cpp \
           qiseTools/SliderSpinBoxWidget.cpp \
           qiseTools/SplitDriverRecursiveDefaultWidget.cpp \
           qiseTools/ThresholdedColorIndex.cpp \
           qiseTools/Transformation.cpp \
           qiseTools/WeightedChannelsColorSpaceWidget.cpp \
           qiseTools/ImageFeatureChoiceWidget.cpp \
           qiseTools/ImageFeatureOrientationDialog.cpp \
           qiseTools/ImageFeatureTextonDialog.cpp \
           qiseTools/ImageFeatureColorSpaceDialog.cpp \
           qiseTools/SegmentationClusteringRLSAWidget.cpp \
           qiseTools/SegmentationClusteringRXYCWidget.cpp \
           
unix {
    install.path += /usr/local/lib/
    install.commands = mkdir /usr/local/include/qiseTools-1.0/ 2> /dev/null; \
                      mkdir /usr/local/include/qiseTools-1.0/qiseTools 2> /dev/null; \
                      /usr/bin/install -c -m 644 qiseTools/*.h* /usr/local/include/qiseTools-1.0/qiseTools/ ; \
                      /usr/bin/install -c -m 644 qiseTools-1.0.pc /usr/local/lib/pkgconfig/; \
		      /usr/bin/install -c libqiseTools-1.0.so.1.0.0 /usr/local/lib/libqiseTools-1.0.so.1.0.0; \
                      (cd /usr/local/lib && ( ln -s -f libqiseTools-1.0.so.1.0.0 libqiseTools-1.0.so.1 || ( rm -f libqiseTools-1.0.so.1 && ln -s libqiseTools-1.0.so.1.0.0 libqiseTools-1.0.so.1 ) ) ); \
                      (cd /usr/local/lib && ( ln -s -f libqiseTools-1.0.so.1.0.0 libqiseTools-1.0.so || ( rm -f libqiseTools-1.0.so && ln -s libqiseTools-1.0.so.1.000.0 libqiseTools-1.0.so ) ))
                      #/usr/bin/install -c -m 644  lib* /usr/local/lib/

    INSTALLS += install
}

QMAKE_CXXFLAGS_RELEASE = -g -Wall -Wextra

CONFIG += link_pkgconfig warn_on debug
PKGCONFIG += ise-0.2


DEFINES += DEBUG

DEPENDPATH += . qiseTools
INCLUDEPATH += . qiseTools

LIBS += -lm

